/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/base/common/codicons","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Q){for(var e=[],w=0,R=Q.length;w<R;w++)e[w]=ge[Q[w]];return e};define(ge[51],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=w}),define(ge[52],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function R(s){const P=[];for(let c in s)w.call(s,c)&&P.push(s[c]);return P}e.values=R;function C(s,P){for(let c in s)if(w.call(s,c)&&P({key:c,value:s[c]},function(){delete s[c]})===!1)return}e.forEach=C;function A(s,P){const c=Object.create(null);for(const p of s){const l=P(p);let h=c[l];h||(h=c[l]=[]),h.push(p)}return c}e.groupBy=A;function y(s){const P=Object.create(null);return s&&s.forEach((c,p)=>{P[p]=c}),P}e.fromMap=y;function k(s,P){const c=[],p=[];for(let l of s)P.has(l)||c.push(l);for(let l of P)s.has(l)||p.push(l);return{removed:c,added:p}}e.diffSets=k;function D(s,P){const c=[],p=[];for(let[l,h]of s)P.has(l)||c.push(h);for(let[l,h]of P)s.has(l)||p.push(h);return{removed:c,added:p}}e.diffMaps=D;class I{constructor(){this.map=new Map}add(P,c){let p=this.map.get(P);p||(p=new Set,this.map.set(P,p)),p.add(c)}delete(P,c){const p=this.map.get(P);!p||(p.delete(c),p.size===0&&this.map.delete(P))}forEach(P,c){const p=this.map.get(P);!p||p.forEach(c)}}e.SetMap=I}),define(ge[53],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(y){return(k,D,I)=>{let s=null,P=null;if(typeof I.value=="function"?(s="value",P=I.value):typeof I.get=="function"&&(s="get",P=I.get),!P)throw new Error("not supported");I[s]=y(P,D)}}e.createDecorator=w;function R(y,k,D){let I=null,s=null;if(typeof D.value=="function"?(I="value",s=D.value,s.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(I="get",s=D.get),!s)throw new Error("not supported");const P=`$memoize$${k}`;D[I]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:s.apply(this,c)}),this[P]}}e.memoize=R;function C(y,k,D){return w((I,s)=>{const P=`$debounce$${s}`,c=`$debounce$result$${s}`;return function(...p){this[c]||(this[c]=D?D():void 0),clearTimeout(this[P]),k&&(this[c]=k(this[c],...p),p=[this[c]]),this[P]=setTimeout(()=>{I.apply(this,p),this[c]=D?D():void 0},y)}})}e.debounce=C;function A(y,k,D){return w((I,s)=>{const P=`$throttle$timer$${s}`,c=`$throttle$result$${s}`,p=`$throttle$lastRun$${s}`,l=`$throttle$pending$${s}`;return function(...h){if(this[c]||(this[c]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[c]=k(this[c],...h)),this[l])return;const _=this[p]+y;_<=Date.now()?(this[p]=Date.now(),I.apply(this,[this[c]]),this[c]=D?D():void 0):(this[l]=!0,this[P]=setTimeout(()=>{this[l]=!1,this[p]=Date.now(),I.apply(this,[this[c]]),this[c]=D?D():void 0},_-Date.now()))}})}e.throttle=A}),define(ge[16],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function R(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=R;function C(u){D(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=C;function A(u){D(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=A;function y(u){if(u instanceof Error){let{name:t,message:n}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:t,message:n,stack:i}}return u}e.transformErrorForSerialization=y;const k="Canceled";function D(u){return u instanceof Error&&u.name===k&&u.message===k}e.isPromiseCanceledError=D;class I extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=I;function s(){const u=new Error(k);return u.name=u.message,u}e.canceled=s;function P(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=P;function c(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=c;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function l(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=h;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function d(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function f(u,t=Object.create(null)){const n=new Error(u);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=f}),define(ge[17],pe([0,1,16]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(N,F=0){return N[N.length-(1+F)]}e.tail=R;function C(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=C;function A(N,F,M=(U,x)=>U===x){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let U=0,x=N.length;U<x;U++)if(!M(N[U],F[U]))return!1;return!0}e.equals=A;function y(N,F,M){let U=0,x=N.length-1;for(;U<=x;){const G=(U+x)/2|0,se=M(N[G],F);if(se<0)U=G+1;else if(se>0)x=G-1;else return G}return-(U+1)}e.binarySearch=y;function k(N,F){let M=0,U=N.length;if(U===0)return 0;for(;M<U;){const x=Math.floor((M+U)/2);F(N[x])?U=x:M=x+1}return M}e.findFirstInSorted=k;function D(N,F,M){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let U=F[Math.floor(F.length*Math.random())],x=[],G=[],se=[];for(let be of F){const Te=M(be,U);Te<0?x.push(be):Te>0?G.push(be):se.push(be)}return N<x.length?D(N,x,M):N<x.length+se.length?se[0]:D(N-(x.length+se.length),G,M)}e.quickSelect=D;function I(N,F){const M=[];let U;for(const x of N.slice(0).sort(F))!U||F(U[0],x)!==0?(U=[x],M.push(U)):U.push(x);return M}e.groupBy=I;function s(N,F,M){const U=[];function x(be,Te,Ce){if(Te===0&&Ce.length===0)return;const Me=U[U.length-1];Me&&Me.start+Me.deleteCount===be?(Me.deleteCount+=Te,Me.toInsert.push(...Ce)):U.push({start:be,deleteCount:Te,toInsert:Ce})}let G=0,se=0;for(;;){if(G===N.length){x(G,0,F.slice(se));break}if(se===F.length){x(G,N.length-G,[]);break}const be=N[G],Te=F[se],Ce=M(be,Te);Ce===0?(G+=1,se+=1):Ce<0?(x(G,1,[]),G+=1):Ce>0&&(x(G,0,[Te]),se+=1)}return U}e.sortedDiff=s;function P(N,F,M){const U=s(N,F,M),x=[],G=[];for(const se of U)x.push(...N.slice(se.start,se.start+se.deleteCount)),G.push(...se.toInsert);return{removed:x,added:G}}e.delta=P;function c(N,F,M){if(M===0)return[];const U=N.slice(0,M).sort(F);return l(N,F,U,M,N.length),U}e.top=c;function p(N,F,M,U,x){return M===0?Promise.resolve([]):new Promise((G,se)=>{(async()=>{const be=N.length,Te=N.slice(0,M).sort(F);for(let Ce=M,Me=Math.min(M+U,be);Ce<be;Ce=Me,Me=Math.min(Me+U,be)){if(Ce>M&&await new Promise(qe=>setTimeout(qe)),x&&x.isCancellationRequested)throw w.canceled();l(N,F,Te,Ce,Me)}return Te})().then(G,se)})}e.topAsync=p;function l(N,F,M,U,x){for(const G=M.length;U<x;U++){const se=N[U];if(F(se,M[G-1])<0){M.pop();const be=k(M,Te=>F(se,Te)<0);M.splice(be,0,se)}}}function h(N){return N.filter(F=>!!F)}e.coalesce=h;function _(N){let F=0;for(let M=0;M<N.length;M++)N[M]&&(N[F]=N[M],F+=1);N.length=F}e.coalesceInPlace=_;function v(N,F,M){N.splice(M,0,N.splice(F,1)[0])}e.move=v;function S(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=S;function d(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=d;function f(N,F){if(!F)return N.filter((U,x)=>N.indexOf(U)===x);const M=Object.create(null);return N.filter(U=>{const x=F(U);return M[x]?!1:(M[x]=!0,!0)})}e.distinct=f;function u(N){const F=new Set;return N.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=u;function t(N){const F=Object.create(null);return M=>{const U=N(M);return F[U]?!1:(F[U]=!0,!0)}}e.uniqueFilter=t;function n(N,F){for(let M=N.length-1;M>=0;M--){const U=N[M];if(F(U))return M}return-1}e.lastIndex=n;function i(N,F){return N.length>0?N[0]:F}e.firstOrDefault=i;function r(N,F,M=(U,x)=>U===x){let U=0;for(let x=0,G=Math.min(N.length,F.length);x<G&&M(N[x],F[x]);x++)U++;return U}e.commonPrefixLength=r;function o(N){return[].concat(...N)}e.flatten=o;function m(N,F){let M=typeof F=="number"?N:0;typeof F=="number"?M=N:(M=0,F=N);const U=[];if(M<=F)for(let x=M;x<F;x++)U.push(x);else for(let x=M;x>F;x--)U.push(x);return U}e.range=m;function g(N,F,M){return N.reduce((U,x)=>(U[F(x)]=M?M(x):x,U),Object.create(null))}e.index=g;function E(N,F){return N.push(F),()=>b(N,F)}e.insert=E;function b(N,F){const M=N.indexOf(F);if(M>-1)return N.splice(M,1),F}e.remove=b;function a(N,F,M){const U=N.slice(0,F),x=N.slice(F);return U.concat(M,x)}e.arrayInsert=a;function L(N,F){let M;if(typeof F=="number"){let U=F;M=()=>{const x=Math.sin(U++)*179426549;return x-Math.floor(x)}}else M=Math.random;for(let U=N.length-1;U>0;U-=1){const x=Math.floor(M()*(U+1)),G=N[U];N[U]=N[x],N[x]=G}}e.shuffle=L;function O(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.unshift(F))}e.pushToStart=O;function W(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.push(F))}e.pushToEnd=W;function ee(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=ee;function oe(N){return Array.isArray(N)?N:[N]}e.asArray=oe;function V(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=V;function B(N,F){for(const M of N){const U=F(M);if(U!==void 0)return U}}e.mapFind=B;function j(N,F){let M=Number.MAX_SAFE_INTEGER,U=0;return N.forEach((x,G)=>{const se=F(x);se<M&&(M=se,U=G)}),U}e.minIndex=j;function T(N,F){let M=Number.MIN_SAFE_INTEGER,U=0;return N.forEach((x,G)=>{const se=F(x);se>M&&(M=se,U=G)}),U}e.maxIndex=T}),define(ge[72],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(R){const C=this;let A=!1,y;return function(){return A||(A=!0,y=R.apply(C,arguments)),y}}e.once=w}),define(ge[73],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(ge[54],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(R){function C(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}R.is=C;const A=Object.freeze([]);function y(){return A}R.empty=y;function*k(u){yield u}R.single=k;function D(u){return u||A}R.from=D;function I(u){return!u||u[Symbol.iterator]().next().done===!0}R.isEmpty=I;function s(u){return u[Symbol.iterator]().next().value}R.first=s;function P(u,t){for(const n of u)if(t(n))return!0;return!1}R.some=P;function c(u,t){for(const n of u)if(t(n))return n}R.find=c;function*p(u,t){for(const n of u)t(n)&&(yield n)}R.filter=p;function*l(u,t){let n=0;for(const i of u)yield t(i,n++)}R.map=l;function*h(...u){for(const t of u)for(const n of t)yield n}R.concat=h;function*_(u){for(const t of u)for(const n of t)yield n}R.concatNested=_;function v(u,t,n){let i=n;for(const r of u)i=t(i,r);return i}R.reduce=v;function*S(u,t,n=u.length){for(t<0&&(t+=u.length),n<0?n+=u.length:n>u.length&&(n=u.length);t<n;t++)yield u[t]}R.slice=S;function d(u,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,u];const i=u[Symbol.iterator]();for(let r=0;r<t;r++){const o=i.next();if(o.done)return[n,R.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return i}}]}R.consume=d;function f(u,t,n=(i,r)=>i===r){const i=u[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=i.next(),m=r.next();if(o.done!==m.done)return!1;if(o.done)return!0;if(!n(o.value,m.value))return!1}}R.equals=f})(w=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let i=0,r=t.length,o="",m=0,g=16,E=0;function b(V){let B=0,j=0;for(;B<V;){const T=t.charCodeAt(i);if(T>=48&&T<=57)j=j*16+T-48;else if(T>=65&&T<=70)j=j*16+T-65+10;else if(T>=97&&T<=102)j=j*16+T-97+10;else break;i++,B++}return B<V&&(j=-1),j}function a(V){i=V,o="",m=0,g=16,E=0}function L(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&I(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&I(t.charCodeAt(i)))for(i++;i<t.length&&I(t.charCodeAt(i));)i++;else return E=3,t.substring(V,i);let B=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&I(t.charCodeAt(i))){for(i++;i<t.length&&I(t.charCodeAt(i));)i++;B=i}else E=3;return t.substring(V,B)}function O(){let V="",B=i;for(;;){if(i>=r){V+=t.substring(B,i),E=2;break}const j=t.charCodeAt(i);if(j===34){V+=t.substring(B,i),i++;break}if(j===92){if(V+=t.substring(B,i),i++,i>=r){E=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const N=b(4);N>=0?V+=String.fromCharCode(N):E=4;break;default:E=5}B=i;continue}if(j>=0&&j<=31)if(D(j)){V+=t.substring(B,i),E=2;break}else E=6;i++}return V}function W(){if(o="",E=0,m=i,i>=r)return m=r,g=17;let V=t.charCodeAt(i);if(k(V)){do i++,o+=String.fromCharCode(V),V=t.charCodeAt(i);while(k(V));return g=15}if(D(V))return i++,o+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),g=14;switch(V){case 123:return i++,g=1;case 125:return i++,g=2;case 91:return i++,g=3;case 93:return i++,g=4;case 58:return i++,g=6;case 44:return i++,g=5;case 34:return i++,o=O(),g=10;case 47:const B=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!D(t.charCodeAt(i));)i++;return o=t.substring(B,i),g=12}if(t.charCodeAt(i+1)===42){i+=2;const j=r-1;let T=!1;for(;i<j;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,T=!0;break}i++}return T||(i++,E=1),o=t.substring(B,i),g=13}return o+=String.fromCharCode(V),i++,g=16;case 45:if(o+=String.fromCharCode(V),i++,i===r||!I(t.charCodeAt(i)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),g=11;default:for(;i<r&&ee(V);)i++,V=t.charCodeAt(i);if(m!==i){switch(o=t.substring(m,i),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(V),i++,g=16}}function ee(V){if(k(V)||D(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let V;do V=W();while(V>=12&&V<=15);return V}return{setPosition:a,getPosition:()=>i,scan:n?oe:W,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>m,getTokenLength:()=>i-m,getTokenError:()=>E}}e.createScanner=y;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var s;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(s||(s={}));function P(t,n){const i=[],r=new Object;let o;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function E(b,a,L,O){m.value=b,m.offset=a,m.length=L,m.type=O,m.colonOffset=void 0,o=m}try{d(t,{onObjectBegin:(b,a)=>{if(n<=b)throw r;o=void 0,g=n>b,i.push("")},onObjectProperty:(b,a,L)=>{if(n<a||(E(b,a,L,"property"),i[i.length-1]=b,n<=a+L))throw r},onObjectEnd:(b,a)=>{if(n<=b)throw r;o=void 0,i.pop()},onArrayBegin:(b,a)=>{if(n<=b)throw r;o=void 0,i.push(0)},onArrayEnd:(b,a)=>{if(n<=b)throw r;o=void 0,i.pop()},onLiteralValue:(b,a,L)=>{if(n<a||(E(b,a,L,u(b)),n<=a+L))throw r},onSeparator:(b,a,L)=>{if(n<=a)throw r;if(b===":"&&o&&o.type==="property")o.colonOffset=a,g=!1,o=void 0;else if(b===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(g=!0,i[i.length-1]=""),o=void 0}}})}catch(b){if(b!==r)throw b}return{path:i,previousNode:o,isAtPropertyKey:g,matches:b=>{let a=0;for(let L=0;a<b.length&&L<i.length;L++)if(b[a]===i[L]||b[a]==="*")a++;else if(b[a]!=="**")return!1;return a===b.length}}}e.getLocation=P;function c(t,n=[],i=A.DEFAULT){let r=null,o=[];const m=[];function g(b){Array.isArray(o)?o.push(b):r!==null&&(o[r]=b)}return d(t,{onObjectBegin:()=>{const b={};g(b),m.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const b=[];g(b),m.push(o),o=b,r=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:g,onError:(b,a,L)=>{n.push({error:b,offset:a,length:L})}},i),o[0]}e.parse=c;function p(t,n=[],i=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function m(b){return r.children.push(b),b}d(t,{onObjectBegin:b=>{r=m({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,a,L)=>{r=m({type:"property",offset:a,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:a,length:L,parent:r})},onObjectEnd:(b,a)=>{r.length=b+a-r.offset,r=r.parent,o(b+a)},onArrayBegin:(b,a)=>{r=m({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,a)=>{r.length=b+a-r.offset,r=r.parent,o(b+a)},onLiteralValue:(b,a,L)=>{m({type:u(b),offset:a,length:L,parent:r,value:b}),o(a+L)},onSeparator:(b,a,L)=>{r.type==="property"&&(b===":"?r.colonOffset=a:b===","&&o(a))},onError:(b,a,L)=>{n.push({error:b,offset:a,length:L})}},i);const E=r.children[0];return E&&delete E.parent,E}e.parseTree=p;function l(t,n){if(!t)return;let i=t;for(let r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const m of i.children)if(Array.isArray(m.children)&&m.children[0].value===r){i=m.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=l;function h(t){if(!t.parent||!t.parent.children)return[];const n=h(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=h;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const n=Object.create(null);for(let i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=_(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function v(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=v;function S(t,n,i=!1){if(v(t,n,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const m=S(r[o],n,i);if(m)return m}return t}}e.findNodeAtOffset=S;function d(t,n,i=A.DEFAULT){const r=y(t,!1);function o(se){return se?()=>se(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(se){return se?be=>se(be,r.getTokenOffset(),r.getTokenLength()):()=>!0}const g=o(n.onObjectBegin),E=m(n.onObjectProperty),b=o(n.onObjectEnd),a=o(n.onArrayBegin),L=o(n.onArrayEnd),O=m(n.onLiteralValue),W=m(n.onSeparator),ee=o(n.onComment),oe=m(n.onError),V=i&&i.disallowComments,B=i&&i.allowTrailingComma;function j(){for(;;){const se=r.scan();switch(r.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:V||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(se){case 12:case 13:V?T(10):ee();break;case 16:T(1);break;case 15:case 14:break;default:return se}}}function T(se,be=[],Te=[]){if(oe(se),be.length+Te.length>0){let Ce=r.getToken();for(;Ce!==17;){if(be.indexOf(Ce)!==-1){j();break}else if(Te.indexOf(Ce)!==-1)break;Ce=j()}}}function N(se){const be=r.getTokenValue();return se?O(be):E(be),j(),!0}function F(){switch(r.getToken()){case 11:let se=0;try{se=JSON.parse(r.getTokenValue()),typeof se!="number"&&(T(2),se=0)}catch(be){T(2)}O(se);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return j(),!0}function M(){return r.getToken()!==10?(T(3,[],[2,5]),!1):(N(!1),r.getToken()===6?(W(":"),j(),G()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function U(){g(),j();let se=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(se||T(4,[],[]),W(","),j(),r.getToken()===2&&B)break}else se&&T(6,[],[]);M()||T(4,[],[2,5]),se=!0}return b(),r.getToken()!==2?T(7,[2],[]):j(),!0}function x(){a(),j();let se=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(se||T(4,[],[]),W(","),j(),r.getToken()===4&&B)break}else se&&T(6,[],[]);G()||T(4,[],[4,5]),se=!0}return L(),r.getToken()!==4?T(8,[4],[]):j(),!0}function G(){switch(r.getToken()){case 3:return x();case 1:return U();case 10:return N(!0);default:return F()}}return j(),r.getToken()===17?i.allowEmptyContent?!0:(T(4,[],[]),!1):G()?(r.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=d;function f(t,n){let i=y(t),r=[],o,m=0,g;do switch(g=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:m!==g&&r.push(t.substring(m,g)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),m=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ge[133],pe([0,1,55]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,I,s){let P,c,p,l,h;if(I){for(l=I.offset,h=l+I.length,p=l;p>0&&!k(D,p-1);)p--;let m=h;for(;m<D.length&&!k(D,m);)m++;c=D.substring(p,m),P=A(c,s)}else c=D,P=0,p=0,l=0,h=D.length;const _=y(s,D);let v=!1,S=0,d;s.insertSpaces?d=C(" ",s.tabSize||4):d="	";const f=w.createScanner(c,!1);let u=!1;function t(){return _+C(d,P+S)}function n(){let m=f.scan();for(v=!1;m===15||m===14;)v=v||m===14,m=f.scan();return u=m===16||f.getTokenError()!==0,m}const i=[];function r(m,g,E){!u&&g<h&&E>l&&D.substring(g,E)!==m&&i.push({offset:g,length:E-g,content:m})}let o=n();if(o!==17){const m=f.getTokenOffset()+p,g=C(d,P);r(g,p,m)}for(;o!==17;){let m=f.getTokenOffset()+f.getTokenLength()+p,g=n(),E="";for(;!v&&(g===12||g===13);){const a=f.getTokenOffset()+p;r(" ",m,a),m=f.getTokenOffset()+f.getTokenLength()+p,E=g===12?t():"",g=n()}if(g===2)o!==1&&(S--,E=t());else if(g===4)o!==3&&(S--,E=t());else{switch(o){case 3:case 1:S++,E=t();break;case 5:case 12:E=t();break;case 13:v?E=t():E=" ";break;case 6:E=" ";break;case 10:if(g===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?E=" ":g!==5&&g!==17&&(u=!0);break;case 16:u=!0;break}v&&(g===12||g===13)&&(E=t())}const b=f.getTokenOffset()+p;r(E,m,b),o=g}return i}e.format=R;function C(D,I){let s="";for(let P=0;P<I;P++)s+=D;return s}function A(D,I){let s=0,P=0;const c=I.tabSize||4;for(;s<D.length;){const p=D.charAt(s);if(p===" ")P++;else if(p==="	")P+=c;else break;s++}return Math.floor(P/c)}function y(D,I){for(let s=0;s<I.length;s++){const P=I.charAt(s);if(P==="\r")return s+1<I.length&&I.charAt(s+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function k(D,I){return`\r
`.indexOf(D.charAt(I))!==-1}e.isEOL=k}),define(ge[134],pe([0,1,55,133]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(I,s,P){return A(I,s,void 0,P)}e.removeProperty=C;function A(I,s,P,c,p){const l=s.slice(),h=[],_=w.parseTree(I,h);let v,S;for(;l.length>0&&(S=l.pop(),v=w.findNodeAtLocation(_,l),v===void 0&&P!==void 0);)typeof S=="string"?P={[S]:P}:P=[P];if(v)if(v.type==="object"&&typeof S=="string"&&Array.isArray(v.children)){const d=w.findNodeAtLocation(v,[S]);if(d!==void 0)if(P===void 0){if(!d.parent)throw new Error("Malformed AST");const f=v.children.indexOf(d.parent);let u,t=d.parent.offset+d.parent.length;if(f>0){const n=v.children[f-1];u=n.offset+n.length}else u=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return y(I,{offset:u,length:t-u,content:""},c)}else return y(I,{offset:d.offset,length:d.length,content:JSON.stringify(P)},c);else{if(P===void 0)return[];const f=`${JSON.stringify(S)}: ${JSON.stringify(P)}`,u=p?p(v.children.map(n=>n.children[0].value)):v.children.length;let t;if(u>0){const n=v.children[u-1];t={offset:n.offset+n.length,length:0,content:","+f}}else v.children.length===0?t={offset:v.offset+1,length:0,content:f}:t={offset:v.offset+1,length:0,content:f+","};return y(I,t,c)}}else if(v.type==="array"&&typeof S=="number"&&Array.isArray(v.children))if(P!==void 0){const d=`${JSON.stringify(P)}`;let f;if(v.children.length===0||S===0)f={offset:v.offset+1,length:0,content:v.children.length===0?d:d+","};else{const u=S===-1||S>v.children.length?v.children.length:S,t=v.children[u-1];f={offset:t.offset+t.length,length:0,content:","+d}}return y(I,f,c)}else{const d=S,f=v.children[d];let u;if(v.children.length===1)u={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===d){const t=v.children[d-1],n=t.offset+t.length,i=v.offset+v.length;u={offset:n,length:i-2-n,content:""}}else u={offset:f.offset,length:v.children[d+1].offset-f.offset,content:""};return y(I,u,c)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${v.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(I,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(P)},c)}}e.setProperty=A;function y(I,s,P){let c=k(I,s),p=s.offset,l=s.offset+s.content.length;if(s.length===0||s.content.length===0){for(;p>0&&!R.isEOL(c,p-1);)p--;for(;l<c.length&&!R.isEOL(c,l);)l++}const h=R.format(c,{offset:p,length:l-p},P);for(let v=h.length-1;v>=0;v--){const S=h[v];c=k(c,S),p=Math.min(p,S.offset),l=Math.max(l,S.offset+S.length),l+=S.content.length-S.length}const _=I.length-(c.length-l)-p;return[{offset:p,length:_,content:c.substring(p,l)}]}e.withFormatting=y;function k(I,s){return I.substring(0,s.offset)+s.content+I.substring(s.offset+s.length)}e.applyEdit=k;function D(I,s){let P=s.slice(0).sort((p,l)=>{const h=p.offset-l.offset;return h===0?p.length-l.length:h}),c=I.length;for(let p=P.length-1;p>=0;p--){let l=P[p];if(l.offset+l.length<=c)I=k(I,l);else throw new Error("Overlapping edit");c=l.offset}return I}e.applyEdits=D}),define(ge[135],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new w(()=>C(this.getValue()))}}e.Lazy=w}),define(ge[6],pe([0,1,72,54]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let A=null;function y(d){A=d}if(e.setDisposableTracker=y,C){const d="__is_disposable_tracked__";A=new class{trackDisposable(f){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[d]||console.log(u)},3e3)}markTracked(f){if(f&&f!==h.None)try{f[d]=!0}catch(u){}}}}function k(d){!A||A.markTracked(d)}function D(d){return A&&A.trackDisposable(d),d}e.trackDisposable=D;class I extends Error{constructor(f){super(`Encountered errors while disposing of store. Errors: [${f.join(", ")}]`);this.errors=f}}e.MultiDisposeError=I;function s(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=s;function P(d){if(R.Iterable.is(d)){let f=[];for(const u of d)if(u){k(u);try{u.dispose()}catch(t){f.push(t)}}if(f.length===1)throw f[0];if(f.length>1)throw new I(f);return Array.isArray(d)?[]:d}else if(d)return k(d),d.dispose(),d}e.dispose=P;function c(...d){return d.forEach(k),p(()=>P(d))}e.combinedDisposable=c;function p(d){const f=D({dispose:()=>{k(f),d()}});return f}e.toDisposable=p;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return k(f),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new l,D(this)}dispose(){k(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){var u;this._isDisposed||f===this._value||((u=this._value)===null||u===void 0||u.dispose(),f&&k(f),this._value=f)}clear(){this.value=void 0}dispose(){var f;this._isDisposed=!0,k(this),(f=this._value)===null||f===void 0||f.dispose(),this._value=void 0}}e.MutableDisposable=_;class v{constructor(){this.references=new Map}acquire(f,...u){let t=this.references.get(f);t||(t={counter:0,object:this.createReferencedObject(f,...u)},this.references.set(f,t));const{object:n}=t,i=w.once(()=>{--t.counter==0&&(this.destroyReferencedObject(f,t.object),this.references.delete(f))});return t.counter++,{object:n,dispose:i}}}e.ReferenceCollection=v;class S{constructor(f){this.object=f}dispose(){}}e.ImmortalReference=S}),define(ge[56],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(A){this.element=A,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class R{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let A=this._first;for(;A!==w.Undefined;){const y=A.next;A.prev=w.Undefined,A.next=w.Undefined,A=y}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const k=new w(A);if(this._first===w.Undefined)this._first=k,this._last=k;else if(y){const I=this._last;this._last=k,k.prev=I,I.next=k}else{const I=this._first;this._first=k,k.next=I,I.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==w.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==w.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==w.Undefined&&A.next!==w.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===w.Undefined&&A.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):A.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):A.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==w.Undefined;)yield A.element,A=A.next}}e.LinkedList=R}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(De,ye){for(var ke=0;ke<ye.length;ke++){var le=ye[ke];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(De,le.key,le)}}function e(De,ye,ke){return ye&&Q(De.prototype,ye),ke&&Q(De,ke),De}function w(De,ye){if(!!De){if(typeof De=="string")return R(De,ye);var ke=Object.prototype.toString.call(De).slice(8,-1);if(ke==="Object"&&De.constructor&&(ke=De.constructor.name),ke==="Map"||ke==="Set")return Array.from(De);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return R(De,ye)}}function R(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var ke=0,le=new Array(ye);ke<ye;ke++)le[ke]=De[ke];return le}function C(De,ye){var ke;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(ke=w(De))||ye&&De&&typeof De.length=="number"){ke&&(De=ke);var le=0;return function(){return le>=De.length?{done:!0}:{done:!1,value:De[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ke=De[Symbol.iterator](),ke.next.bind(ke)}function A(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var y=A(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ke(le){De.exports.defaults=le}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:ke}}),k=/[&<>"']/,D=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,s=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(ye){return P[ye]};function p(De,ye){if(ye){if(k.test(De))return De.replace(D,c)}else if(I.test(De))return De.replace(s,c);return De}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(De){return De.replace(l,function(ye,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var _=/(^|[^\[])\^/g;function v(De,ye){De=De.source||De,ye=ye||"";var ke={replace:function(he,H){return H=H.source||H,H=H.replace(_,"$1"),De=De.replace(he,H),ke},getRegex:function(){return new RegExp(De,ye)}};return ke}var S=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(De,ye,ke){if(De){var le;try{le=decodeURIComponent(h(ke)).replace(S,"").toLowerCase()}catch(he){return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}ye&&!d.test(ke)&&(ke=r(ye,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(he){return null}return ke}var u={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(De,ye){u[" "+De]||(t.test(De)?u[" "+De]=De+"/":u[" "+De]=E(De,"/",!0)),De=u[" "+De];var ke=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?ke?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?ke?ye:De.replace(i,"$1")+ye:De+ye}var o={exec:function(){}};function m(De){for(var ye=1,ke,le;ye<arguments.length;ye++){ke=arguments[ye];for(le in ke)Object.prototype.hasOwnProperty.call(ke,le)&&(De[le]=ke[le])}return De}function g(De,ye){var ke=De.replace(/\|/g,function(H,Z,ue){for(var Ie=!1,Pe=Z;--Pe>=0&&ue[Pe]==="\\";)Ie=!Ie;return Ie?"|":" |"}),le=ke.split(/ \|/),he=0;if(le.length>ye)le.splice(ye);else for(;le.length<ye;)le.push("");for(;he<le.length;he++)le[he]=le[he].trim().replace(/\\\|/g,"|");return le}function E(De,ye,ke){var le=De.length;if(le===0)return"";for(var he=0;he<le;){var H=De.charAt(le-he-1);if(H===ye&&!ke)he++;else if(H!==ye&&ke)he++;else break}return De.substr(0,le-he)}function b(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var ke=De.length,le=0,he=0;he<ke;he++)if(De[he]==="\\")he++;else if(De[he]===ye[0])le++;else if(De[he]===ye[1]&&(le--,le<0))return he;return-1}function a(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(De,ye){if(ye<1)return"";for(var ke="";ye>1;)ye&1&&(ke+=De),ye>>=1,De+=De;return ke+De}var O={escape:p,unescape:h,edit:v,cleanUrl:f,resolveUrl:r,noopTest:o,merge:m,splitCells:g,rtrim:E,findClosingBracket:b,checkSanitizeDeprecation:a,repeatString:L},W=y.defaults,ee=O.rtrim,oe=O.splitCells,V=O.escape,B=O.findClosingBracket;function j(De,ye,ke){var le=ye.href,he=ye.title?V(ye.title):null,H=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:ke,href:le,title:he,text:H}:{type:"image",raw:ke,href:le,title:he,text:V(H)}}function T(De,ye){var ke=De.match(/^(\s+)(?:```)/);if(ke===null)return ye;var le=ke[1];return ye.split(`
`).map(function(he){var H=he.match(/^\s+/);if(H===null)return he;var Z=H[0];return Z.length>=le.length?he.slice(le.length):he}).join(`
`)}var N=function(){function De(ke){this.options=ke||W}var ye=De.prototype;return ye.space=function(le){var he=this.rules.block.newline.exec(le);if(he)return he[0].length>1?{type:"space",raw:he[0]}:{raw:`
`}},ye.code=function(le){var he=this.rules.block.code.exec(le);if(he){var H=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?H:ee(H,`
`)}}},ye.fences=function(le){var he=this.rules.block.fences.exec(le);if(he){var H=he[0],Z=T(H,he[3]||"");return{type:"code",raw:H,lang:he[2]?he[2].trim():he[2],text:Z}}},ye.heading=function(le){var he=this.rules.block.heading.exec(le);if(he){var H=he[2].trim();if(/#$/.test(H)){var Z=ee(H,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(H=Z.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:H}}},ye.nptable=function(le){var he=this.rules.block.nptable.exec(le);if(he){var H={type:"table",header:oe(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[],raw:he[0]};if(H.header.length===H.align.length){var Z=H.align.length,ue;for(ue=0;ue<Z;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(Z=H.cells.length,ue=0;ue<Z;ue++)H.cells[ue]=oe(H.cells[ue],H.header.length);return H}}},ye.hr=function(le){var he=this.rules.block.hr.exec(le);if(he)return{type:"hr",raw:he[0]}},ye.blockquote=function(le){var he=this.rules.block.blockquote.exec(le);if(he){var H=he[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:he[0],text:H}}},ye.list=function(le){var he=this.rules.block.list.exec(le);if(he){var H=he[0],Z=he[2],ue=Z.length>1,Ie={type:"list",raw:H,ordered:ue,start:ue?+Z.slice(0,-1):"",loose:!1,items:[]},Pe=he[0].match(this.rules.block.item),Ue=!1,xe,Qe,rt,tt,Ye,ot,Et,bt,_e=Pe.length;rt=this.rules.block.listItemStart.exec(Pe[0]);for(var fe=0;fe<_e;fe++){if(xe=Pe[fe],H=xe,fe!==_e-1){if(tt=this.rules.block.listItemStart.exec(Pe[fe+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Pe.splice(fe,2,Pe[fe]+`
`+Pe[fe+1]),fe--,_e--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Z[Z.length-1]:ue===(tt[2].length===1))&&(Ye=Pe.slice(fe+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-Ye.length),fe=_e-1);rt=tt}Qe=xe.length,xe=xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~xe.indexOf(`
 `)&&(Qe-=xe.length,xe=this.options.pedantic?xe.replace(/^ {1,4}/gm,""):xe.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=Ue||/\n\n(?!\s*$)/.test(xe),fe!==_e-1&&(Ue=xe.charAt(xe.length-1)===`
`,ot||(ot=Ue)),ot&&(Ie.loose=!0),this.options.gfm&&(Et=/^\[[ xX]\] /.test(xe),bt=void 0,Et&&(bt=xe[1]!==" ",xe=xe.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:H,task:Et,checked:bt,loose:ot,text:xe})}return Ie}},ye.html=function(le){var he=this.rules.block.html.exec(le);if(he)return{type:this.options.sanitize?"paragraph":"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):V(he[0]):he[0]}},ye.def=function(le){var he=this.rules.block.def.exec(le);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var H=he[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:he[0],href:he[2],title:he[3]}}},ye.table=function(le){var he=this.rules.block.table.exec(le);if(he){var H={type:"table",header:oe(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=he[0];var Z=H.align.length,ue;for(ue=0;ue<Z;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(Z=H.cells.length,ue=0;ue<Z;ue++)H.cells[ue]=oe(H.cells[ue].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},ye.lheading=function(le){var he=this.rules.block.lheading.exec(le);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1]}},ye.paragraph=function(le){var he=this.rules.block.paragraph.exec(le);if(he)return{type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1]}},ye.text=function(le){var he=this.rules.block.text.exec(le);if(he)return{type:"text",raw:he[0],text:he[0]}},ye.escape=function(le){var he=this.rules.inline.escape.exec(le);if(he)return{type:"escape",raw:he[0],text:V(he[1])}},ye.tag=function(le,he,H){var Z=this.rules.inline.tag.exec(le);if(Z)return!he&&/^<a /i.test(Z[0])?he=!0:he&&/^<\/a>/i.test(Z[0])&&(he=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:he,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):V(Z[0]):Z[0]}},ye.link=function(le){var he=this.rules.inline.link.exec(le);if(he){var H=he[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var Z=ee(H.slice(0,-1),"\\");if((H.length-Z.length)%2==0)return}else{var ue=B(he[2],"()");if(ue>-1){var Ie=he[0].indexOf("!")===0?5:4,Pe=Ie+he[1].length+ue;he[2]=he[2].substring(0,ue),he[0]=he[0].substring(0,Pe).trim(),he[3]=""}}var Ue=he[2],xe="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);Qe&&(Ue=Qe[1],xe=Qe[3])}else xe=he[3]?he[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(H)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),j(he,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},he[0])}},ye.reflink=function(le,he){var H;if((H=this.rules.inline.reflink.exec(le))||(H=this.rules.inline.nolink.exec(le))){var Z=(H[2]||H[1]).replace(/\s+/g," ");if(Z=he[Z.toLowerCase()],!Z||!Z.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return j(H,Z,H[0])}},ye.emStrong=function(le,he,H){H===void 0&&(H="");var Z=this.rules.inline.emStrong.lDelim.exec(le);if(!!Z&&!(Z[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=Z[1]||Z[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var Ie=Z[0].length-1,Pe,Ue,xe=Ie,Qe=0,rt=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,he=he.slice(-1*le.length+Ie);(Z=rt.exec(he))!=null;)if(Pe=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!Pe){if(Ue=Pe.length,Z[3]||Z[4]){xe+=Ue;continue}else if((Z[5]||Z[6])&&Ie%3&&!((Ie+Ue)%3)){Qe+=Ue;continue}if(xe-=Ue,!(xe>0)){if(xe+Qe-Ue<=0&&!he.slice(rt.lastIndex).match(rt)&&(Ue=Math.min(Ue,Ue+xe+Qe)),Math.min(Ie,Ue)%2)return{type:"em",raw:le.slice(0,Ie+Z.index+Ue+1),text:le.slice(1,Ie+Z.index+Ue)};if(Math.min(Ie,Ue)%2==0)return{type:"strong",raw:le.slice(0,Ie+Z.index+Ue+1),text:le.slice(2,Ie+Z.index+Ue-1)}}}}}},ye.codespan=function(le){var he=this.rules.inline.code.exec(le);if(he){var H=he[2].replace(/\n/g," "),Z=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return Z&&ue&&(H=H.substring(1,H.length-1)),H=V(H,!0),{type:"codespan",raw:he[0],text:H}}},ye.br=function(le){var he=this.rules.inline.br.exec(le);if(he)return{type:"br",raw:he[0]}},ye.del=function(le){var he=this.rules.inline.del.exec(le);if(he)return{type:"del",raw:he[0],text:he[2]}},ye.autolink=function(le,he){var H=this.rules.inline.autolink.exec(le);if(H){var Z,ue;return H[2]==="@"?(Z=V(this.options.mangle?he(H[1]):H[1]),ue="mailto:"+Z):(Z=V(H[1]),ue=Z),{type:"link",raw:H[0],text:Z,href:ue,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(le,he){var H;if(H=this.rules.inline.url.exec(le)){var Z,ue;if(H[2]==="@")Z=V(this.options.mangle?he(H[0]):H[0]),ue="mailto:"+Z;else{var Ie;do Ie=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Ie!==H[0]);Z=V(H[0]),H[1]==="www."?ue="http://"+Z:ue=Z}return{type:"link",raw:H[0],text:Z,href:ue,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(le,he,H){var Z=this.rules.inline.text.exec(le);if(Z){var ue;return he?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):V(Z[0]):Z[0]:ue=V(this.options.smartypants?H(Z[0]):Z[0]),{type:"text",raw:Z[0],text:ue}}},De}(),F=O.noopTest,M=O.edit,U=O.merge,x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=M(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,x.item=M(x.item,"gm").replace(/bull/g,x.bullet).getRegex(),x.listItemStart=M(/^( *)(bull)/).replace("bull",x.bullet).getRegex(),x.list=M(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=M(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=M(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.blockquote=M(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=U({},x),x.gfm=U({},x.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.nptable=M(x.gfm.nptable).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.gfm.table=M(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.pedantic=U({},x.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=M(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=M(x._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=M(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=M(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=M(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=M(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=M(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=M(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=M(G.reflink).replace("label",G._label).getRegex(),G.reflinkSearch=M(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=U({},G),G.pedantic=U({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=U({},G.normal,{escape:M(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),G.gfm.url=M(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=U({},G.gfm,{br:M(G.br).replace("{2,}","*").getRegex(),text:M(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var se={block:x,inline:G},be=y.defaults,Te=se.block,Ce=se.inline,Me=O.repeatString;function qe(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(De){var ye="",ke,le,he=De.length;for(ke=0;ke<he;ke++)le=De.charCodeAt(ke),Math.random()>.5&&(le="x"+le.toString(16)),ye+="&#"+le+";";return ye}var Ke=function(){function De(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||be,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var le={block:Te.normal,inline:Ce.normal};this.options.pedantic?(le.block=Te.pedantic,le.inline=Ce.pedantic):this.options.gfm&&(le.block=Te.gfm,this.options.breaks?le.inline=Ce.breaks:le.inline=Ce.gfm),this.tokenizer.rules=le}De.lex=function(le,he){var H=new De(he);return H.lex(le)},De.lexInline=function(le,he){var H=new De(he);return H.inlineTokens(le)};var ye=De.prototype;return ye.lex=function(le){return le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(le,he,H){he===void 0&&(he=[]),H===void 0&&(H=!0),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var Z,ue,Ie,Pe;le;){if(Z=this.tokenizer.space(le)){le=le.substring(Z.raw.length),Z.type&&he.push(Z);continue}if(Z=this.tokenizer.code(le)){le=le.substring(Z.raw.length),Pe=he[he.length-1],Pe&&Pe.type==="paragraph"?(Pe.raw+=`
`+Z.raw,Pe.text+=`
`+Z.text):he.push(Z);continue}if(Z=this.tokenizer.fences(le)){le=le.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.heading(le)){le=le.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.nptable(le)){le=le.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.hr(le)){le=le.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.blockquote(le)){le=le.substring(Z.raw.length),Z.tokens=this.blockTokens(Z.text,[],H),he.push(Z);continue}if(Z=this.tokenizer.list(le)){for(le=le.substring(Z.raw.length),Ie=Z.items.length,ue=0;ue<Ie;ue++)Z.items[ue].tokens=this.blockTokens(Z.items[ue].text,[],!1);he.push(Z);continue}if(Z=this.tokenizer.html(le)){le=le.substring(Z.raw.length),he.push(Z);continue}if(H&&(Z=this.tokenizer.def(le))){le=le.substring(Z.raw.length),this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(le)){le=le.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.lheading(le)){le=le.substring(Z.raw.length),he.push(Z);continue}if(H&&(Z=this.tokenizer.paragraph(le))){le=le.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.text(le)){le=le.substring(Z.raw.length),Pe=he[he.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+Z.raw,Pe.text+=`
`+Z.text):he.push(Z);continue}if(le){var Ue="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return he},ye.inline=function(le){var he,H,Z,ue,Ie,Pe,Ue=le.length;for(he=0;he<Ue;he++)switch(Pe=le[he],Pe.type){case"paragraph":case"text":case"heading":{Pe.tokens=[],this.inlineTokens(Pe.text,Pe.tokens);break}case"table":{for(Pe.tokens={header:[],cells:[]},ue=Pe.header.length,H=0;H<ue;H++)Pe.tokens.header[H]=[],this.inlineTokens(Pe.header[H],Pe.tokens.header[H]);for(ue=Pe.cells.length,H=0;H<ue;H++)for(Ie=Pe.cells[H],Pe.tokens.cells[H]=[],Z=0;Z<Ie.length;Z++)Pe.tokens.cells[H][Z]=[],this.inlineTokens(Ie[Z],Pe.tokens.cells[H][Z]);break}case"blockquote":{this.inline(Pe.tokens);break}case"list":{for(ue=Pe.items.length,H=0;H<ue;H++)this.inline(Pe.items[H].tokens);break}}return le},ye.inlineTokens=function(le,he,H,Z){he===void 0&&(he=[]),H===void 0&&(H=!1),Z===void 0&&(Z=!1);var ue,Ie,Pe=le,Ue,xe,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)rt.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ue.index)+"["+Me("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"["+Me("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;){if(xe||(Qe=""),xe=!1,ue=this.tokenizer.escape(le)){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.tag(le,H,Z)){le=le.substring(ue.raw.length),H=ue.inLink,Z=ue.inRawBlock;var tt=he[he.length-1];tt&&ue.type==="text"&&tt.type==="text"?(tt.raw+=ue.raw,tt.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.link(le)){le=le.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,Z)),he.push(ue);continue}if(ue=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(ue.raw.length);var Ye=he[he.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,Z),he.push(ue)):Ye&&ue.type==="text"&&Ye.type==="text"?(Ye.raw+=ue.raw,Ye.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.emStrong(le,Pe,Qe)){le=le.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,Z),he.push(ue);continue}if(ue=this.tokenizer.codespan(le)){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.br(le)){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.del(le)){le=le.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,Z),he.push(ue);continue}if(ue=this.tokenizer.autolink(le,ze)){le=le.substring(ue.raw.length),he.push(ue);continue}if(!H&&(ue=this.tokenizer.url(le,ze))){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.inlineText(le,Z,qe)){le=le.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Qe=ue.raw.slice(-1)),xe=!0,Ie=he[he.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ue.raw,Ie.text+=ue.text):he.push(ue);continue}if(le){var ot="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return he},e(De,null,[{key:"rules",get:function(){return{block:Te,inline:Ce}}}]),De}(),q=y.defaults,J=O.cleanUrl,re=O.escape,ae=function(){function De(ke){this.options=ke||q}var ye=De.prototype;return ye.code=function(le,he,H){var Z=(he||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(le,Z);ue!=null&&ue!==le&&(H=!0,le=ue)}return le=le.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+re(Z,!0)+'">'+(H?le:re(le,!0))+`</code></pre>
`:"<pre><code>"+(H?le:re(le,!0))+`</code></pre>
`},ye.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},ye.html=function(le){return le},ye.heading=function(le,he,H,Z){return this.options.headerIds?"<h"+he+' id="'+this.options.headerPrefix+Z.slug(H)+'">'+le+"</h"+he+`>
`:"<h"+he+">"+le+"</h"+he+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(le,he,H){var Z=he?"ol":"ul",ue=he&&H!==1?' start="'+H+'"':"";return"<"+Z+ue+`>
`+le+"</"+Z+`>
`},ye.listitem=function(le){return"<li>"+le+`</li>
`},ye.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(le){return"<p>"+le+`</p>
`},ye.table=function(le,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+he+`</table>
`},ye.tablerow=function(le){return`<tr>
`+le+`</tr>
`},ye.tablecell=function(le,he){var H=he.header?"th":"td",Z=he.align?"<"+H+' align="'+he.align+'">':"<"+H+">";return Z+le+"</"+H+`>
`},ye.strong=function(le){return"<strong>"+le+"</strong>"},ye.em=function(le){return"<em>"+le+"</em>"},ye.codespan=function(le){return"<code>"+le+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(le){return"<del>"+le+"</del>"},ye.link=function(le,he,H){if(le=J(this.options.sanitize,this.options.baseUrl,le),le===null)return H;var Z='<a href="'+re(le)+'"';return he&&(Z+=' title="'+he+'"'),Z+=">"+H+"</a>",Z},ye.image=function(le,he,H){if(le=J(this.options.sanitize,this.options.baseUrl,le),le===null)return H;var Z='<img src="'+le+'" alt="'+H+'"';return he&&(Z+=' title="'+he+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(le){return le},De}(),Y=function(){function De(){}var ye=De.prototype;return ye.strong=function(le){return le},ye.em=function(le){return le},ye.codespan=function(le){return le},ye.del=function(le){return le},ye.html=function(le){return le},ye.text=function(le){return le},ye.link=function(le,he,H){return""+H},ye.image=function(le,he,H){return""+H},ye.br=function(){return""},De}(),ce=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(le,he){var H=le,Z=0;if(this.seen.hasOwnProperty(H)){Z=this.seen[le];do Z++,H=le+"-"+Z;while(this.seen.hasOwnProperty(H))}return he||(this.seen[le]=Z,this.seen[H]=0),H},ye.slug=function(le,he){he===void 0&&(he={});var H=this.serialize(le);return this.getNextSafeSlug(H,he.dryrun)},De}(),ve=y.defaults,Re=O.unescape,we=function(){function De(ke){this.options=ke||ve,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ce}De.parse=function(le,he){var H=new De(he);return H.parse(le)},De.parseInline=function(le,he){var H=new De(he);return H.parseInline(le)};var ye=De.prototype;return ye.parse=function(le,he){he===void 0&&(he=!0);var H="",Z,ue,Ie,Pe,Ue,xe,Qe,rt,tt,Ye,ot,Et,bt,_e,fe,de,X,Oe,Le=le.length;for(Z=0;Z<Le;Z++)switch(Ye=le[Z],Ye.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Re(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(rt="",Qe="",Pe=Ye.header.length,ue=0;ue<Pe;ue++)Qe+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ue]),{header:!0,align:Ye.align[ue]});for(rt+=this.renderer.tablerow(Qe),tt="",Pe=Ye.cells.length,ue=0;ue<Pe;ue++){for(xe=Ye.tokens.cells[ue],Qe="",Ue=xe.length,Ie=0;Ie<Ue;Ie++)Qe+=this.renderer.tablecell(this.parseInline(xe[Ie]),{header:!1,align:Ye.align[Ie]});tt+=this.renderer.tablerow(Qe)}H+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Ye.tokens),H+=this.renderer.blockquote(tt);continue}case"list":{for(ot=Ye.ordered,Et=Ye.start,bt=Ye.loose,Pe=Ye.items.length,tt="",ue=0;ue<Pe;ue++)fe=Ye.items[ue],de=fe.checked,X=fe.task,_e="",fe.task&&(Oe=this.renderer.checkbox(de),bt?fe.tokens.length>0&&fe.tokens[0].type==="text"?(fe.tokens[0].text=Oe+" "+fe.tokens[0].text,fe.tokens[0].tokens&&fe.tokens[0].tokens.length>0&&fe.tokens[0].tokens[0].type==="text"&&(fe.tokens[0].tokens[0].text=Oe+" "+fe.tokens[0].tokens[0].text)):fe.tokens.unshift({type:"text",text:Oe}):_e+=Oe),_e+=this.parse(fe.tokens,bt),tt+=this.renderer.listitem(_e,X,de);H+=this.renderer.list(tt,ot,Et);continue}case"html":{H+=this.renderer.html(Ye.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(tt=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;Z+1<Le&&le[Z+1].type==="text";)Ye=le[++Z],tt+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);H+=he?this.renderer.paragraph(tt):tt;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return H},ye.parseInline=function(le,he){he=he||this.renderer;var H="",Z,ue,Ie=le.length;for(Z=0;Z<Ie;Z++)switch(ue=le[Z],ue.type){case"escape":{H+=he.text(ue.text);break}case"html":{H+=he.html(ue.text);break}case"link":{H+=he.link(ue.href,ue.title,this.parseInline(ue.tokens,he));break}case"image":{H+=he.image(ue.href,ue.title,ue.text);break}case"strong":{H+=he.strong(this.parseInline(ue.tokens,he));break}case"em":{H+=he.em(this.parseInline(ue.tokens,he));break}case"codespan":{H+=he.codespan(ue.text);break}case"br":{H+=he.br();break}case"del":{H+=he.del(this.parseInline(ue.tokens,he));break}case"text":{H+=he.text(ue.text);break}default:{var Pe='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}return H},De}(),je=O.merge,K=O.checkSanitizeDeprecation,ie=O.escape,Ee=y.getDefaults,Ne=y.changeDefaults,$e=y.defaults;function We(De,ye,ke){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(ke=ye,ye=null),ye=je({},We.defaults,ye||{}),K(ye),ke){var le=ye.highlight,he;try{he=Ke.lex(De,ye)}catch(Ie){return ke(Ie)}var H=function(Pe){var Ue;if(!Pe)try{Ue=we.parse(he,ye)}catch(xe){Pe=xe}return ye.highlight=le,Pe?ke(Pe):ke(null,Ue)};if(!le||le.length<3||(delete ye.highlight,!he.length))return H();var Z=0;We.walkTokens(he,function(Ie){Ie.type==="code"&&(Z++,setTimeout(function(){le(Ie.text,Ie.lang,function(Pe,Ue){if(Pe)return H(Pe);Ue!=null&&Ue!==Ie.text&&(Ie.text=Ue,Ie.escaped=!0),Z--,Z===0&&H()})},0))}),Z===0&&H();return}try{var ue=Ke.lex(De,ye);return ye.walkTokens&&We.walkTokens(ue,ye.walkTokens),we.parse(ue,ye)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ie(Ie.message+"",!0)+"</pre>";throw Ie}}We.options=We.setOptions=function(De){return je(We.defaults,De),Ne(We.defaults),We},We.getDefaults=Ee,We.defaults=$e,We.use=function(De){var ye=je({},De);if(De.renderer&&function(){var le=We.defaults.renderer||new ae,he=function(ue){var Ie=le[ue];le[ue]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),xe=0;xe<Pe;xe++)Ue[xe]=arguments[xe];var Qe=De.renderer[ue].apply(le,Ue);return Qe===!1&&(Qe=Ie.apply(le,Ue)),Qe}};for(var H in De.renderer)he(H);ye.renderer=le}(),De.tokenizer&&function(){var le=We.defaults.tokenizer||new N,he=function(ue){var Ie=le[ue];le[ue]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),xe=0;xe<Pe;xe++)Ue[xe]=arguments[xe];var Qe=De.tokenizer[ue].apply(le,Ue);return Qe===!1&&(Qe=Ie.apply(le,Ue)),Qe}};for(var H in De.tokenizer)he(H);ye.tokenizer=le}(),De.walkTokens){var ke=We.defaults.walkTokens;ye.walkTokens=function(le){De.walkTokens(le),ke&&ke(le)}}We.setOptions(ye)},We.walkTokens=function(De,ye){for(var ke=C(De),le;!(le=ke()).done;){var he=le.value;switch(ye(he),he.type){case"table":{for(var H=C(he.tokens.header),Z;!(Z=H()).done;){var ue=Z.value;We.walkTokens(ue,ye)}for(var Ie=C(he.tokens.cells),Pe;!(Pe=Ie()).done;)for(var Ue=Pe.value,xe=C(Ue),Qe;!(Qe=xe()).done;){var rt=Qe.value;We.walkTokens(rt,ye)}break}case"list":{We.walkTokens(he.items,ye);break}default:he.tokens&&We.walkTokens(he.tokens,ye)}}},We.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=je({},We.defaults,ye||{}),K(ye);try{var ke=Ke.lexInline(De,ye);return ye.walkTokens&&We.walkTokens(ke,ye.walkTokens),we.parseInline(ke,ye)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ie(le.message+"",!0)+"</pre>";throw le}},We.Parser=we,We.parser=we.parse,We.Renderer=ae,We.TextRenderer=Y,We.Lexer=Ke,We.lexer=Ke.lex,We.Tokenizer=N,We.Slugger=ce,We.parse=We;var Xe=We;return Xe}),define(ge[74],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(y,k,D){return Math.min(Math.max(y,k),D)}e.clamp=w;function R(y,k){return(k+y%k)%k}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function Q(C){const A=[];typeof C=="number"&&A.push("code/timeOrigin",C);function y(D){A.push(D,Date.now())}function k(){const D=[];for(let I=0;I<A.length;I+=2)D.push({name:A[I],startTime:A[I+1]});return D}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(C+y.startTime)});return A}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))}(),define(ge[11],pe([0,1]),function(Q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,A=!1,y=!1,k=!1,D=!1,I=!1,s=!1,P,c=R,p,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const _=typeof((w=h==null?void 0:h.versions)===null||w===void 0?void 0:w.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=_&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=h==null?void 0:h.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)l=navigator.userAgent,C=l.indexOf("Windows")>=0,A=l.indexOf("Macintosh")>=0,s=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=l.indexOf("Linux")>=0,I=!0,P=navigator.language,c=P;else if(typeof h=="object"){C=h.platform==="win32",A=h.platform==="darwin",y=h.platform==="linux",k=y&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,P=R,c=R;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),m=o.availableLanguages["*"];P=o.locale,c=m||R,p=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let d=0;A?d=1:C?d=3:y&&(d=2),e.isWindows=C,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=k,e.isNative=D,e.isWeb=I,e.isIOS=s,e.platform=d,e.userAgent=l,e.language=c;var f;(function(r){function o(){return e.language}r.value=o;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=m;function g(){return e.language==="en"}r.isDefault=g})(f=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let m=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let b=0,a=m.length;b<a;b++){const L=m[b];if(L.id===E.data.vscodeSetImmediateId){m.splice(b,1),L.callback();return}}});let g=0;return E=>{const b=++g;m.push({id:b,callback:E}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const o=Promise.resolve();return m=>o.then(m)}();var u;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||s?2:C?1:3;let t=!0,n=!1;function i(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(ge[36],pe([0,1,11]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const C=w.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(A){return w.setImmediate(A)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(C){return w.setImmediate(C)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(ge[9],pe([0,1,36]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,A=90,y=122,k=46,D=47,I=92,s=58,P=63;class c extends Error{constructor(f,u,t){let n;typeof u=="string"&&u.indexOf("not ")===0?(n="must not be",u=u.replace(/^not /,"")):n="must be";const i=f.indexOf(".")!==-1?"property":"argument";let r=`The "${f}" ${i} ${n} of type ${u}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(d,f){if(typeof d!="string")throw new c(f,"string",d)}function l(d){return d===D||d===I}function h(d){return d===D}function _(d){return d>=R&&d<=A||d>=C&&d<=y}function v(d,f,u,t){let n="",i=0,r=-1,o=0,m=0;for(let g=0;g<=d.length;++g){if(g<d.length)m=d.charCodeAt(g);else{if(t(m))break;m=D}if(t(m)){if(!(r===g-1||o===1))if(o===2){if(n.length<2||i!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const E=n.lastIndexOf(u);E===-1?(n="",i=0):(n=n.slice(0,E),i=n.length-1-n.lastIndexOf(u)),r=g,o=0;continue}else if(n.length!==0){n="",i=0,r=g,o=0;continue}}f&&(n+=n.length>0?`${u}..`:"..",i=2)}else n.length>0?n+=`${u}${d.slice(r+1,g)}`:n=d.slice(r+1,g),i=g-r-1;r=g,o=0}else m===k&&o!==-1?++o:o=-1}return n}function S(d,f){if(f===null||typeof f!="object")throw new c("pathObject","Object",f);const u=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return u?u===f.root?`${u}${t}`:`${u}${d}${t}`:t}e.win32={resolve(...d){let f="",u="",t=!1;for(let n=d.length-1;n>=-1;n--){let i;if(n>=0){if(i=d[n],p(i,"path"),i.length===0)continue}else f.length===0?i=w.cwd():(i=w.env[`=${f}`]||w.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==f.toLowerCase()&&i.charCodeAt(2)===I)&&(i=`${f}\\`));const r=i.length;let o=0,m="",g=!1;const E=i.charCodeAt(0);if(r===1)l(E)&&(o=1,g=!0);else if(l(E))if(g=!0,l(i.charCodeAt(1))){let b=2,a=b;for(;b<r&&!l(i.charCodeAt(b));)b++;if(b<r&&b!==a){const L=i.slice(a,b);for(a=b;b<r&&l(i.charCodeAt(b));)b++;if(b<r&&b!==a){for(a=b;b<r&&!l(i.charCodeAt(b));)b++;(b===r||b!==a)&&(m=`\\\\${L}\\${i.slice(a,b)}`,o=b)}}}else o=1;else _(E)&&i.charCodeAt(1)===s&&(m=i.slice(0,2),o=2,r>2&&l(i.charCodeAt(2))&&(g=!0,o=3));if(m.length>0)if(f.length>0){if(m.toLowerCase()!==f.toLowerCase())continue}else f=m;if(t){if(f.length>0)break}else if(u=`${i.slice(o)}\\${u}`,t=g,g&&f.length>0)break}return u=v(u,!t,"\\",l),t?`${f}\\${u}`:`${f}${u}`||"."},normalize(d){p(d,"path");const f=d.length;if(f===0)return".";let u=0,t,n=!1;const i=d.charCodeAt(0);if(f===1)return h(i)?"\\":d;if(l(i))if(n=!0,l(d.charCodeAt(1))){let o=2,m=o;for(;o<f&&!l(d.charCodeAt(o));)o++;if(o<f&&o!==m){const g=d.slice(m,o);for(m=o;o<f&&l(d.charCodeAt(o));)o++;if(o<f&&o!==m){for(m=o;o<f&&!l(d.charCodeAt(o));)o++;if(o===f)return`\\\\${g}\\${d.slice(m)}\\`;o!==m&&(t=`\\\\${g}\\${d.slice(m,o)}`,u=o)}}}else u=1;else _(i)&&d.charCodeAt(1)===s&&(t=d.slice(0,2),u=2,f>2&&l(d.charCodeAt(2))&&(n=!0,u=3));let r=u<f?v(d.slice(u),!n,"\\",l):"";return r.length===0&&!n&&(r="."),r.length>0&&l(d.charCodeAt(f-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(d){p(d,"path");const f=d.length;if(f===0)return!1;const u=d.charCodeAt(0);return l(u)||f>2&&_(u)&&d.charCodeAt(1)===s&&l(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let f,u;for(let i=0;i<d.length;++i){const r=d[i];p(r,"path"),r.length>0&&(f===void 0?f=u=r:f+=`\\${r}`)}if(f===void 0)return".";let t=!0,n=0;if(typeof u=="string"&&l(u.charCodeAt(0))){++n;const i=u.length;i>1&&l(u.charCodeAt(1))&&(++n,i>2&&(l(u.charCodeAt(2))?++n:t=!1))}if(t){for(;n<f.length&&l(f.charCodeAt(n));)n++;n>=2&&(f=`\\${f.slice(n)}`)}return e.win32.normalize(f)},relative(d,f){if(p(d,"from"),p(f,"to"),d===f)return"";const u=e.win32.resolve(d),t=e.win32.resolve(f);if(u===t||(d=u.toLowerCase(),f=t.toLowerCase(),d===f))return"";let n=0;for(;n<d.length&&d.charCodeAt(n)===I;)n++;let i=d.length;for(;i-1>n&&d.charCodeAt(i-1)===I;)i--;const r=i-n;let o=0;for(;o<f.length&&f.charCodeAt(o)===I;)o++;let m=f.length;for(;m-1>o&&f.charCodeAt(m-1)===I;)m--;const g=m-o,E=r<g?r:g;let b=-1,a=0;for(;a<E;a++){const O=d.charCodeAt(n+a);if(O!==f.charCodeAt(o+a))break;O===I&&(b=a)}if(a!==E){if(b===-1)return t}else{if(g>E){if(f.charCodeAt(o+a)===I)return t.slice(o+a+1);if(a===2)return t.slice(o+a)}r>E&&(d.charCodeAt(n+a)===I?b=a:a===2&&(b=3)),b===-1&&(b=0)}let L="";for(a=n+b+1;a<=i;++a)(a===i||d.charCodeAt(a)===I)&&(L+=L.length===0?"..":"\\..");return o+=b,L.length>0?`${L}${t.slice(o,m)}`:(t.charCodeAt(o)===I&&++o,t.slice(o,m))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const f=e.win32.resolve(d);if(f.length<=2)return d;if(f.charCodeAt(0)===I){if(f.charCodeAt(1)===I){const u=f.charCodeAt(2);if(u!==P&&u!==k)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(_(f.charCodeAt(0))&&f.charCodeAt(1)===s&&f.charCodeAt(2)===I)return`\\\\?\\${f}`;return d},dirname(d){p(d,"path");const f=d.length;if(f===0)return".";let u=-1,t=0;const n=d.charCodeAt(0);if(f===1)return l(n)?d:".";if(l(n)){if(u=t=1,l(d.charCodeAt(1))){let o=2,m=o;for(;o<f&&!l(d.charCodeAt(o));)o++;if(o<f&&o!==m){for(m=o;o<f&&l(d.charCodeAt(o));)o++;if(o<f&&o!==m){for(m=o;o<f&&!l(d.charCodeAt(o));)o++;if(o===f)return d;o!==m&&(u=t=o+1)}}}}else _(n)&&d.charCodeAt(1)===s&&(u=f>2&&l(d.charCodeAt(2))?3:2,t=u);let i=-1,r=!0;for(let o=f-1;o>=t;--o)if(l(d.charCodeAt(o))){if(!r){i=o;break}}else r=!1;if(i===-1){if(u===-1)return".";i=u}return d.slice(0,i)},basename(d,f){f!==void 0&&p(f,"ext"),p(d,"path");let u=0,t=-1,n=!0,i;if(d.length>=2&&_(d.charCodeAt(0))&&d.charCodeAt(1)===s&&(u=2),f!==void 0&&f.length>0&&f.length<=d.length){if(f===d)return"";let r=f.length-1,o=-1;for(i=d.length-1;i>=u;--i){const m=d.charCodeAt(i);if(l(m)){if(!n){u=i+1;break}}else o===-1&&(n=!1,o=i+1),r>=0&&(m===f.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=o))}return u===t?t=o:t===-1&&(t=d.length),d.slice(u,t)}for(i=d.length-1;i>=u;--i)if(l(d.charCodeAt(i))){if(!n){u=i+1;break}}else t===-1&&(n=!1,t=i+1);return t===-1?"":d.slice(u,t)},extname(d){p(d,"path");let f=0,u=-1,t=0,n=-1,i=!0,r=0;d.length>=2&&d.charCodeAt(1)===s&&_(d.charCodeAt(0))&&(f=t=2);for(let o=d.length-1;o>=f;--o){const m=d.charCodeAt(o);if(l(m)){if(!i){t=o+1;break}continue}n===-1&&(i=!1,n=o+1),m===k?u===-1?u=o:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||n===-1||r===0||r===1&&u===n-1&&u===t+1?"":d.slice(u,n)},format:S.bind(null,"\\"),parse(d){p(d,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return f;const u=d.length;let t=0,n=d.charCodeAt(0);if(u===1)return l(n)?(f.root=f.dir=d,f):(f.base=f.name=d,f);if(l(n)){if(t=1,l(d.charCodeAt(1))){let b=2,a=b;for(;b<u&&!l(d.charCodeAt(b));)b++;if(b<u&&b!==a){for(a=b;b<u&&l(d.charCodeAt(b));)b++;if(b<u&&b!==a){for(a=b;b<u&&!l(d.charCodeAt(b));)b++;b===u?t=b:b!==a&&(t=b+1)}}}}else if(_(n)&&d.charCodeAt(1)===s){if(u<=2)return f.root=f.dir=d,f;if(t=2,l(d.charCodeAt(2))){if(u===3)return f.root=f.dir=d,f;t=3}}t>0&&(f.root=d.slice(0,t));let i=-1,r=t,o=-1,m=!0,g=d.length-1,E=0;for(;g>=t;--g){if(n=d.charCodeAt(g),l(n)){if(!m){r=g+1;break}continue}o===-1&&(m=!1,o=g+1),n===k?i===-1?i=g:E!==1&&(E=1):i!==-1&&(E=-1)}return o!==-1&&(i===-1||E===0||E===1&&i===o-1&&i===r+1?f.base=f.name=d.slice(r,o):(f.name=d.slice(r,i),f.base=d.slice(r,o),f.ext=d.slice(i,o))),r>0&&r!==t?f.dir=d.slice(0,r-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let f="",u=!1;for(let t=d.length-1;t>=-1&&!u;t--){const n=t>=0?d[t]:w.cwd();p(n,"path"),n.length!==0&&(f=`${n}/${f}`,u=n.charCodeAt(0)===D)}return f=v(f,!u,"/",h),u?`/${f}`:f.length>0?f:"."},normalize(d){if(p(d,"path"),d.length===0)return".";const f=d.charCodeAt(0)===D,u=d.charCodeAt(d.length-1)===D;return d=v(d,!f,"/",h),d.length===0?f?"/":u?"./":".":(u&&(d+="/"),f?`/${d}`:d)},isAbsolute(d){return p(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let f;for(let u=0;u<d.length;++u){const t=d[u];p(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(d,f){if(p(d,"from"),p(f,"to"),d===f||(d=e.posix.resolve(d),f=e.posix.resolve(f),d===f))return"";const u=1,t=d.length,n=t-u,i=1,r=f.length-i,o=n<r?n:r;let m=-1,g=0;for(;g<o;g++){const b=d.charCodeAt(u+g);if(b!==f.charCodeAt(i+g))break;b===D&&(m=g)}if(g===o)if(r>o){if(f.charCodeAt(i+g)===D)return f.slice(i+g+1);if(g===0)return f.slice(i+g)}else n>o&&(d.charCodeAt(u+g)===D?m=g:g===0&&(m=0));let E="";for(g=u+m+1;g<=t;++g)(g===t||d.charCodeAt(g)===D)&&(E+=E.length===0?"..":"/..");return`${E}${f.slice(i+m)}`},toNamespacedPath(d){return d},dirname(d){if(p(d,"path"),d.length===0)return".";const f=d.charCodeAt(0)===D;let u=-1,t=!0;for(let n=d.length-1;n>=1;--n)if(d.charCodeAt(n)===D){if(!t){u=n;break}}else t=!1;return u===-1?f?"/":".":f&&u===1?"//":d.slice(0,u)},basename(d,f){f!==void 0&&p(f,"ext"),p(d,"path");let u=0,t=-1,n=!0,i;if(f!==void 0&&f.length>0&&f.length<=d.length){if(f===d)return"";let r=f.length-1,o=-1;for(i=d.length-1;i>=0;--i){const m=d.charCodeAt(i);if(m===D){if(!n){u=i+1;break}}else o===-1&&(n=!1,o=i+1),r>=0&&(m===f.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=o))}return u===t?t=o:t===-1&&(t=d.length),d.slice(u,t)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===D){if(!n){u=i+1;break}}else t===-1&&(n=!1,t=i+1);return t===-1?"":d.slice(u,t)},extname(d){p(d,"path");let f=-1,u=0,t=-1,n=!0,i=0;for(let r=d.length-1;r>=0;--r){const o=d.charCodeAt(r);if(o===D){if(!n){u=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===k?f===-1?f=r:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||t===-1||i===0||i===1&&f===t-1&&f===u+1?"":d.slice(f,t)},format:S.bind(null,"/"),parse(d){p(d,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return f;const u=d.charCodeAt(0)===D;let t;u?(f.root="/",t=1):t=0;let n=-1,i=0,r=-1,o=!0,m=d.length-1,g=0;for(;m>=t;--m){const E=d.charCodeAt(m);if(E===D){if(!o){i=m+1;break}continue}r===-1&&(o=!1,r=m+1),E===k?n===-1?n=m:g!==1&&(g=1):n!==-1&&(g=-1)}if(r!==-1){const E=i===0&&u?1:i;n===-1||g===0||g===1&&n===r-1&&n===i+1?f.base=f.name=d.slice(E,r):(f.name=d.slice(E,n),f.base=d.slice(E,r),f.ext=d.slice(n,r))}return i>0?f.dir=d.slice(0,i-1):u&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[136],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var R;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(A,...y){const k=y.reduce((s,P)=>(s[P]=!0,s),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(s=>!k[s]).forEach(s=>{for(let P=0;P<D.length;P++)if(s.search(D[P])!==-1){delete A[s];break}})}e.sanitizeProcessEnvironment=C}),define(ge[44],pe([0,1,11]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=w.globals.performance&&typeof w.globals.performance.now=="function";class C{constructor(y){this._highResolution=R&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new C(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ge[3],pe([0,1,16,72,6,56,44]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(v){v.None=()=>C.Disposable.None;function S(V){return(B,j=null,T)=>{let N=!1,F;return F=V(M=>{if(!N)return F?F.dispose():N=!0,B.call(j,M)},null,T),N&&F.dispose(),F}}v.once=S;function d(V,B){return r((j,T=null,N)=>V(F=>j.call(T,B(F)),null,N))}v.map=d;function f(V,B){return r((j,T=null,N)=>V(F=>{B(F),j.call(T,F)},null,N))}v.forEach=f;function u(V,B){return r((j,T=null,N)=>V(F=>B(F)&&j.call(T,F),null,N))}v.filter=u;function t(V){return V}v.signal=t;function n(...V){return(B,j=null,T)=>C.combinedDisposable(...V.map(N=>N(F=>B.call(j,F),null,T)))}v.any=n;function i(V,B,j){let T=j;return d(V,N=>(T=B(T,N),T))}v.reduce=i;function r(V){let B;const j=new c({onFirstListenerAdd(){B=V(j.fire,j)},onLastListenerRemove(){B.dispose()}});return j.event}v.snapshot=r;function o(V,B,j=100,T=!1,N){let F,M,U,x=0;const G=new c({leakWarningThreshold:N,onFirstListenerAdd(){F=V(se=>{x++,M=B(M,se),T&&!U&&(G.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const be=M;M=void 0,U=void 0,(!T||x>1)&&G.fire(be),x=0},j)})},onLastListenerRemove(){F.dispose()}});return G.event}v.debounce=o;function m(V){const B=new Date().getTime();return d(S(V),j=>new Date().getTime()-B)}v.stopwatch=m;function g(V,B=(j,T)=>j===T){let j=!0,T;return u(V,N=>{const F=j||!B(N,T);return j=!1,T=N,F})}v.latch=g;function E(V,B){return[v.filter(V,B),v.filter(V,j=>!B(j))]}v.split=E;function b(V,B=!1,j=[]){let T=j.slice(),N=V(U=>{T?T.push(U):M.fire(U)});const F=()=>{T&&T.forEach(U=>M.fire(U)),T=null},M=new c({onFirstListenerAdd(){N||(N=V(U=>M.fire(U)))},onFirstListenerDidAdd(){T&&(B?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return M.event}v.buffer=b;class a{constructor(B){this.event=B}map(B){return new a(d(this.event,B))}forEach(B){return new a(f(this.event,B))}filter(B){return new a(u(this.event,B))}reduce(B,j){return new a(i(this.event,B,j))}latch(){return new a(g(this.event))}debounce(B,j=100,T=!1,N){return new a(o(this.event,B,j,T,N))}on(B,j,T){return this.event(B,j,T)}once(B,j,T){return S(this.event)(B,j,T)}}function L(V){return new a(V)}v.chain=L;function O(V,B,j=T=>T){const T=(...U)=>M.fire(j(...U)),N=()=>V.on(B,T),F=()=>V.removeListener(B,T),M=new c({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}v.fromNodeEventEmitter=O;function W(V,B,j=T=>T){const T=(...U)=>M.fire(j(...U)),N=()=>V.addEventListener(B,T),F=()=>V.removeEventListener(B,T),M=new c({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}v.fromDOMEventEmitter=W;function ee(V){const B=new c;let j=!1;return V.then(void 0,()=>null).then(()=>{j?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),j=!0,B.event}v.fromPromise=ee;function oe(V){return new Promise(B=>S(V)(B))}v.toPromise=oe})(k=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let I=-1;function s(v){const S=I;return I=v,{dispose(){I=S}}}e.setGlobalLeakWarningThreshold=s;class P{constructor(S,d=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let d=I;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),d<=0||S<d)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),u=this._stacks.get(f)||0;if(this._stacks.set(f,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,n=0;for(const[i,r]of this._stacks)(!t||n<r)&&(t=i,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(f)||0;this._stacks.set(f,t-1)}}}class c{constructor(S){var d;this._disposed=!1,this._options=S,this._leakageMon=I>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,d,f)=>{var u;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(d?[S,d]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,d);const i=(u=this._leakageMon)===null||u===void 0?void 0:u.check(this._listeners.size);let r;return r={dispose:()=>{i&&i(),r.dispose=c._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},f instanceof C.DisposableStore?f.add(r):Array.isArray(f)&&f.push(r),r}),this._event}fire(S){var d,f;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,S]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,t]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,t):u[0].call(u[1],t)}catch(n){w.onUnexpectedError(n)}}(f=this._perfMon)===null||f===void 0||f.stop()}}dispose(){var S,d,f,u,t;this._disposed||(this._disposed=!0,(S=this._listeners)===null||S===void 0||S.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(u=(f=this._options)===null||f===void 0?void 0:f.onLastListenerRemove)===null||u===void 0||u.call(f),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=c,c._noop=function(){};class p extends c{constructor(S){super(S);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=p;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const d={event:S,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const f=()=>{this.hasListeners&&this.unhook(d);const u=this.events.indexOf(d);this.events.splice(u,1)};return C.toDisposable(R.once(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(d=>this.emitter.fire(d))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class h{constructor(){this.buffers=[]}wrapEvent(S){return(d,f,u)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>d.call(f,t)):d.call(f,t)},void 0,u)}bufferEvents(S){const d=[];this.buffers.push(d);const f=S();return this.buffers.pop(),d.forEach(u=>u()),f}}e.EventBufferer=h;class _{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=C.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(ge[21],pe([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(k,D){const I=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(I)}}});var C;(function(k){function D(I){return I===k.None||I===k.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=C.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=y}),define(ge[45],pe([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(P){const c=this._icons.get(P.id);c?P.description?c.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function A(s,P){return new k(s,P)}e.registerCodicon=A;function y(s){return s?s.replace(/\$\((.*?)\)/g,(P,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=y;class k{constructor(P,c,p){this.id=P,this.definition=c,this.description=p,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(s,P){const c=["codicon","codicon-"+s];return P&&c.push("codicon-modifier-"+P),c}e.getClassNamesArray=D;var I;(function(s){s.iconNameSegment="[A-Za-z0-9]+",s.iconNameExpression="[A-Za-z0-9\\-]+",s.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${s.iconNameExpression})(${s.iconModifierExpression})?$`);function c(h){if(h instanceof k)return["codicon","codicon-"+h.id];const _=P.exec(h.id);if(!_)return c(k.error);let[,v,S]=_;const d=["codicon","codicon-"+v];return S&&d.push("codicon-modifier-"+S.substr(1)),d}s.asClassNameArray=c;function p(h){return c(h).join(" ")}s.asClassName=p;function l(h){return"."+c(h).join(".")}s.asCSSSelector=l})(I=e.CSSIcon||(e.CSSIcon={})),function(s){s.add=new s("add",{fontCharacter:"\\ea60"}),s.plus=new s("plus",{fontCharacter:"\\ea60"}),s.gistNew=new s("gist-new",{fontCharacter:"\\ea60"}),s.repoCreate=new s("repo-create",{fontCharacter:"\\ea60"}),s.lightbulb=new s("lightbulb",{fontCharacter:"\\ea61"}),s.lightBulb=new s("light-bulb",{fontCharacter:"\\ea61"}),s.repo=new s("repo",{fontCharacter:"\\ea62"}),s.repoDelete=new s("repo-delete",{fontCharacter:"\\ea62"}),s.gistFork=new s("gist-fork",{fontCharacter:"\\ea63"}),s.repoForked=new s("repo-forked",{fontCharacter:"\\ea63"}),s.gitPullRequest=new s("git-pull-request",{fontCharacter:"\\ea64"}),s.gitPullRequestAbandoned=new s("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),s.recordKeys=new s("record-keys",{fontCharacter:"\\ea65"}),s.keyboard=new s("keyboard",{fontCharacter:"\\ea65"}),s.tag=new s("tag",{fontCharacter:"\\ea66"}),s.tagAdd=new s("tag-add",{fontCharacter:"\\ea66"}),s.tagRemove=new s("tag-remove",{fontCharacter:"\\ea66"}),s.person=new s("person",{fontCharacter:"\\ea67"}),s.personFollow=new s("person-follow",{fontCharacter:"\\ea67"}),s.personOutline=new s("person-outline",{fontCharacter:"\\ea67"}),s.personFilled=new s("person-filled",{fontCharacter:"\\ea67"}),s.gitBranch=new s("git-branch",{fontCharacter:"\\ea68"}),s.gitBranchCreate=new s("git-branch-create",{fontCharacter:"\\ea68"}),s.gitBranchDelete=new s("git-branch-delete",{fontCharacter:"\\ea68"}),s.sourceControl=new s("source-control",{fontCharacter:"\\ea68"}),s.mirror=new s("mirror",{fontCharacter:"\\ea69"}),s.mirrorPublic=new s("mirror-public",{fontCharacter:"\\ea69"}),s.star=new s("star",{fontCharacter:"\\ea6a"}),s.starAdd=new s("star-add",{fontCharacter:"\\ea6a"}),s.starDelete=new s("star-delete",{fontCharacter:"\\ea6a"}),s.starEmpty=new s("star-empty",{fontCharacter:"\\ea6a"}),s.comment=new s("comment",{fontCharacter:"\\ea6b"}),s.commentAdd=new s("comment-add",{fontCharacter:"\\ea6b"}),s.alert=new s("alert",{fontCharacter:"\\ea6c"}),s.warning=new s("warning",{fontCharacter:"\\ea6c"}),s.search=new s("search",{fontCharacter:"\\ea6d"}),s.searchSave=new s("search-save",{fontCharacter:"\\ea6d"}),s.logOut=new s("log-out",{fontCharacter:"\\ea6e"}),s.signOut=new s("sign-out",{fontCharacter:"\\ea6e"}),s.logIn=new s("log-in",{fontCharacter:"\\ea6f"}),s.signIn=new s("sign-in",{fontCharacter:"\\ea6f"}),s.eye=new s("eye",{fontCharacter:"\\ea70"}),s.eyeUnwatch=new s("eye-unwatch",{fontCharacter:"\\ea70"}),s.eyeWatch=new s("eye-watch",{fontCharacter:"\\ea70"}),s.circleFilled=new s("circle-filled",{fontCharacter:"\\ea71"}),s.primitiveDot=new s("primitive-dot",{fontCharacter:"\\ea71"}),s.closeDirty=new s("close-dirty",{fontCharacter:"\\ea71"}),s.debugBreakpoint=new s("debug-breakpoint",{fontCharacter:"\\ea71"}),s.debugBreakpointDisabled=new s("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),s.debugHint=new s("debug-hint",{fontCharacter:"\\ea71"}),s.primitiveSquare=new s("primitive-square",{fontCharacter:"\\ea72"}),s.edit=new s("edit",{fontCharacter:"\\ea73"}),s.pencil=new s("pencil",{fontCharacter:"\\ea73"}),s.info=new s("info",{fontCharacter:"\\ea74"}),s.issueOpened=new s("issue-opened",{fontCharacter:"\\ea74"}),s.gistPrivate=new s("gist-private",{fontCharacter:"\\ea75"}),s.gitForkPrivate=new s("git-fork-private",{fontCharacter:"\\ea75"}),s.lock=new s("lock",{fontCharacter:"\\ea75"}),s.mirrorPrivate=new s("mirror-private",{fontCharacter:"\\ea75"}),s.close=new s("close",{fontCharacter:"\\ea76"}),s.removeClose=new s("remove-close",{fontCharacter:"\\ea76"}),s.x=new s("x",{fontCharacter:"\\ea76"}),s.repoSync=new s("repo-sync",{fontCharacter:"\\ea77"}),s.sync=new s("sync",{fontCharacter:"\\ea77"}),s.clone=new s("clone",{fontCharacter:"\\ea78"}),s.desktopDownload=new s("desktop-download",{fontCharacter:"\\ea78"}),s.beaker=new s("beaker",{fontCharacter:"\\ea79"}),s.microscope=new s("microscope",{fontCharacter:"\\ea79"}),s.vm=new s("vm",{fontCharacter:"\\ea7a"}),s.deviceDesktop=new s("device-desktop",{fontCharacter:"\\ea7a"}),s.file=new s("file",{fontCharacter:"\\ea7b"}),s.fileText=new s("file-text",{fontCharacter:"\\ea7b"}),s.more=new s("more",{fontCharacter:"\\ea7c"}),s.ellipsis=new s("ellipsis",{fontCharacter:"\\ea7c"}),s.kebabHorizontal=new s("kebab-horizontal",{fontCharacter:"\\ea7c"}),s.mailReply=new s("mail-reply",{fontCharacter:"\\ea7d"}),s.reply=new s("reply",{fontCharacter:"\\ea7d"}),s.organization=new s("organization",{fontCharacter:"\\ea7e"}),s.organizationFilled=new s("organization-filled",{fontCharacter:"\\ea7e"}),s.organizationOutline=new s("organization-outline",{fontCharacter:"\\ea7e"}),s.newFile=new s("new-file",{fontCharacter:"\\ea7f"}),s.fileAdd=new s("file-add",{fontCharacter:"\\ea7f"}),s.newFolder=new s("new-folder",{fontCharacter:"\\ea80"}),s.fileDirectoryCreate=new s("file-directory-create",{fontCharacter:"\\ea80"}),s.trash=new s("trash",{fontCharacter:"\\ea81"}),s.trashcan=new s("trashcan",{fontCharacter:"\\ea81"}),s.history=new s("history",{fontCharacter:"\\ea82"}),s.clock=new s("clock",{fontCharacter:"\\ea82"}),s.folder=new s("folder",{fontCharacter:"\\ea83"}),s.fileDirectory=new s("file-directory",{fontCharacter:"\\ea83"}),s.symbolFolder=new s("symbol-folder",{fontCharacter:"\\ea83"}),s.logoGithub=new s("logo-github",{fontCharacter:"\\ea84"}),s.markGithub=new s("mark-github",{fontCharacter:"\\ea84"}),s.github=new s("github",{fontCharacter:"\\ea84"}),s.terminal=new s("terminal",{fontCharacter:"\\ea85"}),s.console=new s("console",{fontCharacter:"\\ea85"}),s.repl=new s("repl",{fontCharacter:"\\ea85"}),s.zap=new s("zap",{fontCharacter:"\\ea86"}),s.symbolEvent=new s("symbol-event",{fontCharacter:"\\ea86"}),s.error=new s("error",{fontCharacter:"\\ea87"}),s.stop=new s("stop",{fontCharacter:"\\ea87"}),s.variable=new s("variable",{fontCharacter:"\\ea88"}),s.symbolVariable=new s("symbol-variable",{fontCharacter:"\\ea88"}),s.array=new s("array",{fontCharacter:"\\ea8a"}),s.symbolArray=new s("symbol-array",{fontCharacter:"\\ea8a"}),s.symbolModule=new s("symbol-module",{fontCharacter:"\\ea8b"}),s.symbolPackage=new s("symbol-package",{fontCharacter:"\\ea8b"}),s.symbolNamespace=new s("symbol-namespace",{fontCharacter:"\\ea8b"}),s.symbolObject=new s("symbol-object",{fontCharacter:"\\ea8b"}),s.symbolMethod=new s("symbol-method",{fontCharacter:"\\ea8c"}),s.symbolFunction=new s("symbol-function",{fontCharacter:"\\ea8c"}),s.symbolConstructor=new s("symbol-constructor",{fontCharacter:"\\ea8c"}),s.symbolBoolean=new s("symbol-boolean",{fontCharacter:"\\ea8f"}),s.symbolNull=new s("symbol-null",{fontCharacter:"\\ea8f"}),s.symbolNumeric=new s("symbol-numeric",{fontCharacter:"\\ea90"}),s.symbolNumber=new s("symbol-number",{fontCharacter:"\\ea90"}),s.symbolStructure=new s("symbol-structure",{fontCharacter:"\\ea91"}),s.symbolStruct=new s("symbol-struct",{fontCharacter:"\\ea91"}),s.symbolParameter=new s("symbol-parameter",{fontCharacter:"\\ea92"}),s.symbolTypeParameter=new s("symbol-type-parameter",{fontCharacter:"\\ea92"}),s.symbolKey=new s("symbol-key",{fontCharacter:"\\ea93"}),s.symbolText=new s("symbol-text",{fontCharacter:"\\ea93"}),s.symbolReference=new s("symbol-reference",{fontCharacter:"\\ea94"}),s.goToFile=new s("go-to-file",{fontCharacter:"\\ea94"}),s.symbolEnum=new s("symbol-enum",{fontCharacter:"\\ea95"}),s.symbolValue=new s("symbol-value",{fontCharacter:"\\ea95"}),s.symbolRuler=new s("symbol-ruler",{fontCharacter:"\\ea96"}),s.symbolUnit=new s("symbol-unit",{fontCharacter:"\\ea96"}),s.activateBreakpoints=new s("activate-breakpoints",{fontCharacter:"\\ea97"}),s.archive=new s("archive",{fontCharacter:"\\ea98"}),s.arrowBoth=new s("arrow-both",{fontCharacter:"\\ea99"}),s.arrowDown=new s("arrow-down",{fontCharacter:"\\ea9a"}),s.arrowLeft=new s("arrow-left",{fontCharacter:"\\ea9b"}),s.arrowRight=new s("arrow-right",{fontCharacter:"\\ea9c"}),s.arrowSmallDown=new s("arrow-small-down",{fontCharacter:"\\ea9d"}),s.arrowSmallLeft=new s("arrow-small-left",{fontCharacter:"\\ea9e"}),s.arrowSmallRight=new s("arrow-small-right",{fontCharacter:"\\ea9f"}),s.arrowSmallUp=new s("arrow-small-up",{fontCharacter:"\\eaa0"}),s.arrowUp=new s("arrow-up",{fontCharacter:"\\eaa1"}),s.bell=new s("bell",{fontCharacter:"\\eaa2"}),s.bold=new s("bold",{fontCharacter:"\\eaa3"}),s.book=new s("book",{fontCharacter:"\\eaa4"}),s.bookmark=new s("bookmark",{fontCharacter:"\\eaa5"}),s.debugBreakpointConditionalUnverified=new s("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),s.debugBreakpointConditional=new s("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),s.debugBreakpointConditionalDisabled=new s("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),s.debugBreakpointDataUnverified=new s("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),s.debugBreakpointData=new s("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),s.debugBreakpointDataDisabled=new s("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),s.debugBreakpointLogUnverified=new s("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),s.debugBreakpointLog=new s("debug-breakpoint-log",{fontCharacter:"\\eaab"}),s.debugBreakpointLogDisabled=new s("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),s.briefcase=new s("briefcase",{fontCharacter:"\\eaac"}),s.broadcast=new s("broadcast",{fontCharacter:"\\eaad"}),s.browser=new s("browser",{fontCharacter:"\\eaae"}),s.bug=new s("bug",{fontCharacter:"\\eaaf"}),s.calendar=new s("calendar",{fontCharacter:"\\eab0"}),s.caseSensitive=new s("case-sensitive",{fontCharacter:"\\eab1"}),s.check=new s("check",{fontCharacter:"\\eab2"}),s.checklist=new s("checklist",{fontCharacter:"\\eab3"}),s.chevronDown=new s("chevron-down",{fontCharacter:"\\eab4"}),s.chevronLeft=new s("chevron-left",{fontCharacter:"\\eab5"}),s.chevronRight=new s("chevron-right",{fontCharacter:"\\eab6"}),s.chevronUp=new s("chevron-up",{fontCharacter:"\\eab7"}),s.chromeClose=new s("chrome-close",{fontCharacter:"\\eab8"}),s.chromeMaximize=new s("chrome-maximize",{fontCharacter:"\\eab9"}),s.chromeMinimize=new s("chrome-minimize",{fontCharacter:"\\eaba"}),s.chromeRestore=new s("chrome-restore",{fontCharacter:"\\eabb"}),s.circleOutline=new s("circle-outline",{fontCharacter:"\\eabc"}),s.debugBreakpointUnverified=new s("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),s.circleSlash=new s("circle-slash",{fontCharacter:"\\eabd"}),s.circuitBoard=new s("circuit-board",{fontCharacter:"\\eabe"}),s.clearAll=new s("clear-all",{fontCharacter:"\\eabf"}),s.clippy=new s("clippy",{fontCharacter:"\\eac0"}),s.closeAll=new s("close-all",{fontCharacter:"\\eac1"}),s.cloudDownload=new s("cloud-download",{fontCharacter:"\\eac2"}),s.cloudUpload=new s("cloud-upload",{fontCharacter:"\\eac3"}),s.code=new s("code",{fontCharacter:"\\eac4"}),s.collapseAll=new s("collapse-all",{fontCharacter:"\\eac5"}),s.colorMode=new s("color-mode",{fontCharacter:"\\eac6"}),s.commentDiscussion=new s("comment-discussion",{fontCharacter:"\\eac7"}),s.compareChanges=new s("compare-changes",{fontCharacter:"\\eafd"}),s.creditCard=new s("credit-card",{fontCharacter:"\\eac9"}),s.dash=new s("dash",{fontCharacter:"\\eacc"}),s.dashboard=new s("dashboard",{fontCharacter:"\\eacd"}),s.database=new s("database",{fontCharacter:"\\eace"}),s.debugContinue=new s("debug-continue",{fontCharacter:"\\eacf"}),s.debugDisconnect=new s("debug-disconnect",{fontCharacter:"\\ead0"}),s.debugPause=new s("debug-pause",{fontCharacter:"\\ead1"}),s.debugRestart=new s("debug-restart",{fontCharacter:"\\ead2"}),s.debugStart=new s("debug-start",{fontCharacter:"\\ead3"}),s.debugStepInto=new s("debug-step-into",{fontCharacter:"\\ead4"}),s.debugStepOut=new s("debug-step-out",{fontCharacter:"\\ead5"}),s.debugStepOver=new s("debug-step-over",{fontCharacter:"\\ead6"}),s.debugStop=new s("debug-stop",{fontCharacter:"\\ead7"}),s.debug=new s("debug",{fontCharacter:"\\ead8"}),s.deviceCameraVideo=new s("device-camera-video",{fontCharacter:"\\ead9"}),s.deviceCamera=new s("device-camera",{fontCharacter:"\\eada"}),s.deviceMobile=new s("device-mobile",{fontCharacter:"\\eadb"}),s.diffAdded=new s("diff-added",{fontCharacter:"\\eadc"}),s.diffIgnored=new s("diff-ignored",{fontCharacter:"\\eadd"}),s.diffModified=new s("diff-modified",{fontCharacter:"\\eade"}),s.diffRemoved=new s("diff-removed",{fontCharacter:"\\eadf"}),s.diffRenamed=new s("diff-renamed",{fontCharacter:"\\eae0"}),s.diff=new s("diff",{fontCharacter:"\\eae1"}),s.discard=new s("discard",{fontCharacter:"\\eae2"}),s.editorLayout=new s("editor-layout",{fontCharacter:"\\eae3"}),s.emptyWindow=new s("empty-window",{fontCharacter:"\\eae4"}),s.exclude=new s("exclude",{fontCharacter:"\\eae5"}),s.extensions=new s("extensions",{fontCharacter:"\\eae6"}),s.eyeClosed=new s("eye-closed",{fontCharacter:"\\eae7"}),s.fileBinary=new s("file-binary",{fontCharacter:"\\eae8"}),s.fileCode=new s("file-code",{fontCharacter:"\\eae9"}),s.fileMedia=new s("file-media",{fontCharacter:"\\eaea"}),s.filePdf=new s("file-pdf",{fontCharacter:"\\eaeb"}),s.fileSubmodule=new s("file-submodule",{fontCharacter:"\\eaec"}),s.fileSymlinkDirectory=new s("file-symlink-directory",{fontCharacter:"\\eaed"}),s.fileSymlinkFile=new s("file-symlink-file",{fontCharacter:"\\eaee"}),s.fileZip=new s("file-zip",{fontCharacter:"\\eaef"}),s.files=new s("files",{fontCharacter:"\\eaf0"}),s.filter=new s("filter",{fontCharacter:"\\eaf1"}),s.flame=new s("flame",{fontCharacter:"\\eaf2"}),s.foldDown=new s("fold-down",{fontCharacter:"\\eaf3"}),s.foldUp=new s("fold-up",{fontCharacter:"\\eaf4"}),s.fold=new s("fold",{fontCharacter:"\\eaf5"}),s.folderActive=new s("folder-active",{fontCharacter:"\\eaf6"}),s.folderOpened=new s("folder-opened",{fontCharacter:"\\eaf7"}),s.gear=new s("gear",{fontCharacter:"\\eaf8"}),s.gift=new s("gift",{fontCharacter:"\\eaf9"}),s.gistSecret=new s("gist-secret",{fontCharacter:"\\eafa"}),s.gist=new s("gist",{fontCharacter:"\\eafb"}),s.gitCommit=new s("git-commit",{fontCharacter:"\\eafc"}),s.gitCompare=new s("git-compare",{fontCharacter:"\\eafd"}),s.gitMerge=new s("git-merge",{fontCharacter:"\\eafe"}),s.githubAction=new s("github-action",{fontCharacter:"\\eaff"}),s.githubAlt=new s("github-alt",{fontCharacter:"\\eb00"}),s.globe=new s("globe",{fontCharacter:"\\eb01"}),s.grabber=new s("grabber",{fontCharacter:"\\eb02"}),s.graph=new s("graph",{fontCharacter:"\\eb03"}),s.gripper=new s("gripper",{fontCharacter:"\\eb04"}),s.heart=new s("heart",{fontCharacter:"\\eb05"}),s.home=new s("home",{fontCharacter:"\\eb06"}),s.horizontalRule=new s("horizontal-rule",{fontCharacter:"\\eb07"}),s.hubot=new s("hubot",{fontCharacter:"\\eb08"}),s.inbox=new s("inbox",{fontCharacter:"\\eb09"}),s.issueClosed=new s("issue-closed",{fontCharacter:"\\eb0a"}),s.issueReopened=new s("issue-reopened",{fontCharacter:"\\eb0b"}),s.issues=new s("issues",{fontCharacter:"\\eb0c"}),s.italic=new s("italic",{fontCharacter:"\\eb0d"}),s.jersey=new s("jersey",{fontCharacter:"\\eb0e"}),s.json=new s("json",{fontCharacter:"\\eb0f"}),s.kebabVertical=new s("kebab-vertical",{fontCharacter:"\\eb10"}),s.key=new s("key",{fontCharacter:"\\eb11"}),s.law=new s("law",{fontCharacter:"\\eb12"}),s.lightbulbAutofix=new s("lightbulb-autofix",{fontCharacter:"\\eb13"}),s.linkExternal=new s("link-external",{fontCharacter:"\\eb14"}),s.link=new s("link",{fontCharacter:"\\eb15"}),s.listOrdered=new s("list-ordered",{fontCharacter:"\\eb16"}),s.listUnordered=new s("list-unordered",{fontCharacter:"\\eb17"}),s.liveShare=new s("live-share",{fontCharacter:"\\eb18"}),s.loading=new s("loading",{fontCharacter:"\\eb19"}),s.location=new s("location",{fontCharacter:"\\eb1a"}),s.mailRead=new s("mail-read",{fontCharacter:"\\eb1b"}),s.mail=new s("mail",{fontCharacter:"\\eb1c"}),s.markdown=new s("markdown",{fontCharacter:"\\eb1d"}),s.megaphone=new s("megaphone",{fontCharacter:"\\eb1e"}),s.mention=new s("mention",{fontCharacter:"\\eb1f"}),s.milestone=new s("milestone",{fontCharacter:"\\eb20"}),s.mortarBoard=new s("mortar-board",{fontCharacter:"\\eb21"}),s.move=new s("move",{fontCharacter:"\\eb22"}),s.multipleWindows=new s("multiple-windows",{fontCharacter:"\\eb23"}),s.mute=new s("mute",{fontCharacter:"\\eb24"}),s.noNewline=new s("no-newline",{fontCharacter:"\\eb25"}),s.note=new s("note",{fontCharacter:"\\eb26"}),s.octoface=new s("octoface",{fontCharacter:"\\eb27"}),s.openPreview=new s("open-preview",{fontCharacter:"\\eb28"}),s.package_=new s("package",{fontCharacter:"\\eb29"}),s.paintcan=new s("paintcan",{fontCharacter:"\\eb2a"}),s.pin=new s("pin",{fontCharacter:"\\eb2b"}),s.play=new s("play",{fontCharacter:"\\eb2c"}),s.run=new s("run",{fontCharacter:"\\eb2c"}),s.plug=new s("plug",{fontCharacter:"\\eb2d"}),s.preserveCase=new s("preserve-case",{fontCharacter:"\\eb2e"}),s.preview=new s("preview",{fontCharacter:"\\eb2f"}),s.project=new s("project",{fontCharacter:"\\eb30"}),s.pulse=new s("pulse",{fontCharacter:"\\eb31"}),s.question=new s("question",{fontCharacter:"\\eb32"}),s.quote=new s("quote",{fontCharacter:"\\eb33"}),s.radioTower=new s("radio-tower",{fontCharacter:"\\eb34"}),s.reactions=new s("reactions",{fontCharacter:"\\eb35"}),s.references=new s("references",{fontCharacter:"\\eb36"}),s.refresh=new s("refresh",{fontCharacter:"\\eb37"}),s.regex=new s("regex",{fontCharacter:"\\eb38"}),s.remoteExplorer=new s("remote-explorer",{fontCharacter:"\\eb39"}),s.remote=new s("remote",{fontCharacter:"\\eb3a"}),s.remove=new s("remove",{fontCharacter:"\\eb3b"}),s.replaceAll=new s("replace-all",{fontCharacter:"\\eb3c"}),s.replace=new s("replace",{fontCharacter:"\\eb3d"}),s.repoClone=new s("repo-clone",{fontCharacter:"\\eb3e"}),s.repoForcePush=new s("repo-force-push",{fontCharacter:"\\eb3f"}),s.repoPull=new s("repo-pull",{fontCharacter:"\\eb40"}),s.repoPush=new s("repo-push",{fontCharacter:"\\eb41"}),s.report=new s("report",{fontCharacter:"\\eb42"}),s.requestChanges=new s("request-changes",{fontCharacter:"\\eb43"}),s.rocket=new s("rocket",{fontCharacter:"\\eb44"}),s.rootFolderOpened=new s("root-folder-opened",{fontCharacter:"\\eb45"}),s.rootFolder=new s("root-folder",{fontCharacter:"\\eb46"}),s.rss=new s("rss",{fontCharacter:"\\eb47"}),s.ruby=new s("ruby",{fontCharacter:"\\eb48"}),s.saveAll=new s("save-all",{fontCharacter:"\\eb49"}),s.saveAs=new s("save-as",{fontCharacter:"\\eb4a"}),s.save=new s("save",{fontCharacter:"\\eb4b"}),s.screenFull=new s("screen-full",{fontCharacter:"\\eb4c"}),s.screenNormal=new s("screen-normal",{fontCharacter:"\\eb4d"}),s.searchStop=new s("search-stop",{fontCharacter:"\\eb4e"}),s.server=new s("server",{fontCharacter:"\\eb50"}),s.settingsGear=new s("settings-gear",{fontCharacter:"\\eb51"}),s.settings=new s("settings",{fontCharacter:"\\eb52"}),s.shield=new s("shield",{fontCharacter:"\\eb53"}),s.smiley=new s("smiley",{fontCharacter:"\\eb54"}),s.sortPrecedence=new s("sort-precedence",{fontCharacter:"\\eb55"}),s.splitHorizontal=new s("split-horizontal",{fontCharacter:"\\eb56"}),s.splitVertical=new s("split-vertical",{fontCharacter:"\\eb57"}),s.squirrel=new s("squirrel",{fontCharacter:"\\eb58"}),s.starFull=new s("star-full",{fontCharacter:"\\eb59"}),s.starHalf=new s("star-half",{fontCharacter:"\\eb5a"}),s.symbolClass=new s("symbol-class",{fontCharacter:"\\eb5b"}),s.symbolColor=new s("symbol-color",{fontCharacter:"\\eb5c"}),s.symbolConstant=new s("symbol-constant",{fontCharacter:"\\eb5d"}),s.symbolEnumMember=new s("symbol-enum-member",{fontCharacter:"\\eb5e"}),s.symbolField=new s("symbol-field",{fontCharacter:"\\eb5f"}),s.symbolFile=new s("symbol-file",{fontCharacter:"\\eb60"}),s.symbolInterface=new s("symbol-interface",{fontCharacter:"\\eb61"}),s.symbolKeyword=new s("symbol-keyword",{fontCharacter:"\\eb62"}),s.symbolMisc=new s("symbol-misc",{fontCharacter:"\\eb63"}),s.symbolOperator=new s("symbol-operator",{fontCharacter:"\\eb64"}),s.symbolProperty=new s("symbol-property",{fontCharacter:"\\eb65"}),s.wrench=new s("wrench",{fontCharacter:"\\eb65"}),s.wrenchSubaction=new s("wrench-subaction",{fontCharacter:"\\eb65"}),s.symbolSnippet=new s("symbol-snippet",{fontCharacter:"\\eb66"}),s.tasklist=new s("tasklist",{fontCharacter:"\\eb67"}),s.telescope=new s("telescope",{fontCharacter:"\\eb68"}),s.textSize=new s("text-size",{fontCharacter:"\\eb69"}),s.threeBars=new s("three-bars",{fontCharacter:"\\eb6a"}),s.thumbsdown=new s("thumbsdown",{fontCharacter:"\\eb6b"}),s.thumbsup=new s("thumbsup",{fontCharacter:"\\eb6c"}),s.tools=new s("tools",{fontCharacter:"\\eb6d"}),s.triangleDown=new s("triangle-down",{fontCharacter:"\\eb6e"}),s.triangleLeft=new s("triangle-left",{fontCharacter:"\\eb6f"}),s.triangleRight=new s("triangle-right",{fontCharacter:"\\eb70"}),s.triangleUp=new s("triangle-up",{fontCharacter:"\\eb71"}),s.twitter=new s("twitter",{fontCharacter:"\\eb72"}),s.unfold=new s("unfold",{fontCharacter:"\\eb73"}),s.unlock=new s("unlock",{fontCharacter:"\\eb74"}),s.unmute=new s("unmute",{fontCharacter:"\\eb75"}),s.unverified=new s("unverified",{fontCharacter:"\\eb76"}),s.verified=new s("verified",{fontCharacter:"\\eb77"}),s.versions=new s("versions",{fontCharacter:"\\eb78"}),s.vmActive=new s("vm-active",{fontCharacter:"\\eb79"}),s.vmOutline=new s("vm-outline",{fontCharacter:"\\eb7a"}),s.vmRunning=new s("vm-running",{fontCharacter:"\\eb7b"}),s.watch=new s("watch",{fontCharacter:"\\eb7c"}),s.whitespace=new s("whitespace",{fontCharacter:"\\eb7d"}),s.wholeWord=new s("whole-word",{fontCharacter:"\\eb7e"}),s.window=new s("window",{fontCharacter:"\\eb7f"}),s.wordWrap=new s("word-wrap",{fontCharacter:"\\eb80"}),s.zoomIn=new s("zoom-in",{fontCharacter:"\\eb81"}),s.zoomOut=new s("zoom-out",{fontCharacter:"\\eb82"}),s.listFilter=new s("list-filter",{fontCharacter:"\\eb83"}),s.listFlat=new s("list-flat",{fontCharacter:"\\eb84"}),s.listSelection=new s("list-selection",{fontCharacter:"\\eb85"}),s.selection=new s("selection",{fontCharacter:"\\eb85"}),s.listTree=new s("list-tree",{fontCharacter:"\\eb86"}),s.debugBreakpointFunctionUnverified=new s("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),s.debugBreakpointFunction=new s("debug-breakpoint-function",{fontCharacter:"\\eb88"}),s.debugBreakpointFunctionDisabled=new s("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),s.debugStackframeActive=new s("debug-stackframe-active",{fontCharacter:"\\eb89"}),s.debugStackframeDot=new s("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),s.debugStackframe=new s("debug-stackframe",{fontCharacter:"\\eb8b"}),s.debugStackframeFocused=new s("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),s.debugBreakpointUnsupported=new s("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),s.symbolString=new s("symbol-string",{fontCharacter:"\\eb8d"}),s.debugReverseContinue=new s("debug-reverse-continue",{fontCharacter:"\\eb8e"}),s.debugStepBack=new s("debug-step-back",{fontCharacter:"\\eb8f"}),s.debugRestartFrame=new s("debug-restart-frame",{fontCharacter:"\\eb90"}),s.callIncoming=new s("call-incoming",{fontCharacter:"\\eb92"}),s.callOutgoing=new s("call-outgoing",{fontCharacter:"\\eb93"}),s.menu=new s("menu",{fontCharacter:"\\eb94"}),s.expandAll=new s("expand-all",{fontCharacter:"\\eb95"}),s.feedback=new s("feedback",{fontCharacter:"\\eb96"}),s.groupByRefType=new s("group-by-ref-type",{fontCharacter:"\\eb97"}),s.ungroupByRefType=new s("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),s.account=new s("account",{fontCharacter:"\\eb99"}),s.bellDot=new s("bell-dot",{fontCharacter:"\\eb9a"}),s.debugConsole=new s("debug-console",{fontCharacter:"\\eb9b"}),s.library=new s("library",{fontCharacter:"\\eb9c"}),s.output=new s("output",{fontCharacter:"\\eb9d"}),s.runAll=new s("run-all",{fontCharacter:"\\eb9e"}),s.syncIgnored=new s("sync-ignored",{fontCharacter:"\\eb9f"}),s.pinned=new s("pinned",{fontCharacter:"\\eba0"}),s.githubInverted=new s("github-inverted",{fontCharacter:"\\eba1"}),s.debugAlt=new s("debug-alt",{fontCharacter:"\\eb91"}),s.serverProcess=new s("server-process",{fontCharacter:"\\eba2"}),s.serverEnvironment=new s("server-environment",{fontCharacter:"\\eba3"}),s.pass=new s("pass",{fontCharacter:"\\eba4"}),s.stopCircle=new s("stop-circle",{fontCharacter:"\\eba5"}),s.playCircle=new s("play-circle",{fontCharacter:"\\eba6"}),s.record=new s("record",{fontCharacter:"\\eba7"}),s.debugAltSmall=new s("debug-alt-small",{fontCharacter:"\\eba8"}),s.vmConnect=new s("vm-connect",{fontCharacter:"\\eba9"}),s.cloud=new s("cloud",{fontCharacter:"\\ebaa"}),s.merge=new s("merge",{fontCharacter:"\\ebab"}),s.exportIcon=new s("export",{fontCharacter:"\\ebac"}),s.graphLeft=new s("graph-left",{fontCharacter:"\\ebad"}),s.magnet=new s("magnet",{fontCharacter:"\\ebae"}),s.notebook=new s("notebook",{fontCharacter:"\\ebaf"}),s.redo=new s("redo",{fontCharacter:"\\ebb0"}),s.checkAll=new s("check-all",{fontCharacter:"\\ebb1"}),s.pinnedDirty=new s("pinned-dirty",{fontCharacter:"\\ebb2"}),s.passFilled=new s("pass-filled",{fontCharacter:"\\ebb3"}),s.circleLargeFilled=new s("circle-large-filled",{fontCharacter:"\\ebb4"}),s.circleLargeOutline=new s("circle-large-outline",{fontCharacter:"\\ebb5"}),s.combine=new s("combine",{fontCharacter:"\\ebb6"}),s.gather=new s("gather",{fontCharacter:"\\ebb6"}),s.table=new s("table",{fontCharacter:"\\ebb7"}),s.variableGroup=new s("variable-group",{fontCharacter:"\\ebb8"}),s.typeHierarchy=new s("type-hierarchy",{fontCharacter:"\\ebb9"}),s.typeHierarchySub=new s("type-hierarchy-sub",{fontCharacter:"\\ebba"}),s.typeHierarchySuper=new s("type-hierarchy-super",{fontCharacter:"\\ebbb"}),s.gitPullRequestCreate=new s("git-pull-request-create",{fontCharacter:"\\ebbc"}),s.runAbove=new s("run-above",{fontCharacter:"\\ebbd"}),s.runBelow=new s("run-below",{fontCharacter:"\\ebbe"}),s.notebookTemplate=new s("notebook-template",{fontCharacter:"\\ebbf"}),s.debugRerun=new s("debug-rerun",{fontCharacter:"\\ebc0"}),s.workspaceTrusted=new s("workspace-trusted",{fontCharacter:"\\ebc1"}),s.workspaceUntrusted=new s("workspace-untrusted",{fontCharacter:"\\ebc2"}),s.workspaceUnspecified=new s("workspace-unspecified",{fontCharacter:"\\ebc3"}),s.terminalCmd=new s("terminal-cmd",{fontCharacter:"\\ebc4"}),s.terminalDebian=new s("terminal-debian",{fontCharacter:"\\ebc5"}),s.terminalLinux=new s("terminal-linux",{fontCharacter:"\\ebc6"}),s.terminalPowershell=new s("terminal-powershell",{fontCharacter:"\\ebc7"}),s.terminalTmux=new s("terminal-tmux",{fontCharacter:"\\ebc8"}),s.terminalUbuntu=new s("terminal-ubuntu",{fontCharacter:"\\ebc9"}),s.terminalBash=new s("terminal-bash",{fontCharacter:"\\ebca"}),s.arrowSwap=new s("arrow-swap",{fontCharacter:"\\ebcb"}),s.copy=new s("copy",{fontCharacter:"\\ebcc"}),s.personAdd=new s("person-add",{fontCharacter:"\\ebcd"}),s.filterFilled=new s("filter-filled",{fontCharacter:"\\ebce"}),s.wand=new s("wand",{fontCharacter:"\\ebcf"}),s.debugLineByLine=new s("debug-line-by-line",{fontCharacter:"\\ebd0"}),s.inspect=new s("inspect",{fontCharacter:"\\ebd1"}),s.dropDownButton=new s("drop-down-button",s.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(ge[93],pe([0,1,16,6]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(d){const f=d;return f?[f.on,f.pause,f.resume,f.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=C;function A(d){const f=d;return f?C(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(d,f){return new k(d,f)}e.newWriteableStream=y;class k{constructor(f,u){this.reducer=f,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){var u;if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof((u=this.options)===null||u===void 0?void 0:u.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(u=>u(f))}emitError(f){this.listeners.error.length===0?w.onUnexpectedError(f):this.listeners.error.slice(0).forEach(u=>u(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,u){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(f,u){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(u);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,f){const u=[];let t;for(;(t=d.read())!==null;)u.push(t);return f(u)}e.consumeReadable=D;function I(d,f,u){const t=[];let n;for(;(n=d.read())!==null&&t.length<u;)t.push(n);return n===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return d.read()}}}e.peekReadable=I;function s(d,f){return new Promise((u,t)=>{const n=[];P(d,{onData:i=>{f&&n.push(i)},onError:i=>{f?t(i):u(void 0)},onEnd:()=>{u(f?f(n):void 0)}})})}e.consumeStream=s;function P(d,f){d.on("error",u=>f.onError(u)),d.on("end",()=>f.onEnd()),d.on("data",u=>f.onData(u))}e.listenStream=P;function c(d,f){return new Promise((u,t)=>{const n=new R.DisposableStore,i=[],r=g=>{if(i.push(g),i.length>f)return n.dispose(),d.pause(),u({stream:d,buffer:i,ended:!1})},o=g=>t(g),m=()=>u({stream:d,buffer:i,ended:!0});n.add(R.toDisposable(()=>d.removeListener("error",o))),d.on("error",o),n.add(R.toDisposable(()=>d.removeListener("end",m))),d.on("end",m),n.add(R.toDisposable(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=c;function p(d,f){const u=y(f);return u.end(d),u}e.toStream=p;function l(){const d=y(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=l;function h(d){let f=!1;return{read:()=>f?null:(f=!0,d)}}e.toReadable=h;function _(d,f,u){const t=y(u);return P(d,{onData:n=>t.write(f.data(n)),onError:n=>t.error(f.error?f.error(n):n),onEnd:()=>t.end()}),t}e.transform=_;function v(d,f,u){let t=!1;return{read:()=>{const n=f.read();return t?n:(t=!0,n!==null?u([d,n]):d)}}}e.prefixedReadable=v;function S(d,f,u){let t=!1;const n=y(u);return P(f,{onData:i=>t?n.write(i):(t=!0,n.write(u([d,i]))),onError:i=>n.error(i),onEnd:()=>{t||(t=!0,n.write(d)),n.end()}}),n}e.prefixedStream=S}),define(ge[8],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=w;const R=/{(\d+)}/g;function C(H,...Z){return Z.length===0?H:H.replace(R,function(ue,Ie){const Pe=parseInt(Ie,10);return isNaN(Pe)||Pe<0||Pe>=Z.length?ue:Z[Pe]})}e.format=C;function A(H){return H.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.escape=A;function y(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(H,Z){let ue=0;const Ie=Z.charCodeAt(0);for(let Pe=H.length-1;Pe>=0;Pe--)H.charCodeAt(Pe)===Ie&&ue++;return ue}e.count=k;function D(H,Z,ue="\u2026"){return H.length<=Z?H:`${H.substr(0,Z)}${ue}`}e.truncate=D;function I(H,Z=" "){const ue=s(H,Z);return P(ue,Z)}e.trim=I;function s(H,Z){if(!H||!Z)return H;const ue=Z.length;if(ue===0||H.length===0)return H;let Ie=0;for(;H.indexOf(Z,Ie)===Ie;)Ie=Ie+ue;return H.substring(Ie)}e.ltrim=s;function P(H,Z){if(!H||!Z)return H;const ue=Z.length,Ie=H.length;if(ue===0||Ie===0)return H;let Pe=Ie,Ue=-1;for(;Ue=H.lastIndexOf(Z,Pe-1),!(Ue===-1||Ue+ue!==Pe);){if(Ue===0)return"";Pe=Ue}return H.substring(0,Pe)}e.rtrim=P;function c(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function p(H){return H.replace(/\*/g,"")}e.stripWildcards=p;function l(H,Z,ue={}){if(!H)throw new Error("Cannot create regex from empty string");Z||(H=y(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Ie="";return ue.global&&(Ie+="g"),ue.matchCase||(Ie+="i"),ue.multiline&&(Ie+="m"),ue.unicode&&(Ie+="u"),new RegExp(H,Ie)}e.createRegExp=l;function h(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function _(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function v(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=v;function S(H){return H.split(/\r\n|\r|\n/)}e.splitLines=S;function d(H){for(let Z=0,ue=H.length;Z<ue;Z++){const Ie=H.charCodeAt(Z);if(Ie!==32&&Ie!==9)return Z}return-1}e.firstNonWhitespaceIndex=d;function f(H,Z=0,ue=H.length){for(let Ie=Z;Ie<ue;Ie++){const Pe=H.charCodeAt(Ie);if(Pe!==32&&Pe!==9)return H.substring(Z,Ie)}return H.substring(Z,ue)}e.getLeadingWhitespace=f;function u(H,Z=H.length-1){for(let ue=Z;ue>=0;ue--){const Ie=H.charCodeAt(ue);if(Ie!==32&&Ie!==9)return ue}return-1}e.lastNonWhitespaceIndex=u;function t(H,Z){return H<Z?-1:H>Z?1:0}e.compare=t;function n(H,Z,ue=0,Ie=H.length,Pe=0,Ue=Z.length){for(;ue<Ie&&Pe<Ue;ue++,Pe++){let rt=H.charCodeAt(ue),tt=Z.charCodeAt(Pe);if(rt<tt)return-1;if(rt>tt)return 1}const xe=Ie-ue,Qe=Ue-Pe;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstring=n;function i(H,Z){return r(H,Z,0,H.length,0,Z.length)}e.compareIgnoreCase=i;function r(H,Z,ue=0,Ie=H.length,Pe=0,Ue=Z.length){for(;ue<Ie&&Pe<Ue;ue++,Pe++){let rt=H.charCodeAt(ue),tt=Z.charCodeAt(Pe);if(rt===tt)continue;const Ye=rt-tt;if(!(Ye===32&&m(tt))&&!(Ye===-32&&m(rt)))return o(rt)&&o(tt)?Ye:n(H.toLowerCase(),Z.toLowerCase(),ue,Ie,Pe,Ue)}const xe=Ie-ue,Qe=Ue-Pe;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstringIgnoreCase=r;function o(H){return H>=97&&H<=122}e.isLowerAsciiLetter=o;function m(H){return H>=65&&H<=90}e.isUpperAsciiLetter=m;function g(H){return o(H)||m(H)}function E(H,Z){return H.length===Z.length&&b(H,Z)}e.equalsIgnoreCase=E;function b(H,Z,ue=H.length){for(let Ie=0;Ie<ue;Ie++){const Pe=H.charCodeAt(Ie),Ue=Z.charCodeAt(Ie);if(Pe!==Ue){if(g(Pe)&&g(Ue)){const xe=Math.abs(Pe-Ue);if(xe!==0&&xe!==32)return!1}else if(String.fromCharCode(Pe).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function a(H,Z){const ue=Z.length;return Z.length>H.length?!1:b(H,Z,ue)}e.startsWithIgnoreCase=a;function L(H,Z){let ue,Ie=Math.min(H.length,Z.length);for(ue=0;ue<Ie;ue++)if(H.charCodeAt(ue)!==Z.charCodeAt(ue))return ue;return Ie}e.commonPrefixLength=L;function O(H,Z){let ue,Ie=Math.min(H.length,Z.length);const Pe=H.length-1,Ue=Z.length-1;for(ue=0;ue<Ie;ue++)if(H.charCodeAt(Pe-ue)!==Z.charCodeAt(Ue-ue))return ue;return Ie}e.commonSuffixLength=O;function W(H){return 55296<=H&&H<=56319}e.isHighSurrogate=W;function ee(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ee;function oe(H,Z){return(H-55296<<10)+(Z-56320)+65536}e.computeCodePoint=oe;function V(H,Z,ue){const Ie=H.charCodeAt(ue);if(W(Ie)&&ue+1<Z){const Pe=H.charCodeAt(ue+1);if(ee(Pe))return oe(Ie,Pe)}return Ie}e.getNextCodePoint=V;function B(H,Z){const ue=H.charCodeAt(Z-1);if(ee(ue)&&Z>1){const Ie=H.charCodeAt(Z-2);if(W(Ie))return oe(Ie,ue)}return ue}function j(H,Z){const ue=We.getInstance(),Ie=Z,Pe=H.length,Ue=V(H,Pe,Z);Z+=Ue>=65536?2:1;let xe=ue.getGraphemeBreakType(Ue);for(;Z<Pe;){const Qe=V(H,Pe,Z),rt=ue.getGraphemeBreakType(Qe);if(Ne(xe,rt))break;Z+=Qe>=65536?2:1,xe=rt}return Z-Ie}e.nextCharLength=j;function T(H,Z){const ue=We.getInstance(),Ie=Z,Pe=B(H,Z);Z-=Pe>=65536?2:1;let Ue=ue.getGraphemeBreakType(Pe);for(;Z>0;){const xe=B(H,Z),Qe=ue.getGraphemeBreakType(xe);if(Ne(Qe,Ue))break;Z-=xe>=65536?2:1,Ue=Qe}return Ie-Z}e.prevCharLength=T;function N(H,Z){const ue=We.getInstance(),Ie=H.length,Pe=Z,Ue=V(H,Ie,Z),xe=ue.getGraphemeBreakType(Ue);Z+=Ue>=65536?2:1;let Qe=xe;for(;Z<Ie;){const tt=V(H,Ie,Z),Ye=ue.getGraphemeBreakType(tt);if(Ne(Qe,Ye))break;Z+=tt>=65536?2:1,Qe=Ye}const rt=Z;for(Z=Pe,Qe=xe;Z>0;){const tt=B(H,Z),Ye=ue.getGraphemeBreakType(tt);if(Ne(Ye,Qe))break;Z-=tt>=65536?2:1,Qe=Ye}return[Z,rt]}function F(H,Z){return Z>0&&ee(H.charCodeAt(Z))?N(H,Z-1):N(H,Z)}e.getCharContainingOffset=F;function M(H){const Z=H.length;let ue=0,Ie=0;for(;Ie<Z;){const xe=V(H,Z,Ie);Ie+=xe>=65536?2:1,xe<128?ue+=1:xe<2048?ue+=2:xe<65536?ue+=3:ue+=4}const Pe=new Uint8Array(ue);Ie=0;let Ue=0;for(;Ie<Z;){const xe=V(H,Z,Ie);Ie+=xe>=65536?2:1,xe<128?Pe[Ue++]=xe:xe<2048?(Pe[Ue++]=192|(xe&1984)>>>6,Pe[Ue++]=128|(xe&63)>>>0):xe<65536?(Pe[Ue++]=224|(xe&61440)>>>12,Pe[Ue++]=128|(xe&4032)>>>6,Pe[Ue++]=128|(xe&63)>>>0):(Pe[Ue++]=240|(xe&1835008)>>>18,Pe[Ue++]=128|(xe&258048)>>>12,Pe[Ue++]=128|(xe&4032)>>>6,Pe[Ue++]=128|(xe&63)>>>0)}return Pe}e.encodeUTF8=M;function U(H){const Z=H.byteLength,ue=[];let Ie=0;for(;Ie<Z;){const Pe=H[Ie];let Ue;if(Pe>=240&&Ie+3<Z?Ue=(H[Ie++]&7)<<18>>>0|(H[Ie++]&63)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Pe>=224&&Ie+2<Z?Ue=(H[Ie++]&15)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Pe>=192&&Ie+1<Z?Ue=(H[Ie++]&31)<<6>>>0|(H[Ie++]&63)<<0>>>0:Ue=H[Ie++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)ue.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const xe=Ue-65536,Qe=55296+((xe&1047552)>>>10),rt=56320+((xe&1023)>>>0);ue.push(String.fromCharCode(Qe)),ue.push(String.fromCharCode(rt))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=U;const x=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(H){return x.test(H)}e.containsRTL=G;const se=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(H){return se.test(H)}e.containsEmoji=be;const Te=/^[\t\n\r\x20-\x7E]*$/;function Ce(H){return Te.test(H)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Me;function qe(H){for(let Z=0,ue=H.length;Z<ue;Z++)if(ze(H.charCodeAt(Z)))return!0;return!1}e.containsFullWidthCharacter=qe;function ze(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=ze;function Ke(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=Ke;function q(H,Z){if(H.length<Z)return H;const ue=/\b/g;let Ie=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<Z);)Ie=ue.lastIndex,ue.lastIndex+=1;return H.substring(Ie).replace(/^\s/,"")}e.lcut=q;const J=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function Y(H){return H&&(H=H.replace(J,""),H=H.replace(re,""),H=H.replace(ae,"")),H}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function ve(H){return ce(H)?H.substr(1):H}e.stripUTF8BOM=ve;function Re(H,Z){if(!H||!Z||H.length<Z.length)return!1;const ue=Z.length,Ie=H.toLowerCase();let Pe=0,Ue=-1;for(;Pe<ue;){const xe=Ie.indexOf(Z[Pe],Ue+1);if(xe<0)return!1;Ue=xe,Pe++}return!0}e.fuzzyContains=Re;function we(H,Z=!1){return H?(Z&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=we;function je(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=je;function K(H,Z=1){if(Z===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),Z--;while(Z>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=K;function ie(H){const Z=90-65+1;return H=H%(2*Z),H<Z?String.fromCharCode(97+H):String.fromCharCode(65+H-Z)}e.singleLetterHash=ie;function Ee(H){return We.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=Ee;function Ne(H,Z){return H===0?Z!==5&&Z!==7:H===2&&Z===3?!1:H===4||H===2||H===3||Z===4||Z===2||Z===3?!0:!(H===8&&(Z===8||Z===9||Z===11||Z===12)||(H===11||H===9)&&(Z===9||Z===10)||(H===12||H===10)&&Z===10||Z===5||Z===13||Z===7||H===1||H===13&&Z===14||H===6&&Z===6)}e.breakBetweenGraphemeBreakType=Ne;var $e;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=Xe()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ue=this._data,Ie=ue.length/3;let Pe=1;for(;Pe<=Ie;)if(Z<ue[3*Pe])Pe=2*Pe;else if(Z>ue[3*Pe+1])Pe=2*Pe+1;else return ue[3*Pe+2];return 0}}We._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(H,Z){if(H===0)return 0;const ue=ye(H,Z);if(ue!==void 0)return ue;const Ie=B(Z,H);return H-=ke(Ie),H}e.getLeftDeleteOffset=De;function ye(H,Z){let ue=B(Z,H);for(H-=ke(ue);le(ue)||ue===65039||ue===8419;){if(H===0)return;ue=B(Z,H),H-=ke(ue)}if(!!Ke(ue)){if(H>=0){const Ie=B(Z,H);Ie===8205&&(H-=ke(Ie))}return H}}function ke(H){return H>=65536?2:1}function le(H){return 127995<=H&&H<=127999}var he;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(he||(he={}))}),define(ge[23],pe([0,1,8,93]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let k,D;class I{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return C?new I(Buffer.allocUnsafe(g)):new I(new Uint8Array(g))}static wrap(g){return C&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new I(g)}static fromString(g,E){return!((E==null?void 0:E.dontUseNodeBuffer)||!1)&&C?new I(Buffer.from(g)):A?(k||(k=new TextEncoder),new I(k.encode(g))):new I(w.encodeUTF8(g))}static concat(g,E){if(typeof E=="undefined"){E=0;for(let L=0,O=g.length;L<O;L++)E+=g[L].byteLength}const b=I.alloc(E);let a=0;for(let L=0,O=g.length;L<O;L++){const W=g[L];b.set(W,a),a+=W.byteLength}return b}toString(){return C?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(g,E){return new I(this.buffer.subarray(g,E))}set(g,E){g instanceof I?this.buffer.set(g.buffer,E):this.buffer.set(g,E)}readUInt32BE(g){return c(this.buffer,g)}writeUInt32BE(g,E){p(this.buffer,g,E)}readUInt32LE(g){return l(this.buffer,g)}writeUInt32LE(g,E){h(this.buffer,g,E)}readUInt8(g){return _(this.buffer,g)}writeUInt8(g,E){v(this.buffer,g,E)}}e.VSBuffer=I;function s(m,g){return m[g+0]<<0>>>0|m[g+1]<<8>>>0}e.readUInt16LE=s;function P(m,g,E){m[E+0]=g&255,g=g>>>8,m[E+1]=g&255}e.writeUInt16LE=P;function c(m,g){return m[g]*2**24+m[g+1]*2**16+m[g+2]*2**8+m[g+3]}e.readUInt32BE=c;function p(m,g,E){m[E+3]=g,g=g>>>8,m[E+2]=g,g=g>>>8,m[E+1]=g,g=g>>>8,m[E]=g}e.writeUInt32BE=p;function l(m,g){return m[g+0]<<0>>>0|m[g+1]<<8>>>0|m[g+2]<<16>>>0|m[g+3]<<24>>>0}e.readUInt32LE=l;function h(m,g,E){m[E+0]=g&255,g=g>>>8,m[E+1]=g&255,g=g>>>8,m[E+2]=g&255,g=g>>>8,m[E+3]=g&255}e.writeUInt32LE=h;function _(m,g){return m[g]}e.readUInt8=_;function v(m,g,E){m[E]=g}e.writeUInt8=v;function S(m){return R.consumeReadable(m,g=>I.concat(g))}e.readableToBuffer=S;function d(m){return R.toReadable(m)}e.bufferToReadable=d;function f(m){return R.consumeStream(m,g=>I.concat(g))}e.streamToBuffer=f;async function u(m){return m.ended?I.concat(m.buffer):I.concat([...m.buffer,await f(m.stream)])}e.bufferedStreamToBuffer=u;function t(m){return R.toStream(m,g=>I.concat(g))}e.bufferToStream=t;function n(m){return R.transform(m,{data:g=>typeof g=="string"?I.fromString(g):I.wrap(g)},g=>I.concat(g))}e.streamToBufferReadableStream=n;function i(m){return R.newWriteableStream(g=>I.concat(g),m)}e.newWriteableBufferStream=i;function r(m,g){return R.prefixedReadable(m,g,E=>I.concat(E))}e.prefixedBufferReadable=r;function o(m,g){return R.prefixedStream(m,g,E=>I.concat(E))}e.prefixedBufferStream=o}),define(ge[75],pe([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(v){return C(v,0)}e.hash=R;function C(v,S){switch(typeof v){case"object":return v===null?A(349,S):Array.isArray(v)?D(v,S):I(v,S);case"string":return k(v,S);case"boolean":return y(v,S);case"number":return A(v,S);case"undefined":return A(937,S);default:return A(617,S)}}e.doHash=C;function A(v,S){return(S<<5)-S+v|0}function y(v,S){return A(v?433:863,S)}function k(v,S){S=A(149417,S);for(let d=0,f=v.length;d<f;d++)S=A(v.charCodeAt(d),S);return S}e.stringHash=k;function D(v,S){return S=A(104579,S),v.reduce((d,f)=>C(f,d),S)}function I(v,S){return S=A(181387,S),Object.keys(v).sort().reduce((d,f)=>(d=k(f,d),C(v[f],d)),S)}class s{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=C(S,this._value),this._value}}e.Hasher=s;var P;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(v,S,d=32){const f=d-S,u=~((1<<f)-1);return(v<<S|(u&v)>>>f)>>>0}function p(v,S=0,d=v.byteLength,f=0){for(let u=0;u<d;u++)v[S+u]=f}function l(v,S,d="0"){for(;v.length<S;)v=d+v;return v}function h(v,S=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(d=>d.toString(16).padStart(2,"0")).join(""):l((v>>>0).toString(16),S/4)}e.toHexString=h;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const d=S.length;if(d===0)return;const f=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,n,i;for(t!==0?(n=t,i=-1,t=0):(n=S.charCodeAt(0),i=0);;){let r=n;if(w.isHighSurrogate(n))if(i+1<d){const o=S.charCodeAt(i+1);w.isLowSurrogate(o)?(i++,r=w.computeCodePoint(n,o)):r=65533}else{t=n;break}else w.isLowSurrogate(n)&&(r=65533);if(u=this._push(f,u,r),i++,i<d)n=S.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(S,d,f){return f<128?S[d++]=f:f<2048?(S[d++]=192|(f&1984)>>>6,S[d++]=128|(f&63)>>>0):f<65536?(S[d++]=224|(f&61440)>>>12,S[d++]=128|(f&4032)>>>6,S[d++]=128|(f&63)>>>0):(S[d++]=240|(f&1835008)>>>18,S[d++]=128|(f&258048)>>>12,S[d++]=128|(f&4032)>>>6,S[d++]=128|(f&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=_._bigBlock32,d=this._buffDV;for(let g=0;g<64;g+=4)S.setUint32(g,d.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)S.setUint32(g,c(S.getUint32(g-12,!1)^S.getUint32(g-32,!1)^S.getUint32(g-56,!1)^S.getUint32(g-64,!1),1),!1);let f=this._h0,u=this._h1,t=this._h2,n=this._h3,i=this._h4,r,o,m;for(let g=0;g<80;g++)g<20?(r=u&t|~u&n,o=1518500249):g<40?(r=u^t^n,o=1859775393):g<60?(r=u&t|u&n|t&n,o=2400959708):(r=u^t^n,o=3395469782),m=c(f,5)+r+i+o+S.getUint32(g*4,!1)&4294967295,i=n,n=t,t=c(u,30),u=f,f=m;this._h0=this._h0+f&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[57],pe([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const A="error",y="warning",k="warn",D="info",I="ignore";function s(c){return c?w.equalsIgnoreCase(A,c)?C.Error:w.equalsIgnoreCase(y,c)||w.equalsIgnoreCase(k,c)?C.Warning:w.equalsIgnoreCase(D,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=s;function P(c){switch(c){case C.Error:return A;case C.Warning:return y;case C.Info:return D;default:return I}}C.toString=P}(R||(R={})),e.default=R}),define(ge[12],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(g){return Array.isArray(g)}e.isArray=w;function R(g){return typeof g=="string"}e.isString=R;function C(g){return Array.isArray(g)&&g.every(E=>R(E))}e.isStringArray=C;function A(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=A;function y(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=y;function k(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=k;function D(g){return g===!0||g===!1}e.isBoolean=D;function I(g){return typeof g=="undefined"}e.isUndefined=I;function s(g){return!P(g)}e.isDefined=s;function P(g){return I(g)||g===null}e.isUndefinedOrNull=P;function c(g,E){if(!g)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=c;function p(g){if(P(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function l(...g){const E=[];for(let b=0;b<g.length;b++){const a=g[b];if(P(a))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);E.push(a)}return E}e.assertAllDefined=l;const h=Object.prototype.hasOwnProperty;function _(g){if(!A(g))return!1;for(let E in g)if(h.call(g,E))return!1;return!0}e.isEmptyObject=_;function v(g){return typeof g=="function"}e.isFunction=v;function S(...g){return g.length>0&&g.every(v)}e.areFunctions=S;function d(g,E){const b=Math.min(g.length,E.length);for(let a=0;a<b;a++)f(g[a],E[a])}e.validateConstraints=d;function f(g,E){if(R(E)){if(typeof g!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(v(E)){try{if(g instanceof E)return}catch(b){}if(!P(g)&&g.constructor===E||E.length===1&&E.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function u(g){let E=[],b=Object.getPrototypeOf(g);for(;Object.prototype!==b;)E=E.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return E}e.getAllPropertyNames=u;function t(g){const E=[];for(const b of u(g))typeof g[b]=="function"&&E.push(b);return E}e.getAllMethodNames=t;function n(g,E){const b=L=>function(){const O=Array.prototype.slice.call(arguments,0);return E(L,O)};let a={};for(const L of g)a[L]=b(L);return a}e.createProxyObject=n;function i(g){return g===null?void 0:g}e.withNullAsUndefined=i;function r(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=r;function o(g){return class{constructor(){return new Proxy({},{get(E,b){if(E[b])return E[b];throw new Error(`Not Implemented: ${g}->${String(b)}`)}})}}}e.NotImplementedProxy=o;function m(g){throw new Error("Unreachable")}e.assertNever=m}),define(ge[29],pe([0,1,11,8,9,12]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(i){return i===47||i===92}e.isPathSeparator=y;function k(i){return i.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=k;function D(i){return i.indexOf("/")===-1&&(i=k(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=D;function I(i,r=C.posix.sep){if(!i)return"";const o=i.length,m=i.charCodeAt(0);if(y(m)){if(y(i.charCodeAt(1))&&!y(i.charCodeAt(2))){let E=3;const b=E;for(;E<o&&!y(i.charCodeAt(E));E++);if(b!==E&&!y(i.charCodeAt(E+1))){for(E+=1;E<o;E++)if(y(i.charCodeAt(E)))return i.slice(0,E+1).replace(/[\\/]/g,r)}}return r}else if(v(m)&&i.charCodeAt(1)===58)return y(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let g=i.indexOf("://");if(g!==-1){for(g+=3;g<o;g++)if(y(i.charCodeAt(g)))return i.slice(0,g+1)}return""}e.getRoot=I;function s(i){if(!w.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let o=2;const m=o;for(;o<i.length&&(r=i.charCodeAt(o),r!==92);o++);return!(m===o||(r=i.charCodeAt(o+1),isNaN(r)||r===92))}e.isUNC=s;const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(i,r=w.isWindows){const o=r?P:c;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||r&&p.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=l;function h(i,r,o){const m=i===r;return!o||m?m:!i||!r?!1:R.equalsIgnoreCase(i,r)}e.isEqual=h;function _(i,r,o,m=C.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(o){if(!R.startsWithIgnoreCase(i,r))return!1;if(r.length===i.length)return!0;let E=r.length;return r.charAt(r.length-1)===m&&E--,i.charAt(E)===m}return r.charAt(r.length-1)!==m&&(r+=m),i.indexOf(r)===0}e.isEqualOrParent=_;function v(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=v;function S(i,r){return w.isWindows&&i.endsWith(":")&&(i+=C.sep),C.isAbsolute(i)||(i=C.join(r,i)),i=C.normalize(i),w.isWindows?(i=R.rtrim(i,C.sep),i.endsWith(":")&&(i+=C.sep)):(i=R.rtrim(i,C.sep),i||(i=C.sep)),i}e.sanitizeFilePath=S;function d(i){const r=C.normalize(i);return w.isWindows?i.length>3?!1:f(r)&&(i.length===2||r.charCodeAt(2)===92):r===C.posix.sep}e.isRootOrDriveLetter=d;function f(i){return w.isWindows?v(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(i){return f(i)?i[0]:void 0}e.getDriveLetter=u;function t(i,r,o){return r.length>i.length?-1:i===r?0:(o&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=t;function n(i){const r=i.split(":");let o,m,g;if(r.forEach(E=>{const b=Number(E);A.isNumber(b)?m===void 0?m=b:g===void 0&&(g=b):o=o?[o,E].join(":"):E}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:m!==void 0?m:void 0,column:g!==void 0?g:m!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(ge[25],pe([0,1,12]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const _=Array.isArray(h)?[]:{};return Object.keys(h).forEach(v=>{h[v]&&typeof h[v]=="object"?_[v]=R(h[v]):_[v]=h[v]}),_}e.deepClone=R;function C(h){if(!h||typeof h!="object")return h;const _=[h];for(;_.length>0;){const v=_.shift();Object.freeze(v);for(const S in v)if(A.call(v,S)){const d=v[S];typeof d=="object"&&!Object.isFrozen(d)&&_.push(d)}}return h}e.deepFreeze=C;const A=Object.prototype.hasOwnProperty;function y(h,_){return k(h,_,new Set)}e.cloneAndChange=y;function k(h,_,v){if(w.isUndefinedOrNull(h))return h;const S=_(h);if(typeof S!="undefined")return S;if(w.isArray(h)){const d=[];for(const f of h)d.push(k(f,_,v));return d}if(w.isObject(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const d={};for(let f in h)A.call(h,f)&&(d[f]=k(h[f],_,v));return v.delete(h),d}return h}function D(h,_,v=!0){return w.isObject(h)?(w.isObject(_)&&Object.keys(_).forEach(S=>{S in h?v&&(w.isObject(h[S])&&w.isObject(_[S])?D(h[S],_[S],v):h[S]=_[S]):h[S]=_[S]}),h):_}e.mixin=D;function I(h,_){if(h===_)return!0;if(h==null||_===null||_===void 0||typeof h!=typeof _||typeof h!="object"||Array.isArray(h)!==Array.isArray(_))return!1;let v,S;if(Array.isArray(h)){if(h.length!==_.length)return!1;for(v=0;v<h.length;v++)if(!I(h[v],_[v]))return!1}else{const d=[];for(S in h)d.push(S);d.sort();const f=[];for(S in _)f.push(S);if(f.sort(),!I(d,f))return!1;for(v=0;v<d.length;v++)if(!I(h[d[v]],_[d[v]]))return!1}return!0}e.equals=I;function s(h){const _=new Set;return JSON.stringify(h,(v,S)=>{if(w.isObject(S)||Array.isArray(S)){if(_.has(S))return"[Circular]";_.add(S)}return S})}e.safeStringify=s;function P(h,_,v){const S=_(h);return typeof S=="undefined"?v:S}e.getOrDefault=P;function c(h,_){const v=Object.create(null);return!h||!_||Object.keys(_).forEach(d=>{const f=h[d],u=_[d];I(f,u)||(v[d]=u)}),v}e.distinct=c;function p(h,_){const v=_.toLowerCase(),S=Object.keys(h).find(d=>d.toLowerCase()===v);return S?h[S]:h[_]}e.getCaseInsensitive=p;function l(h,_){const v=Object.create(null);for(const S of Object.keys(h))_(S,h[S])&&(v[S]=h[S]);return v}e.filter=l}),define(ge[94],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function R(A){return A<0?0:A>255?255:A|0}e.toUint8=R;function C(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=C}),define(ge[2],pe([0,1,11,9]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function k(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!C.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(i,r){return!i&&!r?"file":i}function I(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const s="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,o,m,g,E,b=!1){typeof r=="object"?(this.scheme=r.scheme||s,this.authority=r.authority||s,this.path=r.path||s,this.query=r.query||s,this.fragment=r.fragment||s):(this.scheme=D(r,b),this.authority=o||s,this.path=I(this.scheme,m||s),this.query=g||s,this.fragment=E||s,k(this,b))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:m,path:g,query:E,fragment:b}=r;return o===void 0?o=this.scheme:o===null&&(o=s),m===void 0?m=this.authority:m===null&&(m=s),g===void 0?g=this.path:g===null&&(g=s),E===void 0?E=this.query:E===null&&(E=s),b===void 0?b=this.fragment:b===null&&(b=s),o===this.scheme&&m===this.authority&&g===this.path&&E===this.query&&b===this.fragment?this:new h(o,m,g,E,b)}static parse(r,o=!1){const m=c.exec(r);return m?new h(m[2]||s,n(m[4]||s),n(m[5]||s),n(m[7]||s),n(m[9]||s),o):new h(s,s,s,s,s)}static file(r){let o=s;if(w.isWindows&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const m=r.indexOf(P,2);m===-1?(o=r.substring(2),r=P):(o=r.substring(2,m),r=r.substring(m)||P)}return new h("file",o,r,s,s)}static from(r){const o=new h(r.scheme,r.authority,r.path,r.query,r.fragment);return k(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return w.isWindows&&r.scheme==="file"?m=p.file(R.win32.join(d(r,!0),...o)).path:m=R.posix.join(r.path,...o),r.with({path:m})}toString(r=!1){return f(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const o=new h(r);return o._formatted=r.external,o._fsPath=r._sep===l?r.fsPath:null,o}}else return r}}e.URI=p;const l=w.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=l),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(i,r){let o,m=-1;for(let g=0;g<i.length;g++){const E=i.charCodeAt(g);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||r&&E===47)m!==-1&&(o+=encodeURIComponent(i.substring(m,g)),m=-1),o!==void 0&&(o+=i.charAt(g));else{o===void 0&&(o=i.substr(0,g));const b=_[E];b!==void 0?(m!==-1&&(o+=encodeURIComponent(i.substring(m,g)),m=-1),o+=b):m===-1&&(m=g)}}return m!==-1&&(o+=encodeURIComponent(i.substring(m))),o!==void 0?o:i}function S(i){let r;for(let o=0;o<i.length;o++){const m=i.charCodeAt(o);m===35||m===63?(r===void 0&&(r=i.substr(0,o)),r+=_[m]):r!==void 0&&(r+=i[o])}return r!==void 0?r:i}function d(i,r){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,w.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function f(i,r){const o=r?S:v;let m="",{scheme:g,authority:E,path:b,query:a,fragment:L}=i;if(g&&(m+=g,m+=":"),(E||g==="file")&&(m+=P,m+=P),E){let O=E.indexOf("@");if(O!==-1){const W=E.substr(0,O);E=E.substr(O+1),O=W.indexOf(":"),O===-1?m+=o(W,!1):(m+=o(W.substr(0,O),!1),m+=":",m+=o(W.substr(O+1),!1)),m+="@"}E=E.toLowerCase(),O=E.indexOf(":"),O===-1?m+=o(E,!1):(m+=o(E.substr(0,O),!1),m+=E.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}m+=o(b,!0)}return a&&(m+="?",m+=o(a,!1)),L&&(m+="#",m+=r?L:v(L,!1)),m}function u(i){try{return decodeURIComponent(i)}catch(r){return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(t)?i.replace(t,r=>u(r)):i}});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[22],pe([0,1,2,8]),function(Q,e,w,R){"use strict";var C,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(t,n,i){let r=t.get(n);return r===void 0&&(r=i,t.set(n,r)),r}e.getOrSet=k;function D(t){const n=[];return t.forEach((i,r)=>{n.push(`${r} => ${i}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function I(t){const n=[];return t.forEach(i=>{n.push(i)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=I;class s{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const i=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return i-r}value(){return this._value[this._pos]}}e.StringIterator=s;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?R.compareSubstring(n,this._value,0,n.length,this._from,this._to):R.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class c{constructor(n=!0,i=!0){this._splitOnBackslash=n,this._caseSensitive=i}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?R.compareSubstring(n,this._value,0,n.length,this._from,this._to):R.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class l{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(n,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return R.compare(n,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(n){this._iter=n}static forUris(n=()=>!1){return new _(new l(n))}static forPaths(){return new _(new c)}static forStrings(){return new _(new s)}static forConfigKeys(){return new _(new P)}clear(){this._root=void 0}set(n,i){const r=this._iter.reset(n);let o;for(this._root||(this._root=new h,this._root.segment=r.value()),o=this._root;;){const g=r.cmp(o.segment);if(g>0)o.left||(o.left=new h,o.left.segment=r.value()),o=o.left;else if(g<0)o.right||(o.right=new h,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new h,o.mid.segment=r.value()),o=o.mid;else break}const m=o.value;return o.value=i,o.key=n,m}get(n){var i;return(i=this._getNode(n))===null||i===void 0?void 0:i.value}_getNode(n){const i=this._iter.reset(n);let r=this._root;for(;r;){const o=i.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else break}return r}has(n){const i=this._getNode(n);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,i){const r=this._iter.reset(n),o=[];let m=this._root;for(;m;){const g=r.cmp(m.segment);if(g>0)o.push([1,m]),m=m.left;else if(g<0)o.push([-1,m]),m=m.right;else if(r.hasNext())r.next(),o.push([0,m]),m=m.mid;else{for(i?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;o.length>0&&m.isEmpty();){let[E,b]=o.pop();switch(E){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}m=b}break}}}findSubstr(n){const i=this._iter.reset(n);let r=this._root,o;for(;r;){const m=i.cmp(r.segment);if(m>0)r=r.left;else if(m<0)r=r.right;else if(i.hasNext())i.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const i=this._iter.reset(n);let r=this._root;for(;r;){const o=i.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[i,r]of this)n(r,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=_;class v{constructor(n,i){this[C]="ResourceMap",n instanceof v?(this.map=new Map(n.map),this.toKey=i??v.defaultToKey):(this.map=new Map,this.toKey=n??v.defaultToKey)}set(n,i){return this.map.set(this.toKey(n),i),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i!="undefined"&&(n=n.bind(i));for(let[r,o]of this.map)n(o,w.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield w.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[w.URI.parse(n[0]),n[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[w.URI.parse(n[0]),n[1]]}}e.ResourceMap=v,v.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class d{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,i=0){const r=this._map.get(n);if(!!r)return i!==0&&this.touch(r,i),r.value}set(n,i,r=0){let o=this._map.get(n);if(o)o.value=i,r!==0&&this.touch(o,r);else{switch(o={key:n,value:i,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(!!i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const r=this._state;let o=this._head;for(;o;){if(i?n.bind(i)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,i=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:r.key,done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return o}values(){const n=this,i=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:r.value,done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return o}entries(){const n=this,i=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:[r.key,r.value],done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,r=this.size;for(;i&&r>n;)this._map.delete(i.key),i=i.next,r--;this._head=i,this._size=r,i&&(i.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,r=n.previous;if(!i||!r)throw new Error("Invalid list");i.previous=r,r.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,r)=>{n.push([r,i])}),n}fromJSON(n){this.clear();for(const[i,r]of n)this.set(i,r)}}e.LinkedMap=d;class f extends d{constructor(n,i=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=2){return super.get(n,i)}peek(n){return super.get(n,0)}set(n,i){return super.set(n,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class u{constructor(n){y.set(this,void 0),nt(this,y,n,"f")}get size(){return Be(this,y,"f").size}forEach(n,i){Be(this,y,"f").forEach(n,i)}get(n){return Be(this,y,"f").get(n)}has(n){return Be(this,y,"f").has(n)}entries(){return Be(this,y,"f").entries()}keys(){return Be(this,y,"f").keys()}values(){return Be(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Be(this,y,"f").entries()}}e.ReadonlyMapView=u}),define(ge[95],pe([0,1,22,8]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Y){return function(ce,ve){for(let Re=0,we=Y.length;Re<we;Re++){const je=Y[Re](ce,ve);if(je)return je}return null}}e.or=C,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(Y,ce,ve){if(!ve||ve.length<ce.length)return null;let Re;return Y?Re=R.startsWithIgnoreCase(ve,ce):Re=ve.indexOf(ce)===0,Re?ce.length>0?[{start:0,end:ce.length}]:[]:null}function y(Y,ce){const ve=ce.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=y;function k(Y,ce){return D(Y.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=k;function D(Y,ce,ve,Re){if(ve===Y.length)return[];if(Re===ce.length)return null;if(Y[ve]===ce[Re]){let we=null;return(we=D(Y,ce,ve+1,Re+1))?v({start:Re,end:Re+1},we):null}return D(Y,ce,ve,Re+1)}function I(Y){return 97<=Y&&Y<=122}function s(Y){return 65<=Y&&Y<=90}e.isUpper=s;function P(Y){return 48<=Y&&Y<=57}function c(Y){return Y===32||Y===9||Y===10||Y===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>p.add(Y.charCodeAt(0)));function l(Y){return c(Y)||p.has(Y)}function h(Y,ce){return Y===ce||l(Y)&&l(ce)}function _(Y){return I(Y)||s(Y)||P(Y)}function v(Y,ce){return ce.length===0?ce=[Y]:Y.end===ce[0].start?ce[0].start=Y.start:ce.unshift(Y),ce}function S(Y,ce){for(let ve=ce;ve<Y.length;ve++){const Re=Y.charCodeAt(ve);if(s(Re)||P(Re)||ve>0&&!_(Y.charCodeAt(ve-1)))return ve}return Y.length}function d(Y,ce,ve,Re){if(ve===Y.length)return[];if(Re===ce.length)return null;if(Y[ve]!==ce[Re].toLowerCase())return null;{let we=null,je=Re+1;for(we=d(Y,ce,ve+1,Re+1);!we&&(je=S(ce,je))<ce.length;)we=d(Y,ce,ve+1,je),je++;return we===null?null:v({start:Re,end:Re+1},we)}}function f(Y){let ce=0,ve=0,Re=0,we=0,je=0;for(let $e=0;$e<Y.length;$e++)je=Y.charCodeAt($e),s(je)&&ce++,I(je)&&ve++,_(je)&&Re++,P(je)&&we++;const K=ce/Y.length,ie=ve/Y.length,Ee=Re/Y.length,Ne=we/Y.length;return{upperPercent:K,lowerPercent:ie,alphaPercent:Ee,numericPercent:Ne}}function u(Y){const{upperPercent:ce,lowerPercent:ve}=Y;return ve===0&&ce>.6}function t(Y){const{upperPercent:ce,lowerPercent:ve,alphaPercent:Re,numericPercent:we}=Y;return ve>.2&&ce<.8&&Re>.6&&we<.2}function n(Y){let ce=0,ve=0,Re=0,we=0;for(let je=0;je<Y.length;je++)Re=Y.charCodeAt(je),s(Re)&&ce++,I(Re)&&ve++,c(Re)&&we++;return(ce===0||ve===0)&&we===0?Y.length<=30:ce<=5}function i(Y,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!n(Y)||ce.length>60)return null;const ve=f(ce);if(!t(ve)){if(!u(ve))return null;ce=ce.toLowerCase()}let Re=null,we=0;for(Y=Y.toLowerCase();we<ce.length&&(Re=d(Y,ce,0,we))===null;)we=S(ce,we+1);return Re}e.matchesCamelCase=i;function r(Y,ce,ve=!1){if(!ce||ce.length===0)return null;let Re=null,we=0;for(Y=Y.toLowerCase(),ce=ce.toLowerCase();we<ce.length&&(Re=o(Y,ce,0,we,ve))===null;)we=m(ce,we+1);return Re}e.matchesWords=r;function o(Y,ce,ve,Re,we){if(ve===Y.length)return[];if(Re===ce.length)return null;if(h(Y.charCodeAt(ve),ce.charCodeAt(Re))){let je=null,K=Re+1;if(je=o(Y,ce,ve+1,Re+1,we),!we)for(;!je&&(K=m(ce,K))<ce.length;)je=o(Y,ce,ve+1,K,we),K++;return je===null?null:v({start:Re,end:Re+1},je)}else return null}function m(Y,ce){for(let ve=ce;ve<Y.length;ve++)if(l(Y.charCodeAt(ve))||ve>0&&l(Y.charCodeAt(ve-1)))return ve;return Y.length}const g=C(e.matchesPrefix,i,y),E=C(e.matchesPrefix,i,k),b=new w.LRUCache(1e4);function a(Y,ce,ve=!1){if(typeof Y!="string"||typeof ce!="string")return null;let Re=b.get(Y);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),b.set(Y,Re));const we=Re.exec(ce);return we?[{start:we.index,end:we.index+we[0].length}]:ve?E(Y,ce):g(Y,ce)}e.matchesFuzzy=a;function L(Y,ce){const ve=qe(Y,Y.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return ve?W(ve):null}e.matchesFuzzy2=L;function O(Y,ce,ve,Re,we,je){const K=Math.min(13,Y.length);for(;ve<K;ve++){const ie=qe(Y,ce,ve,Re,we,je,!1);if(ie)return ie}return[0,je]}e.anyScore=O;function W(Y){if(typeof Y=="undefined")return[];const ce=[],ve=Y[1];for(let Re=Y.length-1;Re>1;Re--){const we=Y[Re]+ve,je=ce[ce.length-1];je&&je.end===we?je.end=we+1:ce.push({start:we,end:we+1})}return ce}e.createMatches=W;const ee=128;function oe(){const Y=[],ce=[];for(let ve=0;ve<=ee;ve++)ce[ve]=0;for(let ve=0;ve<=ee;ve++)Y.push(ce.slice(0));return Y}function V(Y){const ce=[];for(let ve=0;ve<=Y;ve++)ce[ve]=0;return ce}const B=V(2*ee),j=V(2*ee),T=oe(),N=oe(),F=oe(),M=!1;function U(Y,ce,ve,Re,we){function je(ie,Ee,Ne=" "){for(;ie.length<Ee;)ie=Ne+ie;return ie}let K=` |   |${Re.split("").map(ie=>je(ie,3)).join("|")}
`;for(let ie=0;ie<=ve;ie++)ie===0?K+=" |":K+=`${ce[ie-1]}|`,K+=Y[ie].slice(0,we+1).map(Ee=>je(Ee.toString(),3)).join("|")+`
`;return K}function x(Y,ce,ve,Re){Y=Y.substr(ce),ve=ve.substr(Re),console.log(U(N,Y,Y.length,ve,ve.length)),console.log(U(F,Y,Y.length,ve,ve.length)),console.log(U(T,Y,Y.length,ve,ve.length))}function G(Y,ce){if(ce<0||ce>=Y.length)return!1;const ve=Y.codePointAt(ce);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ve)}}function se(Y,ce){if(ce<0||ce>=Y.length)return!1;switch(Y.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function be(Y,ce,ve){return ce[Y]!==ve[Y]}function Te(Y,ce,ve,Re,we,je,K=!1){for(;ce<ve&&we<je;)Y[ce]===Re[we]&&(K&&(B[ce]=we),ce+=1),we+=1;return ce===ve}e.isPatternInWord=Te;var Ce;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Me;(function(Y){Y.Default=[-100,0];function ce(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=ce})(Me=e.FuzzyScore||(e.FuzzyScore={}));function qe(Y,ce,ve,Re,we,je,K){const ie=Y.length>ee?ee:Y.length,Ee=Re.length>ee?ee:Re.length;if(ve>=ie||je>=Ee||ie-ve>Ee-je||!Te(ce,ve,ie,we,je,Ee,!0))return;ze(ie,Ee,ve,je,ce,we);let Ne=1,$e=1,We=ve,Xe=je;const De=[!1];for(Ne=1,We=ve;We<ie;Ne++,We++){const H=B[We],Z=j[We],ue=We+1<ie?j[We+1]:Ee;for($e=H-je+1,Xe=H;Xe<ue;$e++,Xe++){let Ie=Number.MIN_SAFE_INTEGER,Pe=!1;Xe<=Z&&(Ie=Ke(Y,ce,We,ve,Re,we,Xe,Ee,je,T[Ne-1][$e-1]===0,De));let Ue=0;Ie!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Ue=Ie+N[Ne-1][$e-1]);const xe=Xe>H,Qe=xe?N[Ne][$e-1]+(T[Ne][$e-1]>0?-5:0):0,rt=Xe>H+1&&T[Ne][$e-1]>0,tt=rt?N[Ne][$e-2]+(T[Ne][$e-2]>0?-5:0):0;if(rt&&(!xe||tt>=Qe)&&(!Pe||tt>=Ue))N[Ne][$e]=tt,F[Ne][$e]=3,T[Ne][$e]=0;else if(xe&&(!Pe||Qe>=Ue))N[Ne][$e]=Qe,F[Ne][$e]=2,T[Ne][$e]=0;else if(Pe)N[Ne][$e]=Ue,F[Ne][$e]=1,T[Ne][$e]=T[Ne-1][$e-1]+1;else throw new Error("not possible")}}if(M&&x(Y,ve,Re,je),!De[0]&&!K)return;Ne--,$e--;const ye=[N[Ne][$e],je];let ke=0,le=0;for(;Ne>=1;){let H=$e;do{const Z=F[Ne][H];if(Z===3)H=H-2;else if(Z===2)H=H-1;else break}while(H>=1);ke>1&&ce[ve+Ne-1]===we[je+$e-1]&&!be(H+je-1,Re,we)&&ke+1>T[Ne][H]&&(H=$e),H===$e?ke++:ke=1,le||(le=H),Ne--,$e=H-1,ye.push($e)}Ee===ie&&(ye[0]+=2);const he=le-ie;return ye[0]-=he,ye}e.fuzzyScore=qe;function ze(Y,ce,ve,Re,we,je){let K=Y-1,ie=ce-1;for(;K>=ve&&ie>=Re;)we[K]===je[ie]&&(j[K]=ie,K--),ie--}function Ke(Y,ce,ve,Re,we,je,K,ie,Ee,Ne,$e){if(ce[ve]!==je[K])return Number.MIN_SAFE_INTEGER;let We=1,Xe=!1;return K===ve-Re?We=Y[ve]===we[K]?7:5:be(K,we,je)&&(K===0||!be(K-1,we,je))?(We=Y[ve]===we[K]?7:5,Xe=!0):G(je,K)&&(K===0||!G(je,K-1))?We=5:(G(je,K-1)||se(je,K-1))&&(We=5,Xe=!0),We>1&&ve===Re&&($e[0]=!0),Xe||(Xe=be(K,we,je)||G(je,K-1)||se(je,K-1)),ve===Re?K>Ee&&(We-=Xe?3:5):Ne?We+=Xe?2:0:We+=Xe?0:1,K+1===ie&&(We-=Xe?3:5),We}function q(Y,ce,ve,Re,we,je,K){return re(Y,ce,ve,Re,we,je,!0,K)}e.fuzzyScoreGracefulAggressive=q;function J(Y,ce,ve,Re,we,je,K){return re(Y,ce,ve,Re,we,je,!1,K)}e.fuzzyScoreGraceful=J;function re(Y,ce,ve,Re,we,je,K,ie){let Ee=qe(Y,ce,ve,Re,we,je,ie);if(Ee&&!K)return Ee;if(Y.length>=3){const Ne=Math.min(7,Y.length-1);for(let $e=ve+1;$e<Ne;$e++){const We=ae(Y,$e);if(We){const Xe=qe(We,We.toLowerCase(),ve,Re,we,je,ie);Xe&&(Xe[0]-=3,(!Ee||Xe[0]>Ee[0])&&(Ee=Xe))}}}return Ee}function ae(Y,ce){if(ce+1>=Y.length)return;const ve=Y[ce],Re=Y[ce+1];if(ve!==Re)return Y.slice(0,ce)+Re+ve+Y.slice(ce+2)}}),define(ge[137],pe([0,1,45,95,8]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function k(h){return h.replace(y,(_,v)=>v?_:`\\${_}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${A.source}`,"g");function I(h){return h.replace(D,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=I;const s=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function P(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(s,(_,v,S,d)=>S?_:v||d||"")}e.stripIcons=P;function c(h){const _=h.indexOf(e.iconStartMarker);return _===-1?{text:h}:p(h,_)}e.parseLabelWithIcons=c;function p(h,_){const v=[];let S="";function d(m){if(m){S+=m;for(const g of m)v.push(t)}}let f=-1,u="",t=0,n,i,r=_;const o=h.length;for(d(h.substr(0,_));r<o;)n=h[r],i=h[r+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(f=r,d(u),u=e.iconStartMarker,r++):n===")"&&f!==-1?(t+=r-f+1,f=-1,u=""):f!==-1?/^[a-z0-9\-]$/i.test(n)?u+=n:(d(u),f=-1,u=""):d(n),r++;return d(u),{text:S,iconOffsets:v}}function l(h,_,v=!1){const{text:S,iconOffsets:d}=_;if(!d||d.length===0)return R.matchesFuzzy(h,S,v);const f=C.ltrim(S," "),u=S.length-f.length,t=R.matchesFuzzy(h,f,v);if(t)for(const n of t){const i=d[n.start+u]+u;n.start+=i,n.end+=i}return t}e.matchesFuzzyIconAware=l}),define(ge[96],pe([0,1,137,16]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(P){P[P.Paragraph=0]="Paragraph",P[P.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(c="",p=!1){var l,h;if(this.value=c,typeof this.value!="string")throw R.illegalArgument("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(l=p.isTrusted)!==null&&l!==void 0?l:void 0,this.supportThemeIcons=(h=p.supportThemeIcons)!==null&&h!==void 0?h:!1)}appendText(c,p=0){return this.value+=D(this.supportThemeIcons?w.escapeIcons(c):c).replace(/([ \t]+)/g,(l,h)=>"&nbsp;".repeat(h.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,p){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=A;function y(P){return k(P)?!P.value:Array.isArray(P)?P.every(y):!0}e.isEmptyMarkdownString=y;function k(P){return P instanceof A?!0:P&&typeof P=="object"?typeof P.value=="string"&&(typeof P.isTrusted=="boolean"||P.isTrusted===void 0)&&(typeof P.supportThemeIcons=="boolean"||P.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function D(P){return P.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function I(P){return P&&P.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=I;function s(P){const c=[],p=P.split("|").map(h=>h.trim());P=p[0];const l=p[1];if(l){const h=/height=(\d+)/.exec(l),_=/width=(\d+)/.exec(l),v=h?h[1]:"",S=_?_[1]:"",d=isFinite(parseInt(S)),f=isFinite(parseInt(v));d&&c.push(`width="${S}"`),f&&c.push(`height="${v}"`)}return{href:P,dimensions:c}}e.parseHrefAndDimensions=s}),define(ge[58],pe([0,1,23,8,2]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(I){return JSON.stringify(I,k)}e.stringify=A;function y(I){let s=JSON.parse(I);return s=D(s),s}e.parse=y;function k(I,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:R.regExpFlags(s)}:s}function D(I,s=0){if(!I||s>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return C.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof w.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let P=0;P<I.length;++P)I[P]=D(I[P],s+1);else for(const P in I)Object.hasOwnProperty.call(I,P)&&(I[P]=D(I[P],s+1))}return I}e.revive=D}),define(ge[10],pe([0,1,2,11]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,I,s){this._hosts[D]=I,this._ports[D]=s}setConnectionToken(D,I){this._connectionTokens[D]=I}rewrite(D){if(this._delegate)return this._delegate(D);const I=D.authority;let s=this._hosts[I];s&&s.indexOf(":")!==-1&&(s=`[${s}]`);const P=this._ports[I],c=this._connectionTokens[I];let p=`path=${encodeURIComponent(D.path)}`;return typeof c=="string"&&(p+=`&tkn=${encodeURIComponent(c)}`),w.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${s}:${P}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,I,s){const P=this.toUri(D,I);return P.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(P):R.isNative&&(s||R.isPreferringBrowserCodeLoad)&&P.scheme===C.file?P.with({scheme:C.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,I){const s=this.toUri(D,I);return s.scheme===C.vscodeFileResource?s.with({scheme:C.file,authority:s.authority!==this.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(D,I){return w.URI.isUri(D)?D:w.URI.parse(I.toUrl(D))}}e.FileAccess=new y}),define(ge[76],pe([0,1,22]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new w.LRUCache(1e4);function C(I){return D(I,"NFC",R)}e.normalizeNFC=C;const A=new w.LRUCache(1e4);function y(I){return D(I,"NFD",A)}e.normalizeNFD=y;const k=/[^\u0000-\u0080]/;function D(I,s,P){if(!e.canNormalize||!I)return I;const c=P.get(I);if(c)return c;let p;return k.test(I)?p=I.normalize(s):p=I,P.set(I,p),p}e.removeAccents=function(){if(e.canNormalize){const I=/[\u0300-\u036f]/g;return function(s){return y(s).replace(I,"")}}else return function(I){return I}}()}),define(ge[24],pe([0,1,29,9,2,8,10,11]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return C.uriToFsPath(p,!0)}e.originalFSPath=D;class I{constructor(l){this._ignorePathCasing=l}compare(l,h,_=!1){return l===h?0:A.compare(this.getComparisonKey(l,_),this.getComparisonKey(h,_))}isEqual(l,h,_=!1){return l===h?!0:!l||!h?!1:this.getComparisonKey(l,_)===this.getComparisonKey(h,_)}getComparisonKey(l,h=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,h,_=!1){if(l.scheme===h.scheme){if(l.scheme===y.Schemas.file)return w.isEqualOrParent(D(l),D(h),this._ignorePathCasing(l))&&l.query===h.query&&(_||l.fragment===h.fragment);if(e.isEqualAuthority(l.authority,h.authority))return w.isEqualOrParent(l.path,h.path,this._ignorePathCasing(l),"/")&&l.query===h.query&&(_||l.fragment===h.fragment)}return!1}joinPath(l,...h){return C.URI.joinPath(l,...h)}basenameOrAuthority(l){return e.basename(l)||l.authority}basename(l){return R.posix.basename(l.path)}extname(l){return R.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let h;return l.scheme===y.Schemas.file?h=C.URI.file(R.dirname(D(l))).path:(h=R.posix.dirname(l.path),l.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),h="/")),l.with({path:h})}normalizePath(l){if(!l.path.length)return l;let h;return l.scheme===y.Schemas.file?h=C.URI.file(R.normalize(D(l))).path:h=R.posix.normalize(l.path),l.with({path:h})}relativePath(l,h){if(l.scheme!==h.scheme||!e.isEqualAuthority(l.authority,h.authority))return;if(l.scheme===y.Schemas.file){const S=R.relative(D(l),D(h));return k.isWindows?w.toSlashes(S):S}let _=l.path||"/",v=h.path||"/";if(this._ignorePathCasing(l)){let S=0;for(const d=Math.min(_.length,v.length);S<d&&!(_.charCodeAt(S)!==v.charCodeAt(S)&&_.charAt(S).toLowerCase()!==v.charAt(S).toLowerCase());S++);_=v.substr(0,S)+_.substr(S)}return R.posix.relative(_,v)}resolvePath(l,h){if(l.scheme===y.Schemas.file){const _=C.URI.file(R.resolve(D(l),h));return l.with({authority:_.authority,path:_.path})}return h=w.toPosixPath(h),l.with({path:R.posix.resolve(l.path,h)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,h){return l===h||A.equalsIgnoreCase(l,h)}hasTrailingPathSeparator(l,h=R.sep){if(l.scheme===y.Schemas.file){const _=D(l);return _.length>w.getRoot(_).length&&_[_.length-1]===h}else{const _=l.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,h=R.sep){return e.hasTrailingPathSeparator(l,h)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,h=R.sep){let _=!1;if(l.scheme===y.Schemas.file){const v=D(l);_=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=l.path;_=v.length===1&&v.charCodeAt(v.length-1)===47}return!_&&!e.hasTrailingPathSeparator(l,h)?l.with({path:l.path+"/"}):l}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(p=>p.scheme===y.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new I(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function s(p,l){const h=[];for(let _=0;_<p.length;_++){const v=l(p[_]);p.some((S,d)=>d===_?!1:e.isEqualOrParent(v,l(S)))||h.push(p[_])}return h}e.distinctParents=s;var P;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function l(h){const _=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(d=>{const[f,u]=d.split(":");f&&u&&_.set(f,u)});const S=h.path.substring(0,h.path.indexOf(";"));return S&&_.set(p.META_DATA_MIME,S),_}p.parseMetaData=l})(P=e.DataUri||(e.DataUri={}));function c(p,l,h){if(l){let _=p.path;return _&&_[0]!==R.posix.sep&&(_=R.posix.sep+_),p.with({scheme:h,authority:l,path:_})}return p.with({scheme:h})}e.toLocalResource=c}),define(ge[13],pe([0,1,21,16,3,6,56,24]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(N){return!!N&&typeof N.then=="function"}e.isThenable=D;function I(N){const F=new w.CancellationTokenSource,M=N(F.token),U=new Promise((x,G)=>{F.token.onCancellationRequested(()=>{G(R.canceled())}),Promise.resolve(M).then(se=>{F.dispose(),x(se)},se=>{F.dispose(),G(se)})});return new class{cancel(){F.cancel()}then(x,G){return U.then(x,G)}catch(x){return this.then(void 0,x)}finally(x){return U.finally(x)}}}e.createCancelablePromise=I;function s(N,F,M){return Promise.race([N,new Promise(U=>F.onCancellationRequested(()=>U(M)))])}e.raceCancellation=s;async function P(N){let F=-1;const M=N.map((x,G)=>x.then(se=>(F=G,se))),U=await Promise.race(M);return N.forEach((x,G)=>{G!==F&&x.cancel()}),U}e.raceCancellablePromises=P;function c(N,F,M){let U;const x=setTimeout(()=>{U==null||U(void 0),M==null||M()},F);return Promise.race([N.finally(()=>clearTimeout(x)),new Promise(G=>U=G)])}e.raceTimeout=c;function p(N){return new Promise((F,M)=>{const U=N();D(U)?U.then(F,M):F(U)})}e.asPromise=p;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(M,M).then(U)})}return new Promise((M,U)=>{this.queuedPromise.then(M,U)})}return this.activePromise=F(),new Promise((M,U)=>{this.activePromise.then(x=>{this.activePromise=null,M(x)},x=>{this.activePromise=null,U(x)})})}}e.Throttler=l;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class _{constructor(){this.promiseMap=new Map}queue(F,M){var U;const G=((U=this.promiseMap.get(F))!==null&&U!==void 0?U:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===G&&this.promiseMap.delete(F)});return this.promiseMap.set(F,G),G}}e.SequencerByKey=_;class v{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,x)=>{this.doResolve=U,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class S{constructor(F){this.delayer=new v(F),this.throttler=new l}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class d{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class f extends d{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function u(N,F){return F?new Promise((M,U)=>{const x=setTimeout(M,N);F.onCancellationRequested(()=>{clearTimeout(x),U(R.canceled())})}):I(M=>u(N,M))}e.timeout=u;function t(N,F=0){const M=setTimeout(N,F);return A.toDisposable(()=>clearTimeout(M))}e.disposableTimeout=t;function n(N){return N.then(void 0,F=>{})}e.ignoreErrors=n;function i(N){const F=[];let M=0;const U=N.length;function x(){return M<U?N[M++]():null}function G(se){se!=null&&F.push(se);const be=x();return be?be.then(G):Promise.resolve(F)}return Promise.resolve(null).then(G)}e.sequence=i;function r(N,F=U=>!!U,M=null){let U=0;const x=N.length,G=()=>{if(U>=x)return Promise.resolve(M);const se=N[U++];return Promise.resolve(se()).then(Te=>F(Te)?Promise.resolve(Te):G())};return G()}e.first=r;function o(N,F=U=>!!U,M=null){if(N.length===0)return Promise.resolve(M);let U=N.length;const x=()=>{var G,se;U=-1;for(const be of N)(se=(G=be).cancel)===null||se===void 0||se.call(G)};return new Promise((G,se)=>{for(const be of N)be.then(Te=>{--U>=0&&F(Te)?(x(),G(Te)):U===0&&G(M)}).catch(Te=>{--U>=0&&(x(),se(Te))})})}e.firstParallel=o;class m{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,U)=>{this.outstandingPromises.push({factory:F,c:M,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class g extends m{constructor(){super(1)}}e.Queue=g;class E{constructor(){this.queues=new Map}queueFor(F,M=k.extUri){const U=M.getComparisonKey(F);let x=this.queues.get(U);return x||(x=new g,C.Event.once(x.onFinished)(()=>{x==null||x.dispose(),this.queues.delete(U)}),this.queues.set(U,x)),x}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=E;class b{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=b;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=a;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(N));let U=!1;return{dispose(){U||(U=!0,clearTimeout(M))}}}}else e.runWhenIdle=(N,F)=>{const M=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function ee(N,F,M){let U;for(let x=0;x<M;x++)try{return await N()}catch(G){U=G,await u(F)}throw U}e.retry=ee;class oe{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,U){return this._pending={taskId:F,cancel:()=>U==null?void 0:U(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,U;const x=new Promise((G,se)=>{M=G,U=se});this._next={run:F,promise:x,promiseResolve:M,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=oe;class V{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=B;class j extends C.Emitter{async fireAsync(F,M,U){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const x of this._listeners)this._asyncDeliveryQueue.push([x,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[x,G]=this._asyncDeliveryQueue.shift(),se=[],be=Object.assign(Object.assign({},G),{waitUntil:Te=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");U&&(Te=U(Te,typeof x=="function"?x:x[0])),se.push(Te)}});try{typeof x=="function"?x.call(void 0,be):x[0].call(x[1],be)}catch(Te){R.onUnexpectedError(Te);continue}Object.freeze(se),await T.settled(se).catch(Te=>R.onUnexpectedError(Te))}}}}e.AsyncEmitter=j;var T;(function(N){async function F(G){return typeof Promise.allSettled=="function"?M(G):U(G)}N.allSettled=F;async function M(G){return Promise.allSettled(G)}async function U(G){return Promise.all(G.map(se=>se.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function x(G){let se;const be=await Promise.all(G.map(Te=>Te.then(Ce=>Ce,Ce=>{se||(se=Ce)})));if(typeof se!="undefined")throw se;return be}N.settled=x})(T=e.Promises||(e.Promises={}))}),define(ge[97],pe([0,1,9,13]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(b,a,L=!1){const O=b||"",W=a||"",ee=C.value.collator.compare(O,W);return C.value.collatorIsNumeric&&ee===0&&O!==W?O<W?-1:1:ee}e.compareFileNames=k;function D(b,a){const L=A.value.collator;return b=b||"",a=a||"",u(L,b,a)}e.compareFileNamesDefault=D;function I(b,a){const L=A.value.collator;return b=b||"",a=a||"",r(b,a)||u(L,b,a)}e.compareFileNamesUpper=I;function s(b,a){const L=A.value.collator;return b=b||"",a=a||"",i(b,a)||u(L,b,a)}e.compareFileNamesLower=s;function P(b,a){return b=b||"",a=a||"",b===a?0:b<a?-1:1}e.compareFileNamesUnicode=P;function c(b,a,L=!1){L||(b=b&&b.toLowerCase(),a=a&&a.toLowerCase());const[O,W]=d(b),[ee,oe]=d(a);return O!==ee?O<ee?-1:1:W===oe?0:W<oe?-1:1}e.noIntlCompareFileNames=c;function p(b,a){const[L,O]=d(b),[W,ee]=d(a);let oe=C.value.collator.compare(O,ee);if(oe===0){if(C.value.collatorIsNumeric&&O!==ee)return O<ee?-1:1;if(oe=C.value.collator.compare(L,W),C.value.collatorIsNumeric&&oe===0&&L!==W)return L<W?-1:1}return oe}e.compareFileExtensions=p;function l(b,a){b=b||"",a=a||"";const L=f(b),O=f(a),W=A.value.collator,ee=y.value.collator;return u(ee,L,O)||u(W,b,a)}e.compareFileExtensionsDefault=l;function h(b,a){b=b||"",a=a||"";const L=f(b),O=f(a),W=A.value.collator,ee=y.value.collator;return u(ee,L,O)||r(b,a)||u(W,b,a)}e.compareFileExtensionsUpper=h;function _(b,a){b=b||"",a=a||"";const L=f(b),O=f(a),W=A.value.collator,ee=y.value.collator;return u(ee,L,O)||i(b,a)||u(W,b,a)}e.compareFileExtensionsLower=_;function v(b,a){b=b||"",a=a||"";const L=f(b).toLowerCase(),O=f(a).toLowerCase();return L!==O?L<O?-1:1:b!==a?b<a?-1:1:0}e.compareFileExtensionsUnicode=v;const S=/^(.*?)(\.([^.]*))?$/;function d(b,a=!1){const L=b?S.exec(b):[];let O=[L&&L[1]||"",L&&L[3]||""];return a&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function f(b){const a=b?S.exec(b):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function u(b,a,L){let O=b.compare(a,L);return O!==0?O:a.length!==L.length?a.length<L.length?-1:1:0}function t(b){const a=b.charAt(0);return a.toLocaleUpperCase()!==a}function n(b){const a=b.charAt(0);return a.toLocaleLowerCase()!==a}function i(b,a){return t(b)&&n(a)?-1:n(b)&&t(a)?1:0}function r(b,a){return n(b)&&t(a)?-1:t(b)&&n(a)?1:0}function o(b,a,L=!1){return L||(b=b&&b.toLowerCase(),a=a&&a.toLowerCase()),b===a?0:b<a?-1:1}function m(b,a,L=!1){const O=b.split(w.sep),W=a.split(w.sep),ee=O.length-1,oe=W.length-1;let V,B;for(let j=0;;j++){if(V=ee===j,B=oe===j,V&&B)return k(O[j],W[j],L);if(V)return-1;if(B)return 1;const T=o(O[j],W[j],L);if(T!==0)return T}}e.comparePaths=m;function g(b,a,L){const O=b.toLowerCase(),W=a.toLowerCase(),ee=E(b,a,L);if(ee)return ee;const oe=O.endsWith(L),V=W.endsWith(L);if(oe!==V)return oe?-1:1;const B=k(O,W);return B!==0?B:O.localeCompare(W)}e.compareAnything=g;function E(b,a,L){const O=b.toLowerCase(),W=a.toLowerCase(),ee=O.startsWith(L),oe=W.startsWith(L);if(ee!==oe)return ee?-1:1;if(ee&&oe){if(O.length<W.length)return-1;if(O.length>W.length)return 1}return 0}e.compareByPrefix=E}),define(ge[98],pe([0,1,97,95,9,11,8]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,D=[k,[]];function I(V,B,j,T){if(!V||!B)return D;const N=V.length,F=B.length;if(N<F)return D;const M=V.toLowerCase();return!T&&!M.includes(j)?D:s(B,j,F,V,M,N)}e.scoreFuzzy=I;function s(V,B,j,T,N,F){const M=[],U=[];for(let be=0;be<j;be++){const Te=be*F,Ce=Te-F,Me=be>0,qe=V[be],ze=B[be];for(let Ke=0;Ke<F;Ke++){const q=Ke>0,J=Te+Ke,re=J-1,ae=Ce+Ke-1,Y=q?M[re]:0,ce=Me&&q?M[ae]:0,ve=Me&&q?U[ae]:0;let Re;!ce&&Me?Re=0:Re=P(qe,ze,T,N,Ke,ve),Re&&ce+Re>=Y?(U[J]=ve+1,M[J]=ce+Re):(U[J]=k,M[J]=Y)}}const x=[];let G=j-1,se=F-1;for(;G>=0&&se>=0;){const be=G*F+se;U[be]===k||(x.push(se),G--),se--}return[M[j*F-1],x.reverse()]}function P(V,B,j,T,N,F){let M=0;if(!c(B,T[N]))return M;if(M+=1,F>0&&(M+=F*5),V===j[N]&&(M+=1),N===0)M+=8;else{const U=p(j.charCodeAt(N-1));U?M+=U:R.isUpper(j.charCodeAt(N))&&(M+=2)}return M}function c(V,B){return V===B?!0:V==="/"||V==="\\"?B==="/"||B==="\\":!1}function p(V){switch(V){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function h(V,B,j=0,T=0){const N=B;return N.values&&N.values.length>1?_(V,N.values,j,T):v(V,B,j,T)}e.scoreFuzzy2=h;function _(V,B,j,T){let N=0;const F=[];for(const M of B){const[U,x]=v(V,M,j,T);if(typeof U!="number")return l;N+=U,F.push(...x)}return[N,m(F)]}function v(V,B,j,T){const N=R.fuzzyScore(B.original,B.originalLowercase,j,V,V.toLowerCase(),T,!0);return N?[N[0],R.createMatches(N)]:l}const S=Object.freeze({score:0}),d=1<<18,f=1<<17,u=1<<16;function t(V,B,j,T,N){if(!V||!B.normalized)return S;const F=T.getItemLabel(V);if(!F)return S;const M=T.getItemDescription(V);let U;M?U=`${F}${M}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${j}`:U=`${F}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${j}`;const x=N[U];if(x)return x;const G=n(F,M,T.getItemPath(V),B,j);return N[U]=G,G}e.scoreItemFuzzy=t;function n(V,B,j,T,N){const F=!j||!T.containsPathSeparator;return j&&(A.isLinux?T.pathNormalized===j:y.equalsIgnoreCase(T.pathNormalized,j))?{score:d,labelMatch:[{start:0,end:V.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:T.values&&T.values.length>1?i(V,B,j,T.values,F,N):r(V,B,j,T,F,N)}function i(V,B,j,T,N,F){let M=0;const U=[],x=[];for(const G of T){const{score:se,labelMatch:be,descriptionMatch:Te}=r(V,B,j,G,N,F);if(se===k)return S;M+=se,be&&U.push(...be),Te&&x.push(...Te)}return{score:M,labelMatch:m(U),descriptionMatch:m(x)}}function r(V,B,j,T,N,F){if(N||!B){const[M,U]=I(V,T.normalized,T.normalizedLowercase,F);if(M){const x=R.matchesPrefix(T.normalized,V);let G;return x?(G=f,G+=Math.round(T.normalized.length/V.length*100)):G=u,{score:G+M,labelMatch:x||o(U)}}}if(B){let M=B;j&&(M=`${B}${C.sep}`);const U=M.length,x=`${M}${V}`,[G,se]=I(x,T.normalized,T.normalizedLowercase,F);if(G){const be=o(se),Te=[],Ce=[];return be.forEach(Me=>{Me.start<U&&Me.end>U?(Te.push({start:0,end:Me.end-U}),Ce.push({start:Me.start,end:U})):Me.start>=U?Te.push({start:Me.start-U,end:Me.end-U}):Ce.push(Me)}),{score:G,labelMatch:Te,descriptionMatch:Ce}}}return S}function o(V){const B=[];if(!V)return B;let j;for(const T of V)j&&j.end===T?j.end+=1:(j={start:T,end:T+1},B.push(j));return B}function m(V){const B=V.sort((N,F)=>N.start-F.start),j=[];let T;for(const N of B)!T||!g(T,N)?(T=N,j.push(N)):(T.start=Math.min(T.start,N.start),T.end=Math.max(T.end,N.end));return j}function g(V,B){return!(V.end<B.start||B.end<V.start)}function E(V,B,j,T,N,F){const M=t(V,j,T,N,F),U=t(B,j,T,N,F),x=M.score,G=U.score;if((x===d||G===d)&&x!==G)return x===d?-1:1;if(x>u||G>u){if(x!==G)return x>G?-1:1;if(x<f&&G<f){const ze=a(M.labelMatch,U.labelMatch);if(ze!==0)return ze}const Me=N.getItemLabel(V)||"",qe=N.getItemLabel(B)||"";if(Me.length!==qe.length)return Me.length-qe.length}if(x!==G)return x>G?-1:1;const se=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,be=Array.isArray(U.labelMatch)&&U.labelMatch.length>0;if(se&&!be)return-1;if(be&&!se)return 1;const Te=b(V,M,N),Ce=b(B,U,N);return Te&&Ce&&Te!==Ce?Ce>Te?-1:1:L(V,B,j,N)}e.compareItemsByFuzzyScore=E;function b(V,B,j){let T=-1,N=-1;if(B.descriptionMatch&&B.descriptionMatch.length?T=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(T=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(N=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const F=j.getItemDescription(V);F&&(N+=F.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(N=B.descriptionMatch[B.descriptionMatch.length-1].end);return N-T}function a(V,B){if(!V&&!B||(!V||!V.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!V||!V.length)return 1;const j=V[0].start,N=V[V.length-1].end-j,F=B[0].start,U=B[B.length-1].end-F;return N===U?0:U<N?1:-1}function L(V,B,j,T){const N=T.getItemLabel(V)||"",F=T.getItemLabel(B)||"",M=T.getItemDescription(V),U=T.getItemDescription(B),x=N.length+(M?M.length:0),G=F.length+(U?U.length:0);if(x!==G)return x-G;const se=T.getItemPath(V),be=T.getItemPath(B);return se&&be&&se.length!==be.length?se.length-be.length:N!==F?w.compareAnything(N,F,j.normalized):M&&U&&M!==U?w.compareAnything(M,U,j.normalized):se&&be&&se!==be?w.compareAnything(se,be,j.normalized):0}const O=" ";function W(V){typeof V!="string"&&(V="");const B=V.toLowerCase(),{pathNormalized:j,normalized:T,normalizedLowercase:N}=ee(V),F=j.indexOf(C.sep)>=0;let M;const U=V.split(O);if(U.length>1)for(const x of U){const{pathNormalized:G,normalized:se,normalizedLowercase:be}=ee(x);se&&(M||(M=[]),M.push({original:x,originalLowercase:x.toLowerCase(),pathNormalized:G,normalized:se,normalizedLowercase:be}))}return{original:V,originalLowercase:B,pathNormalized:j,normalized:T,normalizedLowercase:N,values:M,containsPathSeparator:F}}e.prepareQuery=W;function ee(V){let B;A.isWindows?B=V.replace(/\//g,C.sep):B=V.replace(/\\/g,C.sep);const j=y.stripWildcards(B).replace(/\s/g,"");return{pathNormalized:B,normalized:j,normalizedLowercase:j.toLowerCase()}}function oe(V){return Array.isArray(V)?W(V.map(B=>B.original).join(O)):W(V.original)}e.pieceToQuery=oe}),define(ge[30],pe([0,1,8,29,9,22,13]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",I="/",s="[/\\\\]",P="[^/\\\\]",c=/\//g;function p(M){switch(M){case 0:return"";case 1:return`${P}*?`;default:return`(?:${s}|${P}+${s}|${s}${P}+)*?`}}function l(M,U){if(!M)return[];const x=[];let G=!1,se=!1,be="";for(const Te of M){switch(Te){case U:if(!G&&!se){x.push(be),be="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":se=!0;break;case"]":se=!1;break}be+=Te}return be&&x.push(be),x}e.splitGlobAware=l;function h(M){if(!M)return"";let U="";const x=l(M,I);if(x.every(G=>G===D))U=".*";else{let G=!1;x.forEach((se,be)=>{if(se===D){G||(U+=p(2),G=!0);return}let Te=!1,Ce="",Me=!1,qe="";for(const ze of se){if(ze!=="}"&&Te){Ce+=ze;continue}if(Me&&(ze!=="]"||!qe)){let Ke;ze==="-"?Ke=ze:(ze==="^"||ze==="!")&&!qe?Ke="^":ze===I?Ke="":Ke=w.escapeRegExpCharacters(ze),qe+=Ke;continue}switch(ze){case"{":Te=!0;continue;case"[":Me=!0;continue;case"}":U+=`(?:${l(Ce,",").map(J=>h(J)).join("|")})`,Te=!1,Ce="";break;case"]":U+="["+qe+"]",Me=!1,qe="";break;case"?":U+=P;continue;case"*":U+=p(1);continue;default:U+=w.escapeRegExpCharacters(ze)}}be<x.length-1&&(x[be+1]!==D||be+2<x.length)&&(U+=s),G=!1})}return U}const _=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},i=function(){return null};function r(M,U){if(!M)return i;let x;typeof M!="string"?x=M.pattern:x=M,x=x.trim();const G=`${x}_${!!U.trimForExclusions}`;let se=t.get(G);if(se)return o(se,M);let be;if(_.test(x)){const Te=x.substr(4);se=function(Ce,Me){return typeof Ce=="string"&&Ce.endsWith(Te)?x:null}}else(be=v.exec(m(x,U)))?se=g(be[1],x):(U.trimForExclusions?d:S).test(x)?se=E(x,U):(be=f.exec(m(x,U)))?se=b(be[1].substr(1),x,!0):(be=u.exec(m(x,U)))?se=b(be[1],x,!1):se=a(x);return t.set(G,se),o(se,M)}function o(M,U){return typeof U=="string"?M:function(x,G){return R.isEqualOrParent(x,U.base)?M(C.relative(U.base,x),G):null}}function m(M,U){return U.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function g(M,U){const x=`/${M}`,G=`\\${M}`,se=function(Te,Ce){return typeof Te!="string"?null:Ce?Ce===M?U:null:Te===M||Te.endsWith(x)||Te.endsWith(G)?U:null},be=[M];return se.basenames=be,se.patterns=[U],se.allBasenames=be,se}function E(M,U){const x=F(M.slice(1,-1).split(",").map(Ce=>r(Ce,U)).filter(Ce=>Ce!==i),M),G=x.length;if(!G)return i;if(G===1)return x[0];const se=function(Ce,Me){for(let qe=0,ze=x.length;qe<ze;qe++)if(x[qe](Ce,Me))return M;return null},be=x.find(Ce=>!!Ce.allBasenames);be&&(se.allBasenames=be.allBasenames);const Te=x.reduce((Ce,Me)=>Me.allPaths?Ce.concat(Me.allPaths):Ce,[]);return Te.length&&(se.allPaths=Te),se}function b(M,U,x){const G=C.sep===C.posix.sep,se=G?M:M.replace(c,C.sep),be=C.sep+se,Te=C.posix.sep+M,Ce=x?function(Me,qe){return typeof Me=="string"&&(Me===se||Me.endsWith(be)||!G&&(Me===M||Me.endsWith(Te)))?U:null}:function(Me,qe){return typeof Me=="string"&&(Me===se||!G&&Me===M)?U:null};return Ce.allPaths=[(x?"*/":"./")+M],Ce}function a(M){try{const U=new RegExp(`^${h(M)}$`);return function(x){return U.lastIndex=0,typeof x=="string"&&U.test(x)?M:null}}catch(U){return i}}function L(M,U,x){return!M||typeof U!="string"?!1:O(M)(U,void 0,x)}e.match=L;function O(M,U={}){if(!M)return n;if(typeof M=="string"||V(M)){const x=r(M,U);if(x===i)return n;const G=function(se,be){return!!x(se,be)};return x.allBasenames&&(G.allBasenames=x.allBasenames),x.allPaths&&(G.allPaths=x.allPaths),G}return T(M,U)}e.parse=O;function W(M){if(!M)return;let U;return x=>(U||(U=(M()||Promise.resolve([])).then(G=>G?oe(G):{})),U.then(G=>!!G[x]))}e.hasSiblingPromiseFn=W;function ee(M){if(!M)return;let U;return x=>{if(!U){const G=M();U=G?oe(G):{}}return!!U[x]}}e.hasSiblingFn=ee;function oe(M){const U={};for(const x of M)U[x]=!0;return U}function V(M){const U=M;return U&&typeof U.base=="string"&&typeof U.pattern=="string"}e.isRelativePattern=V;function B(M){return M.allBasenames||[]}e.getBasenameTerms=B;function j(M){return M.allPaths||[]}e.getPathTerms=j;function T(M,U){const x=F(Object.getOwnPropertyNames(M).map(Ce=>N(Ce,M[Ce],U)).filter(Ce=>Ce!==i)),G=x.length;if(!G)return i;if(!x.some(Ce=>!!Ce.requiresSiblings)){if(G===1)return x[0];const Ce=function(ze,Ke){for(let q=0,J=x.length;q<J;q++){const re=x[q](ze,Ke);if(re)return re}return null},Me=x.find(ze=>!!ze.allBasenames);Me&&(Ce.allBasenames=Me.allBasenames);const qe=x.reduce((ze,Ke)=>Ke.allPaths?ze.concat(Ke.allPaths):ze,[]);return qe.length&&(Ce.allPaths=qe),Ce}const se=function(Ce,Me,qe){let ze;for(let Ke=0,q=x.length;Ke<q;Ke++){const J=x[Ke];J.requiresSiblings&&qe&&(Me||(Me=C.basename(Ce)),ze||(ze=Me.substr(0,Me.length-C.extname(Ce).length)));const re=J(Ce,Me,ze,qe);if(re)return re}return null},be=x.find(Ce=>!!Ce.allBasenames);be&&(se.allBasenames=be.allBasenames);const Te=x.reduce((Ce,Me)=>Me.allPaths?Ce.concat(Me.allPaths):Ce,[]);return Te.length&&(se.allPaths=Te),se}function N(M,U,x){if(U===!1)return i;const G=r(M,x);if(G===i)return i;if(typeof U=="boolean")return G;if(U){const se=U.when;if(typeof se=="string"){const be=(Te,Ce,Me,qe)=>{if(!qe||!G(Te,Ce))return null;const ze=se.replace("$(basename)",Me),Ke=qe(ze);return y.isThenable(Ke)?Ke.then(q=>q?M:null):Ke?M:null};return be.requiresSiblings=!0,be}}return G}function F(M,U){const x=M.filter(Ce=>!!Ce.basenames);if(x.length<2)return M;const G=x.reduce((Ce,Me)=>{const qe=Me.basenames;return qe?Ce.concat(qe):Ce},[]);let se;if(U){se=[];for(let Ce=0,Me=G.length;Ce<Me;Ce++)se.push(U)}else se=x.reduce((Ce,Me)=>{const qe=Me.patterns;return qe?Ce.concat(qe):Ce},[]);const be=function(Ce,Me){if(typeof Ce!="string")return null;if(!Me){let ze;for(ze=Ce.length;ze>0;ze--){const Ke=Ce.charCodeAt(ze-1);if(Ke===47||Ke===92)break}Me=Ce.substr(ze)}const qe=G.indexOf(Me);return qe!==-1?se[qe]:null};be.basenames=G,be.patterns=se,be.allBasenames=G;const Te=M.filter(Ce=>!Ce.basenames);return Te.push(be),Te}}),define(ge[77],pe([0,1,2,9,8,10,11,24,29]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(r,o,m){if(typeof r=="string"&&(r=w.URI.file(r)),m){const E=m.getWorkspaceFolder(r);if(E){const b=m.getWorkspace().folders.length>1;let a;if(k.isEqual(E.uri,r)?a="":a=k.relativePath(E.uri,r),b){const L=E.name?E.name:k.basename(E.uri);a=a?L+" \u2022 "+a:L}return a}}if(r.scheme!==A.Schemas.file&&r.scheme!==A.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if(D.hasDriveLetter(r.fsPath))return R.normalize(P(r.fsPath));let g=R.normalize(r.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(g=p(g,o.userHome.fsPath)),g}e.getPathLabel=I;function s(r){if(!r)return;typeof r=="string"&&(r=w.URI.file(r));const o=k.basename(r)||(r.scheme===A.Schemas.file?r.fsPath:r.path);return y.isWindows&&D.isRootOrDriveLetter(o)?P(o):o}e.getBaseLabel=s;function P(r){return D.hasDriveLetter(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=P;let c=Object.create(null);function p(r,o){if(y.isWindows||!r||!o)return r;let m=c.original===o?c.normalized:void 0;return m||(m=`${C.rtrim(o,R.posix.sep)}${R.posix.sep}`,c={original:o,normalized:m}),(y.isLinux?r.startsWith(m):C.startsWithIgnoreCase(r,m))&&(r=`~/${r.substr(m.length)}`),r}e.tildify=p;function l(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=l;const h="\u2026",_="\\\\",v="~";function S(r,o=R.sep){const m=new Array(r.length);let g=!1;for(let E=0;E<r.length;E++){let b=r[E];if(b===""){m[E]=`.${o}`;continue}if(!b){m[E]=b;continue}g=!0;let a="";b.indexOf(_)===0?(a=b.substr(0,b.indexOf(_)+_.length),b=b.substr(b.indexOf(_)+_.length)):b.indexOf(o)===0?(a=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length)):b.indexOf(v)===0&&(a=b.substr(0,b.indexOf(v)+v.length),b=b.substr(b.indexOf(v)+v.length));const L=b.split(o);for(let O=1;g&&O<=L.length;O++)for(let W=L.length-O;g&&W>=0;W--){g=!1;let ee=L.slice(W,W+O).join(o);for(let oe=0;!g&&oe<r.length;oe++)if(oe!==E&&r[oe]&&r[oe].indexOf(ee)>-1){const V=W+O===L.length,B=W>0&&r[oe].indexOf(o)>-1?o+ee:ee,j=r[oe].endsWith(B);g=!V||j}if(!g){let oe="";(L[0].endsWith(":")||a!=="")&&(W===1&&(W=0,O++,ee=L[0]+o+ee),W>0&&(oe=L[0]+o),oe=a+oe),W>0&&(oe=oe+h+o),oe=oe+ee,W+O<L.length&&(oe=oe+o+h),m[E]=oe}}g&&(m[E]=b)}return m}e.shorten=S;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function f(r,o=Object.create(null)){const m=[];let g=!1,E="";for(const b of r)if(b==="$"||g&&b==="{")E&&m.push({value:E,type:d.TEXT}),E="",g=!0;else if(b==="}"&&g){const a=o[E];if(typeof a=="string")a.length&&m.push({value:a,type:d.VARIABLE});else if(a){const L=m[m.length-1];(!L||L.type!==d.SEPARATOR)&&m.push({value:a.label,type:d.SEPARATOR})}E="",g=!1}else E+=b;return E&&!g&&m.push({value:E,type:d.TEXT}),m.filter((b,a)=>{if(b.type===d.SEPARATOR){const L=m[a-1],O=m[a+1];return[L,O].every(W=>W&&(W.type===d.VARIABLE||W.type===d.TEXT)&&W.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=f;function u(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function i(r){const o=r.indexOf("/")!==-1?R.posix:R.win32,m=o.basename(r),g=o.dirname(r);return m.length?{name:m,parentPath:g}:{name:g,parentPath:""}}e.splitName=i}),define(ge[138],pe([0,1,9,8,30,10,24]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let k=[],D=[],I=[];function s(t,n=!1){const i=P(t);k.push(i),i.userConfigured?I.push(i):D.push(i),n&&!i.userConfigured&&k.forEach(r=>{r.mime===i.mime||r.userConfigured||(i.extension&&r.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&r.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&r.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&r.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=s;function P(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(w.posix.sep)>=0:!1}}function c(t){t?(k=k.filter(n=>!n.userConfigured),I=[]):(k=[],D=[],I=[])}e.clearTextMimes=c;function p(t,n){let i;if(t)switch(t.scheme){case A.Schemas.file:i=t.fsPath;break;case A.Schemas.data:i=y.DataUri.parseMetaData(t).get(y.DataUri.META_DATA_LABEL);break;default:i=t.path}if(!i)return[e.MIME_UNKNOWN];i=i.toLowerCase();const r=w.basename(i),o=l(i,r,I);if(o)return[o,e.MIME_TEXT];const m=l(i,r,D);if(m)return[m,e.MIME_TEXT];if(n){const g=h(n);if(g)return[g,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=p;function l(t,n,i){let r=null,o=null,m=null;for(let g=i.length-1;g>=0;g--){const E=i[g];if(n===E.filenameLowercase){r=E;break}if(E.filepattern&&(!o||E.filepattern.length>o.filepattern.length)){const b=E.filepatternOnPath?t:n;C.match(E.filepatternLowercase,b)&&(o=E)}E.extension&&(!m||E.extension.length>m.extension.length)&&n.endsWith(E.extensionLowercase)&&(m=E)}return r?r.mime:o?o.mime:m?m.mime:null}function h(t){if(R.startsWithUTF8BOM(t)&&(t=t.substr(1)),t.length>0)for(let n=k.length-1;n>=0;n--){const i=k[n];if(!i.firstline)continue;const r=t.match(i.firstline);if(r&&r.length>0)return i.mime}return null}function _(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&_(t[0]):!0}e.isUnspecific=_;const v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(t){const n=w.extname(t);return v[n.toLowerCase()]}e.getMediaMime=S;function d(t){for(const n in v)if(v[n]===t)return n}e.getExtensionForMimeType=d;const f=/^(.+)\/(.+?)(;.+)?$/;function u(t,n){var i;const r=f.exec(t);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${(i=r[3])!==null&&i!==void 0?i:""}`:n?void 0:t}e.normalizeMimeType=u}),define(ge[99],pe([0,1,2]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(s){return s.toJSON()}class C{constructor(P){this._uriTransformer=P}transformIncoming(P){const c=this._uriTransformer.transformIncoming(P);return c===P?P:R(w.URI.from(c))}transformOutgoing(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:R(w.URI.from(c))}transformOutgoingURI(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:w.URI.from(c)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(s){return s}transformOutgoing(s){return s}transformOutgoingURI(s){return s}transformOutgoingScheme(s){return s}};function A(s,P,c){if(!s||c>200)return null;if(typeof s=="object"){if(s instanceof w.URI)return P.transformOutgoing(s);for(let p in s)if(Object.hasOwnProperty.call(s,p)){const l=A(s[p],P,c+1);l!==null&&(s[p]=l)}}return null}function y(s,P){const c=A(s,P,0);return c===null?s:c}e.transformOutgoingURIs=y;function k(s,P,c,p){if(!s||p>200)return null;if(typeof s=="object"){if(s.$mid===1)return c?w.URI.revive(P.transformIncoming(s)):P.transformIncoming(s);for(let l in s)if(Object.hasOwnProperty.call(s,l)){const h=k(s[l],P,c,p+1);h!==null&&(s[l]=h)}}return null}function D(s,P){const c=k(s,P,!1,0);return c===null?s:c}e.transformIncomingURIs=D;function I(s,P){const c=k(s,P,!0,0);return c===null?s:c}e.transformAndReviveIncomingURIs=I}),define(ge[32],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return w.test(D)}e.isUUID=R;const C=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let I=0;I<D.length;I++)D[I]=Math.floor(Math.random()*256);return D};function k(){y(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let D=0,I="";return I+=A[C[D++]],I+=A[C[D++]],I+=A[C[D++]],I+=A[C[D++]],I+="-",I+=A[C[D++]],I+=A[C[D++]],I+="-",I+=A[C[D++]],I+=A[C[D++]],I+="-",I+=A[C[D++]],I+=A[C[D++]],I+="-",I+=A[C[D++]],I+=A[C[D++]],I+=A[C[D++]],I+=A[C[D++]],I+=A[C[D++]],I+=A[C[D++]],I}e.generateUuid=k}),define(ge[139],pe([0,1,100]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(A="utf8"){this.stringDecoder=new w.StringDecoder(A),this.remaining=null}write(A){const y=[],k=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(k.length<1)return y;let D=0,I,s=D;for(;s<k.length;)if(I=k.charCodeAt(s),I===13||I===10){if(y.push(k.substring(D,s)),s++,s<k.length){const P=I;I=k.charCodeAt(s),(P===13&&I===10||P===10&&I===13)&&s++}D=s}else s++;return this.remaining=D<k.length?k.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=R}),define(ge[28],pe([0,1,59,101,281,9,13,11,29,32,76,24,2]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function l(T,N=p.UNLINK){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");return N===p.UNLINK?_(T):h(T)}e.rimraf=l;async function h(T){try{const N=A.join(R.tmpdir(),I.generateUuid());try{await j.rename(T,N)}catch(F){return _(T)}_(N).catch(F=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function _(T){return j.rmdir(T,{recursive:!0,maxRetries:3})}function v(T){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(T,{recursive:!0})}e.rimrafSync=v;async function S(T,N){return u(await(N?d(T):j.readdir(T)))}e.readdir=S;async function d(T){try{return await j.readdir(T,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const N=[],F=await S(T);for(const M of F){let U=!1,x=!1,G=!1;try{const se=await j.lstat(A.join(T,M));U=se.isFile(),x=se.isDirectory(),G=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}N.push({name:M,isFile:()=>U,isDirectory:()=>x,isSymbolicLink:()=>G})}return N}function f(T){return u(w.readdirSync(T))}e.readdirSync=f;function u(T){return T.map(N=>typeof N=="string"?k.isMacintosh?s.normalizeNFC(N):N:(N.name=k.isMacintosh?s.normalizeNFC(N.name):N.name,N))}async function t(T){const N=await S(T),F=[];for(const M of N)await i.existsDirectory(A.join(T,M))&&F.push(M);return F}e.readDirsInDir=t;function n(T,N=1e3){return new Promise(F=>{let M=!1;const U=setInterval(()=>{M||(M=!0,w.access(T,x=>{M=!1,x&&(clearInterval(U),F(void 0))}))},N)})}e.whenDeleted=n;var i;(function(T){async function N(U){let x;try{if(x=await j.lstat(U),!x.isSymbolicLink())return{stat:x}}catch(G){}try{return{stat:await j.stat(U),symbolicLink:(x==null?void 0:x.isSymbolicLink())?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(k.isWindows&&G.code==="EACCES")try{return{stat:await j.stat(await j.readlink(U)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw se}throw G}}T.stat=N;async function F(U){try{const{stat:x,symbolicLink:G}=await T.stat(U);return x.isFile()&&(G==null?void 0:G.dangling)!==!0}catch(x){}return!1}T.existsFile=F;async function M(U){try{const{stat:x,symbolicLink:G}=await T.stat(U);return x.isDirectory()&&(G==null?void 0:G.dangling)!==!0}catch(x){}return!1}T.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new y.ResourceQueue;function o(T,N,F){return r.queueFor(c.URI.file(T),P.extUriBiasedIgnorePathCase).queue(()=>{const M=b(F);return new Promise((U,x)=>g(T,N,M,G=>G?x(G):U()))})}e.writeFile=o;let m=!0;function g(T,N,F,M){if(!m)return w.writeFile(T,N,{mode:F.mode,flag:F.flag},M);w.open(T,F.flag,F.mode,(U,x)=>{if(U)return M(U);w.writeFile(x,N,G=>{if(G)return w.close(x,()=>M(G));w.fdatasync(x,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),m=!1),w.close(x,be=>M(be))))})})}function E(T,N,F){const M=b(F);if(!m)return w.writeFileSync(T,N,{mode:M.mode,flag:M.flag});const U=w.openSync(T,M.flag,M.mode);try{w.writeFileSync(U,N);try{w.fdatasyncSync(U)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),m=!1}}finally{w.closeSync(U)}}e.writeFileSync=E;function b(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function a(T,N){if(T===N)return;async function F(M){try{const U=await j.lstat(M);if(U.isDirectory()||U.isSymbolicLink())return;await j.utimes(M,U.atime,new Date)}catch(U){}}try{await j.rename(T,N),await F(N)}catch(M){if(T.toLowerCase()!==N.toLowerCase()&&M.code==="EXDEV"||T.endsWith("."))await L(T,N,{preserveSymlinks:!1}),await l(T,p.MOVE),await F(N);else throw M}}e.move=a;async function L(T,N,F){return W(T,N,{root:{source:T,target:N},options:F,handledSourcePaths:new Set})}e.copy=L;const O=511;async function W(T,N,F){if(F.handledSourcePaths.has(T))return;F.handledSourcePaths.add(T);const{stat:M,symbolicLink:U}=await i.stat(T);if(U){if(F.options.preserveSymlinks)try{return await V(T,N,F)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(U.dangling)return}return M.isDirectory()?ee(T,N,M.mode&O,F):oe(T,N,M.mode&O)}async function ee(T,N,F,M){await j.mkdir(N,{recursive:!0,mode:F});const U=await S(T);for(const x of U)await W(A.join(T,x),A.join(N,x),M)}async function oe(T,N,F){await j.copyFile(T,N),await j.chmod(N,F)}async function V(T,N,F){let M=await j.readlink(T);D.isEqualOrParent(M,F.root.source,!k.isLinux)&&(M=A.join(F.root.target,M.substr(F.root.source.length+1))),await j.symlink(M,N)}async function B(T){try{return await j.access(T),!0}catch(N){return!1}}e.exists=B;var j;(function(T){T.access=C.promisify(w.access),T.stat=C.promisify(w.stat),T.lstat=C.promisify(w.lstat),T.utimes=C.promisify(w.utimes),T.read=C.promisify(w.read),T.readFile=C.promisify(w.readFile),T.write=C.promisify(w.write),T.writeFile=C.promisify(w.writeFile),T.appendFile=C.promisify(w.appendFile),T.fdatasync=C.promisify(w.fdatasync),T.truncate=C.promisify(w.truncate),T.rename=C.promisify(w.rename),T.copyFile=C.promisify(w.copyFile),T.open=C.promisify(w.open),T.close=C.promisify(w.close),T.symlink=C.promisify(w.symlink),T.readlink=C.promisify(w.readlink),T.chmod=C.promisify(w.chmod),T.readdir=C.promisify(w.readdir),T.mkdir=C.promisify(w.mkdir),T.unlink=C.promisify(w.unlink),T.rmdir=C.promisify(w.rmdir),T.realpath=C.promisify(w.realpath)})(j=e.Promises||(e.Promises={}))}),define(ge[102],pe([0,1,59,8,9,28]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function y(s){const P=C.dirname(s);if(s===P)return s;const c=(C.basename(s)||s).toLowerCase();try{const l=A.readdirSync(P).filter(h=>h.toLowerCase()===c);if(l.length===1){const h=y(P);if(h)return C.join(h,l[0])}else if(l.length>1){const h=l.indexOf(c);if(h>=0){const _=y(P);if(_)return C.join(_,l[h])}}}catch(p){}return null}e.realcaseSync=y;async function k(s){try{return await A.Promises.realpath(s)}catch(P){const c=I(s);return await A.Promises.access(c,w.constants.R_OK),c}}e.realpath=k;function D(s){try{return w.realpathSync(s)}catch(P){const c=I(s);return w.accessSync(c,w.constants.R_OK),c}}e.realpathSync=D;function I(s){return R.rtrim(C.normalize(s),C.sep)}});var Ve=this&&this.__decorate||function(Q,e,w,R){var C=arguments.length,A=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Q,e,w,R);else for(var k=Q.length-1;k>=0;k--)(y=Q[k])&&(A=(C<3?y(A):C>3?y(e,w,A):y(e,w))||A);return C>3&&A&&Object.defineProperty(e,w,A),A};define(ge[103],pe([0,1,3,6,13,21,16,23,17,12,58,8,53]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function l(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function _(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(v||(v={}));class S{constructor(M){this.buffer=M,this.pos=0}read(M){const U=this.buffer.slice(this.pos,this.pos+M);return this.pos+=U.byteLength,U}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var f;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(f||(f={}));function u(F){const M=k.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=k.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const i={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(i.Undefined);else if(typeof M=="string"){const U=k.VSBuffer.fromString(M);F.write(i.String),F.write(u(U.byteLength)),F.write(U)}else if(r&&Buffer.isBuffer(M)){const U=k.VSBuffer.wrap(M);F.write(i.Buffer),F.write(u(U.byteLength)),F.write(U)}else if(M instanceof k.VSBuffer)F.write(i.VSBuffer),F.write(u(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(i.Array),F.write(u(M.length));for(const U of M)o(F,U)}else{const U=k.VSBuffer.fromString(JSON.stringify(M));F.write(i.Object),F.write(u(U.byteLength)),F.write(U)}}function m(F){switch(F.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return F.read(t(F)).toString();case f.Buffer:return F.read(t(F)).buffer;case f.VSBuffer:return F.read(t(F));case f.Array:{const U=t(F),x=[];for(let G=0;G<U;G++)x.push(m(F));return x}case f.Object:return JSON.parse(F.read(t(F)).toString())}}class g{constructor(M,U,x=null,G=1e3){this.protocol=M,this.ctx=U,this.logger=x,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(M,U){this.channels.set(M,U),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const U=this.send([M.type]);this.logger&&this.logger.logOutgoing(U,0,1,_(M.type));return}case 201:case 202:case 204:case 203:{const U=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(U,M.id,1,_(M.type),M.data);return}}}send(M,U=void 0){const x=new d;return o(x,M),o(x,U),this.sendBuffer(x.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onRawMessage(M){const U=new S(M),x=m(U),G=m(U),se=x[0];switch(se){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${l(se)}: ${x[2]}.${x[3]}`,G),this.onPromise({type:se,id:x[1],channelName:x[2],name:x[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${l(se)}: ${x[2]}.${x[3]}`,G),this.onEventListen({type:se,id:x[1],channelName:x[2],name:x[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${l(se)}`),this.disposeActiveRequest({type:se,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${l(se)}`),this.disposeActiveRequest({type:se,id:x[1]})}}onPromise(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const x=new A.CancellationTokenSource;let G;try{G=U.call(this.ctx,M.name,M.arg,x.token)}catch(Te){G=Promise.reject(Te)}const se=M.id;G.then(Te=>{this.sendResponse({id:se,data:Te,type:201}),this.activeRequests.delete(M.id)},Te=>{Te instanceof Error?this.sendResponse({id:se,data:{message:Te.message,name:Te.name,stack:Te.stack?Te.stack.split?Te.stack.split(`
`):Te.stack:void 0},type:202}):this.sendResponse({id:se,data:Te,type:203}),this.activeRequests.delete(M.id)});const be=R.toDisposable(()=>x.cancel());this.activeRequests.set(M.id,be)}onEventListen(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const x=M.id,se=U.listen(this.ctx,M.name,M.arg)(be=>this.sendResponse({id:x,data:be,type:204}));this.activeRequests.set(M.id,se)}disposeActiveRequest(M){const U=this.activeRequests.get(M.id);U&&(U.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let U=this.pendingRequests.get(M.channelName);U||(U=[],this.pendingRequests.set(M.channelName,U));const x=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:M,timeoutTimer:x})}flushPendingRequests(M){const U=this.pendingRequests.get(M);if(U){for(const x of U)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var E;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(M,U=null){this.protocol=M,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=U}getChannel(M){const U=this;return{call(x,G,se){return U.isDisposed?Promise.reject(y.canceled()):U.requestPromise(M,x,G,se)},listen(x,G){return U.isDisposed?Promise.reject(y.canceled()):U.requestEvent(M,x,G)}}}requestPromise(M,U,x,G=A.CancellationToken.None){const se=this.lastRequestId++,Te={id:se,type:100,channelName:M,name:U,arg:x};if(G.isCancellationRequested)return Promise.reject(y.canceled());let Ce;return new Promise((qe,ze)=>{if(G.isCancellationRequested)return ze(y.canceled());const Ke=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(se),qe(Y.data);break;case 202:this.handlers.delete(se);const ce=new Error(Y.data.message);ce.stack=Y.data.stack,ce.name=Y.data.name,ze(ce);break;case 203:this.handlers.delete(se),ze(Y.data);break}};this.handlers.set(se,ae),this.sendRequest(Te)};let q=null;this.state===v.Idle?Ke():(q=C.createCancelablePromise(ae=>this.whenInitialized()),q.then(()=>{q=null,Ke()}));const J=()=>{q?(q.cancel(),q=null):this.sendRequest({id:se,type:101}),ze(y.canceled())},re=G.onCancellationRequested(J);Ce=R.combinedDisposable(R.toDisposable(J),re),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(M,U,x){const G=this.lastRequestId++,be={id:G,type:102,channelName:M,name:U,arg:x};let Te=null;const Ce=new w.Emitter({onFirstListenerAdd:()=>{Te=C.createCancelablePromise(qe=>this.whenInitialized()),Te.then(()=>{Te=null,this.activeRequests.add(Ce),this.sendRequest(be)})},onLastListenerRemove:()=>{Te?(Te.cancel(),Te=null):(this.activeRequests.delete(Ce),this.sendRequest({id:G,type:103}))}}),Me=qe=>Ce.fire(qe.data);return this.handlers.set(G,Me),Ce.event}sendRequest(M){switch(M.type){case 100:case 102:{const U=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(U,M.id,0,`${l(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const U=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(U,M.id,0,l(M.type));return}}}send(M,U=void 0){const x=new d;return o(x,M),o(x,U),this.sendBuffer(x.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onBuffer(M){const U=new S(M),x=m(U),G=m(U),se=x[0];switch(se){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,_(se)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],0,_(se),G),this.onResponse({type:x[0],id:x[1],data:G})}}onResponse(M){if(M.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const U=this.handlers.get(M.id);U&&U(M)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([c.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class a{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:U,onDidClientDisconnect:x})=>{w.Event.once(U.onMessage)(se=>{const be=new S(se),Te=m(be),Ce=new g(U,Te),Me=new b(U);this.channels.forEach((ze,Ke)=>Ce.registerChannel(Ke,ze));const qe={channelServer:Ce,channelClient:Me,ctx:Te};this._connections.add(qe),this._onDidAddConnection.fire(qe),x(()=>{Ce.dispose(),Me.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const M=[];return this._connections.forEach(U=>M.push(U)),M}getChannel(M,U){const x=this;return{call(G,se,be){let Te;if(I.isFunction(U)){let Me=D.getRandomElement(x.connections.filter(U));Te=Me?Promise.resolve(Me):w.Event.toPromise(w.Event.filter(x.onDidAddConnection,U))}else Te=U.routeCall(x,G,se);const Ce=Te.then(Me=>Me.channelClient.getChannel(M));return O(Ce).call(G,se,be)},listen(G,se){if(I.isFunction(U))return x.getMulticastEvent(M,U,G,se);const be=U.routeEvent(x,G,se).then(Te=>Te.channelClient.getChannel(M));return O(be).listen(G,se)}}}getMulticastEvent(M,U,x,G){const se=this;let be=new R.DisposableStore;const Te=new w.Emitter({onFirstListenerAdd:()=>{be=new R.DisposableStore;const Ce=new w.EventMultiplexer,Me=new Map,qe=Ke=>{const J=Ke.channelClient.getChannel(M).listen(x,G),re=Ce.add(J);Me.set(Ke,re)},ze=Ke=>{const q=Me.get(Ke);!q||(q.dispose(),Me.delete(Ke))};se.connections.filter(U).forEach(qe),w.Event.filter(se.onDidAddConnection,U)(qe,void 0,be),se.onDidRemoveConnection(ze,void 0,be),Ce.event(Te.fire,Te,be),be.add(Ce)},onLastListenerRemove:()=>{be.dispose()}});return Te.event}registerChannel(M,U){this.channels.set(M,U),this._connections.forEach(x=>{x.channelServer.registerChannel(M,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=a;class L{constructor(M,U,x=null){const G=new d;o(G,U),M.send(G.buffer),this.channelClient=new b(M,x),this.channelServer=new g(M,U,x)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,U){this.channelServer.registerChannel(M,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,U,x){return F.then(G=>G.call(M,U,x))},listen(M,U){const x=new w.Relay;return F.then(G=>x.input=G.listen(M,U)),x.event}}}e.getDelayedChannel=O;function W(F){let M=!1;return{call(U,x,G){return M?F.call(U,x,G):C.timeout(0).then(()=>M=!0).then(()=>F.call(U,x,G))},listen(U,x){if(M)return F.listen(U,x);const G=new w.Relay;return C.timeout(0).then(()=>M=!0).then(()=>G.input=F.listen(U,x)),G.event}}}e.getNextTickChannel=W;class ee{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const U of M.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await w.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ee;var oe;(function(F){function M(G,se){const be=G,Te=se&&se.disableMarshalling,Ce=new Map;for(const Me in be)x(Me)&&Ce.set(Me,w.Event.buffer(be[Me],!0));return new class{listen(Me,qe){const ze=Ce.get(qe);if(ze)return ze;throw new Error(`Event not found: ${qe}`)}call(Me,qe,ze){const Ke=be[qe];if(typeof Ke=="function"){if(!Te&&Array.isArray(ze))for(let q=0;q<ze.length;q++)ze[q]=s.revive(ze[q]);return Ke.apply(be,ze)}throw new Error(`Method not found: ${qe}`)}}}F.fromService=M;function U(G,se){const be=se&&se.disableMarshalling;return new Proxy({},{get(Te,Ce){var Me;if(typeof Ce=="string")return((Me=se==null?void 0:se.properties)===null||Me===void 0?void 0:Me.has(Ce))?se.properties.get(Ce):x(Ce)?G.listen(Ce):async function(...qe){let ze;se&&!I.isUndefinedOrNull(se.context)?ze=[se.context,...qe]:ze=qe;const Ke=await G.call(Ce,ze);return be?Ke:s.revive(Ke)};throw new Error(`Property not found: ${String(Ce)}`)}})}F.toService=U;function x(G){return G[0]==="o"&&G[1]==="n"&&P.isUpperAsciiLetter(G.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function j(F){return Array.isArray(F)?F.map(B):B(F)}function T(F,M,U,x,G,se,be){be=j(be);const Te=V[G],Ce=Te[x%Te.length];let Me=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(se)?(Me=Me.concat(be),Me.push(")")):Me.push(be),console.log.apply(console,Me)}e.logWithColors=T;class N{constructor(M,U){this._outgoingPrefix=M,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,U,x,G,se){this._totalOutgoing+=M,T(this._outgoingPrefix,this._totalOutgoing,M,U,x,G,se)}logIncoming(M,U,x,G,se){this._totalIncoming+=M,T(this._incomingPrefix,this._totalIncoming,M,U,x,G,se)}}e.IPCLogger=N}),define(ge[104],pe([0,1,3,103,6,23,11,36]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function I(){return D||(D=A.VSBuffer.alloc(0)),D}class s{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,r){if(i===0)return I();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const E=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=i),E}if(this._chunks[0].byteLength>i){const E=this._chunks[0].slice(0,i);return r&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),E}let o=A.VSBuffer.alloc(i),m=0,g=0;for(;i>0;){const E=this._chunks[g];if(E.byteLength>i){const b=E.slice(0,i);o.set(b,m),m+=i,r&&(this._chunks[g]=E.slice(i),this._totalLength-=i),i-=i}else o.set(E,m),m+=E.byteLength,r?(this._chunks.shift(),this._totalLength-=E.byteLength):g++,i-=E.byteLength}return o}}e.ChunkStream=s;var P;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(P||(P={}));var c;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(c=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(i,r,o,m){this.type=i,this.id=r,this.ack=o,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends C.Disposable{constructor(i){super();this._onMessage=this._register(new w.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new s,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,m=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(o,m,g,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=A.VSBuffer.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this._writeSoon(r,i.data)}_bufferAdd(i,r){const o=this._totalLength===0;return this._data.push(i,r),this._totalLength+=i.byteLength+r.byteLength,o}_bufferTake(){const i=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,r){this._bufferAdd(i,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class _ extends C.Disposable{constructor(i){super();this._onMessage=new w.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new l(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new p(1,0,0,i))}}e.Protocol=_;class v extends R.IPCClient{constructor(i,r,o=null){super(i,r,o);this.protocol=i}static fromSocket(i,r){return new v(new _(i),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=v;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new w.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class d{constructor(i){this.data=i,this.next=null}}class f{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],r=0,o=this._first;for(;o;)i[r++]=o.data,o=o.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const r=new d(i);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class u{constructor(){this.lastRuns=[];const i=Date.now();for(let r=0;r<u._HISTORY_LENGTH;r++)this.lastRuns[r]=i-1e3*r;setInterval(()=>{for(let r=u._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const i=Date.now(),r=(1+u._HISTORY_LENGTH)*1e3;let o=0;for(let m=0;m<u._HISTORY_LENGTH;m++)i-this.lastRuns[m]<=r&&o++;return 1-o/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class t{constructor(i,r=null){this._loadEstimator=u.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new f,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=C.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new p(5,0,0,I());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const r=new p(4,0,0,I());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,r){this._isReconnecting=!0,this._socketDisposables=C.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let r=0,o=i.length;r<o;r++)this._socketWriter.write(i[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new p(6,0,0,I())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,m=r.length;o<m;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,r,this._incomingAckId,i);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(i){const r=new p(2,0,0,i);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),r=Date.now()-i.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new p(3,0,this._incomingAckId,I());this._socketWriter.write(i)}}e.PersistentProtocol=t}),define(ge[105],pe([0,1,94]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(k){let D=w.toUint8(k);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){let D=new Uint8Array(256);for(let I=0;I<256;I++)D[I]=k;return D}set(k,D){let I=w.toUint8(D);k>=0&&k<256?this._asciiMap[k]=I:this._map.set(k,I)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(C||(C={}));class A{constructor(){this._actual=new R(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=A}),define(ge[140],pe([0,1,105]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends w.CharacterClassifier{constructor(k){super(0);for(let D=0,I=k.length;D<I;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function A(y){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=y(D)),k[D])}e.getMapForWordSeparators=A(y=>new C(y))}),define(ge[46],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(C,A){this.lineNumber=C,this.column=A}with(C=this.lineNumber,A=this.column){return C===this.lineNumber&&A===this.column?this:new w(C,A)}delta(C=0,A=0){return this.with(this.lineNumber+C,this.column+A)}equals(C){return w.equals(this,C)}static equals(C,A){return!C&&!A?!0:!!C&&!!A&&C.lineNumber===A.lineNumber&&C.column===A.column}isBefore(C){return w.isBefore(this,C)}static isBefore(C,A){return C.lineNumber<A.lineNumber?!0:A.lineNumber<C.lineNumber?!1:C.column<A.column}isBeforeOrEqual(C){return w.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,A){return C.lineNumber<A.lineNumber?!0:A.lineNumber<C.lineNumber?!1:C.column<=A.column}static compare(C,A){let y=C.lineNumber|0,k=A.lineNumber|0;if(y===k){let D=C.column|0,I=A.column|0;return D-I}return y-k}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new w(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=w}),define(ge[42],pe([0,1,46]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(A,y,k,D){A>k||A===k&&y>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return R.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return R.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return R.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return R.plusRange(this,A)}static plusRange(A,y){let k,D,I,s;return y.startLineNumber<A.startLineNumber?(k=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(k=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(k=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(I=y.endLineNumber,s=y.endColumn):y.endLineNumber===A.endLineNumber?(I=y.endLineNumber,s=Math.max(y.endColumn,A.endColumn)):(I=A.endLineNumber,s=A.endColumn),new R(k,D,I,s)}intersectRanges(A){return R.intersectRanges(this,A)}static intersectRanges(A,y){let k=A.startLineNumber,D=A.startColumn,I=A.endLineNumber,s=A.endColumn,P=y.startLineNumber,c=y.startColumn,p=y.endLineNumber,l=y.endColumn;return k<P?(k=P,D=c):k===P&&(D=Math.max(D,c)),I>p?(I=p,s=l):I===p&&(s=Math.min(s,l)),k>I||k===I&&D>s?null:new R(k,D,I,s)}equalsRange(A){return R.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(A){return new w.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(A){return new w.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new R(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new R(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(A){return new R(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const I=A.startLineNumber|0,s=y.startLineNumber|0;if(I===s){const P=A.startColumn|0,c=y.startColumn|0;if(P===c){const p=A.endLineNumber|0,l=y.endLineNumber|0;if(p===l){const h=A.endColumn|0,_=y.endColumn|0;return h-_}return p-l}return P-c}return I-s}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=R}),define(ge[141],pe([0,1,46,42]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class A extends R.Range{constructor(k,D,I,s){super(k,D,I,s);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=I,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return A.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,k,D):new A(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,D){return this.getDirection()===0?new A(k,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new A(k.lineNumber,k.column,D.lineNumber,D.column)}static liftSelection(k){return new A(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let I=0,s=k.length;I<s;I++)if(!this.selectionsEqual(k[I],D[I]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,I,s,P){return P===0?new A(k,D,I,s):new A(I,s,k,D)}}e.Selection=A}),define(ge[106],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(h){this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace)}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class D{constructor(h,_){this.range=h,this.matches=_}}e.FindMatch=D;var I;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var s;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right"})(s=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class c{constructor(h,_,v,S,d,f){this.identifier=h,this.range=_,this.text=v,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=d,this._isTracked=f}}e.ValidAnnotatedEditOperation=c;class p{constructor(h,_,v){this.reverseEdits=h,this.changes=_,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=p}),define(ge[142],pe([0,1,8,140,46,42,106]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(d,f,u,t){this.searchString=d,this.isRegex=f,this.matchCase=u,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=I(this.searchString):d=this.searchString.indexOf(`
`)>=0;let f=null;try{f=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let u=!this.isRegex&&!d;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new s(f,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,u?this.searchString:null)}}e.SearchParams=D;function I(S){if(!S||S.length===0)return!1;for(let d=0,f=S.length;d<f;d++)if(S.charCodeAt(d)===92){if(d++,d>=f)break;const t=S.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=I;class s{constructor(d,f,u){this.regex=d,this.wordSeparators=f,this.simpleSearch=u}}e.SearchData=s;function P(S,d,f){if(!f)return new y.FindMatch(S,null);let u=[];for(let t=0,n=d.length;t<n;t++)u[t]=d[t];return new y.FindMatch(S,u)}e.createFindMatch=P;class c{constructor(d){let f=[],u=0;for(let t=0,n=d.length;t<n;t++)d.charCodeAt(t)===10&&(f[u++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(d){const f=this._lineFeedsOffsets;let u=0,t=f.length-1;if(t===-1||d<=f[0])return 0;for(;u<t;){const n=u+((t-u)/2>>0);f[n]>=d?t=n-1:f[n+1]>=d?(u=n,t=n):u=n+1}return u+1}}class p{static findMatches(d,f,u,t,n){const i=f.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(d,u,new v(i.wordSeparators,i.regex),t,n):this._doFindMatchesLineByLine(d,u,i,t,n):[]}static _getMultilineMatchRange(d,f,u,t,n,i){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=f+n+o):r=f+n;let m;if(t){let a=t.findLineFeedCountBeforeOffset(n+i.length)-o;m=r+i.length+a}else m=r+i.length;const g=d.getPositionAt(r),E=d.getPositionAt(m);return new A.Range(g.lineNumber,g.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(d,f,u,t,n){const i=d.getOffsetAt(f.getStartPosition()),r=d.getValueInRange(f,1),o=d.getEOL()===`\r
`?new c(r):null,m=[];let g=0,E;for(u.reset(0);E=u.next(r);)if(m[g++]=P(this._getMultilineMatchRange(d,i,r,o,E.index,E[0]),E,t),g>=n)return m;return m}static _doFindMatchesLineByLine(d,f,u,t,n){const i=[];let r=0;if(f.startLineNumber===f.endLineNumber){const m=d.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(u,m,f.startLineNumber,f.startColumn-1,r,i,t,n),i}const o=d.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(u,o,f.startLineNumber,f.startColumn-1,r,i,t,n);for(let m=f.startLineNumber+1;m<f.endLineNumber&&r<n;m++)r=this._findMatchesInLine(u,d.getLineContent(m),m,0,r,i,t,n);if(r<n){const m=d.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(u,m,f.endLineNumber,0,r,i,t,n)}return i}static _findMatchesInLine(d,f,u,t,n,i,r,o){const m=d.wordSeparators;if(!r&&d.simpleSearch){const b=d.simpleSearch,a=b.length,L=f.length;let O=-a;for(;(O=f.indexOf(b,O+a))!==-1;)if((!m||_(m,f,L,O,a))&&(i[n++]=new y.FindMatch(new A.Range(u,O+1+t,u,O+1+a+t),null),n>=o))return n;return n}const g=new v(d.wordSeparators,d.regex);let E;g.reset(0);do if(E=g.next(f),E&&(i[n++]=P(new A.Range(u,E.index+1+t,u,E.index+1+E[0].length+t),E,r),n>=o))return n;while(E);return n}static findNextMatch(d,f,u,t){const n=f.parseSearchRequest();if(!n)return null;const i=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(d,u,i,t):this._doFindNextMatchLineByLine(d,u,i,t)}static _doFindNextMatchMultiline(d,f,u,t){const n=new C.Position(f.lineNumber,1),i=d.getOffsetAt(n),r=d.getLineCount(),o=d.getValueInRange(new A.Range(n.lineNumber,n.column,r,d.getLineMaxColumn(r)),1),m=d.getEOL()===`\r
`?new c(o):null;u.reset(f.column-1);let g=u.next(o);return g?P(this._getMultilineMatchRange(d,i,o,m,g.index,g[0]),g,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(d,new C.Position(1,1),u,t):null}static _doFindNextMatchLineByLine(d,f,u,t){const n=d.getLineCount(),i=f.lineNumber,r=d.getLineContent(i),o=this._findFirstMatchInLine(u,r,i,f.column,t);if(o)return o;for(let m=1;m<=n;m++){const g=(i+m-1)%n,E=d.getLineContent(g+1),b=this._findFirstMatchInLine(u,E,g+1,1,t);if(b)return b}return null}static _findFirstMatchInLine(d,f,u,t,n){d.reset(t-1);const i=d.next(f);return i?P(new A.Range(u,i.index+1,u,i.index+1+i[0].length),i,n):null}static findPreviousMatch(d,f,u,t){const n=f.parseSearchRequest();if(!n)return null;const i=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(d,u,i,t):this._doFindPreviousMatchLineByLine(d,u,i,t)}static _doFindPreviousMatchMultiline(d,f,u,t){const n=this._doFindMatchesMultiline(d,new A.Range(1,1,f.lineNumber,f.column),u,t,10*k);if(n.length>0)return n[n.length-1];const i=d.getLineCount();return f.lineNumber!==i||f.column!==d.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(d,new C.Position(i,d.getLineMaxColumn(i)),u,t):null}static _doFindPreviousMatchLineByLine(d,f,u,t){const n=d.getLineCount(),i=f.lineNumber,r=d.getLineContent(i).substring(0,f.column-1),o=this._findLastMatchInLine(u,r,i,t);if(o)return o;for(let m=1;m<=n;m++){const g=(n+i-m-1)%n,E=d.getLineContent(g+1),b=this._findLastMatchInLine(u,E,g+1,t);if(b)return b}return null}static _findLastMatchInLine(d,f,u,t){let n=null,i;for(d.reset(0);i=d.next(f);)n=P(new A.Range(u,i.index+1,u,i.index+1+i[0].length),i,t);return n}}e.TextModelSearch=p;function l(S,d,f,u,t){if(u===0)return!0;const n=d.charCodeAt(u-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const i=d.charCodeAt(u);if(S.get(i)!==0)return!0}return!1}function h(S,d,f,u,t){if(u+t===f)return!0;const n=d.charCodeAt(u+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const i=d.charCodeAt(u+t-1);if(S.get(i)!==0)return!0}return!1}function _(S,d,f,u,t){return l(S,d,f,u,t)&&h(S,d,f,u,t)}e.isValidMatch=_;class v{constructor(d,f){this._wordSeparators=d,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const f=d.length;let u;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(u=this._searchRegex.exec(d),!u))return null;const t=u.index,n=u[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){w.getNextCodePoint(d,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||_(this._wordSeparators,d,f,t,n))return u}while(u);return null}}e.Searcher=v}),define(ge[107],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)k.indexOf(I)>=0||(D+="\\"+I);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=w();function R(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let I="g";k.ignoreCase&&(I+="i"),k.multiline&&(I+="m"),k.unicode&&(I+="u"),D=new RegExp(k.source,I)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function A(k,D,I,s,P=C){if(I.length>P.maxLen){let _=k-P.maxLen/2;return _<0?_=0:s+=_,I=I.substring(_,k+P.maxLen/2),A(k,D,I,s,P)}const c=Date.now(),p=k-1-s;let l=-1,h=null;for(let _=1;!(Date.now()-c>=P.timeBudget);_++){const v=p-P.windowSize*_;D.lastIndex=Math.max(0,v);const S=y(D,I,p,l);if(!S&&h||(h=S,v<=0))break;l=v}if(h){let _={word:h[0],startColumn:s+1+h.index,endColumn:s+1+h.index+h[0].length};return D.lastIndex=0,_}return null}e.getWordAtText=A;function y(k,D,I,s){let P;for(;P=k.exec(D);){const c=P.index||0;if(c<=I&&k.lastIndex>=I)return P;if(s>0&&c>s)return null}return null}}),define(ge[143],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class R{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,I=k.notIn.length;D<I;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function A(y,k,D){y.has(k)?y.get(k).push(D):y.set(k,[D])}}),define(ge[78],pe([0,1,30,9]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(A,y,k,D){if(Array.isArray(A)){let I=0;for(const s of A){const P=C(s,y,k,D);if(P===10)return P;P>I&&(I=P)}return I}else{if(typeof A=="string")return D?A==="*"?5:A===k?10:0:0;if(A){const{language:I,pattern:s,scheme:P,hasAccessToAllModels:c}=A;if(!D&&!c)return 0;let p=0;if(P)if(P===y.scheme)p=10;else if(P==="*")p=5;else return 0;if(I)if(I===k)p=10;else if(I==="*")p=Math.max(p,5);else return 0;if(s){let l;if(typeof s=="string"?l=s:l=Object.assign(Object.assign({},s),{base:R.normalize(s.base)}),l===y.fsPath||w.match(l,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=C}),define(ge[144],pe([0,1,105]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(l,h,_){const v=new Uint8Array(l*h);for(let S=0,d=l*h;S<d;S++)v[S]=_;this._data=v,this.rows=l,this.cols=h}get(l,h){return this._data[l*this.cols+h]}set(l,h,_){this._data[l*this.cols+h]=_}}e.Uint8Matrix=C;class A{constructor(l){let h=0,_=0;for(let S=0,d=l.length;S<d;S++){let[f,u,t]=l[S];u>h&&(h=u),f>_&&(_=f),t>_&&(_=t)}h++,_++;let v=new C(_,h,0);for(let S=0,d=l.length;S<d;S++){let[f,u,t]=l[S];v.set(f,u,t)}this._states=v,this._maxCharCode=h}nextState(l,h){return h<0||h>=this._maxCharCode?0:this._states.get(l,h)}}e.StateMachine=A;let y=null;function k(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let I=null;function s(){if(I===null){I=new w.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<p.length;h++)I.set(p.charCodeAt(h),1);const l=".,;";for(let h=0;h<l.length;h++)I.set(l.charCodeAt(h),2)}return I}class P{static _createLink(l,h,_,v,S){let d=S-1;do{const f=h.charCodeAt(d);if(l.get(f)!==2)break;d--}while(d>v);if(v>0){const f=h.charCodeAt(v-1),u=h.charCodeAt(d);(f===40&&u===41||f===91&&u===93||f===123&&u===125)&&d--}return{range:{startLineNumber:_,startColumn:v+1,endLineNumber:_,endColumn:d+2},url:h.substring(v,d+1)}}static computeLinks(l,h=k()){const _=s();let v=[];for(let S=1,d=l.getLineCount();S<=d;S++){const f=l.getLineContent(S),u=f.length;let t=0,n=0,i=0,r=1,o=!1,m=!1,g=!1,E=!1;for(;t<u;){let b=!1;const a=f.charCodeAt(t);if(r===13){let L;switch(a){case 40:o=!0,L=0;break;case 41:L=o?0:1;break;case 91:g=!0,m=!0,L=0;break;case 93:g=!1,L=m?0:1;break;case 123:E=!0,L=0;break;case 125:L=E?0:1;break;case 39:L=i===34||i===96?0:1;break;case 34:L=i===39||i===96?0:1;break;case 96:L=i===39||i===34?0:1;break;case 42:L=i===42?1:0;break;case 124:L=i===124?1:0;break;case 32:L=g?0:1;break;default:L=_.get(a)}L===1&&(v.push(P._createLink(_,f,S,n,t)),b=!0)}else if(r===12){let L;a===91?(m=!0,L=0):L=_.get(a),L===1?b=!0:r=13}else r=h.nextState(r,a),r===0&&(b=!0);b&&(r=1,o=!1,m=!1,E=!1,n=t+1,i=a),t++}r===13&&v.push(P._createLink(_,f,S,n,u))}return v}}e.LinkComputer=P;function c(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:P.computeLinks(p)}e.computeLinks=c}),define(ge[145],pe([0,1,3,6]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,k){return this._map.set(y,k),this.fire([y]),R.toDisposable(()=>{this._map.get(y)===k&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,k){let D=null,I=!1;return this._promises.set(y,k.then(s=>{this._promises.delete(y),!(I||!s)&&(D=this.register(y,s))})),R.toDisposable(()=>{I=!0,D&&D.dispose()})}getPromise(y){const k=this.get(y);if(k)return Promise.resolve(k);const D=this._promises.get(y);return D?D.then(I=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(ge[108],pe([0,1,23,11]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(C||(C={}));function A(P){for(let c=0,p=P.length;c<p;c+=4){const l=P[c+0],h=P[c+1],_=P[c+2],v=P[c+3];P[c+0]=v,P[c+1]=_,P[c+2]=h,P[c+3]=l}}function y(P){const c=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||A(c),w.VSBuffer.wrap(c)}function k(P){const c=P.buffer;if(R.isLittleEndian()||A(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const p=new Uint8Array(c.byteLength);return p.set(c),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(P){const c=new Uint32Array(I(P));let p=0;if(c[p++]=P.id,P.type==="full")c[p++]=1,c[p++]=P.data.length,c.set(P.data,p),p+=P.data.length;else{c[p++]=2,c[p++]=P.deltas.length;for(const l of P.deltas)c[p++]=l.start,c[p++]=l.deleteCount,l.data?(c[p++]=l.data.length,c.set(l.data,p),p+=l.data.length):c[p++]=0}return y(c)}e.encodeSemanticTokensDto=D;function I(P){let c=0;if(c+=1+1,P.type==="full")c+=1+P.data.length;else{c+=1,c+=(1+1+1)*P.deltas.length;for(const p of P.deltas)p.data&&(c+=p.data.length)}return c}function s(P){const c=k(P);let p=0;const l=c[p++];if(c[p++]===1){const S=c[p++],d=c.subarray(p,p+S);return p+=S,{id:l,type:"full",data:d}}const _=c[p++];let v=[];for(let S=0;S<_;S++){const d=c[p++],f=c[p++],u=c[p++];let t;u>0&&(t=c.subarray(p,p+u),p+=u),v[S]={start:d,deleteCount:f,data:t}}return{id:l,type:"delta",deltas:v}}e.decodeSemanticTokensDto=s}),define(ge[109],pe([0,1,94]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(y,k){this.index=y,this.remainder=k}}e.PrefixSumIndexOfResult=R;class C{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,k){y=w.toUint32(y);const D=this.values,I=this.prefixSum,s=k.length;return s===0?!1:(this.values=new Uint32Array(D.length+s),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+s),this.values.set(k,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,k){return y=w.toUint32(y),k=w.toUint32(k),this.values[y]===k?!1:(this.values[y]=k,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,k){y=w.toUint32(y),k=w.toUint32(k);const D=this.values,I=this.prefixSum;if(y>=D.length)return!1;let s=D.length-y;return k>=s&&(k=s),k===0?!1:(this.values=new Uint32Array(D.length-k),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+k),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=w.toUint32(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),y>=this.values.length&&(y=this.values.length-1);for(let D=k;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let k=0,D=this.values.length-1,I=0,s=0,P=0;for(;k<=D;)if(I=k+(D-k)/2|0,s=this.prefixSum[I],P=s-this.values[I],y<P)D=I-1;else if(y>=s)k=I+1;else break;return new R(I,y-P)}}e.PrefixSumComputer=C}),define(ge[146],pe([0,1,8,46,109]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(k,D,I,s){this._uri=k,this._lines=D,this._eol=I,this._versionId=s,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const I of D)this._acceptDeleteRange(I.range),this._acceptInsertText(new R.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,I=new Uint32Array(D);for(let s=0;s<D;s++)I[s]=this._lines[s].length+k;this._lineStarts=new C.PrefixSumComputer(I)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length===0)return;let I=w.splitLines(D);if(I.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}I[I.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]);let s=new Uint32Array(I.length-1);for(let P=1;P<I.length;P++)this._lines.splice(k.lineNumber+P-1,0,I[P]),s[P-1]=I[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,s)}}e.MirrorTextModel=A}),define(ge[147],pe([18,19]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ge[148],pe([0,1,147]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,A=C*24,y=A*7,k=A*30,D=A*365;function I(P,c){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return w.localize(0,null,I(new Date().getTime()+p*1e3,!1));if(p<30)return w.localize(1,null);let l;return p<R?(l=p,c?l===1?w.localize(2,null,l):w.localize(3,null,l):l===1?w.localize(4,null,l):w.localize(5,null,l)):p<C?(l=Math.floor(p/R),c?l===1?w.localize(6,null,l):w.localize(7,null,l):l===1?w.localize(8,null,l):w.localize(9,null,l)):p<A?(l=Math.floor(p/C),c?l===1?w.localize(10,null,l):w.localize(11,null,l):l===1?w.localize(12,null,l):w.localize(13,null,l)):p<y?(l=Math.floor(p/A),c?l===1?w.localize(14,null,l):w.localize(15,null,l):l===1?w.localize(16,null,l):w.localize(17,null,l)):p<k?(l=Math.floor(p/y),c?l===1?w.localize(18,null,l):w.localize(19,null,l):l===1?w.localize(20,null,l):w.localize(21,null,l)):p<D?(l=Math.floor(p/k),c?l===1?w.localize(22,null,l):w.localize(23,null,l):l===1?w.localize(24,null,l):w.localize(25,null,l)):(l=Math.floor(p/D),c?l===1?w.localize(26,null,l):w.localize(27,null,l):l===1?w.localize(28,null,l):w.localize(29,null,l))}e.fromNow=I;function s(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=s}),define(ge[149],pe([18,19]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ge[60],pe([0,1,149,12,17]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(I,s){return s&&(I.stack||I.stacktrace)?w.localize(0,null,k(I),y(I.stack)||y(I.stacktrace)):k(I)}function y(I){return Array.isArray(I)?I.join(`
`):I}function k(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?w.localize(1,null,I.message):I.message||w.localize(2,null)}function D(I=null,s=!1){if(!I)return w.localize(3,null);if(Array.isArray(I)){const P=C.coalesce(I),c=D(P[0],s);return P.length>1?w.localize(4,null,c,P.length):c}if(R.isString(I))return I;if(I.detail){const P=I.detail;if(P.error)return A(P.error,s);if(P.exception)return A(P.exception,s)}return I.stack?A(I,s):I.message?I.message:w.localize(5,null)}e.toErrorMessage=D}),define(ge[150],pe([18,19]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ge[110],pe([0,1,9,28,37,150,36,12,25,29,11,139,10]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(f,u){if(s.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};u&&(t.cwd=u);const n=C.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],t);return new Promise(i=>{n.once("error",r=>{i({success:!1,error:r})}),n.once("exit",(r,o)=>{i(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(s.isLinux||s.isMacintosh)try{const t=c.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(n=>{C.execFile(t,[f.pid.toString()],{encoding:"utf8",shell:!0},(i,r,o)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function h(f=y.env){return f.comspec||"cmd.exe"}e.getWindowsShell=h;class _{constructor(u,t,n,i){if(t!==void 0&&n!==void 0&&i!==void 0)this.cmd=u,this.args=t,this.shell=n,this.options=i;else{const r=u;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(y.env).forEach(o=>{r[o]=y.env[o]}),Object.keys(this.options.env).forEach(o=>{r[o]=this.options.env[o]}),this.options.env=r}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const t=u.lastIndexOf(w.sep);return t!==-1&&(u=u.substring(t+1)),_.WellKnowCommands[u]?u:"other"}start(u){return s.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(y.cwd()))?Promise.reject(new Error(A.localize(0,null))):this.useExec().then(t=>{let n,i;const r=new Promise((o,m)=>{n=o,i=m});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=C.exec(o,this.options,(m,g,E)=>{this.childProcess=null;const b=m;b&&b.killed?i({killed:this.terminateRequested,stdout:g.toString(),stderr:E.toString()}):this.handleExec(n,u,m,g,E)})}else{let o=null;const m=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,n,u,i);const E={terminated:this.terminateRequested};k.isNumber(g)&&(E.cmdCode=g),n(E)};if(this.shell&&s.isWindows){const g=D.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let E=!1,b=!1;const a=[];let L=this.ensureQuotes(this.cmd);a.push(L.value),E=L.quoted,this.args&&this.args.forEach(W=>{L=this.ensureQuotes(W),a.push(L.value),b=b&&L.quoted});const O=["/s","/c"];E?b?O.push('"'+a.join(" ")+'"'):a.length>1?O.push('"'+a[0]+'" '+a.slice(1).join(" ")):O.push('"'+a[0]+'"'):O.push(a.join(" ")),o=C.spawn(h(),O,g)}else this.cmd&&(o=C.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(k.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",g=>{this.childProcess=null,i({terminated:this.terminateRequested,error:g})}),o.pid&&(this.childProcess.on("close",m),this.handleSpawn(o,n,u,i,!0)))}return r})}handleClose(u,t,n,i){}ensureQuotes(u){return _.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,l(u,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!s.isWindows)return u(!1);const t=C.spawn(h(),["/s","/c"]);t.on("error",n=>u(!0)),t.on("exit",n=>u(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class v extends _{constructor(u,t,n,i){super(u,t,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,t,n,i,r){[i,r].forEach((o,m)=>{const g=new P.LineDecoder;g.write(o).forEach(a=>{t({line:a,source:m===0?0:1})});const b=g.end();b&&t({line:b,source:m===0?0:1})}),u({terminated:this.terminateRequested,error:n})}handleSpawn(u,t,n,i,r){const o=new P.LineDecoder,m=new P.LineDecoder;u.stdout.on("data",g=>{o.write(g).forEach(b=>n({line:b,source:0}))}),u.stderr.on("data",g=>{m.write(g).forEach(b=>n({line:b,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=m}handleClose(u,t,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&n({line:o,source:1})}}e.LineProcess=v;function S(f){let u=[],t=!1;const n=function(i){if(t){u.push(i);return}(!f.send(i,o=>{if(o&&console.error(o),t=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(g=>n(g))}})||s.isWindows)&&(t=!0)};return{send:n}}e.createQueuedSender=S;var d;(function(f){async function u(t,n,i){if(w.isAbsolute(t))return t;if(n===void 0&&(n=y.cwd()),w.dirname(t)!=="."||(i===void 0&&k.isString(y.env.PATH)&&(i=y.env.PATH.split(w.delimiter)),i===void 0||i.length===0))return w.join(n,t);async function o(m){return await R.exists(m)?!(await R.Promises.stat(m)).isDirectory():!1}for(let m of i){let g;if(w.isAbsolute(m)?g=w.join(m,t):g=w.join(n,m,t),await o(g))return g;let E=g+".com";if(await o(E)||(E=g+".exe",await o(E)))return E}return w.join(n,t)}f.findExecutable=u})(d=e.win32||(e.win32={}))}),define(ge[151],pe([18,19]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(ge[152],pe([0,1,151,11,107]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=y;class k{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Ee){this._values[ie]=Ee}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class I{constructor(ie,Ee,Ne,$e){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=$e}compute(ie,Ee,Ne){return Ne}}class s{constructor(ie,Ee=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ie){return this.defaultValue}}class P{constructor(ie,Ee,Ne,$e){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=$e}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Ee,Ne){return Ne}}function c(K,ie){return typeof K=="undefined"?ie:K==="false"?!1:Boolean(K)}e.boolean=c;class p extends P{constructor(ie,Ee,Ne,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Ne),super(ie,Ee,Ne,$e)}validate(ie){return c(ie,this.defaultValue)}}class l extends P{constructor(ie,Ee,Ne,$e,We,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Ne,Xe.minimum=$e,Xe.maximum=We),super(ie,Ee,Ne,Xe),this.minimum=$e,this.maximum=We}static clampedInt(ie,Ee,Ne,$e){if(typeof ie=="undefined")return Ee;let We=parseInt(ie,10);return isNaN(We)?Ee:(We=Math.max(Ne,We),We=Math.min($e,We),We|0)}validate(ie){return l.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class h extends P{constructor(ie,Ee,Ne,$e,We){typeof We!="undefined"&&(We.type="number",We.default=Ne),super(ie,Ee,Ne,We),this.validationFn=$e}static clamp(ie,Ee,Ne){return ie<Ee?Ee:ie>Ne?Ne:ie}static float(ie,Ee){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Ee;const Ne=parseFloat(ie);return isNaN(Ne)?Ee:Ne}validate(ie){return this.validationFn(h.float(ie,this.defaultValue))}}class _ extends P{static string(ie,Ee){return typeof ie!="string"?Ee:ie}constructor(ie,Ee,Ne,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Ne),super(ie,Ee,Ne,$e)}validate(ie){return _.string(ie,this.defaultValue)}}function v(K,ie,Ee){return typeof K!="string"||Ee.indexOf(K)===-1?ie:K}e.stringSet=v;class S extends P{constructor(ie,Ee,Ne,$e,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=$e,We.default=Ne),super(ie,Ee,Ne,We),this._allowedValues=$e}validate(ie){return v(ie,this.defaultValue,this._allowedValues)}}class d extends I{constructor(ie,Ee,Ne,$e,We,Xe,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=We,De.default=$e),super(ie,Ee,Ne,De),this._allowedValues=We,this._convert=Xe}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function f(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Ee,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends I{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertSpace:c(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(K){switch(K){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function m(K){switch(K){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class g extends s{constructor(){super(124,[62,31])}compute(ie,Ee,Ne){const $e=["monaco-editor"];return Ee.get(31)&&$e.push(Ee.get(31)),ie.extraEditorClassName&&$e.push(ie.extraEditorClassName),Ee.get(62)==="default"?$e.push("mouse-default"):Ee.get(62)==="copy"&&$e.push("mouse-copy"),Ee.get(97)&&$e.push("showUnused"),Ee.get(122)&&$e.push("showDeprecated"),$e.join(" ")}}class E extends p{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ie,Ee,Ne){return Ne&&ie.emptySelectionClipboard}}class b extends I{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:w.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:w.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{cursorMoveOnType:c(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:c(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":v(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(Ee.loop,this.defaultValue.loop)}}}class a extends I{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?a.OFF:ie==="true"?a.ON:ie:Boolean(ie)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class L extends s{constructor(){super(40)}compute(ie,Ee,Ne){return ie.fontInfo}}class O extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(ie){let Ee=h.float(ie,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ee,6,100)}compute(ie,Ee,Ne){return ie.fontInfo.fontSize}}class W extends I{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(l.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class ee extends I{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},Ee),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},Ee),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},Ee),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},Ee),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},Ee),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Ne,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Ne,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Ne,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Ne,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Ne,description:w.localize(35,null)}})}validate(ie){var Ee,Ne,$e,We,Xe;if(!ie||typeof ie!="object")return this.defaultValue;const De=ie;return{multiple:v(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Ee=De.multipleDefinitions)!==null&&Ee!==void 0?Ee:v(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=De.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:v(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:($e=De.multipleDeclarations)!==null&&$e!==void 0?$e:v(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=De.multipleImplementations)!==null&&We!==void 0?We:v(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=De.multipleReferences)!==null&&Xe!==void 0?Xe:v(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class oe extends I{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:w.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:c(Ee.enabled,this.defaultValue.enabled),delay:l.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:c(Ee.sticky,this.defaultValue.sticky)}}}var V;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class B extends s{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(ie,Ee,Ne){return B.computeLayout(Ee,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Ee=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?Ee-1:0,$e=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),We=Math.floor(ie.viewLineCount/$e);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ne,desiredRatio:$e,minimapLineCount:We}}static _computeMinimapLayout(ie,Ee){const Ne=ie.outerWidth,$e=ie.outerHeight,We=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Xe=Ee.stableMinimapLayoutInput,De=Xe&&ie.outerHeight===Xe.outerHeight&&ie.lineHeight===Xe.lineHeight&&ie.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Xe.pixelRatio&&ie.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&ie.minimap.enabled===Xe.minimap.enabled&&ie.minimap.side===Xe.minimap.side&&ie.minimap.size===Xe.minimap.size&&ie.minimap.showSlider===Xe.minimap.showSlider&&ie.minimap.renderCharacters===Xe.minimap.renderCharacters&&ie.minimap.maxColumn===Xe.minimap.maxColumn&&ie.minimap.scale===Xe.minimap.scale&&ie.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&ie.isViewportWrapping===Xe.isViewportWrapping,ye=ie.lineHeight,ke=ie.typicalHalfwidthCharacterWidth,le=ie.scrollBeyondLastLine,he=ie.minimap.renderCharacters;let H=We>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const Z=ie.minimap.maxColumn,ue=ie.minimap.size,Ie=ie.minimap.side,Pe=ie.verticalScrollbarWidth,Ue=ie.viewLineCount,xe=ie.remainingWidth,Qe=ie.isViewportWrapping,rt=he?2:3;let tt=Math.floor(We*$e);const Ye=tt/We;let ot=!1,Et=!1,bt=rt*H,_e=H/We,fe=1;if(ue==="fill"||ue==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:ct,desiredRatio:it,minimapLineCount:vt}=B.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:le,height:$e,lineHeight:ye,pixelRatio:We});if(Ue/vt>1)ot=!0,Et=!0,H=1,bt=1,_e=H/We;else{let lt=!1,mt=H+1;if(ue==="fit"){const Pt=Math.ceil((Ue+ct)*bt);Qe&&De&&xe<=Ee.stableFitRemainingWidth?(lt=!0,mt=Ee.stableFitMaxMinimapScale):(lt=Pt>tt,Qe&&lt?(Ee.stableMinimapLayoutInput=ie,Ee.stableFitRemainingWidth=xe):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0))}if(ue==="fill"||lt){ot=!0;const Pt=H;bt=Math.min(ye*We,Math.max(1,Math.floor(1/it))),H=Math.min(mt,Math.max(1,Math.floor(bt/rt))),H>Pt&&(fe=Math.min(2,H/Pt)),_e=H/We/fe,tt=Math.ceil(Math.max(ft,Ue+ct)*bt),Qe&&lt&&(Ee.stableFitMaxMinimapScale=H)}}}const de=Math.floor(Z*_e),X=Math.min(de,Math.max(0,Math.floor((xe-Pe-2)*_e/(ke+_e)))+e.MINIMAP_GUTTER_WIDTH);let Oe=Math.floor(We*X);const Le=Oe/We;Oe=Math.floor(Oe*fe);const Ze=he?1:2,et=Ie==="left"?0:Ne-X-Pe;return{renderMinimap:Ze,minimapLeft:et,minimapWidth:X,minimapHeightIsEditorHeight:ot,minimapIsSampling:Et,minimapScale:H,minimapLineHeight:bt,minimapCanvasInnerWidth:Oe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ye}}static computeLayout(ie,Ee){const Ne=Ee.outerWidth|0,$e=Ee.outerHeight|0,We=Ee.lineHeight|0,Xe=Ee.lineNumbersDigitCount|0,De=Ee.typicalHalfwidthCharacterWidth,ye=Ee.maxDigitWidth,ke=Ee.pixelRatio,le=Ee.viewLineCount,he=ie.get(119),H=he==="inherit"?ie.get(118):he,Z=H==="inherit"?ie.get(114):H,ue=ie.get(117),Ie=ie.get(2),Pe=Ee.isDominatedByLongLines,Ue=ie.get(46),xe=ie.get(56).renderType!==0,Qe=ie.get(57),rt=ie.get(91),tt=ie.get(61),Ye=ie.get(89),ot=Ye.verticalScrollbarSize,Et=Ye.verticalHasArrows,bt=Ye.arrowSize,_e=Ye.horizontalScrollbarSize,fe=ie.get(54),de=ie.get(35);let X;if(typeof fe=="string"&&/^\d+(\.\d+)?ch$/.test(fe)){const Rt=parseFloat(fe.substr(0,fe.length-2));X=l.clampedInt(Rt*De,0,0,1e3)}else X=l.clampedInt(fe,0,0,1e3);de&&(X+=16);let Oe=0;if(xe){const Rt=Math.max(Xe,Qe);Oe=Math.round(Rt*ye)}let Le=0;Ue&&(Le=We);let Ze=0,et=Ze+Le,ft=et+Oe,ct=ft+X;const it=Ne-Le-Oe-X;let vt=!1,ht=!1,lt=-1;Ie!==2&&(H==="inherit"&&Pe?(vt=!0,ht=!0):Z==="on"||Z==="bounded"?ht=!0:Z==="wordWrapColumn"&&(lt=ue));const mt=B._computeMinimapLayout({outerWidth:Ne,outerHeight:$e,lineHeight:We,typicalHalfwidthCharacterWidth:De,pixelRatio:ke,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:ot,viewLineCount:le,remainingWidth:it,isViewportWrapping:ht},Ee.memory||new D);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Ze+=mt.minimapWidth,et+=mt.minimapWidth,ft+=mt.minimapWidth,ct+=mt.minimapWidth);const Pt=it-mt.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/De)),At=Et?bt:0;return ht&&(lt=Math.max(1,Ct),Z==="bounded"&&(lt=Math.min(lt,ue))),{width:Ne,height:$e,glyphMarginLeft:Ze,glyphMarginWidth:Le,lineNumbersLeft:et,lineNumbersWidth:Oe,decorationsLeft:ft,decorationsWidth:X,contentLeft:ct,contentWidth:Pt,minimap:mt,viewportColumn:Ct,isWordWrapMinified:vt,isViewportWrapping:ht,wrappingColumn:lt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:_e,overviewRuler:{top:At,width:ot,height:$e-2*At,right:0}}}}e.EditorLayoutInfoComputer=B;class j extends I{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:w.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:c(ie.enabled,this.defaultValue.enabled)}}}class T extends I{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:w.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,description:w.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:w.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:c(Ee.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class N extends l{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(ie,Ee,Ne){return ie.fontInfo.lineHeight}}class F extends I{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:ie.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:w.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:c(Ee.enabled,this.defaultValue.enabled),size:v(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(Ee.side,this.defaultValue.side,["right","left"]),showSlider:v(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(Ee.scale,1,1,3),maxColumn:l.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(K){return K==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class U extends I{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{top:l.clampedInt(Ee.top,0,0,1e3),bottom:l.clampedInt(Ee.bottom,0,0,1e3)}}}class x extends I{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:w.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:c(Ee.enabled,this.defaultValue.enabled),cycle:c(Ee.cycle,this.defaultValue.cycle)}}}class G extends s{constructor(){super(125)}compute(ie,Ee,Ne){return ie.pixelRatio}}class se extends I{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:w.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:w.localize(59,null)},other:{type:"boolean",default:ie.other,description:w.localize(60,null)}}}],default:ie,description:w.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Ee=ie,Ne={other:c(Ee.other,this.defaultValue.other),comments:c(Ee.comments,this.defaultValue.comments),strings:c(Ee.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var be;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends I{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(ie){let Ee=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Ee=4,Ne=ie):ie==="interval"?Ee=3:ie==="relative"?Ee=2:ie==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ne}}}function Ce(K){const ie=K.get(84);return ie==="editable"?K.get(77):ie!=="on"}e.filterValidationDecorations=Ce;class Me extends I{constructor(){const ie=[],Ee={type:"number",description:w.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:ie,description:w.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let Ee=[];for(let Ne of ie)if(typeof Ne=="number")Ee.push({column:l.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const $e=Ne;Ee.push({column:l.clampedInt($e.column,0,0,1e4),color:$e.color})}return Ee.sort((Ne,$e)=>Ne.column-$e.column),Ee}return this.defaultValue}}function qe(K,ie){if(typeof K!="string")return ie;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends I{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie,Ne=l.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=l.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(Ee.vertical,this.defaultValue.vertical),horizontal:qe(Ee.horizontal,this.defaultValue.horizontal),useShadows:c(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:l.clampedInt(Ee.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:l.clampedInt(Ee.verticalSliderSize,$e,0,1e3),scrollByPage:c(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class Ke extends I{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,ghostTextExpanded:!0,showInlineCompletions:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:ie.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:w.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:ie.showSuggestionPreview,description:w.localize(79,null)},"editor.suggest.showInlineCompletions":{type:"boolean",default:ie.showInlineCompletions,description:w.localize(80,null)},"editor.suggest.ghostTextExpanded":{type:"boolean",default:ie.ghostTextExpanded,description:w.localize(81,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:w.localize(82,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(83,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(84,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(110,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(111,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(112,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(113,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertMode:v(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:c(Ee.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:c(Ee.showSuggestionPreview,this.defaultValue.showSuggestionPreview),ghostTextExpanded:c(Ee.ghostTextExpanded,this.defaultValue.ghostTextExpanded),showInlineCompletions:c(Ee.showInlineCompletions,this.defaultValue.showInlineCompletions),showInlineDetails:c(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(Ee.showMethods,this.defaultValue.showMethods),showFunctions:c(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:c(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:c(Ee.showFields,this.defaultValue.showFields),showVariables:c(Ee.showVariables,this.defaultValue.showVariables),showClasses:c(Ee.showClasses,this.defaultValue.showClasses),showStructs:c(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:c(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:c(Ee.showModules,this.defaultValue.showModules),showProperties:c(Ee.showProperties,this.defaultValue.showProperties),showEvents:c(Ee.showEvents,this.defaultValue.showEvents),showOperators:c(Ee.showOperators,this.defaultValue.showOperators),showUnits:c(Ee.showUnits,this.defaultValue.showUnits),showValues:c(Ee.showValues,this.defaultValue.showValues),showConstants:c(Ee.showConstants,this.defaultValue.showConstants),showEnums:c(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:c(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(Ee.showKeywords,this.defaultValue.showKeywords),showWords:c(Ee.showWords,this.defaultValue.showWords),showColors:c(Ee.showColors,this.defaultValue.showColors),showFiles:c(Ee.showFiles,this.defaultValue.showFiles),showReferences:c(Ee.showReferences,this.defaultValue.showReferences),showFolders:c(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:c(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:c(Ee.showUsers,this.defaultValue.showUsers),showIssues:c(Ee.showIssues,this.defaultValue.showIssues)}}}class q extends I{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(114,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class J extends s{constructor(){super(126,[77])}compute(ie,Ee,Ne){return Ee.get(77)?!0:ie.tabFocusMode}}var re;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function ae(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Y extends s{constructor(){super(128,[127])}compute(ie,Ee,Ne){const $e=Ee.get(127);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const ce="Consolas, 'Courier New', monospace",ve="Menlo, Monaco, 'Courier New', monospace",Re="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?ve:R.isLinux?Re:ce,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function we(K){return e.editorOptionsRegistry[K.id]=K,K}var je;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.letterSpacing=52]="letterSpacing",K[K.lightbulb=53]="lightbulb",K[K.lineDecorationsWidth=54]="lineDecorationsWidth",K[K.lineHeight=55]="lineHeight",K[K.lineNumbers=56]="lineNumbers",K[K.lineNumbersMinChars=57]="lineNumbersMinChars",K[K.linkedEditing=58]="linkedEditing",K[K.links=59]="links",K[K.matchBrackets=60]="matchBrackets",K[K.minimap=61]="minimap",K[K.mouseStyle=62]="mouseStyle",K[K.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=64]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",K[K.multiCursorModifier=66]="multiCursorModifier",K[K.multiCursorPaste=67]="multiCursorPaste",K[K.occurrencesHighlight=68]="occurrencesHighlight",K[K.overviewRulerBorder=69]="overviewRulerBorder",K[K.overviewRulerLanes=70]="overviewRulerLanes",K[K.padding=71]="padding",K[K.parameterHints=72]="parameterHints",K[K.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",K[K.quickSuggestions=75]="quickSuggestions",K[K.quickSuggestionsDelay=76]="quickSuggestionsDelay",K[K.readOnly=77]="readOnly",K[K.renameOnType=78]="renameOnType",K[K.renderControlCharacters=79]="renderControlCharacters",K[K.renderIndentGuides=80]="renderIndentGuides",K[K.renderFinalNewline=81]="renderFinalNewline",K[K.renderLineHighlight=82]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=84]="renderValidationDecorations",K[K.renderWhitespace=85]="renderWhitespace",K[K.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",K[K.roundedSelection=87]="roundedSelection",K[K.rulers=88]="rulers",K[K.scrollbar=89]="scrollbar",K[K.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=91]="scrollBeyondLastLine",K[K.scrollPredominantAxis=92]="scrollPredominantAxis",K[K.selectionClipboard=93]="selectionClipboard",K[K.selectionHighlight=94]="selectionHighlight",K[K.selectOnLineNumbers=95]="selectOnLineNumbers",K[K.showFoldingControls=96]="showFoldingControls",K[K.showUnused=97]="showUnused",K[K.snippetSuggestions=98]="snippetSuggestions",K[K.smartSelect=99]="smartSelect",K[K.smoothScrolling=100]="smoothScrolling",K[K.stickyTabStops=101]="stickyTabStops",K[K.stopRenderingLineAfter=102]="stopRenderingLineAfter",K[K.suggest=103]="suggest",K[K.suggestFontSize=104]="suggestFontSize",K[K.suggestLineHeight=105]="suggestLineHeight",K[K.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",K[K.suggestSelection=107]="suggestSelection",K[K.tabCompletion=108]="tabCompletion",K[K.tabIndex=109]="tabIndex",K[K.unusualLineTerminators=110]="unusualLineTerminators",K[K.useShadowDOM=111]="useShadowDOM",K[K.useTabStops=112]="useTabStops",K[K.wordSeparators=113]="wordSeparators",K[K.wordWrap=114]="wordWrap",K[K.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=117]="wordWrapColumn",K[K.wordWrapOverride1=118]="wordWrapOverride1",K[K.wordWrapOverride2=119]="wordWrapOverride2",K[K.wrappingIndent=120]="wrappingIndent",K[K.wrappingStrategy=121]="wrappingStrategy",K[K.showDeprecated=122]="showDeprecated",K[K.inlayHints=123]="inlayHints",K[K.editorClassName=124]="editorClassName",K[K.pixelRatio=125]="pixelRatio",K[K.tabFocusMode=126]="tabFocusMode",K[K.layoutInfo=127]="layoutInfo",K[K.wrappingInfo=128]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(115,null)})),acceptSuggestionOnEnter:we(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(116,null),""],markdownDescription:w.localize(117,null)})),accessibilitySupport:we(new u),accessibilityPageSize:we(new l(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(118,null)})),ariaLabel:we(new _(4,"ariaLabel",w.localize(119,null))),autoClosingBrackets:we(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(120,null),w.localize(121,null),""],description:w.localize(122,null)})),autoClosingDelete:we(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(123,null),""],description:w.localize(124,null)})),autoClosingOvertype:we(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(125,null),""],description:w.localize(126,null)})),autoClosingQuotes:we(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(127,null),w.localize(128,null),""],description:w.localize(129,null)})),autoIndent:we(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[w.localize(130,null),w.localize(131,null),w.localize(132,null),w.localize(133,null),w.localize(134,null)],description:w.localize(135,null)})),automaticLayout:we(new p(10,"automaticLayout",!1)),autoSurround:we(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(136,null),w.localize(137,null),w.localize(138,null),""],description:w.localize(139,null)})),stickyTabStops:we(new p(101,"stickyTabStops",!1,{description:w.localize(140,null)})),codeLens:we(new p(12,"codeLens",!0,{description:w.localize(141,null)})),codeLensFontFamily:we(new _(13,"codeLensFontFamily","",{description:w.localize(142,null)})),codeLensFontSize:we(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(143,null)})),colorDecorators:we(new p(15,"colorDecorators",!0,{description:w.localize(144,null)})),columnSelection:we(new p(16,"columnSelection",!1,{description:w.localize(145,null)})),comments:we(new t),contextmenu:we(new p(18,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new p(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(146,null)})),cursorBlinking:we(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:w.localize(147,null)})),cursorSmoothCaretAnimation:we(new p(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(148,null)})),cursorStyle:we(new d(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:w.localize(149,null)})),cursorSurroundingLines:we(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(150,null)})),cursorSurroundingLinesStyle:we(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(151,null),w.localize(152,null)],description:w.localize(153,null)})),cursorWidth:we(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(154,null)})),disableLayerHinting:we(new p(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new p(27,"disableMonospaceOptimizations",!1)),domReadOnly:we(new p(28,"domReadOnly",!1)),dragAndDrop:we(new p(29,"dragAndDrop",!0,{description:w.localize(155,null)})),emptySelectionClipboard:we(new E),extraEditorClassName:we(new _(31,"extraEditorClassName","")),fastScrollSensitivity:we(new h(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:w.localize(156,null)})),find:we(new b),fixedOverflowWidgets:we(new p(34,"fixedOverflowWidgets",!1)),folding:we(new p(35,"folding",!0,{description:w.localize(157,null)})),foldingStrategy:we(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(158,null),w.localize(159,null)],description:w.localize(160,null)})),foldingHighlight:we(new p(37,"foldingHighlight",!0,{description:w.localize(161,null)})),unfoldOnClickAfterEndOfLine:we(new p(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(162,null)})),fontFamily:we(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(163,null)})),fontInfo:we(new L),fontLigatures2:we(new a),fontSize:we(new O),fontWeight:we(new W),formatOnPaste:we(new p(44,"formatOnPaste",!1,{description:w.localize(164,null)})),formatOnType:we(new p(45,"formatOnType",!1,{description:w.localize(165,null)})),glyphMargin:we(new p(46,"glyphMargin",!0,{description:w.localize(166,null)})),gotoLocation:we(new ee),hideCursorInOverviewRuler:we(new p(48,"hideCursorInOverviewRuler",!1,{description:w.localize(167,null)})),highlightActiveIndentGuide:we(new p(49,"highlightActiveIndentGuide",!0,{description:w.localize(168,null)})),hover:we(new oe),inDiffEditor:we(new p(51,"inDiffEditor",!1)),letterSpacing:we(new h(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>h.clamp(K,-5,20),{description:w.localize(169,null)})),lightbulb:we(new j),lineDecorationsWidth:we(new P(54,"lineDecorationsWidth",10)),lineHeight:we(new N),lineNumbers:we(new Te),lineNumbersMinChars:we(new l(57,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new p(58,"linkedEditing",!1,{description:w.localize(170,null)})),links:we(new p(59,"links",!0,{description:w.localize(171,null)})),matchBrackets:we(new S(60,"matchBrackets","always",["always","near","never"],{description:w.localize(172,null)})),minimap:we(new F),mouseStyle:we(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new h(63,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:w.localize(173,null)})),mouseWheelZoom:we(new p(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(174,null)})),multiCursorMergeOverlapping:we(new p(65,"multiCursorMergeOverlapping",!0,{description:w.localize(175,null)})),multiCursorModifier:we(new d(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[w.localize(176,null),w.localize(177,null)],markdownDescription:w.localize(178,null)})),multiCursorPaste:we(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(179,null),w.localize(180,null)],markdownDescription:w.localize(181,null)})),occurrencesHighlight:we(new p(68,"occurrencesHighlight",!0,{description:w.localize(182,null)})),overviewRulerBorder:we(new p(69,"overviewRulerBorder",!0,{description:w.localize(183,null)})),overviewRulerLanes:we(new l(70,"overviewRulerLanes",3,0,3)),padding:we(new U),parameterHints:we(new x),peekWidgetDefaultFocus:we(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(184,null),w.localize(185,null)],description:w.localize(186,null)})),definitionLinkOpensInPeek:we(new p(74,"definitionLinkOpensInPeek",!1,{description:w.localize(187,null)})),quickSuggestions:we(new se),quickSuggestionsDelay:we(new l(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(188,null)})),readOnly:we(new p(77,"readOnly",!1)),renameOnType:we(new p(78,"renameOnType",!1,{description:w.localize(189,null),markdownDeprecationMessage:w.localize(190,null)})),renderControlCharacters:we(new p(79,"renderControlCharacters",!1,{description:w.localize(191,null)})),renderIndentGuides:we(new p(80,"renderIndentGuides",!0,{description:w.localize(192,null)})),renderFinalNewline:we(new p(81,"renderFinalNewline",!0,{description:w.localize(193,null)})),renderLineHighlight:we(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(194,null)],description:w.localize(195,null)})),renderLineHighlightOnlyWhenFocus:we(new p(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(196,null)})),renderValidationDecorations:we(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(197,null),w.localize(198,null),w.localize(199,null),""],description:w.localize(200,null)})),revealHorizontalRightPadding:we(new l(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new p(87,"roundedSelection",!0,{description:w.localize(201,null)})),rulers:we(new Me),scrollbar:we(new ze),scrollBeyondLastColumn:we(new l(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(202,null)})),scrollBeyondLastLine:we(new p(91,"scrollBeyondLastLine",!0,{description:w.localize(203,null)})),scrollPredominantAxis:we(new p(92,"scrollPredominantAxis",!0,{description:w.localize(204,null)})),selectionClipboard:we(new p(93,"selectionClipboard",!0,{description:w.localize(205,null),included:R.isLinux})),selectionHighlight:we(new p(94,"selectionHighlight",!0,{description:w.localize(206,null)})),selectOnLineNumbers:we(new p(95,"selectOnLineNumbers",!0)),showFoldingControls:we(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(207,null),w.localize(208,null)],description:w.localize(209,null)})),showUnused:we(new p(97,"showUnused",!0,{description:w.localize(210,null)})),showDeprecated:we(new p(122,"showDeprecated",!0,{description:w.localize(211,null)})),inlayHints:we(new T),snippetSuggestions:we(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(212,null),w.localize(213,null),w.localize(214,null),w.localize(215,null)],description:w.localize(216,null)})),smartSelect:we(new q),smoothScrolling:we(new p(100,"smoothScrolling",!1,{description:w.localize(217,null)})),stopRenderingLineAfter:we(new l(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new Ke),suggestFontSize:we(new l(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(218,null)})),suggestLineHeight:we(new l(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(219,null)})),suggestOnTriggerCharacters:we(new p(106,"suggestOnTriggerCharacters",!0,{description:w.localize(220,null)})),suggestSelection:we(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null)],description:w.localize(224,null)})),tabCompletion:we(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(225,null),w.localize(226,null),w.localize(227,null)],description:w.localize(228,null)})),tabIndex:we(new l(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(229,null),w.localize(230,null),w.localize(231,null)],description:w.localize(232,null)})),useShadowDOM:we(new p(111,"useShadowDOM",!0)),useTabStops:we(new p(112,"useTabStops",!0,{description:w.localize(233,null)})),wordSeparators:we(new _(113,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:w.localize(234,null)})),wordWrap:we(new S(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(235,null),w.localize(236,null),w.localize(237,null),w.localize(238,null)],description:w.localize(239,null)})),wordWrapBreakAfterCharacters:we(new _(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new _(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new l(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(240,null)})),wordWrapOverride1:we(new S(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new S(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new d(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ae,{enumDescriptions:[w.localize(241,null),w.localize(242,null),w.localize(243,null),w.localize(244,null)],description:w.localize(245,null)})),wrappingStrategy:we(new S(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(246,null),w.localize(247,null)],description:w.localize(248,null)})),editorClassName:we(new g),pixelRatio:we(new G),tabFocusMode:we(new J),layoutInfo:we(new B),wrappingInfo:we(new Y)}}),define(ge[153],pe([18,19]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[154],pe([18,19]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[155],pe([18,19]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[156],pe([18,19]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[157],pe([18,19]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ge[158],pe([18,19]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(ge[159],pe([18,19]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[160],pe([18,19]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[161],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[162],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[163],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[164],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[165],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[166],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[167],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[168],pe([18,19]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[169],pe([18,19]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(ge[170],pe([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[171],pe([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[172],pe([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[173],pe([18,19]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[174],pe([18,19]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[175],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var R;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var C;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[176],pe([0,1,155]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function A(c){return c=c.trim(),c==="*"||R.test(c)}e.isValidVersionStr=A;function y(c){if(!A(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=c.match(R);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=y;function k(c){if(!c)return null;let p=c.majorBase,l=c.majorMustEqual,h=c.minorBase,_=c.minorMustEqual,v=c.patchBase,S=c.patchMustEqual;c.hasCaret&&(p===0||(_=!1),S=!1);let d=0;if(c.preRelease){const f=C.exec(c.preRelease);if(f){const[,u,t,n]=f;d=Date.UTC(Number(u),Number(t)-1,Number(n))}}return{majorBase:p,majorMustEqual:l,minorBase:h,minorMustEqual:_,patchBase:v,patchMustEqual:S,isMinimum:c.hasGreaterEquals,notBefore:d}}e.normalizeVersion=k;function D(c,p,l){let h;typeof c=="string"?h=k(y(c)):h=c;let _;p instanceof Date?_=p.getTime():typeof p=="string"&&(_=new Date(p).getTime());let v;if(typeof l=="string"?v=k(y(l)):v=l,!h||!v)return!1;let S=h.majorBase,d=h.minorBase,f=h.patchBase,u=v.majorBase,t=v.minorBase,n=v.patchBase,i=v.notBefore,r=v.majorMustEqual,o=v.minorMustEqual,m=v.patchMustEqual;return v.isMinimum?S>u?!0:S<u?!1:d>t?!0:d<t||_&&_<i?!1:f>=n:(S===1&&u===0&&(!r||!o||!m)&&(u=1,t=0,n=0,r=!0,o=!1,m=!1),S<u?!1:S>u?!r:d<t?!1:d>t?!o:f<n?!1:f>n?!m:!(_&&_<i))}e.isValidVersion=D;function I(c,p,l,h){return l.isBuiltin||typeof l.main=="undefined"?!0:P(c,p,l.engines.vscode,h)}e.isValidExtensionVersion=I;function s(c,p,l){return c==="*"||P(p,l,c)}e.isEngineValid=s;function P(c,p,l,h=[]){let _=k(y(l));if(!_)return h.push(w.localize(0,null,l)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return h.push(w.localize(1,null,l)),!1}else if(!_.majorMustEqual)return h.push(w.localize(2,null,l)),!1;return D(c,p,_)?!0:(h.push(w.localize(3,null,c,l)),!1)}}),define(ge[111],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(A,y=[],k=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=w;const R=(C,...A)=>new w(C,A);e.createSyncDescriptor=R}),define(ge[79],pe([0,1,111]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(y,k,D){k instanceof w.SyncDescriptor||(k=new w.SyncDescriptor(k,[],D)),R.push([y,k])}e.registerSingleton=C;function A(){return R}e.getSingletonServiceDescriptors=A}),define(ge[177],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=w;class R{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const k=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);k.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),k)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let k=this._nodes.get(y);return k||(k=new w(A),this._nodes.set(y,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,k]of this._nodes)A.push(`${y}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const k=new Set([A]),D=this._findCycle(y,k);if(D)return D}}_findCycle(A,y){for(let[k,D]of A.outgoing){if(y.has(k))return[...y,k].join(" -> ");y.add(k);const I=this._findCycle(D,y);if(I)return I;y.delete(k)}}}e.Graph=R}),define(ge[4],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(I){return I[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(w=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(k,D,I,s){D[w.DI_TARGET]===D?D[w.DI_DEPENDENCIES].push({id:k,index:I,optional:s}):(D[w.DI_DEPENDENCIES]=[{id:k,index:I,optional:s}],D[w.DI_TARGET]=D)}function C(k){if(w.serviceIds.has(k))return w.serviceIds.get(k);const D=function(I,s,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,I,P,!1)};return D.toString=()=>k,w.serviceIds.set(k,D),D}e.createDecorator=C;function A(k){return k}e.refineServiceDecorator=A;function y(k){return function(D,I,s){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(k,D,s,!0)}}e.optional=y}),define(ge[178],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=w.createDecorator("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ge[179],pe([0,1,3,75,6,22,74,78,178]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(I):!!c.exclusive}class s{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(p,l){let h={selector:p,provider:l,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),C.toDisposable(()=>{if(h){let _=this._entries.indexOf(h);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const l=[];for(let h of this._entries)h._score>0&&l.push(h.provider);return l}ordered(p){const l=[];return this._orderedForEach(p,h=>l.push(h.provider)),l}orderedGroups(p){const l=[];let h,_;return this._orderedForEach(p,v=>{h&&_===v._score?h.push(v.provider):(_=v._score,h=[v.provider],l.push(h))}),l}_orderedForEach(p,l){if(!!p){this._updateScores(p);for(const h of this._entries)h._score>0&&l(h)}}_updateScores(p){let l={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let h of this._entries)if(h._score=k.score(h.selector,p.uri,p.getLanguageIdentifier().language,D.shouldSynchronizeModel(p)),I(h.selector)&&h._score>0){for(let _ of this._entries)_._score=0;h._score=1e3;break}this._entries.sort(s._compareByScoreAndTime)}}static _compareByScoreAndTime(p,l){return p._score<l._score?1:p._score>l._score?-1:p._time<l._time?1:p._time>l._time?-1:0}}e.LanguageFeatureRegistry=s;class P{constructor(p,l,h=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=l,this.max=h,this._cache=new A.LRUCache(50,.7)}_key(p){return p.id+R.hash(this._registry.all(p))}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const l=this._key(p),h=this._cache.get(l);return this._clamp(h==null?void 0:h.value)}update(p,l){const h=this._key(p);let _=this._cache.get(h);return _||(_=new y.MovingAverage,this._cache.set(h,_)),_.update(l),this.get(p)}}e.LanguageFeatureRequestDelays=P}),define(ge[80],pe([0,1,2,42,179,145,45]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=D;var I;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var s;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(s=e.ColorId||(e.ColorId={}));var P;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class p{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),W="mtk"+O,ee=this.getFontStyle(L);return ee&1&&(W+=" mtki"),ee&2&&(W+=" mtkb"),ee&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(L,O){const W=this.getForeground(L),ee=this.getFontStyle(L);let oe=`color: ${O[W]};`;return ee&1&&(oe+="font-style: italic;"),ee&2&&(oe+="font-weight: bold;"),ee&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=p;var l;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(L){const O=a[L];let W=O&&y.iconRegistry.get(O);return W||(console.info("No codicon found for CompletionItemKind "+L),W=y.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(L,O){let W=a[L];return typeof W=="undefined"&&!O&&(W=9),W}}();var h;(function(a){a[a.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&w.URI.isUri(a.uri)&&R.Range.isIRange(a.range)&&(R.Range.isIRange(a.originSelectionRange)||R.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var n;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var i;(function(a){a[a.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function W(V){return L.get(V)}a.fromString=W;function ee(V){return O.get(V)}a.toString=ee;function oe(V,B){const j=O.get(V);let T=j&&y.iconRegistry.get("symbol-"+j);return T||(console.info("No codicon found for SymbolKind "+V),T=y.Codicon.symbolProperty),`${B?"inline":"block"} ${T.classNames}`}a.toCssClassName=oe})(r=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(L){this.value=L}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var m;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var E;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(E=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var b;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[180],pe([0,1,6,12,4,3,56,54]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=C.createDecorator("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,I){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!I)throw new Error("invalid command");return this.registerCommand({id:D,handler:I})}if(D.description){const l=[];for(let _ of D.description.args)l.push(_.constraint);const h=D.handler;D.handler=function(_,...v){return R.validateConstraints(v,l),h(_,...v)}}const{id:s}=D;let P=this._commands.get(s);P||(P=new y.LinkedList,this._commands.set(s,P));let c=P.unshift(D),p=w.toDisposable(()=>{c();const l=this._commands.get(s);(l==null?void 0:l.isEmpty())&&this._commands.delete(s)});return this._onDidRegisterCommand.fire(s),p}registerCommandAlias(D,I){return e.CommandsRegistry.registerCommand(D,(s,...P)=>s.get(e.ICommandService).executeCommand(I,...P))}getCommand(D){const I=this._commands.get(D);if(!(!I||I.isEmpty()))return k.Iterable.first(I)}getCommands(){const D=new Map;for(const I of this._commands.keys()){const s=this.getCommand(I);s&&D.set(I,s)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ge[81],pe([0,1,8,4,11]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=C.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",C.isMacintosh),y.set("isLinux",C.isLinux),y.set("isWindows",C.isWindows),y.set("isWeb",C.isWeb),y.set("isMacNative",C.isMacintosh&&!C.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return P.INSTANCE}static true(){return c.INSTANCE}static has(a){return p.create(a)}static equals(a,L){return l.create(a,L)}static notEquals(a,L){return v.create(a,L)}static regex(a,L){return n.create(a,L)}static in(a,L){return h.create(a,L)}static not(a){return S.create(a)}static and(...a){return r.create(a)}static or(...a){return o.create(a)}static greater(a,L){return d.create(a,L)}static less(a,L){return u.create(a,L)}static deserialize(a,L=!1){if(!!a)return this._deserializeOrExpression(a,L)}static _deserializeOrExpression(a,L){let O=a.split("||");return o.create(O.map(W=>this._deserializeAndExpression(W,L)))}static _deserializeAndExpression(a,L){let O=a.split("&&");return r.create(O.map(W=>this._deserializeOne(W,L)))}static _deserializeOne(a,L){if(a=a.trim(),a.indexOf("!=")>=0){let O=a.split("!=");return v.create(O[0].trim(),this._deserializeValue(O[1],L))}if(a.indexOf("==")>=0){let O=a.split("==");return l.create(O[0].trim(),this._deserializeValue(O[1],L))}if(a.indexOf("=~")>=0){let O=a.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(a.indexOf(" in ")>=0){let O=a.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const O=a.split(">=");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const O=a.split(">");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const O=a.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const O=a.split("<");return u.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(a)?S.create(a.substr(1).trim()):p.create(a)}static _deserializeValue(a,L){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let O=/^'([^']*)'$/.exec(a);return O?O[1].trim():a}static _deserializeRegexValue(a,L){if(w.isFalsyOrWhitespace(a)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=a.indexOf("/"),W=a.lastIndexOf("/");if(O===W||O<0){if(L)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let ee=a.slice(O+1,W),oe=a[W+1]==="i"?"i":"";try{return new RegExp(ee,oe)}catch(V){if(L)throw new Error(`bad regexp-value '${a}', parse error: ${V}`);return console.warn(`bad regexp-value '${a}', parse error: ${V}`),null}}}e.ContextKeyExpr=I;function s(b,a){return b.cmp(a)}class P{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class c{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class p{constructor(a){this.key=a,this.type=2}static create(a){const L=y.get(a);return typeof L=="boolean"?L?c.INSTANCE:P.INSTANCE:new p(a)}cmp(a){return a.type!==this.type?this.type-a.type:g(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=p;class l{constructor(a,L){this.key=a,this.value=L,this.type=4}static create(a,L){if(typeof L=="boolean")return L?p.create(a):S.create(a);const O=y.get(a);return typeof O=="boolean"?L===(O?"true":"false")?c.INSTANCE:P.INSTANCE:new l(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class h{constructor(a,L){this.key=a,this.valueKey=L,this.type=10}static create(a,L){return new h(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const L=a.getValue(this.valueKey),O=a.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?k.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=h;class _{constructor(a){this._actual=a,this.type=11}static create(a){return new _(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new _(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class v{constructor(a,L){this.key=a,this.value=L,this.type=5}static create(a,L){if(typeof L=="boolean")return L?S.create(a):p.create(a);const O=y.get(a);return typeof O=="boolean"?L===(O?"true":"false")?P.INSTANCE:c.INSTANCE:new v(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class S{constructor(a){this.key=a,this.type=3}static create(a){const L=y.get(a);return typeof L=="boolean"?L?P.INSTANCE:c.INSTANCE:new S(a)}cmp(a){return a.type!==this.type?this.type-a.type:g(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return p.create(this.key)}}e.ContextKeyNotExpr=S;class d{constructor(a,L){this.key=a,this.value=L,this.type=12}static create(a,L){return new d(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class f{constructor(a,L){this.key=a,this.value=L,this.type=13}static create(a,L){return new f(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class u{constructor(a,L){this.key=a,this.value=L,this.type=14}static create(a,L){return new u(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=u;class t{constructor(a,L){this.key=a,this.value=L,this.type=15}static create(a,L){return new t(a,L)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(a,L){this.key=a,this.regexp=L,this.type=7}static create(a,L){return new n(a,L)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const L=this.regexp?this.regexp.source:"",O=a.regexp?a.regexp.source:"";return L<O?-1:L>O?1:0}equals(a){if(a.type===this.type){const L=this.regexp?this.regexp.source:"",O=a.regexp?a.regexp.source:"";return this.key===a.key&&L===O}return!1}evaluate(a){let L=a.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=n;class i{constructor(a){this._actual=a,this.type=8}static create(a){return new i(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new i(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class r{constructor(a){this.expr=a,this.type=6}static create(a){return r._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],a.expr[L]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(a.expr[L]))return!1;return!0}return!1}evaluate(a){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(a))return!1;return!0}static _normalizeArr(a){const L=[];let O=!1;for(const W of a)if(!!W){if(W.type===1){O=!0;continue}if(W.type===0)return P.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&O)return c.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(s);L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const ee=L.pop(),oe=o.create(W.expr.map(V=>r.create([V,ee])));oe&&(L.push(oe),L.sort(s))}return L.length===1?L[0]:new r(L)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let L of this.expr)a.push(...L.keys());return a}map(a){return new r(this.expr.map(L=>L.map(a)))}negate(){let a=[];for(let L of this.expr)a.push(L.negate());return o.create(a)}}e.ContextKeyAndExpr=r;class o{constructor(a){this.expr=a,this.type=9}static create(a){const L=o._normalizeArr(a);if(L.length!==0)return L.length===1?L[0]:new o(L)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],a.expr[L]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(a.expr[L]))return!1;return!0}return!1}evaluate(a){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(a))return!0;return!1}static _normalizeArr(a){let L=[],O=!1;if(a){for(let W=0,ee=a.length;W<ee;W++){const oe=a[W];if(!!oe){if(oe.type===0){O=!0;continue}if(oe.type===1)return[c.INSTANCE];if(oe.type===9){L=L.concat(oe.expr);continue}L.push(oe)}}if(L.length===0&&O)return[P.INSTANCE];L.sort(s)}return L}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let L of this.expr)a.push(...L.keys());return a}map(a){return new o(this.expr.map(L=>L.map(a)))}negate(){let a=[];for(let O of this.expr)a.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;a.length>1;){const O=a.shift(),W=a.shift(),ee=[];for(const oe of L(O))for(const V of L(W))ee.push(I.and(oe,V));a.unshift(I.or(...ee))}return a[0]}}e.ContextKeyOrExpr=o;class m extends p{constructor(a,L,O){super(a);this._defaultValue=L,typeof O=="object"?m._info.push(Object.assign(Object.assign({},O),{key:a})):O!==!0&&m._info.push({key:a,description:O,type:L!=null?typeof L:void 0})}static all(){return m._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return I.not(this.key)}isEqualTo(a){return I.equals(this.key,a)}notEqualsTo(a){return I.notEquals(this.key,a)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(b,a){return b<a?-1:b>a?1:0}function E(b,a,L,O){return b<L?-1:b>L?1:a<O?-1:a>O?1:0}}),define(ge[181],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=w.createDecorator("environmentService"),e.INativeEnvironmentService=w.refineServiceDecorator(e.IEnvironmentService)}),define(ge[182],pe([0,1,154,4,10]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var k;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var D;(function(P){P.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var I;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(c,p){super(c);this.code=p}}e.ExtensionManagementError=s,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=w.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=w.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.getWorkpaceSupportTypeMessage=C;function A(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class k{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,c){if(typeof P=="undefined"||P===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof P=="string"||typeof c=="string"){let p=typeof P=="string"?P:P.value,l=typeof c=="string"?c:c.value;return w.equalsIgnoreCase(p,l)}return P._lower===c._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=k;function D(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function I(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(ge[183],pe([0,1,8,26]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(p,l){return p.uuid&&l.uuid?p.uuid===l.uuid:p.id===l.id?!0:w.compareIgnoreCase(p.id,l.id)===0}e.areSameExtensions=C;class A{constructor(l,h){this.version=h,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof A?C(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(p,l){return`${p}.${l}`}e.getExtensionId=y;function k(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(p,l){return k(y(p,l))}e.getGalleryExtensionId=D;function I(p,l){const h=[],_=v=>{for(const S of h)if(S.some(d=>C(l(d),l(v))))return S;return null};for(const v of p){const S=_(v);S?S.push(v):h.push([v])}return h}e.groupByExtension=I;function s(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=s;function P(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function c(p){const l=new Set;for(const h of p)h.malicious&&l.add(h.id.id);return l}e.getMaliciousExtensionsSet=c}),define(ge[184],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=w.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=w.createDecorator("externalTerminal")}),define(ge[43],pe([0,1,157,9,2,4,8,12,22]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=A.createDecorator("fileService");function I(B){return B.create===!0}e.isFileOpenForWriteOptions=I;var s;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(s=e.FileType||(e.FileType={}));var P;(function(B){B[B.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var c;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=p;function l(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=l;function h(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function _(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=_;var v;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(j,T){super(j);this.code=T}}e.FileSystemProviderError=S;function d(B,j){const T=new S(B.toString(),j);return u(T,j),T}e.createFileSystemProviderError=d;function f(B){return B||d(w.localize(0,null),v.Unknown)}e.ensureFileSystemProviderError=f;function u(B,j){return B.name=j?`${j} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=u;function t(B){if(!B)return v.Unknown;if(B instanceof S)return B.code;const j=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!j)return v.Unknown;switch(j[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=t;function n(B){if(B instanceof E)return B.fileOperationResult;switch(t(B)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var i;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(j,T,N){this.resource=j,this.operation=T,this.target=N}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var o;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class m{constructor(j,T){this.ignorePathCasing=T,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const N of j)switch(N.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(N.resource,N);break}}contains(j,...T){return this.doContains(j,{includeChildren:!1},...T)}affects(j,...T){return this.doContains(j,{includeChildren:!0},...T)}doContains(j,T,...N){var F,M,U,x,G,se;if(!j)return!1;const be=N.length>0;return!!((!be||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(j))||T.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(j)))||(!be||N.includes(0))&&(((U=this.updated)===null||U===void 0?void 0:U.get(j))||T.includeChildren&&((x=this.updated)===null||x===void 0?void 0:x.findSuperstr(j)))||(!be||N.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(j))||T.includeChildren&&((se=this.deleted)===null||se===void 0?void 0:se.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const T=[],N=j===1?this.added:j===0?this.updated:this.deleted;if(N)for(const[,F]of N)T.push(F);return T}filter(j){return new m(this.changes.filter(T=>j(T)),this.ignorePathCasing)}}e.FileChangesEvent=m;function g(B,j,T){return!B||!j||B===j||j.length>B.length?!1:(j.charAt(j.length-1)!==R.sep&&(j+=R.sep),T?y.startsWithIgnoreCase(B,j):B.indexOf(j)===0)}e.isParent=g;class E extends Error{constructor(j,T,N){super(j);this.fileOperationResult=T,this.options=N}}e.FileOperationError=E;class b extends E{constructor(j,T,N){super(j,2,N);this.stat=T}}e.NotModifiedSinceFileOperationError=b;var a;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=O;async function W(B,j){if(!j.canHandleResource(C.URI.from({scheme:B.scheme})))return new Promise(T=>{const N=j.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===B.scheme&&F.added&&(N.dispose(),T())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ee{static formatSize(j){return k.isNumber(j)||(j=0),j<ee.KB?w.localize(1,null,j.toFixed(0)):j<ee.MB?w.localize(2,null,(j/ee.KB).toFixed(2)):j<ee.GB?w.localize(3,null,(j/ee.MB).toFixed(2)):j<ee.TB?w.localize(4,null,(j/ee.GB).toFixed(2)):w.localize(5,null,(j/ee.TB).toFixed(2))}}e.ByteSize=ee,ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB;var oe;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function V(B){return{maxFileSize:B===0?300*ee.MB:16*ee.GB,maxHeapSize:B===0?700*ee.MB:2*700*ee.MB}}e.getPlatformLimits=V}),define(ge[82],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...C){this._entries=new Map;for(let[A,y]of C)this.set(A,y)}set(C,A){const y=this._entries.get(C);return this._entries.set(C,A),y}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=w}),define(ge[185],pe([0,1,16,177,111,4,82,13]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class I extends Error{constructor(l){var h;super("cyclic dependency between services");this.message=(h=l.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class s{constructor(l=new y.ServiceCollection,h=!1,_){this._activeInstantiations=new Set,this._services=l,this._strict=h,this._parent=_,this._services.set(A.IInstantiationService,this)}createChild(l){return new s(l,this._strict,this)}invokeFunction(l,...h){let _=c.traceInvocation(l),v=!1;try{return l({get:(d,f)=>{if(v)throw w.illegalState("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(d,_);if(!u&&f!==A.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return u}},...h)}finally{v=!0,_.stop()}}createInstance(l,...h){let _,v;return l instanceof C.SyncDescriptor?(_=c.traceCreation(l.ctor),v=this._createInstance(l.ctor,l.staticArguments.concat(h),_)):(_=c.traceCreation(l),v=this._createInstance(l,h,_)),_.stop(),v}_createInstance(l,h=[],_){let v=A._util.getServiceDependencies(l).sort((f,u)=>f.index-u.index),S=[];for(const f of v){let u=this._getOrCreateServiceInstance(f.id,_);if(!u&&this._strict&&!f.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${f.id}.`);S.push(u)}let d=v.length>0?v[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${l.name} at position ${d+1} conflicts with ${h.length} static arguments`);let f=d-h.length;f>0?h=h.concat(new Array(f)):h=h.slice(0,d)}return new l(...[...h,...S])}_setServiceInstance(l,h){if(this._services.get(l)instanceof C.SyncDescriptor)this._services.set(l,h);else if(this._parent)this._parent._setServiceInstance(l,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let h=this._services.get(l);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):h}_getOrCreateServiceInstance(l,h){let _=this._getServiceInstanceOrDescriptor(l);return _ instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,_,h.branch(l,!0)):(h.branch(l,!1),_)}_safeCreateAndCacheServiceInstance(l,h,_){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,h,_)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,h,_){const v=new R.Graph(f=>f.id.toString());let S=0;const d=[{id:l,desc:h,_trace:_}];for(;d.length;){const f=d.pop();if(v.lookupOrInsertNode(f),S++>1e3)throw new I(v);for(let u of A._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${l} depends on ${u.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const n={id:u.id,desc:t,_trace:f._trace.branch(u.id,!0)};v.insertEdge(f,n),d.push(n)}}}for(;;){const f=v.roots();if(f.length===0){if(!v.isEmpty())throw new I(v);break}for(const{data:u}of f){if(this._getServiceInstanceOrDescriptor(u.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,n)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,h,_=[],v,S){if(this._services.get(l)instanceof C.SyncDescriptor)return this._createServiceInstance(h,_,v,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,h,_,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(l,h=[],_,v){if(_){const S=new k.IdleValue(()=>this._createInstance(l,h,v));return new Proxy(Object.create(null),{get(d,f){if(f in d)return d[f];let u=S.value,t=u[f];return typeof t!="function"||(t=t.bind(u),d[f]=t),t},set(d,f,u){return S.value[f]=u,!0}})}else return this._createInstance(l,h,v)}}e.InstantiationService=s;var P;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(P||(P={}));class c{constructor(l,h){this.type=l,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new c(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(l){return D?new c(0,l.name):c._None}branch(l,h){let _=new c(2,l.toString());return this._dep.push([l,h,_]),_}stop(){let l=Date.now()-this._start;c._totals+=l;let h=!1;function _(S,d){let f=[],u=new Array(S+1).join("	");for(const[t,n,i]of d._dep)if(n&&i){h=!0,f.push(`${u}CREATES -> ${t}`);let r=_(S+1,i);r&&f.push(r)}else f.push(`${u}uses -> ${t}`);return f.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(l>2||h)&&console.log(v.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(ge[14],pe([0,1,4,6,11,3,60]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=w.createDecorator("logService"),e.ILoggerService=w.createDecorator("loggerService");function k(){return new Date().toISOString()}var D;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class I extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class s extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(D.Error,this.format(i))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let i=0;i<t.length;i++){let r=t[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(i>0?" ":"")+r}return n}}e.AbstractMessageLogger=s;class P extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...n):console.warn(`[main ${k()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class c extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=c;class p extends I{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:y.toErrorMessage(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class l extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const i of this.logServices)i.trace(t,...n)}debug(t,...n){for(const i of this.logServices)i.debug(t,...n)}info(t,...n){for(const i of this.logServices)i.info(t,...n)}warn(t,...n){for(const i of this.logServices)i.warn(t,...n)}error(t,...n){for(const i of this.logServices)i.error(t,...n)}critical(t,...n){for(const i of this.logServices)i.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class h extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=h;class _ extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}createLogger(t,n){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),i),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class v{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=v;function S(u){if(u.verbose)return D.Trace;if(typeof u.logLevel=="string"){const t=d(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function d(u){switch(u){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function f(u){switch(u){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=f}),define(ge[112],pe([0,1,14,43]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(D,I,s,P){try{const c=await new Promise((p,l)=>{Q(["spdlog"],p,l)});return c.setFlushOn(w.LogLevel.Info),c.createAsyncRotatingLogger(D,I,s,P)}catch(c){console.error(c)}return null}function A(D,I,s,P){const c=Q.__$__nodeRequire("spdlog");return c.setFlushOn(w.LogLevel.Info),c.createRotatingLogger(D,I,s,P)}e.createRotatingLogger=A;function y(D,I,s){switch(I){case w.LogLevel.Trace:D.trace(s);break;case w.LogLevel.Debug:D.debug(s);break;case w.LogLevel.Info:D.info(s);break;case w.LogLevel.Warning:D.warn(s);break;case w.LogLevel.Error:D.error(s);break;case w.LogLevel.Critical:D.critical(s);break;default:throw new Error("Invalid log level")}}class k extends w.AbstractMessageLogger{constructor(I,s,P,c){super();this.name=I,this.filepath=s,this.rotating=P,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const I=this.rotating?6:1,s=30/I*R.ByteSize.MB;return C(this.name,this.filepath,s,I).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:c,message:p}of this.buffer)y(this._logger,c,p);this.buffer=[]}})}log(I,s){this._logger?y(this._logger,I,s):this.getLevel()<=I&&this.buffer.push({level:I,message:s})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ge[113],pe([0,1,4,158,57]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function I(l,h){return h-l}D.compare=I;const s=Object.create(null);s[D.Error]=R.localize(0,null),s[D.Warning]=R.localize(1,null),s[D.Info]=R.localize(2,null);function P(l){return s[l]||""}D.toString=P;function c(l){switch(l){case C.default.Error:return D.Error;case C.default.Warning:return D.Warning;case C.default.Info:return D.Info;case C.default.Ignore:return D.Hint}}D.fromSeverity=c;function p(l){switch(l){case D.Error:return C.default.Error;case D.Warning:return C.default.Warning;case D.Info:return C.default.Info;case D.Hint:return C.default.Ignore}}D.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const I="";function s(c){return P(c,!0)}D.makeKey=s;function P(c,p){let l=[I];return c.source?l.push(c.source.replace("\xA6","\\\xA6")):l.push(I),c.code?typeof c.code=="string"?l.push(c.code.replace("\xA6","\\\xA6")):l.push(c.code.value.replace("\xA6","\\\xA6")):l.push(I),c.severity!==void 0&&c.severity!==null?l.push(y.toString(c.severity)):l.push(I),c.message&&p?l.push(c.message.replace("\xA6","\\\xA6")):l.push(I),c.startLineNumber!==void 0&&c.startLineNumber!==null?l.push(c.startLineNumber.toString()):l.push(I),c.startColumn!==void 0&&c.startColumn!==null?l.push(c.startColumn.toString()):l.push(I),c.endLineNumber!==void 0&&c.endLineNumber!==null?l.push(c.endLineNumber.toString()):l.push(I),c.endColumn!==void 0&&c.endColumn!==null?l.push(c.endColumn.toString()):l.push(I),l.push(I),l.join("\xA6")}D.makeKeyOptionalMessage=P})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=w.createDecorator("markerService")}),define(ge[186],pe([0,1,57,4,3]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=R.createDecorator("notificationService");var A;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(s){}updateMessage(s){}updateActions(s){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(s){}worked(s){}}e.NoOpProgress=D}),define(ge[187],pe([0,1,6,8,2,4]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=A.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return w.Disposable.None},registerValidator(){return w.Disposable.None},registerExternalUriResolver(){return w.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return w.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function y(k,D){return C.URI.isUri(k)?R.equalsIgnoreCase(k.scheme,D):R.startsWithIgnoreCase(k,D+":")}e.matchesScheme=y}),define(ge[188],pe([0,1,10,11,36,24]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const k=R.globals.vscode.context.configuration();if(k)y=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Q==null?void 0:Q.__$__nodeRequire)=="function"){const k=A.dirname(w.FileAccess.asFileUri("",Q));y=Q.__$__nodeRequire(A.joinPath(k,"product.json").fsPath);const D=Q.__$__nodeRequire(A.joinPath(k,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(Q,e){return function(w,R){e(w,R,Q)}};define(ge[114],pe([0,1,4,21,6,13]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=w.createDecorator("progressService");var y;(function(s){s[s.Explorer=1]="Explorer",s[s.Scm=3]="Scm",s[s.Extensions=5]="Extensions",s[s.Window=10]="Window",s[s.Notification=15]="Notification",s[s.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends C.Disposable{constructor(P,c){super();this.deferred=new A.DeferredPromise,c.withProgress(P,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register(C.toDisposable(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=Ve([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class I extends C.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(P){this.stop();const c=++this.currentOperationId,p=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add(C.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(C.toDisposable(()=>p.cancel())),this.currentOperationDisposables.add(C.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:p.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=w.createDecorator("editorProgressService")}),define(ge[38],pe([0,1,12,51]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(y,k){R.ok(w.isString(y)),R.ok(w.isObject(k)),R.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new C}),define(ge[115],pe([0,1,38,3]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,I){this.schemasById[C(D)]=I,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;w.Registry.add(e.Extensions.JSONContribution,y)}),define(ge[83],pe([0,1,153,3,38,12,115]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=C.Registry.as(y.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,S=!0){this.registerConfigurations([v],S)}registerConfigurations(v,S=!0){const d=[];v.forEach(f=>{d.push(...this.validateAndRegisterProperties(f,S,f.extensionInfo)),this.configurationContributors.push(f),this.registerJSONConfiguration(f)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(v){const S=[],d=f=>{if(f.properties)for(const u in f.properties)S.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,f.properties[u]);f.allOf&&f.allOf.forEach(u=>d(u))};for(const f of v){d(f);const u=this.configurationContributors.indexOf(f);u!==-1&&this.configurationContributors.splice(u,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(v){const S=[],d=[];for(const f of v)for(const u in f)if(S.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]=Object.assign(Object.assign({},this.defaultValues[u]||{}),f[u]);const t={type:"object",default:this.defaultValues[u],description:w.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};d.push(P(u)),this.configurationProperties[u]=t,this.defaultLanguageConfigurationOverridesNode.properties[u]=t}else{this.defaultValues[u]=f[u];const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(v){const S=[];for(const d of v)for(const f in d)if(S.push(f),delete this.defaultValues[f],e.OVERRIDE_PROPERTY_PATTERN.test(f))delete this.configurationProperties[f],delete this.defaultLanguageConfigurationOverridesNode.properties[f];else{const u=this.configurationProperties[f];u&&(this.updatePropertyDefaultValue(f,u),this.updateSchema(f,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const S of v)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,S=!0,d,f=3){var u;f=A.isUndefinedOrNull(v.scope)?f:v.scope;let t=[],n=v.properties;if(n)for(let r in n){if(S&&l(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=A.isUndefinedOrNull(o.scope)?f:o.scope,o.restricted=A.isUndefinedOrNull(o.restricted)?!!((u=d==null?void 0:d.restrictedConfigurations)===null||u===void 0?void 0:u.includes(r)):o.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let i=v.allOf;if(i)for(let r of i)t.push(...this.validateAndRegisterProperties(r,S,d,f));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const S=d=>{let f=d.properties;if(f)for(const t in f)this.updateSchema(t,f[t]);let u=d.allOf;u&&u.forEach(S)};S(v)}updateSchema(v,S){switch(e.allSettings.properties[v]=S,S.scope){case 1:e.applicationSettings.properties[v]=S;break;case 2:e.machineSettings.properties[v]=S;break;case 6:e.machineOverridableSettings.properties[v]=S;break;case 3:e.windowSettings.properties[v]=S;break;case 4:e.resourceSettings.properties[v]=S;break;case 5:e.resourceSettings.properties[v]=S,this.resourceLanguageSettingsSchema.properties[v]=S;break}}removeFromSchema(v,S){switch(delete e.allSettings.properties[v],S.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const S=`[${v}]`,d={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,d),e.allSettings.properties[S]=d,e.applicationSettings.properties[S]=d,e.machineSettings.properties[S]=d,e.machineOverridableSettings.properties[S]=d,e.windowSettings.properties[S]=d,e.resourceSettings.properties[S]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,S){let d=this.defaultValues[v];A.isUndefined(d)&&(d=S.default),A.isUndefined(d)&&(d=c(S.type)),S.default=d}}const s="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(s);function P(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=P;function c(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const p=new I;C.Registry.add(e.Extensions.Configuration,p);function l(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?w.localize(5,null,_):p.getConfigurationProperties()[_]!==void 0?w.localize(6,null,_):null:w.localize(4,null)}e.validateProperty=l;function h(){const _=[],v=p.getConfigurationProperties();for(const S of Object.keys(v))_.push([S,v[S].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=h}),define(ge[84],pe([0,1,25,12,2,38,4,83]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=y.createDecorator("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}e.isConfigurationOverrides=D;var I;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function s(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=s;function P(n,i){const r=i?n?i.keys.filter(L=>n.keys.indexOf(L)===-1):[...i.keys]:[],o=n?i?n.keys.filter(L=>i.keys.indexOf(L)===-1):[...n.keys]:[],m=[];if(i&&n){for(const L of n.keys)if(i.keys.indexOf(L)!==-1){const O=v(n.contents,L),W=v(i.contents,L);w.equals(O,W)||m.push(L)}}const g=[],E=L=>{const O={};for(const W of L)for(const ee of W.identifiers)O[u(ee)]=W;return O},b=i?E(i.overrides):{},a=n?E(n.overrides):{};if(Object.keys(b).length)for(const L of r){const O=b[L];O&&g.push([k.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(a).length)for(const L of o){const O=a[L];O&&g.push([k.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(b).length&&Object.keys(a).length)for(const L of m){const O=a[L],W=b[L];if(O&&W){const ee=P({contents:O.contents,keys:O.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});g.push([k.overrideIdentifierFromKey(L),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:o,updated:m,overrides:g}}e.compare=P;function c(n,i){const r=[];for(const o of Object.keys(n))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const m={};for(const g in n[o])m[g]=n[o][g];r.push({identifiers:[k.overrideIdentifierFromKey(o).trim()],keys:Object.keys(m),contents:p(m,i)})}return r}e.toOverrides=c;function p(n,i){const r=Object.create(null);for(let o in n)l(r,o,n[o],i);return r}e.toValuesTree=p;function l(n,i,r,o){const m=i.split("."),g=m.pop();let E=n;for(let b=0;b<m.length;b++){let a=m[b],L=E[a];switch(typeof L){case"undefined":L=E[a]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${m.slice(0,b+1).join(".")} is ${JSON.stringify(L)}`);return}E=L}if(typeof E=="object"&&E!==null)try{E[g]=r}catch(b){o(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(E)}`)}else o(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=l;function h(n,i){const r=i.split(".");_(n,r)}e.removeFromValueTree=h;function _(n,i){const r=i.shift();if(i.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(_(o,i),Object.keys(o).length===0&&delete n[r])}}function v(n,i,r){function o(E,b){let a=E;for(const L of b){if(typeof a!="object"||a===null)return;a=a[L]}return a}const m=i.split("."),g=o(n,m);return typeof g=="undefined"?r:g}e.getConfigurationValue=v;function S(n,i,r){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in n?R.isObject(n[o])&&R.isObject(i[o])?S(n[o],i[o],r):r&&(n[o]=i[o]):n[o]=i[o])})}e.merge=S;function d(){const n=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=d;function f(){const n=Object.create(null),i=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in i){let o=i[r].default;l(n,r,o,m=>console.error(`Conflict in default settings: ${m}`))}return n}e.getDefaultValues=f;function u(n){return`[${n}]`}e.keyFromOverrideIdentifier=u;function t(n,i,r){const o=n.inspect(i),m=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:o.defaultValue}e.getMigratedSettingValue=t}),define(ge[189],pe([0,1,55,22,17,12,25,2,83,84,38,6,3]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},n=[],i=[]){this._contents=t,this._keys=n,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?I.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,n){const i=this.getContentsForOverrideIdentifer(n);return i?t?I.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],m=n[r];m&&(typeof o=="object"&&typeof m=="object"?(o=y.deepClone(o),this.mergeContents(o,m)):o=m),i[r]=o}return new p(i,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),i=y.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const m of o.overrides){const[g]=i.filter(E=>C.equals(E.identifiers,m.identifiers));g?this.mergeContents(g.contents,m.contents):i.push(y.deepClone(m))}for(const m of o.keys)r.indexOf(m)===-1&&r.push(m)}return new p(n,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const i of Object.keys(n)){if(i in t&&A.isObject(t[i])&&A.isObject(n[i])){this.mergeContents(t[i],n[i]);continue}t[i]=y.deepClone(n[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),I.addToValueTree(this.contents,t,n,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&I.removeFromValueTree(this.contents,t)}addKey(t){let n=this.keys.length;for(let i=0;i<n;i++)t.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class l extends p{constructor(){const t=I.getDefaultValues(),n=I.getConfigurationKeys(),i=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[D.overrideIdentifierFromKey(r).trim()],keys:Object.keys(t[r]),contents:I.toValuesTree(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,i)}}e.DefaultConfigurationModel=l;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:i,keys:r,overrides:o,restricted:m}=this.doParseRaw(t,n);this._configurationModel=new p(i,r,o),this._restrictedConfigurations=m||[]}doParseContent(t){let n={},i=null,r=[],o=[],m=[];function g(b){Array.isArray(r)?r.push(b):i&&(r[i]=b)}let E={onObjectBegin:()=>{let b={};g(b),o.push(r),r=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let b=[];g(b),o.push(r),r=b,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:g,onError:(b,a,L)=>{m.push({error:b,offset:a,length:L})}};if(t)try{w.visit(t,E),n=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return n}doParseRaw(t,n){const i=s.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,i,!0,n);t=r.raw;const o=I.toValuesTree(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),m=Object.keys(t),g=I.toOverrides(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:m,overrides:g,restricted:r.restricted}}filter(t,n,i,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const o={},m=[];for(let g in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(g)&&i){const E=this.filter(t[g],n,!1,r);o[g]=E.raw,m.push(...E.restricted)}else{const E=n[g],b=E?typeof E.scope!="undefined"?E.scope:3:void 0;(E==null?void 0:E.restricted)&&m.push(g),(b===void 0||r.scopes===void 0||r.scopes.includes(b))&&(r.skipRestricted&&(E==null?void 0:E.restricted)||(o[g]=t[g]))}return{raw:o,restricted:m}}}e.ConfigurationModelParser=h;class _ extends P.Disposable{constructor(t,n,i,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class v{constructor(t,n,i=new p,r=new p,o=new R.ResourceMap,m=new p,g=new R.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=m,this._memoryConfigurationByResource=g,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(t)}updateValue(t,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new p,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,i){const r=this.getConsolidateConfigurationModel(n,i),o=this.getFolderConfigurationModelForResource(n.resource,i),m=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,W=n.overrideIdentifier?m.override(n.overrideIdentifier).getValue(t):m.getValue(t),ee=r.getValue(t),oe=C.distinct(C.flatten(r.overrides.map(V=>V.identifiers))).filter(V=>r.getOverrideValue(t,V)!==void 0);return{defaultValue:g,userValue:E,userLocalValue:b,userRemoteValue:a,workspaceValue:L,workspaceFolderValue:O,memoryValue:W,value:ee,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:m.getValue(t),override:n.overrideIdentifier?m.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const i=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=D.overrideIdentifierFromKey(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),g=t.getKeysForOverrideIdentifier(o),E=[...g.filter(b=>m.indexOf(b)===-1),...m.filter(b=>g.indexOf(b)===-1),...m.filter(b=>!y.equals(this._defaultConfiguration.override(o).getValue(b),t.override(o).getValue(b)))];return[o,E]});return this.updateDefaultConfiguration(t),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:i,removed:r,overrides:o}=I.compare(this.localUserConfiguration,t),m=[...n,...i,...r];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:i,removed:r,overrides:o}=I.compare(this.remoteUserConfiguration,t);let m=[...n,...i,...r];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:i,removed:r,overrides:o}=I.compare(this.workspaceConfiguration,t);let m=[...n,...i,...r];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const i=this.folderConfigurations.get(t),{added:r,updated:o,removed:m,overrides:g}=I.compare(i,n);let E=[...r,...o,...m];return(E.length||!i)&&this.updateFolderConfiguration(t,n),{keys:E,overrides:g}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:r,removed:o,overrides:m}=I.compare(n,void 0);return{keys:[...i,...r,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let i=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const o=this._memoryConfigurationByResource.get(t);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=i}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const i=n.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:i,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:i,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((m,g)=>(m.set(k.URI.revive(g[0]),this.parseConfigurationModel(g[1])),m),new R.ResourceMap);return new v(n,i,new p,r,o,new p,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function S(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,n=new Map;for(const r of u)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,m])=>{const g=R.getOrSet(n,o,new Set);m.forEach(E=>g.add(E))});const i=[];return n.forEach((r,o)=>i.push([o,[...r.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=S;class d{constructor(t,n,i,r){this.change=t,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(g=>o.add(g)),t.overrides.forEach(([,g])=>g.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const m=new p;this.affectedKeys.forEach(g=>m.setValue(g,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let i=I.toValuesTree({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(t=t[r],!t)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=d;class f extends d{constructor(t,n,i,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=f}),define(ge[190],pe([0,1,37,9,110,156,28,11,184,84,4,10,136]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=A.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const t=await v.getDefaultTerminalLinuxReady();return{windows:h.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let h=class zt extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(w,n,C.getWindowsShell(),t)}spawnTerminal(t,n,i,r){const o=n.terminal.external,m=(o==null?void 0:o.windowsExec)||zt.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const g=R.basename(m).toLowerCase();if(g==="cmder"||g==="cmder.exe")return t.spawn(m,r?[r]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return m.indexOf(" ")>=0&&E.push('""'),E.push(m),(g==="wt"||g==="wt.exe")&&E.push("-d ."),new Promise((b,a)=>{const L=S(process),O=t.spawn(i,E,{cwd:r,env:L});O.on("error",a),O.on("exit",()=>b())})}runInTerminal(t,n,i,r,o){const m="windowsExec"in o&&o.windowsExec?o.windowsExec:zt.getDefaultTerminalWindows();return new Promise((g,E)=>{const b=`"${n} - ${p}"`,a=`""${i.join('" "')}" & pause"`,L=["/c","start",b,"/wait",m,"/c",a],O=Object.assign({},S(process),r);Object.keys(O).filter(oe=>O[oe]===null).forEach(oe=>delete O[oe]);const W={cwd:n,env:O,windowsVerbatimArguments:!0};w.spawn(zt.CMD,L,W).on("error",oe=>{E(d(oe))}),g(void 0)})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};h.CMD="cmd.exe",h=Ve([He(0,s.optional(I.IConfigurationService))],h),e.WindowsExternalTerminalService=h;let _=class Nn extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(w,n,t)}runInTerminal(t,n,i,r,o){const m=o.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((g,E)=>{if(m===D.DEFAULT_TERMINAL_OSX||m==="iTerm.app"){const b=m===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`,Q).fsPath,"-t",t||p,"-w",n];for(let ee of i)L.push("-a"),L.push(ee);if(r)for(let ee in r){const oe=r[ee];oe===null?(L.push("-u"),L.push(ee)):(L.push("-e"),L.push(`${ee}=${oe}`))}let O="";const W=w.spawn(Nn.OSASCRIPT,L);W.on("error",ee=>{E(d(ee))}),W.stderr.on("data",ee=>{O+=ee.toString()}),W.on("exit",ee=>{if(ee===0)g(void 0);else if(O){const oe=O.split(`
`,1);E(new Error(oe[0]))}else E(new Error(A.localize(1,null,b,ee)))})}else E(new Error(A.localize(2,null,m)))})}spawnTerminal(t,n,i){const r=n.terminal.external,o=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((m,g)=>{const E=["-a",o];i&&E.push(i);const b=t.spawn("/usr/bin/open",E);b.on("error",g),b.on("exit",()=>m())})}};_.OSASCRIPT="/usr/bin/osascript",_=Ve([He(0,s.optional(I.IConfigurationService))],_),e.MacExternalTerminalService=_;let v=class Vt extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(w,n,t)}runInTerminal(t,n,i,r,o){const m=o.linuxExec?Promise.resolve(o.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((g,E)=>{let b=[];m.then(a=>{a.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const L=`${f(i)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;b.push(`''${L}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(V=>O[V]===null).forEach(V=>delete O[V]);const W={cwd:n,env:O};let ee="";const oe=w.spawn(a,b,W);oe.on("error",V=>{E(d(V))}),oe.stderr.on("data",V=>{ee+=V.toString()}),oe.on("exit",V=>{if(V===0)g(void 0);else if(ee){const B=ee.split(`
`,1);E(new Error(B[0]))}else E(new Error(A.localize(4,null,a,V)))})})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{k.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,i){const r=n.terminal.external,o=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((m,g)=>{o.then(E=>{const b=S(process),a=t.spawn(E,[],{cwd:i,env:b});a.on("error",g),a.on("exit",()=>m())})})}};v.WAIT_MESSAGE=A.localize(3,null),v=Ve([He(0,s.optional(I.IConfigurationService))],v),e.LinuxExternalTerminalService=v;function S(u){const t=u.env;return c.sanitizeProcessEnvironment(t),t}function d(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(A.localize(5,null,u.path)):u}function f(u){let t="";for(let n of u)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(ge[116],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=w.createDecorator("remoteAuthorityResolverService");var R;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(y,k=R.Unknown,D){super(y);this._message=y,this._code=k,this._detail=D,this.isHandled=k===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(y){return y instanceof C&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof C&&y._code===R.NoResolverFound}static isHandled(y){return y instanceof C&&y.isHandled}}e.RemoteAuthorityResolverError=C}),define(ge[117],pe([0,1,10]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(I){return I.scheme===w.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=R;function C(I){if(!I)return;const s=I.indexOf("+");return s<0?I:I.substr(0,s)}e.getRemoteName=C;function A(I){return I.scheme!==w.Schemas.file&&I.scheme!==w.Schemas.vscodeRemote}function y(I){if(I.folders.length)return I.folders.every(s=>A(s.uri))?I.folders[0].uri:void 0;if(I.configuration&&A(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=y;function k(I){var s;return(s=y(I))===null||s===void 0?void 0:s.scheme}e.getVirtualWorkspaceScheme=k;function D(I){return y(I)!==void 0}e.isVirtualWorkspace=D}),define(ge[191],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{vsda(){return new Promise((C,A)=>Q(["vsda"],C,A))}async sign(C){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(C)}catch(A){}return C}}e.SignService=w}),define(ge[192],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,A,y=5){let k;return k=A(D=>{const I=typeof D=="string"?D:D.data;let s=this._terminalBufferMap.get(C);if(s){s.data.push(I);return}const P=setTimeout(()=>this.flushBuffer(C),y);s={data:[I],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(C),k.dispose()}},this._terminalBufferMap.set(C,s)}),k}stopBuffering(C){const A=this._terminalBufferMap.get(C);A&&A.dispose()}flushBuffer(C){const A=this._terminalBufferMap.get(C);A&&(this._terminalBufferMap.delete(C),this._callback(C,A.data.join("")))}}e.TerminalDataBufferer=w}),define(ge[193],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(ge[194],pe([0,1,4,6,38,3,193,45]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=w.createDecorator("themeService");var D;(function(_){function v(S){return S&&typeof S=="object"&&typeof S.id=="string"}_.isThemeColor=v})(D=e.ThemeColor||(e.ThemeColor={}));function I(_){return{id:_}}e.themeColorFromId=I;var s;(function(_){function v(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}_.isThemeIcon=v;const S=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(n){const i=S.exec(n);if(!i)return;let[,r]=i;return{id:r}}_.fromString=d;function f(n,i){let r=n.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),i&&(r=`${r}~${i}`),{id:r}}_.modify=f;function u(n,i){var r,o;return n.id===i.id&&((r=n.color)===null||r===void 0?void 0:r.id)===((o=i.color)===null||o===void 0?void 0:o.id)}_.isEqual=u;function t(n){return{id:n.id}}_.asThemeIcon=t,_.asClassNameArray=k.CSSIcon.asClassNameArray,_.asClassName=k.CSSIcon.asClassName,_.asCSSSelector=k.CSSIcon.asCSSSelector})(s=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function P(_){switch(_){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),R.toDisposable(()=>{const S=this.themingParticipants.indexOf(v);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new c;C.Registry.add(e.Extensions.ThemingContribution,p);function l(_){return p.onColorThemeChange(_)}e.registerThemingParticipant=l;class h extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,S){let d=this.theme.getColor(v);return d&&S&&(d=S(d,this.theme)),d?d.toString():null}}e.Themable=h}),define(ge[195],pe([0,1,38,194,3,159,115,13,45]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:A.localize(0,null)},fontCharacter:{type:"string",description:A.localize(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,S,d,f){const u=this.iconsById[v];if(u){if(d&&!u.description){u.description=d,this.iconSchema.properties[v].markdownDescription=`${d} $(${v})`;const i=this.iconReferenceSchema.enum.indexOf(v);i!==-1&&(this.iconReferenceSchema.enumDescriptions[i]=d),this._onDidChange.fire()}return u}let t={id:v,description:d,defaults:S,deprecationMessage:f};this.iconsById[v]=t;let n={$ref:"#/definitions/icons"};return f&&(n.deprecationMessage=f),d&&(n.markdownDescription=`${d}: $(${v})`),this.iconSchema.properties[v]=n,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const S=this.iconReferenceSchema.enum.indexOf(v);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,S){const d=this.iconFontsById[v];if(d)return d;let f={id:v,definition:S};return this.iconFontsById[v]=f,this._onDidChange.fire(),f}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(u,t)=>u.id.localeCompare(t.id),S=u=>{for(;R.ThemeIcon.isThemeIcon(u.defaults);)u=this.iconsById[u.defaults.id];return`codicon codicon-${u?u.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(u=>this.iconsById[u]);for(const u of f.filter(t=>!!t.description).sort(v))d.push(`|<i class="${S(u)}"></i>|${u.id}|${R.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const u of f.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(v))d.push(`|<i class="${S(u)}"></i>|${u.id}|`);return d.join(`
`)}}const s=new I;w.Registry.add(e.Extensions.IconContribution,s);function P(_,v,S,d){return s.registerIcon(_,v,S,d)}e.registerIcon=P;function c(){return s}e.getIconRegistry=c;function p(){for(const _ of D.iconRegistry.all)s.registerIcon(_.id,_.definition,_.description);D.iconRegistry.onDidRegister(_=>s.registerIcon(_.id,_.definition,_.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let l=w.Registry.as(y.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,s.getIconSchema());const h=new k.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);s.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=P("widget-close",D.Codicon.close,A.localize(2,null)),e.gotoPreviousLocation=P("goto-previous-location",D.Codicon.arrowUp,A.localize(3,null)),e.gotoNextLocation=P("goto-next-location",D.Codicon.arrowDown,A.localize(4,null)),e.syncing=R.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(ge[61],pe([0,1,2,24,4,22]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=C.createDecorator("contextService");var y;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function k(c){const p=c;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=k;function D(c){const p=c;return!!(p&&typeof p=="object"&&w.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=D;class I{constructor(p,l,h,_){this._id=p,this._configuration=h,this._ignorePathCasing=_,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class s{constructor(p,l){this.raw=l,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return R.joinPath(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=s;function P(c){return new s({uri:c,index:0,name:R.basenameOrAuthority(c)},{uri:c.toString()})}e.toWorkspaceFolder=P}),define(ge[118],pe([0,1,4,160,61,2,11,9,24,134,55,10,77,29,117]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(B){return(typeof B=="string"?k.extname(B):D.extname(B))===h}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=w.createDecorator("workspacesService");function v(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function S(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=S;function d(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=d;function f(B){const j=B;return typeof(j==null?void 0:j.id)=="string"&&A.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=f;function u(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(B){const j=B;return typeof(j==null?void 0:j.id)=="string"&&A.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=t;function n(B){const j=B;if(j==null?void 0:j.uri)return{id:j.id,uri:A.URI.revive(j.uri)};const T=B;if(T==null?void 0:T.configPath)return{id:T.id,configPath:A.URI.revive(T.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=n;function i(B,j){return D.extUriBiasedIgnorePathCase.isEqualOrParent(B,j.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function r(B){return o(B)||m(B)}e.isStoredWorkspaceFolder=r;function o(B){const j=B;return typeof(j==null?void 0:j.path)=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=o;function m(B){const j=B;return typeof(j==null?void 0:j.uri)=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=m;function g(B,j,T,N,F=!y.isWindows,M){if(B.scheme!==N.scheme)return{name:T,uri:B.toString(!0)};let U=j?void 0:M.relativePath(N,B);if(U!==void 0)U.length===0?U=".":y.isWindows&&B.scheme===P.Schemas.file&&!F&&(U=U.replace(/\//g,"\\"));else if(B.scheme===P.Schemas.file)U=B.fsPath,y.isWindows&&(U=c.normalizeDriveLetter(U),F&&(U=p.toSlashes(U)));else{if(!M.isEqualAuthority(B.authority,N.authority))return{name:T,uri:B.toString(!0)};U=B.path}return{name:T,path:U}}e.getStoredWorkspaceFolder=g;function E(B,j,T){let N=[],F=new Set;const M=T.dirname(j);for(let U of B){let x;if(o(U))U.path&&(x=T.resolvePath(M,U.path));else if(m(U))try{x=A.URI.parse(U.uri),x.path[0]!=="/"&&(x=x.with({path:"/"+x.path}))}catch(G){console.warn(G)}if(x){let G=T.getComparisonKey(x);if(!F.has(G)){F.add(G);const se=U.name||T.basenameOrAuthority(x);N.push(new C.WorkspaceFolder({uri:x,name:se,index:N.length},U))}}}return N}e.toWorkspaceFolders=E;function b(B,j,T,N,F){let M=a(j,B);const U=F.dirname(j),x=F.dirname(N),G=[],se=L(M.folders);for(const Me of M.folders){const qe=o(Me)?F.resolvePath(U,Me.path):A.URI.parse(Me.uri);let ze;T?ze=!1:ze=!o(Me)||k.isAbsolute(Me.path),G.push(g(qe,ze,Me.name,x,se,F))}const be={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Te=I.setProperty(B,["folders"],G,be);let Ce=I.applyEdits(B,Te);return M.remoteAuthority===l.getRemoteAuthority(N)&&(Ce=I.applyEdits(Ce,I.removeProperty(Ce,["remoteAuthority"],be))),Ce}e.rewriteWorkspaceFileForNewLocation=b;function a(B,j){let T=s.parse(j);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>r(N));else throw new Error(`${B} looks like an invalid workspace file.`);return T}function L(B){return y.isWindows?B.some(j=>o(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function W(B){return typeof B.folderUri=="string"}function ee(B){return typeof B.fileUri=="string"}function oe(B,j){const T={workspaces:[],files:[]};if(B){const N=function(M,U){for(let x=0;x<M.length;x++)try{U(M[x],x)}catch(G){j.warn(`Error restoring recent entry ${JSON.stringify(M[x])}: ${G.toString()}. Skip entry.`)}},F=B;if(Array.isArray(F.entries))N(F.entries,M=>{const U=M.label,x=M.remoteAuthority;O(M)?T.workspaces.push({label:U,remoteAuthority:x,workspace:{id:M.workspace.id,configPath:A.URI.parse(M.workspace.configPath)}}):W(M)?T.workspaces.push({label:U,remoteAuthority:x,folderUri:A.URI.parse(M.folderUri)}):ee(M)&&T.files.push({label:U,remoteAuthority:x,fileUri:A.URI.parse(M.fileUri)})});else{const M=B;Array.isArray(M.workspaces3)&&N(M.workspaces3,(U,x)=>{const G=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[x]||void 0;typeof U=="object"&&typeof U.id=="string"&&typeof U.configURIPath=="string"?T.workspaces.push({label:G,workspace:{id:U.id,configPath:A.URI.parse(U.configURIPath)}}):typeof U=="string"&&T.workspaces.push({label:G,folderUri:A.URI.parse(U)})}),Array.isArray(M.files2)&&N(M.files2,(U,x)=>{const G=Array.isArray(M.fileLabels)&&M.fileLabels[x]||void 0;typeof U=="string"&&T.files.push({label:G,fileUri:A.URI.parse(U)})})}}return T}e.restoreRecentlyOpened=oe;function V(B){const j={entries:[]};for(const T of B.workspaces)S(T)?j.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):j.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of B.files)j.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return j}e.toStoreData=V}),define(ge[85],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const A=this._idPool++;return this._data.set(A,C),this.logDebugInfo(),A}get(C,A){return this._data.has(C)?this._data.get(C)[A]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(ge[47],pe([0,1,2,3,4]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=C.createDecorator("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(k){this._tabs=k.map(D=>({name:D.name,group:D.group,resource:w.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(ge[62],pe([0,1,10,4]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,k){k===null?this._providerInfo.delete(y):this._providerInfo.set(y,k)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=w.createDecorator("IExtHostInitDataService")}),define(ge[196],pe([0,1,13]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(y,k,D){this._deferredPromises=new Map,this._id=y,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const s of I.values())s.complete()}catch(s){for(const P of I.values())P.error(s)}})()},0)}get keys(){var y;return Object.entries((y=this._value)!==null&&y!==void 0?y:{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(y,k){let D=this._value[y];return typeof D=="undefined"&&(D=k),D}update(y,k){this._value[y]=k;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const I=new w.DeferredPromise;return this._deferredPromises.set(y,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(y,k){super(y.identifier.value,!0,k);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=C}),define(ge[15],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=w.createDecorator("IExtHostRpcService");class R{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[197],pe([0,1,26,3]),function(Q,e,w,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,D){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(k.identifier),nt(this,C,D,"f"),Be(this,C,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(k){return Be(this,C,"f").get(this._id,k)}store(k,D){return Be(this,C,"f").store(this._id,k,D)}delete(k){return Be(this,C,"f").delete(this._id,k)}}e.ExtensionSecrets=A,C=new WeakMap}),define(ge[119],pe([0,1,4,3]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=w.createDecorator("IExtHostTelemetry")}),define(ge[86],pe([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,A=y=>{let k=C.get(y);return k||(k={children:new Map,bus:new w.Emitter},C.set(y,k)),k};e.getPrivateApiFor=A}),define(ge[48],pe([0,1,4,3,15]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(k){function D(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public}}k.fromApiTunnel=D;function I(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.public}}k.fromServiceTunnel=I})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=w.createDecorator("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,I){return{dispose:()=>{}}}async $providePortAttributes(D,I,s,P,c){return[]}async $forwardPort(D,I){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([He(0,C.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)},Qt=this&&this.__rest||function(Q,e){var w={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(w[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(Q);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[C])&&(w[R[C]]=Q[R[C]]);return w};define(ge[7],pe([0,1,17,16,96,22,138,12,2,32,43,116,86]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";var p,l,h,_,v,S,d,f,u,t,n,i,r,o,m,g,E,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(z){function $(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf($,z),Object.setPrototypeOf($.prototype,z.prototype),$}let L=v=class{constructor($){p.set(this,void 0),nt(this,p,$,"f")}static from(...$){let ne=$;return new v(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}dispose(){typeof Be(this,p,"f")=="function"&&(Be(this,p,"f").call(this),nt(this,p,void 0,"f"))}};p=new WeakMap,L=v=Ve([a],L),e.Disposable=L;let O=S=class{constructor($,ne){if($<0)throw R.illegalArgument("line must be non-negative");if(ne<0)throw R.illegalArgument("character must be non-negative");this._line=$,this._character=ne}static Min(...$){if($.length===0)throw new TypeError;let ne=$[0];for(let Se=1;Se<$.length;Se++){const Ge=$[Se];Ge.isBefore(ne)&&(ne=Ge)}return ne}static Max(...$){if($.length===0)throw new TypeError;let ne=$[0];for(let Se=1;Se<$.length;Se++){const Ge=$[Se];Ge.isAfter(ne)&&(ne=Ge)}return ne}static isPosition($){if(!$)return!1;if($ instanceof S)return!0;let{line:ne,character:Se}=$;return typeof ne=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,ne=0){if($===null||ne===null)throw R.illegalArgument();let Se;return typeof $=="undefined"?Se=0:typeof $=="number"?Se=$:(Se=typeof $.lineDelta=="number"?$.lineDelta:0,ne=typeof $.characterDelta=="number"?$.characterDelta:0),Se===0&&ne===0?this:new S(this.line+Se,this.character+ne)}with($,ne=this.character){if($===null||ne===null)throw R.illegalArgument();let Se;return typeof $=="undefined"?Se=this.line:typeof $=="number"?Se=$:(Se=typeof $.line=="number"?$.line:this.line,ne=typeof $.character=="number"?$.character:this.character),Se===this.line&&ne===this.character?this:new S(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};O=S=Ve([a],O),e.Position=O;let W=d=class{constructor($,ne,Se,Ge){let Je,at;if(typeof $=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(Je=new O($,ne),at=new O(Se,Ge)):$ instanceof O&&ne instanceof O&&(Je=$,at=ne),!Je||!at)throw new Error("Invalid arguments");Je.isBefore(at)?(this._start=Je,this._end=at):(this._start=at,this._end=Je)}static isRange($){return $ instanceof d?!0:$?O.isPosition($.start)&&O.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof d?this.contains($._start)&&this.contains($._end):$ instanceof O?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const ne=O.Max($.start,this._start),Se=O.Min($.end,this._end);if(!ne.isAfter(Se))return new d(ne,Se)}union($){if(this.contains($))return this;if($.contains(this))return $;const ne=O.Min($.start,this._start),Se=O.Max($.end,this.end);return new d(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,ne=this.end){if($===null||ne===null)throw R.illegalArgument();let Se;return $?O.isPosition($)?Se=$:(Se=$.start||this.start,ne=$.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new d(Se,ne)}toJSON(){return[this.start,this.end]}};W=d=Ve([a],W),e.Range=W;let ee=f=class extends W{constructor($,ne,Se,Ge){let Je,at;if(typeof $=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(Je=new O($,ne),at=new O(Se,Ge)):$ instanceof O&&ne instanceof O&&(Je=$,at=ne),!Je||!at)throw new Error("Invalid arguments");super(Je,at);this._anchor=Je,this._active=at}static isSelection($){return $ instanceof f?!0:$?W.isRange($)&&O.isPosition($.anchor)&&O.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=f=Ve([a],ee),e.Selection=ee;class oe{constructor($,ne,Se){if(typeof $!="string"||$.length===0)throw R.illegalArgument("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw R.illegalArgument("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw R.illegalArgument("connectionToken");this.host=$,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=oe;class V extends Error{constructor($,ne=P.RemoteAuthorityResolverErrorCode.Unknown,Se){super($);this._message=$,this._code=ne,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable($,ne){return new V($,P.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable($){return new V($,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var B;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var j;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let T=u=class{constructor($,ne){this._range=$,this._newText=ne}static isTextEdit($){return $ instanceof u?!0:$?W.isRange($)&&typeof $.newText=="string":!1}static replace($,ne){return new u($,ne)}static insert($,ne){return u.replace(new W($,$),ne)}static delete($){return u.replace($,"")}static setEndOfLine($){const ne=new u(new W(new O(0,0),new O(0,0)),"");return ne.newEol=$,ne}get range(){return this._range}set range($){if($&&!W.isRange($))throw R.illegalArgument("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw R.illegalArgument("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw R.illegalArgument("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};T=u=Ve([a],T),e.TextEdit=T;var N;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(N=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,ne,Se,Ge){this._edits.push({_type:1,from:$,to:ne,options:Se,metadata:Ge})}createFile($,ne,Se){this._edits.push({_type:1,from:void 0,to:$,options:ne,metadata:Se})}deleteFile($,ne,Se){this._edits.push({_type:1,from:$,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata($,ne,Se){this._edits.push({_type:3,metadata:Se,uri:$,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells($,ne,Se,Ge,Je){let at,dt,yt=[],kt;if($t.isNotebookRange(ne)&&Fe.isNotebookCellDataArray(Se)&&!Fe.isNotebookCellDataArray(Ge)?(at=ne.start,dt=ne.end,yt=Se,kt=Ge):typeof ne=="number"&&typeof Se=="number"&&Fe.isNotebookCellDataArray(Ge)&&(at=ne,dt=Se,yt=Ge,kt=Je),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||yt.length>0)&&this._edits.push({_type:5,uri:$,index:at,count:dt-at,cells:yt,metadata:kt})}replaceNotebookCellMetadata($,ne,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:$,edit:{editType:8,index:ne,metadata:Se}})}replace($,ne,Se,Ge){this._edits.push({_type:2,uri:$,edit:new T(ne,Se),metadata:Ge})}insert($,ne,Se,Ge){this.replace($,new W(ne,ne),Se,Ge)}delete($,ne,Se){this.replace($,ne,"",Se)}has($){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===$.toString())}set($,ne){if(ne)for(const Se of ne)Se&&this._edits.push({_type:2,uri:$,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===$.toString()&&(this._edits[Se]=void 0)}w.coalesceInPlace(this._edits)}}get($){const ne=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===$.toString()&&ne.push(Se.edit);return ne}entries(){const $=new A.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Se=$.get(ne.uri);Se||(Se=[ne.uri,[]],$.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([a],F),e.WorkspaceEdit=F;let M=t=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof t?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=t._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,ne=this._tabstop++){if(typeof $=="function"){const Se=new t;Se._tabstop=this._tabstop,$(Se),this._tabstop=Se._tabstop,$=Se.value}else $=t._escape($);return this.value+="${",this.value+=ne,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,ne=this._tabstop++){const Se=$.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable($,ne){if(typeof ne=="function"){const Se=new t;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};M=t=Ve([a],M),e.SnippetString=M;var U;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=n=class{constructor($,ne){if(this.uri=$,ne)if(ne instanceof W)this.range=ne;else if(ne instanceof O)this.range=new W(ne,ne);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof n?!0:$?W.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=n=Ve([a],G),e.Location=G;let se=class{constructor($,ne){this.location=$,this.message=ne}static is($){return $?typeof $.message=="string"&&$.location&&W.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,ne){return $===ne?!0:!$||!ne?!1:$.message===ne.message&&$.location.range.isEqual(ne.location.range)&&$.location.uri.toString()===ne.location.uri.toString()}};se=Ve([a],se),e.DiagnosticRelatedInformation=se;let be=class{constructor($,ne,Se=x.Error){if(!W.isRange($))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=$,this.message=ne,this.severity=Se}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,ne){return $===ne?!0:!$||!ne?!1:$.message===ne.message&&$.severity===ne.severity&&$.code===ne.code&&$.severity===ne.severity&&$.source===ne.source&&$.range.isEqual(ne.range)&&w.equals($.tags,ne.tags)&&w.equals($.relatedInformation,ne.relatedInformation,se.isEqual)}};be=Ve([a],be),e.Diagnostic=be;let Te=class{constructor($,ne){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:C.isMarkdownString($)?this.contents=[$]:this.contents=[$],this.range=ne}};Te=Ve([a],Te),e.Hover=Te;var Ce;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(Ce=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor($,ne=Ce.Text){this.range=$,this.kind=ne}toJSON(){return{range:this.range,kind:Ce[this.kind]}}};Me=Ve([a],Me),e.DocumentHighlight=Me;var qe;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(z){z[z.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let Ke=i=class{constructor($,ne,Se,Ge,Je){this.name=$,this.kind=ne,this.containerName=Je,typeof Se=="string"&&(this.containerName=Se),Ge instanceof G?this.location=Ge:Se instanceof W&&(this.location=new G(Ge,Se)),i.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};Ke=i=Ve([a],Ke),e.SymbolInformation=Ke;let q=r=class{constructor($,ne,Se,Ge,Je){this.name=$,this.detail=ne,this.kind=Se,this.range=Ge,this.selectionRange=Je,this.children=[],r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(r.validate)}};q=r=Ve([a],q),e.DocumentSymbol=q;var J;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor($,ne){this.title=$,this.kind=ne}};re=Ve([a],re),e.CodeAction=re;let ae=o=class{constructor($){this.value=$}append($){return new o(this.value?this.value+o.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+o.sep)}};ae.sep=".",ae=o=Ve([a],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let Y=class{constructor($,ne){if(this.range=$,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Ve([a],Y),e.SelectionRange=Y;class ce{constructor($,ne,Se,Ge,Je,at){this.kind=$,this.name=ne,this.detail=Se,this.uri=Ge,this.range=Je,this.selectionRange=at}}e.CallHierarchyItem=ce;class ve{constructor($,ne){this.fromRanges=ne,this.from=$}}e.CallHierarchyIncomingCall=ve;class Re{constructor($,ne){this.fromRanges=ne,this.to=$}}e.CallHierarchyOutgoingCall=Re;let we=class{constructor($,ne){this.range=$,this.command=ne}get isResolved(){return!!this.command}};we=Ve([a],we),e.CodeLens=we;let je=m=class{constructor($,ne=!1){l.set(this,void 0),nt(this,l,new C.MarkdownString($,{supportThemeIcons:ne}),"f")}static isMarkdownString($){return $ instanceof m?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Be(this,l,"f").value}set value($){Be(this,l,"f").value=$}get isTrusted(){return Be(this,l,"f").isTrusted}set isTrusted($){Be(this,l,"f").isTrusted=$}get supportThemeIcons(){return Be(this,l,"f").supportThemeIcons}appendText($){return Be(this,l,"f").appendText($),this}appendMarkdown($){return Be(this,l,"f").appendMarkdown($),this}appendCodeblock($,ne){return Be(this,l,"f").appendCodeblock(ne??"",$),this}};l=new WeakMap,je=m=Ve([a],je),e.MarkdownString=je;let K=class{constructor($,ne){this.label=$,this.documentation=ne}};K=Ve([a],K),e.ParameterInformation=K;let ie=class{constructor($,ne){this.label=$,this.documentation=ne,this.parameters=[]}};ie=Ve([a],ie),e.SignatureInformation=ie;let Ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ee=Ve([a],Ee),e.SignatureHelp=Ee;var Ne;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $e;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})($e=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor($,ne,Se){this.text=$,this.position=ne,this.kind=Se}};We=Ve([a],We),e.InlayHint=We;var Xe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var ye;(function(z){z[z.Deprecated=1]="Deprecated"})(ye=e.CompletionItemTag||(e.CompletionItemTag={}));let ke=class{constructor($,ne){this.label=$,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ke=Ve([a],ke),e.CompletionItem=ke;let le=class{constructor($=[],ne=!1){this.items=$,this.isIncomplete=ne}};le=Ve([a],le),e.CompletionList=le;let he=class{constructor($,ne,Se){this.text=$,this.range=ne,this.command=Se}};he=Ve([a],he),e.InlineSuggestion=he;let H=class{constructor($){this.items=$}};H=Ve([a],H),e.InlineSuggestions=H;var Z;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Z=e.ViewColumn||(e.ViewColumn={}));var ue;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var xe;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function $(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=$}(xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor($,ne){if(ne&&!D.URI.isUri(ne))throw R.illegalArgument("target");if(!W.isRange($)||$.isEmpty)throw R.illegalArgument("range");this.range=$,this.target=ne}};rt=Ve([a],rt),e.DocumentLink=rt;let tt=class{constructor($,ne,Se,Ge){this.red=$,this.green=ne,this.blue=Se,this.alpha=Ge}};tt=Ve([a],tt),e.Color=tt;let Ye=class{constructor($,ne){if(ne&&!(ne instanceof tt))throw R.illegalArgument("color");if(!W.isRange($)||$.isEmpty)throw R.illegalArgument("range");this.range=$,this.color=ne}};Ye=Ve([a],Ye),e.ColorInformation=Ye;let ot=class{constructor($){if(!$||typeof $!="string")throw R.illegalArgument("label");this.label=$}};ot=Ve([a],ot),e.ColorPresentation=ot;var Et;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Et=e.ColorFormat||(e.ColorFormat={}));var bt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var fe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(fe=e.TaskPanelKind||(e.TaskPanelKind={}));let de=g=class{constructor($,ne){if(typeof $!="string"||typeof ne!="string")throw R.illegalArgument("name");this._id=$}static from($){switch($){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}get id(){return this._id}};de.Clean=new g("clean","Clean"),de.Build=new g("build","Build"),de.Rebuild=new g("rebuild","Rebuild"),de.Test=new g("test","Test"),de=g=Ve([a],de),e.TaskGroup=de;function X(z){let $="";for(let ne=0;ne<z.length;ne++)$+=z[ne].replace(/,/g,",,")+",";return $}let Oe=class{constructor($,ne,Se){if(typeof $!="string")throw R.illegalArgument("process");this._args=[],this._process=$,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process($){if(typeof $!="string")throw R.illegalArgument("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)$.push(ne);return X($)}};Oe=Ve([a],Oe),e.ProcessExecution=Oe;let Le=class{constructor($,ne,Se){if(this._args=[],Array.isArray(ne)){if(!$)throw R.illegalArgument("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw R.illegalArgument("command");this._command=$,this._args=ne,this._options=Se}else{if(typeof $!="string")throw R.illegalArgument("commandLine");this._commandLine=$,this._options=ne}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw R.illegalArgument("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw R.illegalArgument("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)$.push(typeof ne=="string"?ne:ne.value);return X($)}};Le=Ve([a],Le),e.ShellExecution=Le;var Ze;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Ze=e.ShellQuoting||(e.ShellQuoting={}));var et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(et=e.TaskScope||(e.TaskScope={}));class ft{constructor($){this._callback=$}computeId(){return"customExecution"+I.generateUuid()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=ft;let ct=E=class{constructor($,ne,Se,Ge,Je,at){this.__deprecated=!1,this._definition=this.definition=$;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=Ge,dt=Je,this.__deprecated=!0):ne===et.Global||ne===et.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=Ge,this.execution=Je,dt=at):(this.target=ne,this._name=this.name=Se,this._source=this.source=Ge,this.execution=Je,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Oe?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:I.generateUuid()}}get definition(){return this._definition}set definition($){if($==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw R.illegalArgument("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const ne=this._definition.type;(E.EmptyType===ne||E.ProcessType===ne||E.ShellType===ne||E.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=E=Ve([a],ct),e.Task=ct;var it;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,ne=ht.None){this.collapsibleState=ne,D.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=Ve([a],vt),e.TreeItem=vt;var ht;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let lt=class{constructor($,ne){this.id=$,this.color=ne}};lt=Ve([a],lt),e.ThemeIcon=lt,lt.File=new lt("file"),lt.Folder=new lt("folder");let mt=class{constructor($){this.id=$}};mt=Ve([a],mt),e.ThemeColor=mt;var Pt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor($,ne){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw R.illegalArgument("base");if(typeof ne!="string")throw R.illegalArgument("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=ne}};Ct=Ve([a],Ct),e.RelativePattern=Ct;let At=class{constructor($,ne,Se,Ge){this.enabled=typeof $=="boolean"?$:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=I.generateUuid()),this._id}};At=Ve([a],At),e.Breakpoint=At;let Rt=class extends At{constructor($,ne,Se,Ge,Je){super(ne,Se,Ge,Je);if($===null)throw R.illegalArgument("location");this.location=$}};Rt=Ve([a],Rt),e.SourceBreakpoint=Rt;let St=class extends At{constructor($,ne,Se,Ge,Je){super(ne,Se,Ge,Je);this.functionName=$}};St=Ve([a],St),e.FunctionBreakpoint=St;let Xt=class extends At{constructor($,ne,Se,Ge,Je,at,dt){super(Ge,Je,at,dt);if(!ne)throw R.illegalArgument("dataId");this.label=$,this.dataId=ne,this.canPersist=Se}};Xt=Ve([a],Xt),e.DataBreakpoint=Xt;let Yt=class{constructor($,ne,Se){this.command=$,this.args=ne||[],this.options=Se}};Yt=Ve([a],Yt),e.DebugAdapterExecutable=Yt;let pt=class{constructor($,ne){this.port=$,this.host=ne}};pt=Ve([a],pt),e.DebugAdapterServer=pt;let Jt=class{constructor($){this.path=$}};Jt=Ve([a],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor($){this.implementation=$}};Zt=Ve([a],Zt),e.DebugAdapterInlineImplementation=Zt;let Dt=class{constructor($,ne){this.range=$,this.expression=ne}};Dt=Ve([a],Dt),e.EvaluatableExpression=Dt;var hn;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor($,ne){this.range=$,this.text=ne}};en=Ve([a],en),e.InlineValueText=en;let xt=class{constructor($,ne,Se=!0){this.range=$,this.variableName=ne,this.caseSensitiveLookup=Se}};xt=Ve([a],xt),e.InlineValueVariableLookup=xt;let ut=class{constructor($,ne){this.range=$,this.expression=ne}};ut=Ve([a],ut),e.InlineValueEvaluatableExpression=ut;let tn=class{constructor($,ne){this.frameId=$,this.stoppedLocation=ne}};tn=Ve([a],tn),e.InlineValueContext=tn;var Ft;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let Mt=b=class extends Error{constructor($,ne=s.FileSystemProviderErrorCode.Unknown,Se){var Ge;super(D.URI.isUri($)?$.toString(!0):$);this.code=(Ge=Se==null?void 0:Se.name)!==null&&Ge!==void 0?Ge:"Unknown",s.markAsFileSystemProviderError(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists($){return new b($,s.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,s.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,s.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,s.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,s.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,s.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Mt=b=Ve([a],Mt),e.FileSystemError=Mt;let qt=class{constructor($,ne,Se){this.start=$,this.end=ne,this.kind=Se}};qt=Ve([a],qt),e.FoldingRange=qt;var bn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var En;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(En=e.CommentMode||(e.CommentMode={}));class mn{constructor($,ne=[]){this.tokenTypes=$,this.tokenModifiers=ne}}e.SemanticTokensLegend=mn;function Bt(z){return typeof z=="undefined"||k.isStringArray(z)}class nn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let ne=0,Se=$.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set($.tokenTypes[ne],ne);for(let ne=0,Se=$.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set($.tokenModifiers[ne],ne)}}push($,ne,Se,Ge,Je){if(typeof $=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded($,ne,Se,Ge,Je);if(W.isRange($)&&typeof ne=="string"&&Bt(Se))return this._push($,ne,Se);throw R.illegalArgument()}_push($,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ge=$.start.line,Je=$.start.character,at=$.end.character-$.start.character,dt=this._tokenTypeStrToInt.get(ne);let yt=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);yt|=1<<Tt>>>0}this._pushEncoded(Ge,Je,at,dt,yt)}_pushEncoded($,ne,Se,Ge,Je){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,Tt=0;for(let Lt=0;Lt<yt;Lt++){let Nt=this._data[5*Lt],un=this._data[5*Lt+1];Nt===0?(Nt=kt,un+=Tt):Nt+=kt,this._data[5*Lt]=Nt,this._data[5*Lt+1]=un,kt=Nt,Tt=un}}let at=$,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Je,this._prevLine=$,this._prevChar=ne}static _sortAndDeltaEncode($){let ne=[];const Se=$.length/5|0;for(let dt=0;dt<Se;dt++)ne[dt]=dt;ne.sort((dt,yt)=>{const kt=$[5*dt],Tt=$[5*yt];if(kt===Tt){const Lt=$[5*dt+1],Nt=$[5*yt+1];return Lt-Nt}return kt-Tt});const Ge=new Uint32Array($.length);let Je=0,at=0;for(let dt=0;dt<Se;dt++){const yt=5*ne[dt],kt=$[yt+0],Tt=$[yt+1],Lt=$[yt+2],Nt=$[yt+3],un=$[yt+4],On=kt-Je,zn=On===0?Tt-at:Tt,dn=5*dt;Ge[dn+0]=On,Ge[dn+1]=zn,Ge[dn+2]=Lt,Ge[dn+3]=Nt,Ge[dn+4]=un,Je=kt,at=Tt}return Ge}build($){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),$):new Ht(nn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=nn;class Ht{constructor($,ne){this.resultId=ne,this.data=$}}e.SemanticTokens=Ht;class rn{constructor($,ne,Se){this.start=$,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=rn;class _n{constructor($,ne){this.resultId=ne,this.edits=$}}e.SemanticTokensEdits=_n;var Sn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new lt("arrow-left")},Kt=Ve([a],Kt),e.QuickInputButtons=Kt;var yn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Dn{constructor($,ne,Se){this.badge=$,this.tooltip=ne,this.color=Se}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Dn;let sn=class{constructor($){this.kind=$}};sn=Ve([a],sn),e.ColorTheme=sn;var on;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(on=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor($,ne){if($<0)throw R.illegalArgument("start must be positive");if(ne<0)throw R.illegalArgument("end must be positive");$<=ne?(this._start=$,this._end=ne):(this._start=ne,this._end=$)}static isNotebookRange($){return $ instanceof $t?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let ne=this._start,Se=this._end;return $.start!==void 0&&(ne=$.start),$.end!==void 0&&(Se=$.end),ne===this._start&&Se===this._end?this:new $t(ne,Se)}}e.NotebookRange=$t;class Gt{constructor($,ne){typeof $=="object"?Object.assign(this,$):(this.inputCollapsed=$,this.outputCollapsed=ne)}with($){let{inputCollapsed:ne,outputCollapsed:Se}=$,Ge=Qt($,["inputCollapsed","outputCollapsed"]);return ne===void 0?ne=this.inputCollapsed:ne===null&&(ne=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),ne===this.inputCollapsed&&Se===this.outputCollapsed&&Object.keys(Ge).length===0?this:new Gt(Object.assign({inputCollapsed:ne,outputCollapsed:Se},Ge))}}e.NotebookCellMetadata=Gt;class Wt{constructor($={}){Object.assign(this,$)}with($){return new Wt($)}}e.NotebookDocumentMetadata=Wt;class Fe{constructor($,ne,Se,Ge,Je,at){this.kind=$,this.value=ne,this.languageId=Se,this.outputs=Ge??[],this.metadata=Je,this.executionSummary=at,Fe.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(ne=>Fe.isNotebookCellData(ne))}static isNotebookCellData($){return!0}}e.NotebookCellData=Fe;class an{constructor($,ne){this.cells=$,this.metadata=ne??new Wt}}e.NotebookData=an;class It{constructor($,ne,Se){this.data=$,this.mime=ne,this.metadata=Se;const Ge=y.normalizeMimeType(ne,!0);if(!Ge)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=Ge}static isNotebookCellOutputItem($){return $ instanceof It?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($,ne){const Se={name:$.name,message:$.message,stack:$.stack};return It.json(Se,"application/vnd.code.notebook.error",ne)}static stdout($,ne){return It.text($,"application/vnd.code.notebook.stdout",ne)}static stderr($,ne){return It.text($,"application/vnd.code.notebook.stderr",ne)}static bytes($,ne="application/octet-stream",Se){return new It($,ne,Se)}static text($,ne="text/plain",Se){const Ge=Be(It,h,"f",_).encode(String($));return new It(Ge,ne,Se)}static json($,ne="application/json",Se){const Ge=JSON.stringify($,void 0,"	");return It.text(Ge,ne,Se)}}e.NotebookCellOutputItem=It,h=It,_={value:new TextEncoder};class gt{constructor($,ne,Se){this.items=gt.ensureUniqueMimeTypes($,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=I.generateUuid(),this.metadata=ne??Se)}static isNotebookCellOutput($){return $ instanceof gt?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&k.isArray($.items)}static ensureUniqueMimeTypes($,ne=!1){const Se=new Set,Ge=new Set;for(let Je=0;Je<$.length;Je++){const at=$[Je],dt=y.normalizeMimeType(at.mime);if(!Se.has(dt)){Se.add(dt);continue}Ge.add(Je),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?$:$.filter((Je,at)=>!Ge.has(at))}get outputs(){return this.items}set outputs($){this.items=$}}e.NotebookCellOutput=gt;var Cn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Cn=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var pn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ln{constructor($,ne,Se,Ge,Je,at){this.text=$,this.alignment=ne,this.command=Se,this.tooltip=Ge,this.priority=Je,this.accessibilityInformation=at}}e.NotebookCellStatusBarItem=ln;var In;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(In=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor($,ne=[]){this.uri=$,this.provides=w.asArray(ne)}}e.NotebookRendererScript=Pn;let cn=class{constructor($,ne){this.label=$,this.timestamp=ne}};cn=Ve([a],cn),e.TimelineItem=cn;var vn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var An;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(An=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Tn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(Tn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor($,ne){this.ranges=$,this.wordPattern=ne}}e.LinkedEditingRanges=Rn;class Ln{constructor($,ne){this._port=$,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var te;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(te=e.TestMessageSeverity||(e.TestMessageSeverity={}));var me;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(me=e.TestItemStatus||(e.TestItemStatus={}));const Ae=(z,$,ne,Se)=>{let Ge=ne;return{enumerable:!0,configurable:!1,get(){return Ge},set(Je){Se(Ge,Je)||(Ge=Je,z.bus.fire([3,$,Je]))}}},st=(z,$)=>z===$,wt=(z,$)=>z===$?!0:!z||!$?!1:z.isEqual($);class _t{constructor($,ne,Se,Ge){this.label=ne,this.data=Ge;const Je=c.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Je.parent},children:{value:new A.ReadonlyMapView(Je.children),enumerable:!0,writable:!1},range:Ae(Je,"range",void 0,wt),description:Ae(Je,"description",void 0,st),runnable:Ae(Je,"runnable",!0,st),debuggable:Ae(Je,"debuggable",!1,st),status:Ae(Je,"status",me.Resolved,st),error:Ae(Je,"error",void 0,st)})}invalidate(){c.getPrivateApiFor(this).bus.fire([2])}dispose(){const $=c.getPrivateApiFor(this);$.parent&&c.getPrivateApiFor($.parent).children.delete(this.id),$.bus.fire([1])}addChild($){if(!($ instanceof _t))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=c.getPrivateApiFor(this);if(ne.children.has($.id))throw new Error(`Attempted to insert a duplicate test item ID ${$.id}`);ne.children.set($.id,$),ne.bus.fire([0,$])}}e.TestItemImpl=_t;class Mn{constructor($){this.message=$,this.severity=te.Error}static diff($,ne,Se){const Ge=new Mn($);return Ge.expectedOutput=ne,Ge.actualOutput=Se,Ge}}e.TestMessage=Mn;var $n;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})($n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Wn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Hn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(Hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[120],pe([0,1,51,10,8,146,107,7,17]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function s(l,h){h?I.set(l,h):I.delete(l)}e.setWordDefinitionFor=s;function P(l){return I.get(l)}e.getWordDefinitionFor=P;class c extends A.MirrorTextModel{constructor(h,_,v,S,d,f,u,t){super(_,v,S,d);this._proxy=h,this._languageId=f,this._isDirty=u,this._notebook=t,this._isDisposed=!1}dispose(){w.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return D.equals(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===R.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(_){return _?h._getTextInRange(_):h.getText()},get eol(){return h._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(_){return h._lineAt(_)},offsetAt(_){return h._offsetAt(_)},positionAt(_){return h._positionAt(_)},validateRange(_){return h._validateRange(_)},validatePosition(_){return h._validatePosition(_)},getWordRangeAtPosition(_,v){return h._getWordRangeAtPosition(_,v)}}}return Object.freeze(this._document)}_acceptLanguageId(h){w.ok(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){w.ok(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const _=this._validateRange(h);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const v=this._eol,S=_.start.line,d=_.end.line,f=[];f.push(this._lines[S].substring(_.start.character));for(let u=S+1;u<d;u++)f.push(this._lines[u]);return f.push(this._lines[d].substring(0,_.end.character)),f.join(v)}_lineAt(h){let _;if(h instanceof k.Position?_=h.line:typeof h=="number"&&(_=h),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new p(_,this._lines[_],_===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(h),v=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,v))}_validateRange(h){if(!(h instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(h.start),v=this._validatePosition(h.end);return _===h.start&&v===h.end?h:new k.Range(_.line,_.character,v.line,v.character)}_validatePosition(h){if(!(h instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:_,character:v}=h,S=!1;if(_<0)_=0,v=0,S=!0;else if(_>=this._lines.length)_=this._lines.length-1,v=this._lines[_].length,S=!0;else{const d=this._lines[_].length;v<0?(v=0,S=!0):v>d&&(v=d,S=!0)}return S?new k.Position(_,v):h}_getWordRangeAtPosition(h,_){const v=this._validatePosition(h);if(!_)_=P(this._languageId);else if(C.regExpLeadsToEndlessLoop(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const S=y.getWordAtText(v.character+1,y.ensureValidWordDefinition(_),this._lines[v.line],0);if(S)return new k.Range(v.line,S.startColumn-1,v.line,S.endColumn-1)}}e.ExtHostDocumentData=c;class p{constructor(h,_,v){this._line=h,this._text=_,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(ge[198],pe([0,1,7,3,109,6,78,22,2,32]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class s{constructor(c,p,l,h){this._notebook=l,this._selector=h,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:I.generateUuid()}),this._init(),this._disposables.add(p.onDidChangeDocument(v=>{const S=this._cellUris.get(v.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(v=>_(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const c=[],p=[];for(const l of this._notebook.getCells())l.kind===w.NotebookCellKind.Code&&(!this._selector||y.score(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),c.push(l.document.getText().length+1),p.push(l.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(c){var p,l;if(!c){let d="";for(const f of this._cells)d+=f.document.getText()+`
`;return d=d.slice(0,-1),d}if(c.isEmpty)return"";const h=this.locationAt(c.start),_=this.locationAt(c.end),v=this._cells[(p=this._cellUris.get(h.uri))!==null&&p!==void 0?p:-1],S=this._cells[(l=this._cellUris.get(_.uri))!==null&&l!==void 0?l:-1];if(!v||!S)return"";if(v===S)return v.document.getText(new w.Range(h.range.start,_.range.end));{const d=v.document.getText(new w.Range(h.range.start,new w.Position(v.document.lineCount,0))),f=S.document.getText(new w.Range(new w.Position(0,0),_.range.end));return d+`
`+f}}offsetAt(c){const p=this._cellLines.getIndexOf(c.line),l=this._cellLengths.getAccumulatedValue(p.index-1),h=this._cells[p.index].document.offsetAt(c.with(p.remainder));return l+h}positionAt(c){if(typeof c=="number"){const l=this._cellLengths.getIndexOf(c),h=this._cellLines.getAccumulatedValue(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(h)}const p=this._cellUris.get(c.uri);if(p!==void 0){const l=this._cellLines.getAccumulatedValue(p-1);return new w.Position(l+c.range.start.line,c.range.start.character)}return new w.Position(0,0)}locationAt(c){w.Range.isRange(c)||(c=new w.Range(c,c));const p=this._cellLines.getIndexOf(c.start.line);let l=p;c.isEmpty||(l=this._cellLines.getIndexOf(c.end.line));const h=new w.Position(p.remainder,c.start.character),_=new w.Position(l.remainder,c.end.character),v=new w.Range(h,_),S=this._cells[p.index];return new w.Location(S.document.uri,S.document.validateRange(v))}contains(c){return this._cellUris.has(c)}validateRange(c){const p=this.validatePosition(c.start),l=this.validatePosition(c.end);return c.with(p,l)}validatePosition(c){const p=this._cellLines.getIndexOf(c.line),l=new w.Position(p.remainder,c.character),h=this._cells[p.index].document.validatePosition(l),_=this._cellLines.getAccumulatedValue(p.index-1);return new w.Position(_+h.line,h.character)}}e.ExtHostNotebookConcatDocument=s}),define(ge[199],pe([0,1,7,15,3]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?w.ColorThemeKind.Light:k==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ve([He(0,R.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ge[63],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=w.createDecorator("IURITransformerService");class R{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=R}),define(ge[200],pe([0,1,23]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let I=this.buffers.indexOf(D);return I<0&&(I=this.buffers.length,this.buffers.push(D)),I}}function C(k,D){if(D.serializeBuffersForPostMessage){const I=new R,s=(p,l)=>{if(l instanceof ArrayBuffer){const h=I.add(l);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(l)){const h=A(l);if(h){const _=I.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:h,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},P=JSON.stringify(k,s),c=I.buffers.map(p=>{const l=new Uint8Array(p);return w.VSBuffer.wrap(l)});return{message:P,buffers:c}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=C;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(k,D){const I=D.map(c=>{const p=new ArrayBuffer(c.byteLength);return new Uint8Array(p).set(c.buffer),p}),s=D.length?(c,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const l=p,{index:h}=l,_=I[h];if(l.view)switch(l.view.type){case 1:return new Int8Array(_,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return p}:void 0;return{message:JSON.parse(k,s),arrayBuffers:I}}e.deserializeWebviewMessage=y}),define(ge[87],pe([0,1,10,2]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(A,y){return A.scheme===w.Schemas.http||A.scheme===w.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===w.Schemas.file&&(A=R.URI.from({scheme:w.Schemas.vscodeRemote,authority:y.authority,path:A.path})),R.URI.from({scheme:w.Schemas.https,authority:`${A.scheme}+${A.authority}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=C}),define(ge[201],pe([0,1,3,6,87]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,D,I){this._proxy=k,this._editors=D,this._initData=I,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const s=D.getVisibleTextEditors();for(const P of this._insets.values())s.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,I,s,P){let c;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===k){c=d;break}if(!c)throw new Error("not a visible editor");const p=this,l=this._handlePool++,h=new w.Emitter,_=new w.Emitter,v=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return C.asWebviewUri(d,p._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(d){this._options=d,p._proxy.$setOptions(l,d)}get options(){return this._options}set html(d){this._html=d,p._proxy.$setHtml(l,d)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(d){return p._proxy.$postMessage(l,d)}},S=new class{constructor(){this.editor=k,this.line=D,this.height=I,this.webview=v,this.onDidDispose=_.event}dispose(){p._insets.has(l)&&(p._insets.delete(l),p._proxy.$disposeEditorInset(l),_.fire(),_.dispose(),h.dispose())}};return this._proxy.$createEditorInset(l,c.id,c.value.document.uri,D+1,I,s||{},P.identifier,P.extensionLocation),this._insets.set(l,{editor:k,inset:S,onDidReceiveMessage:h}),S}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const I=this._insets.get(k);I&&I.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=A}),define(ge[202],pe([0,1,3,81,169,4,6,22,38,17,52,25,45,195]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=p.registerIcon("default-view-icon",c.Codicon.window,C.localize(0,null));var l;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var h;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function v(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=v;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return I.flatten([...this.viewContainers.values()])}registerViewContainer(m,g,E){var b;const a=this.get(m.id);if(a)return a;const L=m;return L.openCommandActionDescriptor=(E==null?void 0:E.donotRegisterOpenCommand)?void 0:(b=L.openCommandActionDescriptor)!==null&&b!==void 0?b:{id:L.id},k.getOrSet(this.viewContainers,g,[]).push(L),(E==null?void 0:E.isDefault)&&this.defaultViewContainers.push(L),this._onDidRegister.fire({viewContainer:L,viewContainerLocation:g}),L}deregisterViewContainer(m){for(const g of this.viewContainers.keys()){const E=this.viewContainers.get(g),b=E==null?void 0:E.indexOf(m);if(b!==-1){E==null||E.splice(b,1),E.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:m,viewContainerLocation:g});return}}}get(m){return this.all.filter(g=>g.id===m)[0]}getViewContainers(m){return[...this.viewContainers.get(m)||[]]}getViewContainerLocation(m){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(E=>(E==null?void 0:E.id)===m.id).length>0)[0]}getDefaultViewContainer(m){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===m)}}D.Registry.add(l.ViewContainersRegistry,new S);var d;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function f(o,m){var g,E,b,a;const L=(g=o.group)!==null&&g!==void 0?g:d.More,O=(E=m.group)!==null&&E!==void 0?E:d.More;return L!==O?L.localeCompare(O):((b=o.order)!==null&&b!==void 0?b:5)-((a=m.order)!==null&&a!==void 0?a:5)}class u extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new s.SetMap}registerViews(m,g){this.registerViews2([{views:m,viewContainer:g}])}registerViews2(m){m.forEach(({views:g,viewContainer:E})=>this.addViews(g,E)),this._onViewsRegistered.fire(m)}deregisterViews(m,g){const E=this.removeViews(m,g);E.length&&this._onViewsDeregistered.fire({views:E,viewContainer:g})}moveViews(m,g){for(const E of this._views.keys())if(E!==g){const b=this.removeViews(m,E);b.length&&(this.addViews(b,g),this._onDidChangeContainer.fire({views:b,from:E,to:g}))}}getViews(m){return this._views.get(m)||[]}getView(m){for(const g of this._viewContainers){const E=(this._views.get(g)||[]).filter(b=>b.id===m)[0];if(E)return E}return null}getViewContainer(m){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(b=>b.id===m)[0])return g;return null}registerViewWelcomeContent(m,g){return this._viewWelcomeContents.add(m,g),this._onDidChangeViewWelcomeContent.fire(m),y.toDisposable(()=>{this._viewWelcomeContents.delete(m,g),this._onDidChangeViewWelcomeContent.fire(m)})}registerViewWelcomeContent2(m,g){const E=new Map;for(const[b,a]of g)this._viewWelcomeContents.add(m,a),E.set(b,y.toDisposable(()=>{this._viewWelcomeContents.delete(m,a),this._onDidChangeViewWelcomeContent.fire(m)}));return this._onDidChangeViewWelcomeContent.fire(m),E}getViewWelcomeContent(m){const g=[];return this._viewWelcomeContents.forEach(m,E=>g.push(E)),g.sort(f)}addViews(m,g){let E=this._views.get(g);E||(E=[],this._views.set(g,E),this._viewContainers.push(g));for(const b of m){if(this.getView(b.id)!==null)throw new Error(C.localize(1,null,b.id));E.push(b)}}removeViews(m,g){const E=this._views.get(g);if(!E)return[];const b=[],a=[];for(const L of E)m.includes(L)?b.push(L):a.push(L);return b.length&&(a.length?this._views.set(g,a):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),b}}D.Registry.add(l.ViewsRegistry,new u),e.IViewsService=A.createDecorator("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",C.localize(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=A.createDecorator("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(m,g){this.resolved=!1,this._hasResolve=!1,P.mixin(this,m),this._hasResolve=!!g,this.resolve=async E=>{var b,a;if(g&&!this.resolved){const L=await g(E);L&&(this.tooltip=(b=this.tooltip)!==null&&b!==void 0?b:L.tooltip,this.command=(a=this.command)!==null&&a!==void 0?a:L.command)}E.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[203],pe([0,1,2,180,118,14,181,202]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(l){return(h,..._)=>l(h.get(R.ICommandService),..._)}class I{static execute(h,_){const v={forceReuseWindow:_&&_.reuseWindow,remoteAuthority:_&&_.remoteAuthority};return h.executeCommand("_files.newWindow",v)}}e.NewWindowAPICommand=I,I.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:I.ID,handler:D(I.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(l,h){return l.get(C.IWorkspacesService).removeRecentlyOpened([h])});class s{static execute(h,_){return typeof _=="string"?_=_.match(/^[^:/?#]+:\/\//)?w.URI.parse(_):w.URI.file(_):_=w.URI.revive(_),h.executeCommand("_workbench.removeFromRecentlyOpened",_)}}e.RemoveFromRecentlyOpenedAPICommand=s,s.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(s.ID,D(s.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(l,h){const _=l.get(C.IWorkspacesService);let v;const S=h.uri,d=h.label,f=h.remoteAuthority;return h.type==="workspace"?v={workspace:await _.getWorkspaceIdentifier(S),label:d,remoteAuthority:f}:h.type==="folder"?v={folderUri:S,label:d,remoteAuthority:f}:v={fileUri:S,label:d,remoteAuthority:f},_.addRecentlyOpened([v])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(l){return l.get(C.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(l,h){const _=l.get(A.ILogService),v=l.get(y.IEnvironmentService);v.isExtensionDevelopment&&!!v.extensionTestsLocationURI&&_.setLevel(h)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(l){return l.get(A.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(l,h){const _=l.get(k.IViewDescriptorService),v=_.getViewContainerById(h.destinationId);if(!!v){for(const S of h.viewIds){const d=_.getViewDescriptorById(S);(d==null?void 0:d.canMoveView)&&_.moveViewsToContainer([d],v,k.ViewVisibilityState.Default)}await l.get(k.IViewsService).openViewContainer(v.id,!0)}});class P{static execute(h,_){return!Array.isArray(_==null?void 0:_.viewIds)||typeof(_==null?void 0:_.destinationId)!="string"?Promise.reject("Invalid arguments"):h.executeCommand("_workbench.action.moveViews",_)}}e.MoveViewsAPICommand=P,P.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:P.ID,handler:D(P.execute),description:{description:"Move Views",args:[]}});class c{static execute(h,_){return h.executeCommand("_workbench.open",_)}}c.ID="vscode.open",R.CommandsRegistry.registerCommand(c.ID,D(c.execute));class p{static execute(h,_,v,S,d){return h.executeCommand("_workbench.diff",[_,v,S])}}p.ID="vscode.diff",R.CommandsRegistry.registerCommand(p.ID,D(p.execute))}),define(ge[121],pe([0,1,3,13,170]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,I,s){const P={command:k};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof s=="number"){const c=setTimeout(()=>{clearTimeout(c);const p=this.pendingRequests.get(P.seq);if(p){this.pendingRequests.delete(P.seq);const l={type:"response",seq:0,request_seq:P.seq,success:!1,command:k,message:C.localize(0,null,s,k)};p(l)}},s)}return I&&this.pendingRequests.set(P.seq,I),P.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await R.timeout(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,I=this.pendingRequests.get(D.request_seq);I&&(this.pendingRequests.delete(D.request_seq),I(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,I)=>k.set(I,D)),await R.timeout(500),k.forEach((D,I)=>{D({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ge[204],pe([0,1,8,2,9,25,10]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(n,i,r){return n.replace(k,function(o,m){return i&&m.length>0&&m[0]!=="_"?o:r&&r.hasOwnProperty(m)?r[m]:o})}e.formatPII=D;function I(n){const i={};for(const r of Object.keys(n))r.startsWith("!")||(i[r]=n[r]);return i}e.filterExceptionsFromTelemetry=I;function s(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=s;function P(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),w.equalsIgnoreCase(i,"extensionhost")||w.equalsIgnoreCase(i,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function p(n,i,r){let o,m=0,g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=g.exec(n);){let b=E.index+1,a=b+E[0].length;if(b<=i&&a>=r){o=E[0],m=b;break}}if(o){let b=/\w+/g,a=null;for(;(a=b.exec(o))&&!(a.index+1+m+a[0].length>=r););a&&(o=o.substring(0,b.lastIndex))}return o?{start:m,end:m+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(l))}e.isUri=h;function _(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return R.URI.parse(n.path);if(C.isAbsolute(n.path))return R.URI.file(n.path)}return n.path}function v(n){if(typeof n.path=="object"){const i=R.URI.revive(n.path);if(i)return i.scheme===y.Schemas.file?i.fsPath:i.toString()}return n.path}function S(n,i){const r=i?_:v,o=A.deepClone(n);return f(o,(m,g)=>{m&&g&&(g.path=r(g))}),o}e.convertToDAPaths=S;function d(n,i){const r=i?_:v,o=A.deepClone(n);return f(o,(m,g)=>{!m&&g&&(g.path=r(g))}),o}e.convertToVSCPaths=d;function f(n,i){switch(n.type){case"event":const r=n;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":i(!0,o.arguments.source);break;case"breakpointLocations":i(!0,o.arguments.source);break;case"source":i(!0,o.arguments.source);break;case"gotoTargets":i(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(g=>i(!1,g));break;default:break}break;case"response":const m=n;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(g=>i(!1,g.source));break;case"loadedSources":m.body.sources.forEach(g=>i(!1,g));break;case"scopes":m.body.scopes.forEach(g=>i(!1,g.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(g=>i(!1,g.source));break;case"setBreakpoints":m.body.breakpoints.forEach(g=>i(!1,g.source));break;default:break}break}}function u(n){return n.filter(i=>{var r;return!((r=i.presentation)===null||r===void 0?void 0:r.hidden)}).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):t(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=u;function t(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}}),define(ge[205],pe([0,1,28,37,171,122,9,8,25,11,182,121]),function(Q,e,w,R,C,A,y,k,D,I,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",f=>this.handleData(f))}sendMessage(S){if(this.outputStream){const d=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${c.TWO_CRLF}${d}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+d))}continue}}else{const d=this.rawData.indexOf(c.TWO_CRLF);if(d!==-1){const u=this.rawData.toString("utf8",0,d).split(c.HEADER_LINESEPARATOR);for(const t of u){const n=t.split(c.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(d+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class p extends c{startSession(){return new Promise((S,d)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",u=>{f?this._onError.fire(u):d(u)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class l extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=l;class h extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=h;class _ extends c{constructor(S,d,f){super();this.adapterExecutable=S,this.debugType=d,this.outputService=f}async startSession(){const S=this.adapterExecutable.command,d=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await w.exists(S))throw new Error(C.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let u=process.env;if(f.env&&Object.keys(f.env).length>0&&(u=D.mixin(D.deepClone(process.env),f.env)),S==="node")if(Array.isArray(d)&&d.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:u,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(i.cwd=f.cwd);const r=R.fork(d[0],d.slice(1),i);if(!r.pid)throw new Error(C.localize(2,null,d[0]));this.serverProcess=r}else throw new Error(C.localize(3,null));else{const n={env:u};f.cwd&&(n.cwd=f.cwd),this.serverProcess=R.spawn(S,d,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,i)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=i=>i.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",i=>{const r=t.getChannel(s.ExtensionsChannelId);r&&r.append(n(i))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(u){this._onError.fire(u)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((S,d)=>{const f=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(u,t,n){if(u)return d(u)});f.on("exit",S),f.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,d){if(!S)return;const f=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?f.runtime=y.join(d,S.runtime):f.runtime=S.runtime),S.runtimeArgs&&(f.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?f.program=S.program:f.program=y.join(d,S.program)),S.args&&(f.args=S.args);const u=S;return u.win&&(f.win=_.extract(u.win,d)),u.winx86&&(f.winx86=_.extract(u.winx86,d)),u.windows&&(f.windows=_.extract(u.windows,d)),u.osx&&(f.osx=_.extract(u.osx,d)),u.linux&&(f.linux=_.extract(u.linux,d)),f}static platformAdapterExecutable(S,d){let f=Object.create(null);d=d.toLowerCase();for(const o of S)if(o.contributes){const m=o.contributes.debuggers;m&&m.length>0&&m.filter(g=>typeof g.type=="string"&&k.equalsIgnoreCase(g.type,d)).forEach(g=>{const E=_.extract(g,o.extensionLocation.fsPath);f=D.mixin(f,E,o.isBuiltin)})}let u;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=f.winx86||f.win||f.windows:I.isWindows?u=f.win||f.windows:I.isMacintosh?u=f.osx:I.isLinux&&(u=f.linux),u=u||f;let t=u.program||f.program;const n=u.args||f.args;let i=u.runtime||f.runtime;const r=u.runtimeArgs||f.runtimeArgs;if(i)return{type:"executable",command:i,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=_}),define(ge[206],pe([0,1,37,11,29,190]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(c,p){return new Promise((l,h)=>{let _="";const v=w.spawn(c,p);v.pid&&v.stdout.on("data",S=>{_+=S.toString()}),v.on("error",S=>{h(S)}),v.on("close",S=>{l(_)})})}let k;function D(c,p){if(!k)if(R.isWindows)k=new A.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)k=new A.MacExternalTerminalService(void 0);else if(R.isLinux)k=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const l=p.getConfiguration("terminal");return k.runInTerminal(c.title,c.cwd,c.args,c.env||{},l.external||{})}e.runInExternalTerminal=D;function I(c){return c?R.isWindows?new Promise(async p=>{(await new Promise((h,_)=>{Q(["windows-process-tree"],h,_)})).getProcessTree(c,h=>{p(h.children.length>0)})}):y("/usr/bin/pgrep",["-lP",String(c)]).then(p=>{const l=p.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},p=>!0):Promise.resolve(!0)}e.hasChildProcesses=I;var s;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(s||(s={}));function P(c,p,l,h){c=c.trim().toLowerCase();let _;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?_=1:c.indexOf("cmd.exe")>=0?_=0:c.indexOf("bash")>=0?_=2:R.isWindows?_=0:_=2;let v,S=" ";switch(_){case 1:if(v=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),l){const f=C.getDriveLetter(l);f&&(S+=`${f}:; `),S+=`cd ${v(l)}; `}if(h)for(let f in h){const u=h[f];u===null?S+=`Remove-Item env:${f}; `:S+=`\${env:${f}}='${u}'; `}if(p.length>0){const f=v(p.shift());S+=f[0]==="'"?`& ${f} `:`${f} `;for(let u of p)S+=`${v(u)} `}break;case 0:if(v=f=>(f=f.replace(/\"/g,'""'),f.indexOf(" ")>=0||f.indexOf('"')>=0||f.length===0?`"${f}"`:f),l){const f=C.getDriveLetter(l);f&&(S+=`${f}: && `),S+=`cd ${v(l)} && `}if(h){S+='cmd /C "';for(let f in h){let u=h[f];u===null?S+=`set "${f}=" && `:(u=u.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${f}=${u}" && `)}}for(let f of p)S+=`${v(f)} `;h&&(S+='"');break;case 2:v=f=>(f=f.replace(/(["'\\\$])/g,"\\$1"),f.indexOf(" ")>=0||f.indexOf(";")>=0||f.length===0?`"${f}"`:f);const d=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(l&&(S+=`cd ${v(l)} ; `),h){S+="/usr/bin/env";for(let f in h){const u=h[f];u===null?S+=` -u ${d(f)}`:S+=` ${d(`${f}=${u}`)}`}S+=" "}for(let f of p)S+=`${v(f)} `;break}return S}e.prepareCommand=P}),define(ge[64],pe([0,1,30,10,9,11,81]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarAfterExecuteKey=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var I;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var s;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(s=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.CellClearOutput=3]="CellClearOutput",b[b.CellsClearOutput=4]="CellsClearOutput",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.Unknown=100]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));function l(b,a){if(a)return b.toString();const L=h.parse(b);return L?L.notebook.toString():b.toString()}e.getCellUndoRedoComparisonKey=l;var h;(function(b){b.scheme=R.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function L(V,B){return V.with({scheme:b.scheme,fragment:`ch${B.toString().padStart(7,"0")}${V.scheme!==R.Schemas.file?V.scheme:""}`})}b.generate=L;function O(V){if(V.scheme!==b.scheme)return;const B=a.exec(V.fragment);return B?{handle:Number(B[1]),notebook:V.with({scheme:V.fragment.substr(B[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parse=O;function W(V){if(V.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const B=a.exec(V.fragment);return B?{handle:Number(B[1]),notebook:V.with({scheme:V.fragment.substr(B[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellMetadataUri=W;function ee(V,B,j){return V.with({scheme:j,fragment:`ch${B.toString().padStart(7,"0")}${V.scheme!==R.Schemas.file?V.scheme:""}`})}b.generateCellUri=ee;function oe(V,B){if(V.scheme!==B)return;const j=a.exec(V.fragment);return j?{handle:Number(j[1]),notebook:V.with({scheme:V.fragment.substr(j[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellUri=oe})(h=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(b){var a,L;return(L=(a=_.get(b))===null||a===void 0?void 0:a.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=v;function S(b){var a,L;return(L=(a=_.get(b))===null||a===void 0?void 0:a.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=S;function d(b){var a,L;return(L=(a=_.get(b))===null||a===void 0?void 0:a.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=d;function f(b,a){return A.isWindows&&(b=b.replace(/\//g,"\\"),a=a.replace(/\//g,"\\")),w.match(b,a)}function u(b,a,L){let O=0;for(let W=0;W<a.length;W++){if(f(a[W],b))return O;O++}for(let W=0;W<L.length;W++){if(f(L[W],b))return O;O++}return O}function t(b,a,L){return b.sort((O,W)=>u(O,a,L)-u(W,a,L))}e.sortMimeTypes=t;function n(b,a,L,O=(W,ee)=>W===ee){const W=[];function ee(B,j,T){if(j===0&&T.length===0)return;const N=W[W.length-1];N&&N.start+N.deleteCount===B?(N.deleteCount+=j,N.toInsert.push(...T)):W.push({start:B,deleteCount:j,toInsert:T})}let oe=0,V=0;for(;;){if(oe===b.length){ee(oe,0,a.slice(V));break}if(V===a.length){ee(oe,b.length-oe,[]);break}const B=b[oe],j=a[V];if(O(B,j)){oe+=1,V+=1;continue}L(j)?(ee(oe,1,[]),oe+=1):(ee(oe,0,[j]),V+=1)}return W}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(b){b.default="default",b.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(b){const a=b;return!!((typeof a.include=="string"||w.isRelativePattern(a.include))&&(typeof a.exclude=="string"||w.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=r;function o(b,a,L){if(Array.isArray(b.viewType)&&b.viewType.indexOf(a)>=0||b.viewType===a)return!0;if(b.filenamePattern){let O=r(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,W=r(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(w.match(O,C.basename(L.fsPath).toLowerCase()))return!(W&&w.match(W,C.basename(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class m{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)a[L]=this.textModel.cells[L].getHashValue();return a}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.ShowCellStatusBarAfterExecuteKey="notebook.showCellStatusBarAfterExecute",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton";var g;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(g=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(a){return`${E._prefix}${a}`}static parse(a){if(a.startsWith(E._prefix))return a.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(ge[207],pe([0,1,173,4,81]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[208],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=w;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(ge[123],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,I)=>{I.expand!==void 0&&(D.expand=I.expand),I.item!==void 0&&(D.item=D.item?Object.assign(D.item,I.item):I.item)};e.applyTestItemUpdate=R;var C;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,I)=>`${D}:${I.toString()}`;e.getTestSubscriptionKey=A;class y{add(I){}update(I){}remove(I,s){}complete(){}}e.IncrementalChangeCollector=y;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(I){const s=this.createChangeCollector();for(const P of I)switch(P[0]){case 0:{const c=P[1];if(c.parent){if(this.items.has(c.parent)){const p=this.items.get(c.parent);p.children.add(c.item.extId);const l=this.createItem(c,p);this.items.set(c.item.extId,l),s.add(l)}}else{this.roots.add(c.item.extId);const p=this.createItem(c);this.items.set(c.item.extId,p),s.add(p)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=P[1],p=this.items.get(c.extId);if(!p)break;c.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(p,c),s.update(p);break}case 2:{const c=this.items.get(P[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c.item.extId);const p=[[P[1]]];for(;p.length;)for(const l of p.pop()){const h=this.items.get(l);h&&(p.push(h.children),this.items.delete(l),s.remove(h,h!==c),h.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}s.complete()}retireTest(I){}updatePendingRoots(I){this.pendingRootCount+=I}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=k}),define(ge[209],pe([0,1,9,36,12,25,11,77,174]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(P,c,p){this._contributedVariables=new Map,this._context=P,this._labelService=c,p&&(this._envVariablesPromise=p.then(l=>this.prepareEnv(l)))}prepareEnv(P){if(y.isWindows){const c=Object.create(null);return Object.keys(P).forEach(p=>{c[p.toLowerCase()]=P[p]}),c}return P}resolveWithEnvironment(P,c,p){return this.recursiveResolve(this.prepareEnv(P),c?c.uri:void 0,p)}async resolveAsync(P,c){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c)}async resolveAnyBase(P,c,p,l){const h=A.deepClone(c);return y.isWindows&&h.windows?Object.keys(h.windows).forEach(_=>h[_]=h.windows[_]):y.isMacintosh&&h.osx?Object.keys(h.osx).forEach(_=>h[_]=h.osx[_]):y.isLinux&&h.linux&&Object.keys(h.linux).forEach(_=>h[_]=h.linux[_]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,h,p,l)}async resolveAnyAsync(P,c,p){return this.resolveAnyBase(P,c,p)}async resolveAnyMap(P,c,p){const l=new Map;return{newConfig:await this.resolveAnyBase(P,c,p,l),resolvedVariables:l}}resolveWithInteractionReplace(P,c,p,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,c,p,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,c){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,c)}recursiveResolve(P,c,p,l,h){if(C.isString(p))return this.resolveString(P,c,p,l,h);if(C.isArray(p))return p.map(_=>this.recursiveResolve(P,c,_,l,h));if(C.isObject(p)){let _=Object.create(null);return Object.keys(p).forEach(v=>{const S=this.resolveString(P,c,v,l,h);_[S]=this.recursiveResolve(P,c,p[v],l,h)}),_}return p}resolveString(P,c,p,l,h){return p.replace(I.VARIABLE_REGEXP,(v,S)=>{if(S.includes(I.VARIABLE_LHS))return v;let d=this.evaluateSingleVariable(P,v,S,c,l);return h&&h.set(S,d),d})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,c,p,l,h){let _;const v=p.split(":");v.length>1&&(p=v[0],_=v[1]);const S=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error(D.localize(0,null,c))},d=()=>{const u=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(D.localize(1,null,c,w.basename(u)))},f=()=>{if(_){const u=this._context.getFolderUri(_);if(u)return u;throw new Error(D.localize(2,null,c,_))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error(D.localize(3,null,c)):new Error(D.localize(4,null,c))};switch(p){case"env":if(_){if(P){const u=P[y.isWindows?_.toLowerCase():_];if(C.isString(u))return u}return""}throw new Error(D.localize(5,null,c));case"config":if(_){const u=this._context.getConfigurationValue(l,_);if(C.isUndefinedOrNull(u))throw new Error(D.localize(6,null,c,_));if(C.isObject(u))throw new Error(D.localize(7,null,c,_));return u}throw new Error(D.localize(8,null,c));case"command":return this.resolveFromMap(c,_,h,"command");case"input":return this.resolveFromMap(c,_,h,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return k.normalizeDriveLetter(this.fsPath(f()));case"cwd":return l||_?k.normalizeDriveLetter(this.fsPath(f())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(f()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error(D.localize(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(D.localize(10,null,c));case"file":return S();case"fileWorkspaceFolder":return d();case"relativeFile":return l||_?w.relative(this.fsPath(f()),S()):S();case"relativeFileDirname":const n=w.dirname(S());if(l||_){const m=w.relative(this.fsPath(f()),n);return m.length===0?".":m}return n;case"fileDirname":return w.dirname(S());case"fileExtname":return w.extname(S());case"fileBasename":return w.basename(S());case"fileBasenameNoExtension":const i=w.basename(S());return i.slice(0,i.length-w.extname(i).length);case"fileDirnameBasename":return w.basename(w.dirname(S()));case"execPath":const r=this._context.getExecPath();return r||c;case"execInstallFolder":const o=this._context.getAppRoot();return o||c;case"pathSeparator":return w.sep;default:try{const m=_?`${p}:${_}`:p;return this.resolveFromMap(c,m,h,void 0)}catch(m){return c}}}}resolveFromMap(P,c,p,l){if(c&&p){const h=l===void 0?p[c]:p[l+":"+c];if(typeof h=="string")return h;throw new Error(D.localize(11,null,P))}return P}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[210],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=w.createDecorator("editorGroupsService");var R;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.EDITOR_OPEN=2]="EDITOR_OPEN",c[c.EDITOR_CLOSE=3]="EDITOR_CLOSE",c[c.EDITOR_MOVE=4]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=6]="EDITOR_LABEL",c[c.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",c[c.EDITOR_PIN=8]="EDITOR_PIN",c[c.EDITOR_STICKY=9]="EDITOR_STICKY",c[c.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var s;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(s=e.OpenEditorContext||(e.OpenEditorContext={}));function P(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(ge[211],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=w.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,17,96,282,58,25,12,2,42,80,175,113,64,211,7]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(_e){function fe(X){const{selectionStartLineNumber:Oe,selectionStartColumn:Le,positionLineNumber:Ze,positionColumn:et}=X,ft=new h.Position(Oe-1,Le-1),ct=new h.Position(Ze-1,et-1);return new h.Selection(ft,ct)}_e.to=fe;function de(X){const{anchor:Oe,active:Le}=X;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}_e.from=de})(_=e.Selection||(e.Selection={}));var v;(function(_e){function fe(X){if(!X)return;const{start:Oe,end:Le}=X;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}_e.from=fe;function de(X){if(!X)return;const{startLineNumber:Oe,startColumn:Le,endLineNumber:Ze,endColumn:et}=X;return new h.Range(Oe-1,Le-1,Ze-1,et-1)}_e.to=de})(v=e.Range||(e.Range={}));var S;(function(_e){function fe(de){switch(de){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}_e.to=fe})(S=e.TokenType||(e.TokenType={}));var d;(function(_e){function fe(X){return new h.Position(X.lineNumber-1,X.column-1)}_e.to=fe;function de(X){return{lineNumber:X.line+1,column:X.character+1}}_e.from=de})(d=e.Position||(e.Position={}));var f;(function(_e){function fe(X){switch(X){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}_e.from=fe;function de(X){switch(X){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}_e.to=de})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(_e){function fe(X){let Oe;return X.code&&(k.isString(X.code)||k.isNumber(X.code)?Oe=String(X.code):Oe={value:String(X.code.value),target:X.code.target}),Object.assign(Object.assign({},v.from(X.range)),{message:X.message,source:X.source,code:Oe,severity:n.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(t.from),tags:Array.isArray(X.tags)?w.coalesce(X.tags.map(f.from)):void 0})}_e.from=fe;function de(X){var Oe;const Le=new h.Diagnostic(v.to(X),X.message,n.to(X.severity));return Le.source=X.source,Le.code=k.isString(X.code)?X.code:(Oe=X.code)===null||Oe===void 0?void 0:Oe.value,Le.relatedInformation=X.relatedInformation&&X.relatedInformation.map(t.to),Le.tags=X.tags&&w.coalesce(X.tags.map(f.to)),Le}_e.to=de})(u=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function fe(X){return Object.assign(Object.assign({},v.from(X.location.range)),{message:X.message,resource:X.location.uri})}_e.from=fe;function de(X){return new h.DiagnosticRelatedInformation(new h.Location(X.resource,v.to(X)),X.message)}_e.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(_e){function fe(X){switch(X){case h.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}_e.from=fe;function de(X){switch(X){case c.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}_e.to=de})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var i;(function(_e){function fe(X){return typeof X=="number"&&X>=h.ViewColumn.One?X-1:X===h.ViewColumn.Beside?l.SIDE_GROUP:l.ACTIVE_GROUP}_e.from=fe;function de(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=de})(i=e.ViewColumn||(e.ViewColumn={}));function r(_e){return typeof _e.range!="undefined"}function o(_e){return _e.length===0?!0:!!r(_e[0])}e.isDecorationOptionsArr=o;var m;(function(_e){function fe(et){return et.map(_e.from)}_e.fromMany=fe;function de(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function X(et){let ft;if(de(et)){const{language:ht,value:lt}=et;ft={value:"```"+ht+`
`+lt+"\n```\n"}}else h.MarkdownString.isMarkdownString(et)?ft={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ft={value:et}:ft={value:""};const ct=Object.create(null);ft.uris=ct;const it=ht=>{try{let lt=D.URI.parse(ht,!0);lt=lt.with({query:Oe(lt.query,ct)}),ct[ht]=lt}catch(lt){}return""},vt=new C.Renderer;return vt.link=it,vt.image=ht=>it(R.parseHrefAndDimensions(ht).href),C(ft.value,{renderer:vt}),ft}_e.from=X;function Oe(et,ft){if(!et)return et;let ct;try{ct=A.parse(et)}catch(vt){}if(!ct)return et;let it=!1;return ct=y.cloneAndChange(ct,vt=>{if(D.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ht]=vt,it=!0,ht}else return}),it?JSON.stringify(ct):et}function Le(et){const ft=new h.MarkdownString(et.value,et.supportThemeIcons);return ft.isTrusted=et.isTrusted,ft}_e.to=Le;function Ze(et){if(!!et)return typeof et=="string"?et:_e.from(et)}_e.fromStrict=Ze})(m=e.MarkdownString||(e.MarkdownString={}));function g(_e){return o(_e)?_e.map(fe=>({range:v.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?m.fromMany(fe.hoverMessage):fe.hoverMessage?m.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):_e.map(fe=>({range:v.from(fe)}))}e.fromRangeOrRangeWithMessage=g;function E(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?D.URI.file(_e):_e}e.pathOrURIToURI=E;var b;(function(_e){function fe(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?E(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}_e.from=fe})(b=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(_e){function fe(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?b.from(de.before):void 0,after:de.after?b.from(de.after):void 0}}_e.from=fe})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(_e){function fe(de){if(typeof de=="undefined")return de;switch(de){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=fe})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(_e){function fe(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?L.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?a.from(de.light):void 0,dark:de.dark?a.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?b.from(de.before):void 0,after:de.after?b.from(de.after):void 0}}_e.from=fe})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(_e){function fe(X){return{text:X.newText,eol:X.newEol&&ie.from(X.newEol),range:v.from(X.range)}}_e.from=fe;function de(X){const Oe=new h.TextEdit(v.to(X.range),X.text);return Oe.newEol=typeof X.eol=="undefined"?void 0:ie.to(X.eol),Oe}_e.to=de})(W=e.TextEdit||(e.TextEdit={}));var ee;(function(_e){function fe(X,Oe,Le){var Ze,et,ft;const ct={edits:[]};if(X instanceof h.WorkspaceEdit)for(let it of X._allEntries())if(it._type===1)ct.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const vt=Oe==null?void 0:Oe.getDocument(it.uri);ct.edits.push({_type:2,resource:it.uri,edit:W.from(it.edit),modelVersionId:vt==null?void 0:vt.version,metadata:it.metadata})}else it._type===3?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ze=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version}):it._type===4?(it.newOutputs&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(Pe.from)}}),it.newMetadata&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(et=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(ue.from)}}):it._type===6&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((ft=it.newOutputItems)===null||ft===void 0?void 0:ft.map(Ie.from))||[],append:it.append}});return ct}_e.from=fe;function de(X){const Oe=new h.WorkspaceEdit;for(const Le of X.edits)Le.edit?Oe.replace(D.URI.revive(Le.resource),v.to(Le.edit.range),Le.edit.text):Oe.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Oe}_e.to=de})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(_e){const fe=Object.create(null);fe[h.SymbolKind.File]=0,fe[h.SymbolKind.Module]=1,fe[h.SymbolKind.Namespace]=2,fe[h.SymbolKind.Package]=3,fe[h.SymbolKind.Class]=4,fe[h.SymbolKind.Method]=5,fe[h.SymbolKind.Property]=6,fe[h.SymbolKind.Field]=7,fe[h.SymbolKind.Constructor]=8,fe[h.SymbolKind.Enum]=9,fe[h.SymbolKind.Interface]=10,fe[h.SymbolKind.Function]=11,fe[h.SymbolKind.Variable]=12,fe[h.SymbolKind.Constant]=13,fe[h.SymbolKind.String]=14,fe[h.SymbolKind.Number]=15,fe[h.SymbolKind.Boolean]=16,fe[h.SymbolKind.Array]=17,fe[h.SymbolKind.Object]=18,fe[h.SymbolKind.Key]=19,fe[h.SymbolKind.Null]=20,fe[h.SymbolKind.EnumMember]=21,fe[h.SymbolKind.Struct]=22,fe[h.SymbolKind.Event]=23,fe[h.SymbolKind.Operator]=24,fe[h.SymbolKind.TypeParameter]=25;function de(Oe){return typeof fe[Oe]=="number"?fe[Oe]:6}_e.from=de;function X(Oe){for(const Le in fe)if(fe[Le]===Oe)return Number(Le);return h.SymbolKind.Property}_e.to=X})(oe=e.SymbolKind||(e.SymbolKind={}));var V;(function(_e){function fe(X){switch(X){case h.SymbolTag.Deprecated:return 1}}_e.from=fe;function de(X){switch(X){case 1:return h.SymbolTag.Deprecated}}_e.to=de})(V=e.SymbolTag||(e.SymbolTag={}));var B;(function(_e){function fe(X){return{name:X.name,kind:oe.from(X.kind),tags:X.tags&&X.tags.map(V.from),containerName:X.containerName,location:M.from(X.location)}}_e.from=fe;function de(X){const Oe=new h.SymbolInformation(X.name,oe.to(X.kind),X.containerName,M.to(X.location));return Oe.tags=X.tags&&X.tags.map(V.to),Oe}_e.to=de})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(_e){function fe(X){var Oe,Le;const Ze={name:X.name||"!!MISSING: name!!",detail:X.detail,range:v.from(X.range),selectionRange:v.from(X.selectionRange),kind:oe.from(X.kind),tags:(Le=(Oe=X.tags)===null||Oe===void 0?void 0:Oe.map(V.from))!==null&&Le!==void 0?Le:[]};return X.children&&(Ze.children=X.children.map(fe)),Ze}_e.from=fe;function de(X){const Oe=new h.DocumentSymbol(X.name,X.detail,oe.to(X.kind),v.to(X.range),v.to(X.selectionRange));return w.isNonEmptyArray(X.tags)&&(Oe.tags=X.tags.map(V.to)),X.children&&(Oe.children=X.children.map(de)),Oe}_e.to=de})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var T;(function(_e){function fe(de){const X=new h.CallHierarchyItem(oe.to(de.kind),de.name,de.detail||"",D.URI.revive(de.uri),v.to(de.range),v.to(de.selectionRange));return X._sessionId=de._sessionId,X._itemId=de._itemId,X}_e.to=fe})(T=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(_e){function fe(de){return new h.CallHierarchyIncomingCall(T.to(de.from),de.fromRanges.map(X=>v.to(X)))}_e.to=fe})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(_e){function fe(de){return new h.CallHierarchyOutgoingCall(T.to(de.to),de.fromRanges.map(X=>v.to(X)))}_e.to=fe})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(_e){function fe(X){return{range:X.range&&v.from(X.range),uri:X.uri}}_e.from=fe;function de(X){return new h.Location(D.URI.revive(X.uri),v.to(X.range))}_e.to=de})(M=e.location||(e.location={}));var U;(function(_e){function fe(X){const Oe=X,Le=X;return{originSelectionRange:Oe.originSelectionRange?v.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Le.uri,range:v.from(Oe.targetRange?Oe.targetRange:Le.range),targetSelectionRange:Oe.targetSelectionRange?v.from(Oe.targetSelectionRange):void 0}}_e.from=fe;function de(X){return{targetUri:D.URI.revive(X.uri),targetRange:v.to(X.range),targetSelectionRange:X.targetSelectionRange?v.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?v.to(X.originSelectionRange):void 0}}_e.to=de})(U=e.DefinitionLink||(e.DefinitionLink={}));var x;(function(_e){function fe(X){return{range:v.from(X.range),contents:m.fromMany(X.contents)}}_e.from=fe;function de(X){return new h.Hover(X.contents.map(m.to),v.to(X.range))}_e.to=de})(x=e.Hover||(e.Hover={}));var G;(function(_e){function fe(X){return{range:v.from(X.range),expression:X.expression}}_e.from=fe;function de(X){return new h.EvaluatableExpression(v.to(X.range),X.expression)}_e.to=de})(G=e.EvaluatableExpression||(e.EvaluatableExpression={}));var se;(function(_e){function fe(X){if(X instanceof h.InlineValueText)return{type:"text",range:v.from(X.range),text:X.text};if(X instanceof h.InlineValueVariableLookup)return{type:"variable",range:v.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=fe;function de(X){switch(X.type){case"text":return{range:v.to(X.range),text:X.text};case"variable":return{range:v.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:v.to(X.range),expression:X.expression}}}_e.to=de})(se=e.InlineValue||(e.InlineValue={}));var be;(function(_e){function fe(X){return{frameId:X.frameId,stoppedLocation:v.from(X.stoppedLocation)}}_e.from=fe;function de(X){return new h.InlineValueContext(X.frameId,v.to(X.stoppedLocation))}_e.to=de})(be=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(_e){function fe(X){return{range:v.from(X.range),kind:X.kind}}_e.from=fe;function de(X){return new h.DocumentHighlight(v.to(X.range),X.kind)}_e.to=de})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(_e){function fe(de){switch(de){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}_e.to=fe})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(_e){function fe(de){return{triggerKind:Ce.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}_e.to=fe})(Me=e.CompletionContext||(e.CompletionContext={}));var qe;(function(_e){function fe(X){switch(X){case h.CompletionItemTag.Deprecated:return 1}}_e.from=fe;function de(X){switch(X){case 1:return h.CompletionItemTag.Deprecated}}_e.to=de})(qe=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(_e){const fe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function de(Le){var Ze;return(Ze=fe.get(Le))!==null&&Ze!==void 0?Ze:9}_e.from=de;const X=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Oe(Le){var Ze;return(Ze=X.get(Le))!==null&&Ze!==void 0?Ze:h.CompletionItemKind.Property}_e.to=Oe})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var Ke;(function(_e){function fe(de,X){var Oe;const Le=new h.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(Le.label2=de.label),Le.insertText=de.insertText,Le.kind=ze.to(de.kind),Le.tags=(Oe=de.tags)===null||Oe===void 0?void 0:Oe.map(qe.to),Le.detail=de.detail,Le.documentation=R.isMarkdownString(de.documentation)?m.to(de.documentation):de.documentation,Le.sortText=de.sortText,Le.filterText=de.filterText,Le.preselect=de.preselect,Le.commitCharacters=de.commitCharacters,I.Range.isIRange(de.range)?Le.range=v.to(de.range):typeof de.range=="object"&&(Le.range={inserting:v.to(de.range.insert),replacing:v.to(de.range.replace)}),Le.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Le.insertText=new h.SnippetString(de.insertText):(Le.insertText=de.insertText,Le.textEdit=Le.range instanceof h.Range?new h.TextEdit(Le.range,Le.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Le.additionalTextEdits=de.additionalTextEdits.map(Ze=>W.to(Ze))),Le.command=X&&de.command?X.fromInternal(de.command):void 0,Le}_e.to=fe})(Ke=e.CompletionItem||(e.CompletionItem={}));var q;(function(_e){function fe(X){return{label:X.label,documentation:X.documentation?m.fromStrict(X.documentation):void 0}}_e.from=fe;function de(X){return{label:X.label,documentation:R.isMarkdownString(X.documentation)?m.to(X.documentation):X.documentation}}_e.to=de})(q=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(_e){function fe(X){return{label:X.label,documentation:X.documentation?m.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(q.from):[],activeParameter:X.activeParameter}}_e.from=fe;function de(X){return{label:X.label,documentation:R.isMarkdownString(X.documentation)?m.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(q.to):[],activeParameter:X.activeParameter}}_e.to=de})(J=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(_e){function fe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.from):[]}}_e.from=fe;function de(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.to):[]}}_e.to=de})(re=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(_e){function fe(X){var Oe;return{text:X.text,position:d.from(X.position),kind:Y.from((Oe=X.kind)!==null&&Oe!==void 0?Oe:h.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}_e.from=fe;function de(X){const Oe=new h.InlayHint(X.text,d.to(X.position),Y.to(X.kind));return Oe.whitespaceAfter=X.whitespaceAfter,Oe.whitespaceBefore=X.whitespaceBefore,Oe}_e.to=de})(ae=e.InlayHint||(e.InlayHint={}));var Y;(function(_e){function fe(X){return X}_e.from=fe;function de(X){return X}_e.to=de})(Y=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(_e){function fe(X){return{range:v.from(X.range),url:X.target,tooltip:X.tooltip}}_e.from=fe;function de(X){let Oe;if(X.url)try{Oe=typeof X.url=="string"?D.URI.parse(X.url,!0):D.URI.revive(X.url)}catch(Le){}return new h.DocumentLink(v.to(X.range),Oe)}_e.to=de})(ce=e.DocumentLink||(e.DocumentLink={}));var ve;(function(_e){function fe(X){const Oe=new h.ColorPresentation(X.label);return X.textEdit&&(Oe.textEdit=W.to(X.textEdit)),X.additionalTextEdits&&(Oe.additionalTextEdits=X.additionalTextEdits.map(Le=>W.to(Le))),Oe}_e.to=fe;function de(X){return{label:X.label,textEdit:X.textEdit?W.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Oe=>W.from(Oe)):void 0}}_e.from=de})(ve=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(_e){function fe(X){return new h.Color(X[0],X[1],X[2],X[3])}_e.to=fe;function de(X){return[X.red,X.green,X.blue,X.alpha]}_e.from=de})(Re=e.Color||(e.Color={}));var we;(function(_e){function fe(X){return{range:v.from(X.range)}}_e.from=fe;function de(X){return new h.SelectionRange(v.to(X.range))}_e.to=de})(we=e.SelectionRange||(e.SelectionRange={}));var je;(function(_e){function fe(de){switch(de){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}_e.to=fe})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var K;(function(_e){function fe(X){switch(X){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=fe;function de(X){switch(X){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}_e.to=de})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(_e){function fe(X){if(X===h.EndOfLine.CRLF)return 1;if(X===h.EndOfLine.LF)return 0}_e.from=fe;function de(X){if(X===1)return h.EndOfLine.CRLF;if(X===0)return h.EndOfLine.LF}_e.to=de})(ie=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(_e){function fe(de){if(typeof de=="object")return de.viewId;switch(de){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=fe})(Ee=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(_e){function fe(de){const X={start:de.start+1,end:de.end+1};return de.kind&&(X.kind=$e.from(de.kind)),X}_e.from=fe})(Ne=e.FoldingRange||(e.FoldingRange={}));var $e;(function(_e){function fe(de){if(de)switch(de){case h.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}_e.from=fe})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(_e){function fe(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?v.from(de.selection):void 0,override:typeof de.override=="boolean"?P.EditorOverride.DISABLED:void 0}}_e.from=fe})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(_e){function fe(X){return X instanceof h.RelativePattern||typeof X=="string"?X:de(X)?new h.RelativePattern(X.base,X.pattern):X}_e.from=fe;function de(X){const Oe=X;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var De;(function(_e){function fe(de){if(de){if(Array.isArray(de))return de.map(fe);if(typeof de=="string")return de;{const X=de;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:Xe.from(X.pattern),exclusive:X.exclusive}}}else return}_e.from=fe})(De=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(_e){function fe(X){return{start:X.start,end:X.end}}_e.from=fe;function de(X){return new h.NotebookRange(X.start,X.end)}_e.to=de})(ye=e.NotebookRange||(e.NotebookRange={}));var ke;(function(_e){function fe(de){return new h.NotebookCellMetadata().with(Object.assign(Object.assign({},de),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}_e.to=fe})(ke=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var le;(function(_e){function fe(X){return X}_e.from=fe;function de(X){return new h.NotebookDocumentMetadata().with(X)}_e.to=de})(le=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var he;(function(_e){function fe(X){return{startTime:X.runStartTime,endTime:X.runEndTime,executionOrder:X.executionOrder,success:X.lastRunSuccess}}_e.to=fe;function de(X){return{lastRunSuccess:X.success,runStartTime:X.startTime,runEndTime:X.endTime,executionOrder:X.executionOrder}}_e.from=de})(he=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var H;(function(_e){function fe(X){switch(X){case h.NotebookCellKind.Markup:return p.CellKind.Markup;case h.NotebookCellKind.Code:default:return p.CellKind.Code}}_e.from=fe;function de(X){switch(X){case p.CellKind.Markup:return h.NotebookCellKind.Markup;case p.CellKind.Code:default:return h.NotebookCellKind.Code}}_e.to=de})(H=e.NotebookCellKind||(e.NotebookCellKind={}));var Z;(function(_e){function fe(X){const Oe={metadata:le.from(X.metadata),cells:[]};for(let Le of X.cells)h.NotebookCellData.validate(Le),Oe.cells.push(ue.from(Le));return Oe}_e.from=fe;function de(X){return{metadata:le.to(X.metadata),cells:X.cells.map(ue.to)}}_e.to=de})(Z=e.NotebookData||(e.NotebookData={}));var ue;(function(_e){function fe(X){var Oe;return{cellKind:H.from(X.kind),language:X.languageId,source:X.value,metadata:X.metadata,internalMetadata:he.from((Oe=X.executionSummary)!==null&&Oe!==void 0?Oe:{}),outputs:X.outputs?X.outputs.map(Pe.from):[]}}_e.from=fe;function de(X){return new h.NotebookCellData(H.to(X.cellKind),X.source,X.language,X.outputs?X.outputs.map(Pe.to):void 0,X.metadata?ke.to(X.metadata):void 0,X.internalMetadata?he.to(X.internalMetadata):void 0)}_e.to=de})(ue=e.NotebookCellData||(e.NotebookCellData={}));var Ie;(function(_e){function fe(X){return{metadata:X.metadata,mime:X.mime,valueBytes:Array.from(X.data)}}_e.from=fe;function de(X){return new h.NotebookCellOutputItem(new Uint8Array(X.valueBytes),X.mime,X.metadata)}_e.to=de})(Ie=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(_e){function fe(X){return{outputId:X.id,outputs:X.items.map(Ie.from),metadata:X.metadata}}_e.from=fe;function de(X){const Oe=X.outputs.map(Ie.to);return new h.NotebookCellOutput(Oe,X.outputId,X.metadata)}_e.to=de})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ue;(function(_e){function fe(Le){if(Le!=null){if(Le instanceof h.RelativePattern||typeof Le=="string")return Le;if(Oe(Le))return new h.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:Xe.from(Le.include)||void 0,exclude:Xe.from(Le.exclude)||void 0}}}_e.from=fe;function de(Le){return typeof Le=="string"?Le:Oe(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}_e.to=de;function X(Le){const Ze=Le,et=Xe.from(Ze.include);if(!(et&&et instanceof h.RelativePattern||typeof et=="string"))return!1;const ft=Xe.from(Ze.exclude);return!!(ft&&ft instanceof h.RelativePattern||typeof ft=="string")}function Oe(Le){const Ze=Le;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Ue=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var xe;(function(_e){function fe(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?b.from(de.top):void 0}}_e.from=fe})(xe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(_e){function fe(de,X,Oe){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,Oe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}_e.from=fe})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(_e){function fe(de){var X,Oe,Le;return{transientOutputs:(X=de==null?void 0:de.transientOutputs)!==null&&X!==void 0?X:!1,transientCellMetadata:(Oe=de==null?void 0:de.transientCellMetadata)!==null&&Oe!==void 0?Oe:{},transientDocumentMetadata:(Le=de==null?void 0:de.transientDocumentMetadata)!==null&&Le!==void 0?Le:{}}}_e.from=fe})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var tt;(function(_e){function fe(X){return{uri:X.uri,provides:X.provides}}_e.from=fe;function de(X){return new h.NotebookRendererScript(D.URI.revive(X.uri),X.provides)}_e.to=de})(tt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ye;(function(_e){function fe(X){return{message:m.fromStrict(X.message)||"",severity:X.severity,expectedOutput:X.expectedOutput,actualOutput:X.actualOutput,location:X.location?M.from(X.location):void 0}}_e.from=fe;function de(X){const Oe=new h.TestMessage(typeof X.message=="string"?X.message:m.to(X.message));return Oe.severity=X.severity,Oe.actualOutput=X.actualOutput,Oe.expectedOutput=X.expectedOutput,Oe}_e.to=de})(Ye=e.TestMessage||(e.TestMessage={}));var ot;(function(_e){function fe(Le){var Ze,et;return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range)||null,debuggable:(Ze=Le.debuggable)!==null&&Ze!==void 0?Ze:!1,description:Le.description||null,runnable:(et=Le.runnable)!==null&&et!==void 0?et:!0,error:Le.error&&m.fromStrict(Le.error)||null}}_e.from=fe;function de(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range)||null,debuggable:!1,description:Le.description||null,error:null,runnable:!0}}_e.fromResultSnapshot=de;function X(Le){return{id:Le.extId,label:Le.label,uri:D.URI.revive(Le.uri),range:v.to(Le.range||void 0),addChild:()=>{},dispose:()=>{},status:h.TestItemStatus.Pending,data:void 0,debuggable:Le.debuggable,description:Le.description||void 0,runnable:Le.runnable}}_e.toPlain=X;function Oe(Le){const Ze=new h.TestItemImpl(Le.extId,Le.label,D.URI.revive(Le.uri),void 0);return Ze.range=v.to(Le.range||void 0),Ze.debuggable=Le.debuggable,Ze.description=Le.description||void 0,Ze.runnable=Le.runnable,Ze}_e.to=Oe})(ot=e.TestItem||(e.TestItem={}));var Et;(function(_e){const fe=(X,Oe)=>Object.assign(Object.assign({},ot.toPlain(X.item)),{taskStates:X.tasks.map(Le=>({state:Le.state,duration:Le.duration,messages:Le.messages.map(Ye.to)})),children:X.children.map(Le=>Oe.get(Le)).filter(k.isDefined).map(Le=>fe(Le,Oe))});function de(X){const Oe=[],Le=new Map;for(const Ze of X.items)Le.set(Ze.item.extId,Ze),Ze.direct&&Oe.push(Ze);return{completedAt:X.completedAt,results:Oe.map(Ze=>fe(Ze,Le))}}_e.to=de})(Et=e.TestResults||(e.TestResults={}));var bt;(function(_e){function fe(de){switch(de){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}_e.to=fe})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[212],pe([0,1,2,16,7,20,56]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(I,s,P,c={timeout:1500,errors:3}){this._logService=I,this._documents=s,this._mainThreadBulkEdits=P,this._thresholds=c,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(s,P,c)=>{const l={dispose:this._callbacks.push([s,P,I])};return Array.isArray(c)&&c.push(l),l}}async $participateInSave(I,s){const P=w.URI.revive(I);let c=!1;const p=setTimeout(()=>c=!0,this._thresholds.timeout),l=[];try{for(let h of[...this._callbacks]){if(c)break;const _=this._documents.getDocument(P),v=await this._deliverEventAsyncAndBlameBadListeners(h,{document:_,reason:A.TextDocumentSaveReason.to(s)});l.push(v)}}finally{clearTimeout(p)}return l}_deliverEventAsyncAndBlameBadListeners([I,s,P],c){const p=this._badListeners.get(I);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,I,s,c).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const h=this._badListeners.get(I);this._badListeners.set(I,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,s,P,c){const p=[],l=Date.now(),{document:h,reason:_}=c,{version:v}=h,S=Object.freeze({document:h,reason:_,waitUntil(d){if(Object.isFrozen(p))throw R.illegalState("waitUntil can not be called async");p.push(Promise.resolve(d))}});try{s.apply(P,[S])}catch(d){return Promise.reject(d)}return Object.freeze(p),new Promise((d,f)=>{const u=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(u),d(t)}).catch(t=>{clearTimeout(u),f(t)})}).then(d=>{const f={edits:[]};for(const u of d)if(Array.isArray(u)&&u.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:n,range:i}of u)f.edits.push({_type:2,resource:h.uri,edit:{range:i&&A.Range.from(i),text:t,eol:n&&A.EndOfLine.from(n)}});if(f.edits.length!==0)return v===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ge[213],pe([0,1,3,13,30,2,20,7]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(P,c,p,l,h){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,p&&(this._config+=1),l&&(this._config+=2),h&&(this._config+=4);const _=C.parse(c),v=P(S=>{if(!p)for(let d of S.created){const f=A.URI.revive(d);_(f.fsPath)&&this._onDidCreate.fire(f)}if(!l)for(let d of S.changed){const f=A.URI.revive(d);_(f.fsPath)&&this._onDidChange.fire(f)}if(!h)for(let d of S.deleted){const f=A.URI.revive(d);_(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(P,c,p){this._logService=c,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,c,p,l){return new D(this._onFileSystemEvent.event,P,c,p,l)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,c){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(p=>({oldUri:A.URI.revive(p.source),newUri:A.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(p=>A.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:c.map(p=>A.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,c){return(p,l,h)=>{const _=function(S){p.call(l,S)};return _.extension=P,c.event(_,void 0,h)}}async $onWillRunFileOperation(P,c,p,l){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(h=>({oldUri:A.URI.revive(h.source),newUri:A.URI.revive(h.target)}))},p,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(h=>A.URI.revive(h.target))},p,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(h=>A.URI.revive(h.target))},p,l)}}async _fireWillEvent(P,c,p,l){const h=new Set,_=[];if(await P.fireAsync(c,l,async(S,d)=>{var f;const u=Date.now(),t=await Promise.resolve(S);t instanceof k.WorkspaceEdit&&(_.push(t),h.add((f=d.extension.displayName)!==null&&f!==void 0?f:d.extension.identifier.value)),Date.now()-u>p&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),l.isCancellationRequested||_.length===0)return;const v={edits:[]};for(let S of _){let{edits:d}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(d)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=I}),define(ge[214],pe([0,1,10,25,2,20,7,64]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(c,p,l,h){this.start=c,this.deletedCount=p,this.deletedItems=l,this.items=h}static asApiEvents(c){return c.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(l=>l.apiCell)}))}}class I{constructor(c,p,l){var h,_,v;this.notebook=c,this._extHostDocument=p,this._cellData=l,this.handle=l.handle,this.uri=C.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(h=l.internalMetadata)!==null&&h!==void 0?h:{},this._metadata=A.NotebookCellMetadata.to((_=l.metadata)!==null&&_!==void 0?_:{}),this._previousResult=A.NotebookCellExecutionSummary.to((v=l.internalMetadata)!==null&&v!==void 0?v:{})}static asModelAddData(c,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(A.NotebookCellOutput.to)}setOutputItems(c,p,l){const h=l.map(A.NotebookCellOutputItem.to),_=this._outputs.find(v=>v.id===c);_&&(p||(_.items.length=0),_.items.push(...h))}setMetadata(c){this._metadata=A.NotebookCellMetadata.to(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=A.NotebookCellExecutionSummary.to(c)}}e.ExtHostCell=I;class s{constructor(c,p,l,h,_,v,S){this._proxy=c,this._textDocumentsAndEditors=p,this._textDocuments=l,this._emitter=h,this._viewType=_,this._metadata=v,this.uri=S,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get viewType(){return c._viewType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===w.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(p){return p=c._validateIndex(p),c._cells[p].apiCell},getCells(p){return(p?c._getCells(p):c._cells).map(h=>h.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=c}disposeBackup(){var c;(c=this._backup)===null||c===void 0||c.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=this._metadata.with(c.metadata))}acceptModelChanged(c,p){this._versionId=c.versionId,this._isDirty=p;for(const l of c.rawEvents)l.kind===k.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(l.changes,!0),l.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===k.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let p=c.start|0,l=c.end|0;return p<0&&(p=0),l>this._cells.length&&(l=this._cells.length),c.with({start:p,end:l})}_getCells(c){c=this._validateRange(c);const p=[];for(let l=c.start;l<c.end;l++)p.push(this._cells[l]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,p){if(this._disposed)return;const l=[],h=[],_=[];c.reverse().forEach(v=>{const d=v[2].map(t=>{const n=new I(this,this._textDocumentsAndEditors,t);return p||h.push(I.asModelAddData(this.apiNotebook,t)),n}),f=new D(v[0],v[1],[],d),u=this._cells.splice(v[0],v[1],...d);for(const t of u)_.push(t.uri),f.deletedItems.push(t.apiCell);l.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:_}),p||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(l)}))}_moveCell(c,p){const l=this._cells.splice(c,1);this._cells.splice(p,0,...l);const h=[new D(c,1,l.map(_=>_.apiCell),[]),new D(p,0,[],l)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(h)}))}_setCellOutputs(c,p){const l=this._cells[c];l.setOutputs(p),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(c,p,l,h){const _=this._cells[c];_.setOutputItems(p,l,h),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(c,p){const l=this._cells[c];l.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(l.uri,p)}_changeCellMetadata(c,p){const l=this._cells[c],h=l.apiCell.metadata;l.setMetadata(p);const _=l.apiCell.metadata;R.equals(h,_)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(c,p){var l;const h=this._cells[c],_=h.internalMetadata;if(h.setInternalMetadata(p),_.runState!==p.runState){const v=(l=p.runState)!==null&&l!==void 0?l:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:h.apiCell,executionState:v}))}}getCellFromApiCell(c){return this._cells.find(p=>p.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(p=>p.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=s,s._handlePool=0}),define(ge[124],pe([0,1,7,20]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:D})}replaceCells(k,D,I){this._throwIfFinalized(),!(k===D&&I.length===0)&&this._collectedEdits.push({editType:1,index:k,count:D-k,cells:I.map(R.NotebookCellData.from)})}}class A{constructor(k,D,I,s,P,c){this.id=k,this._proxy=D,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=s,this._viewColumn=c}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.apiNotebook},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(D,I){k._proxy.$tryRevealRange(k.id,R.NotebookRange.from(D),I??w.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(D){const I=new C(this.document.version);return D(I),k._applyEdit(I.finalize())},setDecorations(D,I){return k.setDecorations(D,I)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const D=[];let I=-1;for(let s=0;s<k.cellEdits.length;s++){if(I<0){D.push(k.cellEdits[s]),I++;continue}const c=D[I],p=k.cellEdits[s];if(c.editType===1&&p.editType===1&&c.index===p.index){c.cells.push(...k.cellEdits[s].cells),c.count+=k.cellEdits[s].count;continue}D.push(k.cellEdits[s]),I++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,D)}setDecorations(k,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return D.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),k.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(ge[215],pe([0,1,20,114,163,21,53]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,c,p){const l=this._handles++,{title:h,location:_,cancellable:v}=c,S={label:C.localize(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(l,{location:w.ProgressLocation.from(_),title:h,source:S,cancellable:v},P),this._withProgress(l,p,!!v)}_withProgress(P,c,p){let l;p&&(l=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,l));const h=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),l&&l.dispose()};let _;try{_=c(new I(this._proxy,P),p&&l?l.token:A.CancellationToken.None)}catch(v){throw h(P),v}return _.then(v=>h(P),v=>h(P)),_}$acceptProgressCanceled(P){const c=this._mapHandleToCancellationSource.get(P);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=k;function D(s,P){return s.message=P.message,typeof P.increment=="number"&&(typeof s.increment=="number"?s.increment+=P.increment:s.increment=P.increment),s}class I extends R.Progress{constructor(P,c){super(p=>this.throttledReport(p));this._proxy=P,this._handle=c}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([y.throttle(100,(s,P)=>D(s,P),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(ge[125],pe([0,1,51,16,73,20,7]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(c,p,l){const h=k._Keys.nextId();c.$registerTextEditorDecorationType(p.identifier,h,A.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:h,dispose(){c.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=k,k._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(c,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,p){this._throwIfFinalized();let l=null;if(c instanceof y.Position)l=new y.Range(c,c);else if(c instanceof y.Range)l=c;else throw new Error("Unrecognized location");this._pushEdit(l,p,!1)}insert(c,p){this._throwIfFinalized(),this._pushEdit(new y.Range(c,c),p,!0)}delete(c){this._throwIfFinalized();let p=null;if(c instanceof y.Range)p=c;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(c,p,l){const h=this._document.validateRange(c);this._collectedEdits.push({range:h,text:p,forceMoveMarkers:l})}setEndOfLine(c){if(this._throwIfFinalized(),c!==y.EndOfLine.LF&&c!==y.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=D;class I{constructor(c,p,l,h){this._proxy=c,this._id=p,this._accept(l),this._logService=h;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(v){_._setTabSize(v)},get insertSpaces(){return _._insertSpaces},set insertSpaces(v){_._setInsertSpaces(v)},get cursorStyle(){return _._cursorStyle},set cursorStyle(v){_._setCursorStyle(v)},get lineNumbers(){return _._lineNumbers},set lineNumbers(v){_._setLineNumbers(v)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(c){const p=this._validateTabSize(c);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const p=this._validateInsertSpaces(c);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(c)})))}assign(c){const p={};let l=!1;if(typeof c.tabSize!="undefined"){const h=this._validateTabSize(c.tabSize);h==="auto"?(l=!0,p.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,l=!0,p.tabSize=h)}if(typeof c.insertSpaces!="undefined"){const h=this._validateInsertSpaces(c.insertSpaces);h==="auto"?(l=!0,p.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,l=!0,p.insertSpaces=h)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,l=!0,p.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,l=!0,p.lineNumbers=A.TextEditorLineNumbersStyle.from(c.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(c){c.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=I;class s{constructor(c,p,l,h,_,v,S,d){this.id=c,this._proxy=p,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new I(this._proxy,this.id,v,l),this._visibleRanges=S,this._viewColumn=d;const f=this;this.value=Object.freeze({get document(){return h.getValue()},set document(u){throw R.readonly("document")},get selection(){return f._selections&&f._selections[0]},set selection(u){if(!(u instanceof y.Selection))throw R.illegalArgument("selection");f._selections=[u],f._trySetSelection()},get selections(){return f._selections},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof y.Selection)))throw R.illegalArgument("selections");f._selections=u,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(u){throw R.readonly("visibleRanges")},get options(){return f._options.value},set options(u){f._disposed||f._options.assign(u)},get viewColumn(){return f._viewColumn},set viewColumn(u){throw R.readonly("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(h.getValue(),t);return u(n),f._applyEdit(n)},insertSnippet(u,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=f._selections.map(r=>A.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:o}=A.Position.from(t);i=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof y.Range)i=[A.Range.from(t)];else{i=[];for(const r of t)if(r instanceof y.Range)i.push(A.Range.from(r));else{const{lineNumber:o,column:m}=A.Position.from(r);i.push({startLineNumber:o,startColumn:m,endLineNumber:o,endColumn:m})}}return p.$tryInsertSnippet(c,u.value,i,n)},setDecorations(u,t){const n=t.length===0;n&&!f._hasDecorationsForKey.has(u.key)||(n?f._hasDecorationsForKey.delete(u.key):f._hasDecorationsForKey.add(u.key),f._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return p.$trySetDecorations(c,u.key,A.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const m=t[r];i[4*r]=m.start.line+1,i[4*r+1]=m.start.character+1,i[4*r+2]=m.end.line+1,i[4*r+3]=m.end.character+1}return p.$trySetDecorationsFast(c,u.key,i)}}))},revealRange(u,t){f._runOnProxy(()=>p.$tryRevealRange(c,A.Range.from(u),t||y.TextEditorRevealType.Default))},show(u){p.$tryShowEditor(c,A.ViewColumn.from(u))},hide(){p.$tryHideEditor(c)}})}dispose(){w.ok(!this._disposed),this._disposed=!0}_acceptOptions(c){w.ok(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){w.ok(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){w.ok(!this._disposed),this._viewColumn=c}_acceptSelections(c){w.ok(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const p=c.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const l=p.edits.map(_=>_.range);l.sort((_,v)=>_.end.line===v.end.line?_.end.character===v.end.character?_.start.line===v.start.line?_.start.character-v.start.character:_.start.line-v.start.line:_.end.character-v.end.character:_.end.line-v.end.line);for(let _=0,v=l.length-1;_<v;_++){const S=l[_].end;if(l[_+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=p.edits.map(_=>({range:A.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,h,{setEndOfLine:typeof p.setEndOfLine=="number"?A.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=s}),define(ge[216],pe([0,1,166,24,2,3,6,13,7,12,17,20,21]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(_,v){if(I.isString(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let S;return Array.isArray(_.highlights)&&(S=_.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),S=S.length?S:void 0),{label:_.label,highlights:S}}}class l{constructor(v,S,d){this._proxy=v,this.commands=S,this.logService=d,this.treeViews=new Map;function f(u){return u&&u.$treeViewId&&u.$treeItemHandle}S.registerArgumentProcessor({processArgument:u=>f(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(t=>f(t)?this.convertArgument(t):t):u})}registerTreeDataProvider(v,S,d){const f=this.createTreeView(v,{treeDataProvider:S},d);return{dispose:()=>f.dispose()}}createTreeView(v,S,d){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=S.dragAndDropController!==void 0,u=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:f}),t=this.createExtHostTreeView(v,S,d);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,i)=>t.reveal(n,i),dispose:async()=>{await u,this.treeViews.delete(v),t.dispose()}}}$getChildren(v,S){const d=this.treeViews.get(v);return d?d.getChildren(S):Promise.reject(new Error(w.localize(0,null,v)))}$onDrop(v,S,d){const f=this.treeViews.get(v);return f?f.onDrop(S,d):Promise.reject(new Error(w.localize(1,null,v)))}async $hasResolve(v){const S=this.treeViews.get(v);if(!S)throw new Error(w.localize(2,null,v));return S.hasResolve}$resolve(v,S,d){const f=this.treeViews.get(v);if(!f)throw new Error(w.localize(3,null,v));return f.resolveTreeItem(S,d)}$setExpanded(v,S,d){const f=this.treeViews.get(v);if(!f)throw new Error(w.localize(4,null,v));f.setExpanded(S,d)}$setSelection(v,S){const d=this.treeViews.get(v);if(!d)throw new Error(w.localize(5,null,v));d.setSelection(S)}$setVisible(v,S){const d=this.treeViews.get(v);if(!d)throw new Error(w.localize(6,null,v));d.setVisible(S)}createExtHostTreeView(v,S,d){const f=new h(v,S,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(v,f),f}convertArgument(v){const S=this.treeViews.get(v.$treeViewId);return S?S.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=l;class h extends y.Disposable{constructor(v,S,d,f,u,t){super();if(this.viewId=v,this.proxy=d,this.commands=f,this.logService=u,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===v&&(this._title=o.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,i;this._register(A.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(m=>i=m),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=i;return n=null,this.refresh(o).then(()=>m())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!I.isUndefinedOrNull(v))}getChildren(v){const S=v?this.getExtensionElement(v):void 0;if(v&&!S)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(v);return(d?Promise.resolve(d):this.fetchChildrenNodes(S)).then(f=>f.map(u=>u.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,S){S=S||{select:!0,focus:!1};const d=I.isUndefinedOrNull(S.select)?!0:S.select,f=I.isUndefinedOrNull(S.focus)?!1:S.focus,u=I.isUndefinedOrNull(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(i=>i.item)},{select:d,focus:f,expand:u})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:f,expand:u})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,S){const d=this.getExtensionElement(v);d&&(S?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(v){s.equals(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(v,S){const d=v.map(u=>this.getExtensionElement(u)).filter(u=>!I.isUndefinedOrNull(u)),f=this.getExtensionElement(S);return d&&f?k.asPromise(()=>{var u;return(u=this.dndController)===null||u===void 0?void 0:u.onDrop(d,f)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,S){var d;if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(v);if(f){const u=this.nodes.get(f);if(u){const t=(d=await this.dataProvider.resolveTreeItem(u.extensionItem,f,S))!==null&&d!==void 0?d:u.extensionItem;return u.item.tooltip=this.getTooltip(t.tooltip),u.item.command=this.getCommand(u.disposableStore,t.command),u.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(S=>S?this.resolveUnknownParentChain(S).then(d=>this.resolveTreeNode(S,d[d.length-1]).then(f=>(d.push(f),d))):Promise.resolve([]))}resolveParent(v){const S=this.nodes.get(v);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):k.asPromise(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,S){const d=this.nodes.get(v);return d?Promise.resolve(d):k.asPromise(()=>this.dataProvider.getTreeItem(v)).then(f=>this.createHandle(v,f,S,!0)).then(f=>this.getChildren(S?S.item.handle:void 0).then(()=>{const u=this.getExtensionElement(f);if(u){const t=this.nodes.get(u);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${f}`)}))}getChildrenNodes(v){if(v){let S;if(typeof v=="string"){const d=this.getExtensionElement(v);S=d?this.nodes.get(d):void 0}else S=v;return S&&S.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const S=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=v?this.nodes.get(v):void 0,f=await this.dataProvider.getChildren(v);if(S.token.isCancellationRequested)return[];const u=await Promise.all(s.coalesce(f||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,d):null}));return S.token.isCancellationRequested?[]:s.coalesce(u)}finally{S.dispose()}}refresh(v){if(v.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(v);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const S=new Set,d=v.map(u=>this.nodes.get(u));for(const u of d)if(u&&!S.has(u.item.handle)){let t=u;for(;t&&t.parent&&d.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(u.item.handle)}const f=[];return S.forEach(u=>{const t=this.elements.get(u);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&f.push(u)}}),f}refreshHandles(v){const S={};return Promise.all(v.map(d=>this.refreshNode(d).then(f=>{f&&(S[d]=f.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(v){const S=this.getExtensionElement(v);if(S){const d=this.nodes.get(S);if(d)return this.clearChildren(S),k.asPromise(()=>this.dataProvider.getTreeItem(S)).then(f=>{if(f){const u=this.createTreeNode(S,f,d.parent);return this.updateNodeCache(S,u,d,d.parent),d.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,S,d){const f=this.createTreeNode(v,S,d);if(S.id&&this.elements.has(f.item.handle))throw new Error(w.localize(7,null,S.id));return this.addNodeToCache(v,f),this.addNodeToParentCache(f,d),f}getTooltip(v){return D.MarkdownString.isMarkdownString(v)?P.MarkdownString.from(v):v}getCommand(v,S){return S?this.commands.toInternal(S,v):void 0}createTreeNode(v,S,d){const f=new y.DisposableStore,u=this.createHandle(v,S,d),t=this.getLightIconPath(S);return{item:{handle:u,parentHandle:d?d.item.handle:void 0,label:p(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(f,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:I.isUndefinedOrNull(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:d,children:void 0,disposableStore:f,dispose(){f.dispose()}}}getThemeIcon(v){return v.iconPath instanceof D.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:S,label:d,resourceUri:f},u,t){if(S)return`${h.ID_HANDLE_PREFIX}/${S}`;const n=p(d,this.extension),i=u?u.item.handle:h.LABEL_HANDLE_PREFIX;let r=n?n.label:f?R.basename(f):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,m=this.getChildrenNodes(u)||[];let g,E=0;do{if(g=`${i}/${E}:${r}`,t||!this.elements.has(g)||o===g)break;E++}while(E<=m.length);return g}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return C.URI.isUri(v)?v:C.URI.file(v)}addNodeToCache(v,S){this.elements.set(S.item.handle,v),this.nodes.set(v,S)}updateNodeCache(v,S,d,f){this.elements.delete(S.item.handle),this.nodes.delete(v),S.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(v,S);const u=this.getChildrenNodes(f)||[],t=u.filter(n=>n.item.handle===d.item.handle)[0];t&&u.splice(u.indexOf(t),1,S)}addNodeToParentCache(v,S){S?(S.children||(S.children=[]),S.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const S=this.nodes.get(v);if(S){if(S.children)for(const d of S.children){const f=this.elements.get(d.item.handle);f&&this.clear(f)}S.children=void 0}}else this.clearAll()}clear(v){const S=this.nodes.get(v);if(S){if(S.children)for(const d of S.children){const f=this.elements.get(d.item.handle);f&&this.clear(f)}this.nodes.delete(v),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(ge[217],pe([0,1,17,13,21,12,86,20,7,123]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class s{constructor(){this.testIdsToInternal=new Map}getTestById(_,v){if(v!==void 0){const S=this.testIdsToInternal.get(v),d=S==null?void 0:S.get(_);if(d)return[S,d]}return w.mapFind(this.testIdsToInternal.values(),S=>{const d=S.get(_);return d&&[S,d]})}createForHierarchy(_=()=>{}){return new l(this.createIdMap(c++),_)}createIdMap(_){const v=new p(_);return this.testIdsToInternal.set(v.id,v),{object:v,dispose:()=>this.testIdsToInternal.delete(v.id)}}}e.OwnedTestCollection=s;var P;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let c=0;class p{constructor(_){this.id=_,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(_){if(this.map.has(_.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${_.item.extId}`);this.map.set(_.item.extId,_),_.parent||this._roots.add(_)}has(_){return this.map.has(_)}delete(_){const v=this.map.get(_);return v?(this.map.delete(_),this._roots.delete(v),!0):!1}get(_){return this.map.get(_)}comparePositions(_,v){const S=typeof _=="string"?this.map.get(_):_,d=typeof v=="string"?this.map.get(v):v;if(!S||!d)return 0;if(S===d)return 3;for(let f=this.map.get(d.parent);f;f=this.map.get(f.parent))if(f===S)return 1;for(let f=this.map.get(S.parent);f;f=this.map.get(f.parent))if(f===d)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=p;class l{constructor(_,v){this.testIdToInternal=_,this.publishDiff=v,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(_,v){this.addItem(_,v,null)}getTestByReference(_){return this.testItemToInternal.get(_)}collectDiff(){const _=this.diff;return this.diff=[],_}pushDiff(_){const v=this.diff[this.diff.length-1];if(v&&_[0]===1){if(v[0]===1&&v[1].extId===_[1].extId){I.applyTestItemUpdate(v[1],_[1]);return}if(v[0]===0&&v[1].item.extId===_[1].extId){I.applyTestItemUpdate(v[1],_[1]);return}}this.diff.push(_),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(_,v){var S;const d=this.testIdToInternal.object.get(_);if(!!d){if((d.expandLevels===void 0||v>d.expandLevels)&&(d.expandLevels=v),d.expand===1){const f=this.refreshChildren(d);return f.isSettled?this.expandChildren(d,v-1):f.p.then(()=>this.expandChildren(d,v-1))}else if(d.expand===3)return((S=d.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?d.initialExpand.p.then(()=>this.expandChildren(d,v-1)):this.expandChildren(d,v-1)}}dispose(){var _;for(const v of this.testItemToInternal.values())(_=v.discoverCts)===null||_===void 0||_.dispose(!0),y.getPrivateApiFor(v.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(_,v){const S=_==null?void 0:_.actual.id;switch(v[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(_);break;case 0:this.addItem(v[1],_.src.controller,_);break;case 3:const[d,f,u]=v;switch(f){case"status":this.updateExpandability(_);break;case"range":this.pushDiff([1,{extId:S,item:{range:k.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:k.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[f]:u??null}}]);break}break;default:A.assertNever(v[0])}}addItem(_,v,S){if(!(_ instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${_.id} did not`);if(this.testItemToInternal.has(_))throw new Error(`Attempted to add a single TestItem ${_.id} multiple times to the tree`);if(this.testIdToInternal.object.has(_.id))throw new Error(`Attempted to insert a duplicate test item ID ${_.id}`);const d=S?S.item.extId:null,f=_.resolveHandler?1:0,u=S?S.expandLevels:1,t={controller:v,tree:this.testIdToInternal.object.id},n={actual:_,parent:d,item:k.TestItem.from(_),expandLevels:u?u-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(_,n),this.pushDiff([0,{parent:d,src:t,expand:f,item:n.item}]);const i=y.getPrivateApiFor(_);i.parent=S==null?void 0:S.actual,i.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of i.children.values())this.testItemToInternal.has(r)||this.addItem(r,v,n)}updateExpandability(_){var v;let S;_.actual.resolveHandler?_.actual.status===D.TestItemStatus.Pending?S=_.discoverCts?2:1:((v=_.initialExpand)===null||v===void 0||v.complete(),S=3):S=0,S!==_.expand&&(_.expand=S,this.pushDiff([1,{extId:_.actual.id,expand:S}]),S===1&&_.expandLevels!==void 0&&this.refreshChildren(_))}expandChildren(_,v){if(v<0)return;const S=[..._.actual.children.values()].map(d=>this.expand(d.id,v)).filter(R.isThenable);if(S.length)return Promise.all(S).then(()=>{})}refreshChildren(_){if(_.discoverCts&&_.discoverCts.dispose(!0),!_.actual.resolveHandler){const v=new R.DeferredPromise;return v.complete(),v}return _.expand=2,_.discoverCts=new C.CancellationTokenSource,this.pushExpandStateUpdate(_),_.initialExpand=new R.DeferredPromise,_.actual.resolveHandler(_.discoverCts.token),_.initialExpand}pushExpandStateUpdate(_){this.pushDiff([1,{extId:_.actual.id,expand:_.expand}])}removeItem(_){var v;this.pushDiff([2,_.actual.id]);const S=[_];for(;S.length;){const d=S.pop();if(!!d){(v=d.discoverCts)===null||v===void 0||v.dispose(!0),this.testIdToInternal.object.delete(d.item.extId),this.testItemToInternal.delete(d.actual);for(const f of d.actual.children.values())S.push(this.testIdToInternal.object.get(f.id))}}}flushDiff(){const _=this.collectDiff();_.length&&this.publishDiff(_)}}e.SingleUseTestCollection=l}),define(ge[218],pe([0,1,26,3,9]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(s){this.removedDueToLooping=s}}e.DeltaExtensionsResult=A;class y{constructor(s){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(s.identifier))){console.error("Extension `"+s.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(s.identifier),s),this._extensionsArr.push(s),Array.isArray(s.activationEvents))for(let P of s.activationEvents)P==="onUri"&&(P=`onUri:${w.ExtensionIdentifier.toKey(s.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(s)}}keepOnly(s){const P=new Set;s.forEach(c=>P.add(w.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>P.has(w.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(s,P){s.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(s));const c=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(c.map(p=>p.identifier)),P.length>0){const p=new Set;P.forEach(l=>p.add(w.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!p.has(w.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(c)}static _findLoopingExtensions(s){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,v){this.addNode(_),this.addNode(v),this._arcs.has(_)?this._arcs.get(_).push(v):this._arcs.set(_,[v])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,v){const S=P.getArcs(_);for(let d=0;d<S.length;d++)if(!v.has(S[d]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let _ of s){const v=w.ExtensionIdentifier.toKey(_.identifier);if(c.set(v,_),_.extensionDependencies)for(let S of _.extensionDependencies){const d=w.ExtensionIdentifier.toKey(S);P.addArc(v,d)}}let p=new Set;P.getNodes().filter(_=>P.getArcs(_).length===0).forEach(_=>p.add(_));let l=P.getNodes().filter(_=>!p.has(_)),h;do{h=!1;for(let _=0;_<l.length;_++){const v=l[_];P.hasOnlyGoodArcs(v,p)&&(l.splice(_,1),_--,p.add(v),h=!0)}}while(h);return l.map(_=>c.get(_))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(s))}getExtensionDescriptionsForActivationEvent(s){const P=this._activationMap.get(s);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(s){const P=this._extensionsMap.get(w.ExtensionIdentifier.toKey(s));return P||void 0}}e.ExtensionDescriptionRegistry=y;var k;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(k||(k={}));function D(I,s){const P=I.isBuiltin?0:I.isUnderDevelopment?2:1,c=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(P!==c)return P-c;const p=C.posix.basename(I.extensionLocation.path),l=C.posix.basename(s.extensionLocation.path);return p<l?-1:p>l?1:0}}),define(ge[219],pe([0,1,23]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function A(k){const D=w.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(ge[39],pe([0,1,3,2,4,26,183]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=C.createDecorator("extensionService");class k{constructor(S){this.dependency=S}}e.MissingExtensionDependency=k;var D;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class I{constructor(S,d,f,u){this.codeLoadingTime=S,this.activateCallTime=d,this.activateResolvedTime=f,this.activationReason=u}}e.ActivationTimes=I;class s{constructor(S,d){this.description=S,this.value=d}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var P;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function c(v){v.enableProposedApi||p(v)}e.checkProposedApiEnabled=c;function p(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=p;function l(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:y.getGalleryExtensionId(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=l;function h(v){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=h;class _{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,d){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,d,f,u,t){}_onDidActivateExtensionError(S,d){}_onExtensionRuntimeError(S,d){}_onExtensionHostExit(S){}}e.NullExtensionService=_}),define(ge[220],pe([0,1,26,39,14]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class y{constructor(l,h,_,v){this.startup=l,this.codeLoadingTime=h,this.activateCallTime=_,this.activateResolvedTime=v}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class k{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,h){return l===-1||h===-1?-1:h-l}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class D{constructor(l,h,_,v,S,d){this.activationFailed=l,this.activationFailedError=h,this.activationTimes=_,this.module=v,this.exports=S,this.subscriptions=d}}e.ActivatedExtension=D;class I extends D{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class s extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=s;class P extends D{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let c=class{constructor(l,h,_,v,S){this._logService=S,this._registry=l,this._resolvedExtensionsSet=new Set,h.forEach(d=>this._resolvedExtensionsSet.add(w.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,_.forEach(d=>this._hostExtensionsMap.set(w.ExtensionIdentifier.toKey(d),d)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const h=w.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(h)}getActivatedExtension(l){const h=w.ExtensionIdentifier.toKey(l),_=this._activatedExtensions.get(h);if(!_)throw new Error("Extension `"+l.value+"` is not known or not activated");return _}activateByEvent(l,h){if(this._alreadyActivatedEvents[l])return A;const _=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(_.map(v=>({id:v.identifier,reason:{startup:h,extensionId:v.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,h){const _=this._registry.getExtensionDescription(l);if(!_)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:_.identifier,reason:h}])}_handleActivateRequest(l,h,_){if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(l.id))){h[w.ExtensionIdentifier.toKey(l.id)]=l;return}const v=this._registry.getExtensionDescription(l.id);if(!v){const f=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,f,new R.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(l.id),new P(f));return}const S=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let d=!0;for(let f=0,u=S.length;f<u;f++){const t=S[f];if(this._resolvedExtensionsSet.has(w.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(w.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const m=v.displayName||v.identifier.value,g=this._registry.getExtensionDescription(t),E=g&&g.displayName||t,b=new Error(`Cannot activate the '${m}' extension because its dependency '${E}' failed to activate`);b.detail=n.activationFailedError,this._host.onExtensionActivationError(v.identifier,b,null),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(v.identifier),new P(b));return}if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(t))){d=!1,h[w.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(w.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const i=this._registry.getExtensionDescription(t);if(i){d=!1,h[w.ExtensionIdentifier.toKey(t)]={id:i.identifier,reason:l.reason};continue}const r=v.displayName||v.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(v.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(v.identifier),new P(o));return}d?h[w.ExtensionIdentifier.toKey(v.identifier)]=l:_.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(S=>!this._activatedExtensions.has(w.ExtensionIdentifier.toKey(S.id))),l.length===0))return Promise.resolve(void 0);const h=Object.create(null),_=[];for(let S=0,d=l.length;S<d;S++)this._handleActivateRequest(l[S],h,_);for(let S=0,d=_.length;S<d;S++){const f=w.ExtensionIdentifier.toKey(_[S].id);h[f]&&delete h[f]}const v=Object.keys(h).map(S=>h[S]);return _.length===0?Promise.all(v.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(v).then(S=>this._activateExtensions(_))}_activateExtension(l,h){const _=w.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const v=this._activatingExtensions.get(_);if(v)return v;const S=this._host.actualActivateExtension(l,h).then(void 0,d=>{const f=new Error;return d&&d.name&&(f.name=d.name),d&&d.message?f.message=`Activating extension '${l.value}' failed: ${d.message}.`:f.message=`Activating extension '${l.value}' failed: ${d}.`,d&&d.stack&&(f.stack=d.stack),this._host.onExtensionActivationError(l,f,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(d),new P(d)}).then(d=>{this._activatedExtensions.set(_,d),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,S),S}};c=Ve([He(4,C.ILogService)],c),e.ExtensionsActivator=c}),define(ge[221],pe([0,1,14,39,27,10,112]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends w.LogService{constructor(I){if(I.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(R.ExtensionHostLogFileName,I.logFile.fsPath,!0,I.logLevel))}$setLevel(I){this.setLevel(I)}};k=Ve([He(0,C.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(ge[222],pe([0,1,16]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):w.onUnexpectedError(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=R}),define(ge[126],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(D,I){this.isMain=D,this.sid=I,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const R=[];function C(k){const D=new w(!0,k);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=C;function A(k){const D=new w(!1,k);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(k){return R[k].sid}e.getStringIdentifierForProxy=y}),define(ge[5],pe([0,1,58,2,126]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var s;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(s=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(d){d.name="$ident";function f(t,n){return Object.defineProperty(t,d.name,{value:n,enumerable:!0}),t}d.mixin=f;function u(t){return t[d.name]}d.of=u})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(f){return f._id=p._n++,f}}e.IdObject=p,p._n=0;var l;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(d){if(d&&d.edits)for(const f of d.edits)typeof f.resource=="object"?f.resource=R.URI.revive(f.resource):(f.newUri=R.URI.revive(f.newUri),f.oldUri=R.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=w.revive(f.metadata));return d}e.reviveWorkspaceEditDto=v;var S;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:C.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:C.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:C.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:C.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:C.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:C.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:C.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:C.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:C.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:C.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:C.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:C.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:C.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:C.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:C.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:C.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:C.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:C.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:C.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:C.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:C.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:C.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:C.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:C.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:C.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:C.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:C.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:C.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:C.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:C.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:C.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:C.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:C.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:C.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:C.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:C.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:C.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:C.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:C.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:C.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:C.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:C.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:C.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:C.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:C.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:C.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:C.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:C.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:C.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:C.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:C.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:C.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:C.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:C.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:C.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:C.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:C.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:C.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:C.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:C.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:C.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:C.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:C.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:C.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:C.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:C.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:C.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:C.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:C.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:C.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:C.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:C.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:C.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:C.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:C.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:C.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:C.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:C.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:C.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:C.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:C.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:C.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:C.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:C.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:C.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:C.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:C.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:C.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:C.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:C.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:C.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:C.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:C.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:C.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookKernels:C.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:C.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:C.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:C.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:C.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:C.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:C.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:C.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(ge[88],pe([0,1,5,3,4]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,I){return this._proxy.$setPassword(k,D,I)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=C.createDecorator("IExtHostSecretState")}),define(ge[65],pe([0,1,4,14,5,15]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=w.createDecorator("IExtHostApiDeprecationService");let y=class{constructor(D,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,I,s){const P=this.getUsageKey(D,I);this._reportedUsages.has(P)||(this._reportedUsages.add(P),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${s}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:D}))}getUsageKey(D,I){return`${D}-${I.identifier.value}`}};y=Ve([He(0,A.IExtHostRpcService),He(1,R.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,I){}})}),define(ge[223],pe([0,1,3,5,7,26]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,I,s,P={}){const c=A.ExtensionIdentifier.toKey(D.identifier),p=this._inFlightRequests.get(c)||[],l=[...s].sort().join(" ");let h=p.find(_=>_.scopes===l);if(h)return h.result;{const _=this._getSession(D,c,I,s,P);h={scopes:l,result:_},p.push(h),this._inFlightRequests.set(c,p);try{await _}finally{const v=p.findIndex(S=>S.scopes===l);v>-1&&(p.splice(v),this._inFlightRequests.set(c,p))}return _}}async _getSession(D,I,s,P,c={}){await this._proxy.$ensureProvider(s);const p=D.displayName||D.name;return this._proxy.$getSession(s,P,I,p,c)}async removeSession(D,I){const s=this._authenticationProviders.get(D);return s?s.provider.removeSession(I):this._proxy.$removeSession(D,I)}registerAuthenticationProvider(D,I,s,P){var c;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:I,provider:s,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(l=>l.id===D)||this._providers.push({id:D,label:I});const p=s.onDidChangeSessions(l=>{var h,_,v;this._proxy.$sendDidChangeSessions(D,{added:(h=l.added)!==null&&h!==void 0?h:[],changed:(_=l.changed)!==null&&_!==void 0?_:[],removed:(v=l.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(D,I,(c=P==null?void 0:P.supportsMultipleAccounts)!==null&&c!==void 0?c:!1),new C.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(D);const l=this._providers.findIndex(h=>h.id===D);l>-1&&this._providers.splice(l),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,I){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,I){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,I){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,I){return this._onDidChangeSessions.fire({provider:{id:D,label:I}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,I){return D.forEach(s=>{this._providers.some(P=>P.id===s.id)||this._providers.push(s)}),I.forEach(s=>{const P=this._providers.findIndex(c=>c.id===s.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:I}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ge[224],pe([0,1,5,15,20]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=C.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=Ve([He(0,R.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ge[225],pe([0,1,5]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(A){const y=A.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=R}),define(ge[49],pe([0,1,12,7,20,25,5,17,14,58,42,46,2,6,4,15]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new v(this,i=>{const r=this._apiCommands.get(i);return(r==null?void 0:r.result)===d.Void?r:void 0},n),this._argumentProcessors=[{processArgument(i){return I.revive(i)}},{processArgument(i){return A.cloneAndChange(i,function(r){if(s.Range.isIRange(r))return C.Range.to(r);if(P.Position.isIPosition(r))return C.Position.to(r);if(s.Range.isIRange(r.range)&&c.URI.isUri(r.uri))return C.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...i)=>{const r=t.args.map((m,g)=>{if(!m.validate(i[g]))throw new Error(`Invalid argument '${m.name}' when running '${t.id}', received: ${i[g]}`);return m.convert(i[g])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,i,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:i,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,i){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=A.cloneAndChange(n,function(o){if(o instanceof R.Position)return C.Position.from(o);if(o instanceof R.Range)return C.Range.from(o);if(o instanceof R.Location)return C.location.from(o);if(R.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,i);return I.revive(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:r,thisArg:o,description:m}=i;if(m)for(let g=0;g<m.args.length;g++)try{w.validateConstraint(n[g],m.args[g].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${m.args[g].name}' - ${m.args[g].description}`)}try{return await r.apply(o,n)}catch(g){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...n);E&&(t=E.command)}throw this._logService.error(g,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(i=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),i)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(i=>i[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,i]of this._commands){let{description:r}=i;r&&(t[n]=r)}return Promise.resolve(t)}};_=Ve([He(0,h.IExtHostRpcService),He(1,D.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=l.createDecorator("IExtHostCommands");class v{constructor(t,n,i){this._commands=t,this._lookupApiCommand=n,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const r=this._lookupApiCommand(t.command);if(r)i.id=r.internalId,i.arguments=r.args.map((o,m)=>o.convert(t.arguments&&t.arguments[m]));else if(k.isNonEmptyArray(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add(p.toDisposable(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),i.$ident=o,i.id=this.delegatingCommandId,i.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return i}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class S{constructor(t,n,i,r){this.name=t,this.description=n,this.validate=i,this.convert=r}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t??this.name,n??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",u=>c.URI.isUri(u),u=>u),S.Position=new S("position","A position in a text document",u=>R.Position.isPosition(u),C.Position.from),S.Range=new S("range","A range in a text document",u=>R.Range.isRange(u),C.Range.from),S.Selection=new S("selection","A selection in a text document",u=>R.Selection.isSelection(u),C.Selection.from),S.Number=new S("number","",u=>typeof u=="number",u=>u),S.String=new S("string","",u=>typeof u=="string",u=>u),S.CallHierarchyItem=new S("item","A call hierarchy item",u=>u instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class d{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=d,d.Void=new d("no result",u=>u);class f{constructor(t,n,i,r,o){this.id=t,this.internalId=n,this.description=i,this.args=r,this.result=o}}e.ApiCommand=f}),define(ge[226],pe([0,1,6,20,7,80,49,203,17,108]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const s=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",c(R.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if(D.isFalsyOrEmpty(l))return;class _ extends C.SymbolInformation{static to(S){const d=new _(S.name,R.SymbolKind.to(S.kind),S.containerName||"",new C.Location(h[0],R.Range.to(S.range)));return d.detail=S.detail,d.range=d.location.range,d.selectionRange=R.Range.to(S.selectionRange),d.children=S.children?S.children.map(_.to):[],d}}return l.map(_.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(R.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",c(R.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",c(R.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>C.Position.isPosition(h)),l=>l.map(R.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let _;for(const v of h.reverse())_=new C.SelectionRange(R.Range.to(v),_);return _}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let _ of l)h.push(..._[1].map(R.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(R.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(R.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(R.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return R.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(R.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new C.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=I.decodeSemanticTokensDto(l);if(h.type==="full")return new C.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new C.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=I.decodeSemanticTokensDto(l);if(h.type==="full")return new C.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,_)=>{if(!l)return new C.CompletionList([]);const v=l.suggestions.map(S=>R.CompletionItem.to(S,_));return new C.CompletionList(v,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return R.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,_)=>c(v=>new C.CodeLens(R.Range.to(v.range),v.command&&_.fromInternal(v.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>C.Range.isRange(l),l=>C.Selection.isSelection(l)?R.Selection.from(l):R.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,_)=>c(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return _.fromInternal(v.command)}else{const S=new C.CodeAction(v.title,v.kind?new C.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=R.WorkspaceEdit.to(v.edit)),v.command&&(S.command=_.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new C.ColorInformation(R.Range.to(h.range),R.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof C.Color,R.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:R.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(R.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(R.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",c(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>R.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(R.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class P{constructor(h){this._disposables=new w.DisposableStore,this._commands=h}static register(h){return s.forEach(h.registerApiCommand,h),new P(h).registerCommands()}registerCommands(){const h=_=>(...v)=>_(this._commands,...v);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,h(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:_=>typeof _=="string"}]})}_register(h,_,v){const S=this._commands.registerCommand(!1,h,_,this,v);this._disposables.add(S)}}e.ExtHostApiCommands=P;function c(l){return h=>{if(Array.isArray(h))return h.map(l)}}function p(l){if(!Array.isArray(l))return;const h=[];for(const _ of l)A.isLocationLink(_)?h.push(R.DefinitionLink.to(_)):h.push(R.location.to(_));return h}}),define(ge[227],pe([0,1,13,53,3,6,2,80,26,20,7,5]),function(Q,e,w,R,C,A,y,k,D,I,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class c{constructor(f,u,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=f.getProxy(P.MainContext.MainThreadComments),u.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const i=this._commentControllers.get(n.handle);return i||n}else if(n&&n.$mid===7){const i=this._commentControllers.get(n.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const i=this._commentControllers.get(n.thread.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const i=this._commentControllers.get(n.thread.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,m=r.getCommentByUniqueId(o);return m||n}else if(n&&n.$mid===10){const i=this._commentControllers.get(n.thread.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,m=n.commentUniqueId,g=r.getCommentByUniqueId(m);return g?(g.body=o,g):n}return n}})}createCommentController(f,u,t){const n=c.handlePool++,i=new l(f,n,this._proxy,u,t);this._commentControllers.set(i.handle,i);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(f.identifier))||[];return r.push(i),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(f.identifier),r),i}$createCommentThreadTemplate(f,u,t){const n=this._commentControllers.get(f);!n||n.$createCommentThreadTemplate(u,t)}async $updateCommentThreadTemplate(f,u,t){const n=this._commentControllers.get(f);!n||n.$updateCommentThreadTemplate(u,t)}$deleteCommentThread(f,u){const t=this._commentControllers.get(f);t&&t.$deleteCommentThread(u)}$provideCommentingRanges(f,u,t){const n=this._commentControllers.get(f);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const i=this._documents.getDocument(y.URI.revive(u));return w.asPromise(()=>n.commentingRangeProvider.provideCommentingRanges(i,t)).then(r=>r?r.map(o=>I.Range.from(o)):void 0)}$toggleReaction(f,u,t,n,i){const r=this._commentControllers.get(f);return!r||!r.reactionHandler?Promise.resolve(void 0):w.asPromise(()=>{const o=r.getCommentThread(u);if(o){const m=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&m&&r.reactionHandler)return r.reactionHandler(m,v(i))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=c,c.handlePool=0;class p{constructor(f,u,t,n,i,r,o){this._proxy=f,this._commentController=u,this._id=t,this._uri=n,this._range=i,this._comments=r,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${u.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,I.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const f=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),u={};f("range")&&(u.range=I.Range.from(this._range)),f("label")&&(u.label=this.label),f("contextValue")&&(u.contextValue=this.contextValue),f("comments")&&(u.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),f("collapsibleState")&&(u.collapseState=S(this._collapseState)),f("canReply")&&(u.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(f){for(let u of this._commentsMap){let t=u[0],n=u[1];if(f===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}p._handlePool=0,Ve([R.debounce(100)],p.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=p;class l{constructor(f,u,t,n,i){this._extension=f,this._handle=u,this._proxy=t,this._id=n,this._label=i,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,i)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(f,u,t,n){if(typeof f=="string"){const i=new p(this._proxy,this,f,u,t,n,this._extension.identifier);return this._threads.set(i.handle,i),i}else{const i=new p(this._proxy,this,void 0,f,u,t,this._extension.identifier);return this._threads.set(i.handle,i),i}}$createCommentThreadTemplate(f,u){const t=new p(this._proxy,this,void 0,y.URI.revive(f),I.Range.to(u),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(f,u){let t=this._threads.get(f);t&&(t.range=I.Range.to(u))}$deleteCommentThread(f){let u=this._threads.get(f);u&&u.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(d,f,u,t){let n=t.get(u);n||(n=++d.commentHandle,t.set(u,n));const i=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:n,body:I.MarkdownString.from(u.body),userName:u.author.name,userIconPath:i,label:u.label,commentReactions:u.reactions?u.reactions.map(r=>_(r)):void 0}}function _(d){return{label:d.label,iconPath:d.iconPath?I.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function v(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?y.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function S(d){if(d!==void 0)switch(d){case s.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case s.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(ge[127],pe([0,1,2,5,7,4,15,14,17,8,9]),function(Q,e,w,R,C,A,y,k,D,I,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class wn{constructor(p,l){this._logService=l,this._provider=new Map,this._proxy=p.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,l){const h=wn._handlePool++;this._provider.set(h,{provider:p,extensionId:l}),this._proxy.$registerDecorationProvider(h,l.value);const _=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(h,null);return}let S=D.asArray(v);if(S.length<=wn._maxEventSize){this._proxy.$onDidChange(h,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,S.length);const d=S.map(t=>({uri:t,rank:I.count(t.path,"/")})),f=D.groupBy(d,(t,n)=>t.rank-n.rank||I.compare(t.uri.path,n.uri.path));let u=[];e:for(let t of f){let n;for(let i of t){let r=s.dirname(i.uri.path);if(n!==r&&(n=r,u.push(i.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(h,u)});return new C.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(p,l,h){if(!this._provider.has(p))return Object.create(null);const _=Object.create(null),{provider:v,extensionId:S}=this._provider.get(p);return await Promise.all(l.map(async d=>{try{const{uri:f,id:u}=d,t=await Promise.resolve(v.provideFileDecoration(w.URI.revive(f),h));if(!t)return;try{C.FileDecoration.validate(t),_[u]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(f){this._logService.error(f)}})),_}};P._handlePool=0,P._maxEventSize=250,P=Ve([He(0,y.IExtHostRpcService),He(1,k.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=A.createDecorator("IExtHostDecorations")}),define(ge[228],pe([0,1,161,113,2,5,7,20,3,14,22]),function(Q,e,w,R,C,A,y,k,D,I,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(l,h,_,v,S){this._name=l,this._owner=h,this._maxDiagnosticsPerFile=_,this._proxy=v,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new s.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,h){if(!l){this.clear();return}this._checkDisposed();let _=[];if(C.URI.isUri(l)){if(!h){this.delete(l);return}this._data.set(l,h.slice()),_=[l]}else if(Array.isArray(l)){_=[];let S;l=[...l].sort(P._compareIndexedTuplesByUri);for(const d of l){const[f,u]=d;if((!S||f.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=f,_.push(f),this._data.set(f,[])),u){const t=this._data.get(f);t&&t.push(...u)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const v=[];for(let S of _){let d=[];const f=this._data.get(S);if(f)if(f.length>this._maxDiagnosticsPerFile){d=[];const u=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of f)if(n.severity===u[t]&&d.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;d.push({severity:R.MarkerSeverity.Info,message:w.localize(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=f.map(u=>k.Diagnostic.from(u));v.push([S,d])}this._proxy.$changeMany(this._owner,v)}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,h){this._checkDisposed();for(let _ of this._data.keys())l.apply(h,[_,this.get(_),this])}get(l){this._checkDisposed();const h=this._data.get(l);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,h){return l[0].toString()<h[0].toString()?-1:l[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=P;let c=class jt{constructor(l,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=l.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(l,h){return l?l.concat(h):h}static _mapper(l){const h=new s.ResourceMap;for(const _ of l)h.set(_,_);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(l,h){const{_collections:_,_proxy:v,_onDidChangeDiagnostics:S,_logService:d}=this,f=new class{$changeMany(n,i){v.$changeMany(n,i),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,n,i.length===0?"CLEARING":i)}$clear(n){v.$clear(n),d.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,n)}dispose(){v.dispose()}};let u;if(!h)h="_generated_diagnostic_collection_name_#"+jt._idPool++,u=h;else if(!_.has(h))u=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do u=h+jt._idPool++;while(_.has(u))}return new class extends P{constructor(){super(h,u,jt._maxDiagnosticsPerFile,f,S);_.set(u,this)}dispose(){super.dispose(),_.delete(u)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const h=new Map,_=[];for(const v of this._collections.values())v.forEach((S,d)=>{let f=h.get(S.toString());typeof f=="undefined"&&(f=_.length,h.set(S.toString(),f),_.push([S,[]])),_[f][1]=_[f][1].concat(...d)});return _}}_getDiagnostics(l){let h=[];for(let _ of this._collections.values())_.has(l)&&(h=h.concat(_.get(l)));return h}$acceptMarkersChange(l){if(!this._mirrorCollection){const h="_generated_mirror",_=new P(h,h,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,_),this._mirrorCollection=_}for(const[h,_]of l)this._mirrorCollection.set(C.URI.revive(h),_.map(k.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=Ve([He(1,I.ILogService)],c),e.ExtHostDiagnostics=c}),define(ge[229],pe([0,1,2,5]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(y){this._proxy=y.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(D=>w.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?w.URI.revive(k):void 0)}}e.ExtHostDialogs=C}),define(ge[230],pe([0,1,16,2,7,5,10,21,8]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(P,c,p){this._documentsAndEditors=c,this._logService=p,this._documentContentProviders=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,c){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const p=I._handlePool++;this._documentContentProviders.set(p,c),this._proxy.$registerTextContentProvider(p,P);let l;return typeof c.onDidChange=="function"&&(l=c.onDidChange(h=>{if(h.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(p,h).then(_=>{if(!_&&typeof _!="string")return;const v=this._documentsAndEditors.getDocument(h);if(!v)return;const S=D.splitLines(_);if(!v.equalLines(S))return this._proxy.$onVirtualDocumentChange(h,_)},w.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(P,c){const p=this._documentContentProviders.get(P);return p?Promise.resolve(p.provideTextDocumentContent(R.URI.revive(c),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(ge[231],pe([0,1,3,6,2,5,120,20,12,25]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class s{constructor(c,p){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const h of l)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const h of l)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(c){if(!c)return;const p=this._documentsAndEditors.getDocument(c);if(p)return p}getDocument(c){const p=this.getDocumentData(c);if(!(p==null?void 0:p.document))throw new Error(`Unable to retrieve document from URI '${c}'`);return p.document}ensureDocumentData(c){const p=this._documentsAndEditors.getDocument(c);if(p)return Promise.resolve(p);let l=this._documentLoader.get(c.toString());return l||(l=this._proxy.$tryOpenDocument(c).then(h=>{this._documentLoader.delete(c.toString());const _=C.URI.revive(h);return D.assertIsDefined(this._documentsAndEditors.getDocument(_))},h=>(this._documentLoader.delete(c.toString()),Promise.reject(h))),this._documentLoader.set(c.toString(),l)),l}createDocumentData(c){return this._proxy.$tryCreateDocument(c).then(p=>C.URI.revive(p))}$acceptModelModeChanged(c,p){const l=C.URI.revive(c),h=this._documentsAndEditors.getDocument(l);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(p),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(c){const p=C.URI.revive(c),l=this._documentsAndEditors.getDocument(p);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(c,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(c,p){const l=C.URI.revive(c),h=this._documentsAndEditors.getDocument(l);if(!h)throw new Error("unknown document");h._acceptIsDirty(p),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(c,p,l){const h=C.URI.revive(c),_=this._documentsAndEditors.getDocument(h);if(!_)throw new Error("unknown document");_._acceptIsDirty(l),_.onEvents(p),this._onDidChangeDocument.fire(I.deepFreeze({document:_.document,contentChanges:p.changes.map(v=>({range:k.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(c,p){y.setWordDefinitionFor(c,p)}}e.ExtHostDocuments=s}),define(ge[40],pe([0,1,51,3,6,2,4,5,120,15,125,20,14,22,10,54,135]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(f,u){this._extHostRpc=f,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const u=[],t=[],n=[];if(f.removedDocuments)for(const i of f.removedDocuments){const r=A.URI.revive(i),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),u.push(o.value))}if(f.addedDocuments)for(const i of f.addedDocuments){const r=A.URI.revive(i.uri);let o=this._documents.get(r);if(o&&r.scheme!==l.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new v(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,i.lines,i.EOL,i.versionId,i.modeId,i.isDirty,i.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(f.removedEditors)for(const i of f.removedEditors){const r=this._editors.get(i);this._editors.delete(i),r&&n.push(r)}if(f.addedEditors)for(const i of f.addedEditors){const r=A.URI.revive(i.documentUri);w.ok(this._documents.has(r),`document '${r}' does not exist`),w.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const o=this._documents.get(r).value,m=new s.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>o.document),i.selections.map(P.Selection.to),i.options,i.visibleRanges.map(g=>P.Range.to(g)),typeof i.editorPosition=="number"?P.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,m)}f.newActiveEditor!==void 0&&(w.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),C.dispose(u),C.dispose(n),f.removedDocuments&&this._onDidRemoveDocuments.fire(u),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){var u;return(u=this._documents.get(f))===null||u===void 0?void 0:u.value}allDocuments(){return h.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return f?u:u==null?void 0:u.value}allEditors(){return[...this._editors.values()]}};S=Ve([He(0,I.IExtHostRpcService),He(1,c.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=y.createDecorator("IExtHostDocumentsAndEditors")}),define(ge[232],pe([0,1,2,5,6,7,20,144,8,23]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class s{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const l=this._schemes.indexOf(p);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),l=[];let h,_,v=14,S=14;for(const d of p){let f=h?D.commonPrefixLength(h,d):0;for(f===0?_=1:_=S;f<d.length;f++)f+1===d.length?(v=S,S=9):S+=1,l.push([_,d.toUpperCase().charCodeAt(f),S]),l.push([_,d.toLowerCase().charCodeAt(f),S]),_=S;h=d,S=v}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new k.StateMachine(l)}}provideDocumentLinks(p){this._initStateMachine();const l=[],h=k.LinkComputer.computeLinks({getLineContent(_){return p.lineAt(_-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const _ of h){const v=y.DocumentLink.to(_);v.target&&l.push(v)}return l}}class P{constructor(p,l){this._extHostLanguageFeatures=l,this._linkProvider=new s,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=p.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var p;(p=this._linkProviderRegistration)===null||p===void 0||p.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,l,h,_={},v){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(S,h),this._enableProposedApi.set(S,v??!1);let d=2;_.isCaseSensitive&&(d+=1024),_.isReadonly&&(d+=2048),typeof h.copy=="function"&&(d+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(S,l,d).catch(u=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${l}`),console.error(u)});const f=h.onDidChangeFile(u=>{const t=[];for(const n of u){let{uri:i,type:r}=n;if(i.scheme!==l)continue;let o;switch(r){case A.FileChangeType.Changed:o=0;break;case A.FileChangeType.Created:o=1;break;case A.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:o})}this._proxy.$onFileSystemChange(S,t)});return C.toDisposable(()=>{f.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(S),this._enableProposedApi.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(p,l){const{type:h,ctime:_,mtime:v,size:S,permissions:d}=p;return l?{type:h,ctime:_,mtime:v,size:S,permissions:d}:{type:h,ctime:_,mtime:v,size:S}}$stat(p,l){return Promise.resolve(this._getFsProvider(p).stat(w.URI.revive(l))).then(h=>{var _;return P._asIStat(h,(_=this._enableProposedApi.get(p))!==null&&_!==void 0?_:!1)})}$readdir(p,l){return Promise.resolve(this._getFsProvider(p).readDirectory(w.URI.revive(l)))}$readFile(p,l){return Promise.resolve(this._getFsProvider(p).readFile(w.URI.revive(l))).then(h=>I.VSBuffer.wrap(h))}$writeFile(p,l,h,_){return Promise.resolve(this._getFsProvider(p).writeFile(w.URI.revive(l),h.buffer,_))}$delete(p,l,h){return Promise.resolve(this._getFsProvider(p).delete(w.URI.revive(l),h))}$rename(p,l,h,_){return Promise.resolve(this._getFsProvider(p).rename(w.URI.revive(l),w.URI.revive(h),_))}$copy(p,l,h,_){const v=this._getFsProvider(p);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(w.URI.revive(l),w.URI.revive(h),_))}$mkdir(p,l){return Promise.resolve(this._getFsProvider(p).createDirectory(w.URI.revive(l)))}$watch(p,l,h,_){const v=this._getFsProvider(p).watch(w.URI.revive(h),_);this._watches.set(l,v)}$unwatch(p,l){const h=this._watches.get(l);h&&(h.dispose(),this._watches.delete(l))}$open(p,l,h){const _=this._getFsProvider(p);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(w.URI.revive(l),h))}$close(p,l){const h=this._getFsProvider(p);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(l))}$read(p,l,h,_){const v=this._getFsProvider(p);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const S=I.VSBuffer.alloc(_);return Promise.resolve(v.read(l,h,S.buffer,0,_)).then(d=>S.slice(0,d))}$write(p,l,h,_){const v=this._getFsProvider(p);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(l,h,_.buffer,0,_.byteLength))}_getFsProvider(p){const l=this._fsProvider.get(p);if(!l){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return l}}e.ExtHostFileSystem=P}),define(ge[89],pe([0,1,5,43,7,23,4,15,62]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Ut{constructor(P,c){const p=P.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return p.$stat(l).catch(Ut._handleError)},readDirectory(l){return p.$readdir(l).catch(Ut._handleError)},createDirectory(l){return p.$mkdir(l).catch(Ut._handleError)},async readFile(l){return p.$readFile(l).then(h=>h.buffer).catch(Ut._handleError)},writeFile(l,h){return p.$writeFile(l,A.VSBuffer.wrap(h)).catch(Ut._handleError)},delete(l,h){return p.$delete(l,Object.assign({recursive:!1,useTrash:!1},h)).catch(Ut._handleError)},rename(l,h,_){return p.$rename(l,h,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},copy(l,h,_){return p.$copy(l,h,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},isWritableFileSystem(l){const h=c.getCapabilities(l);if(typeof h=="number")return!(h&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new C.FileSystemError(String(P));if(P.name==="ENOPRO")throw C.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(P.message);default:throw new C.FileSystemError(P.message,P.name)}}};I=Ve([He(0,k.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=y.createDecorator("IExtHostConsumerFileSystem")}),define(ge[233],pe([0,1,6,5]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(y){this._handlePool=0,this._proxy=y.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),w.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=C}),define(ge[234],pe([0,1,2,25,20,7,13,5,8,42,17,12,141,6,108,73,85,44,16,3]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(q,J){this._documents=q,this._provider=J}provideDocumentSymbols(q,J){const re=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideDocumentSymbols(re,J)).then(ae=>{if(!s.isFalsyOrEmpty(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(C.DocumentSymbol.from):f._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(q){var J;q=q.slice(0).sort((Y,ce)=>{let ve=Y.location.range.start.compareTo(ce.location.range.start);return ve===0&&(ve=ce.location.range.end.compareTo(Y.location.range.end)),ve});const re=[],ae=[];for(const Y of q){const ce={name:Y.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Y.kind),tags:((J=Y.tags)===null||J===void 0?void 0:J.map(C.SymbolTag.from))||[],detail:"",containerName:Y.containerName,range:C.Range.from(Y.location.range),selectionRange:C.Range.from(Y.location.range),children:[]};for(;;){if(ae.length===0){ae.push(ce),re.push(ce);break}const ve=ae[ae.length-1];if(I.Range.containsRange(ve.range,ce.range)&&!I.Range.equalsRange(ve.range,ce.range)){ve.children&&ve.children.push(ce),ae.push(ce);break}ae.pop()}}return re}}class u{constructor(q,J,re){this._documents=q,this._commands=J,this._provider=re,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,J){const re=this._documents.getDocument(q),ae=await this._provider.provideCodeLenses(re,J);if(!ae||J.isCancellationRequested)return;const Y=this._cache.add(ae),ce=new p.DisposableStore;this._disposables.set(Y,ce);const ve={cacheId:Y,lenses:[]};for(let Re=0;Re<ae.length;Re++)ve.lenses.push({cacheId:[Y,Re],range:C.Range.from(ae[Re].range),command:this._commands.toInternal(ae[Re].command,ce)});return ve}async resolveCodeLens(q,J){var re;const ae=q.cacheId&&this._cache.get(...q.cacheId);if(!ae)return;let Y;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?Y=ae:Y=await this._provider.resolveCodeLens(ae,J),Y||(Y=ae),J.isCancellationRequested)return;const ce=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!ce)return q.command=this._commands.toInternal((re=Y.command)!==null&&re!==void 0?re:u._badCmd,ce),q}releaseCodeLenses(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ke){return Array.isArray(Ke)?Ke.map(C.DefinitionLink.from):Ke?[C.DefinitionLink.from(Ke)]:[]}class n{constructor(q,J){this._documents=q,this._provider=J}provideDefinition(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideDefinition(ae,Y,re)).then(t)}}class i{constructor(q,J){this._documents=q,this._provider=J}provideDeclaration(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideDeclaration(ae,Y,re)).then(t)}}class r{constructor(q,J){this._documents=q,this._provider=J}provideImplementation(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideImplementation(ae,Y,re)).then(t)}}class o{constructor(q,J){this._documents=q,this._provider=J}provideTypeDefinition(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideTypeDefinition(ae,Y,re)).then(t)}}class m{constructor(q,J){this._documents=q,this._provider=J}provideHover(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideHover(ae,Y,re)).then(ce=>{if(!(!ce||s.isFalsyOrEmpty(ce.contents)))return ce.range||(ce.range=ae.getWordRangeAtPosition(Y)),ce.range||(ce.range=new A.Range(Y,Y)),C.Hover.from(ce)})}}class g{constructor(q,J){this._documents=q,this._provider=J}provideEvaluatableExpression(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideEvaluatableExpression(ae,Y,re)).then(ce=>{if(ce)return C.EvaluatableExpression.from(ce)})}}class E{constructor(q,J){this._documents=q,this._provider=J}provideInlineValues(q,J,re,ae){const Y=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideInlineValues(Y,C.Range.to(J),C.InlineValueContext.to(re),ae)).then(ce=>{if(Array.isArray(ce))return ce.map(ve=>C.InlineValue.from(ve))})}}class b{constructor(q,J){this._documents=q,this._provider=J}provideDocumentHighlights(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideDocumentHighlights(ae,Y,re)).then(ce=>{if(Array.isArray(ce))return ce.map(C.DocumentHighlight.from)})}}class a{constructor(q,J){this._documents=q,this._provider=J}provideLinkedEditingRanges(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.provideLinkedEditingRanges(ae,Y,re)).then(ce=>{if(ce&&Array.isArray(ce.ranges))return{ranges:s.coalesce(ce.ranges.map(C.Range.from)),wordPattern:ce.wordPattern}})}}class L{constructor(q,J){this._documents=q,this._provider=J}provideReferences(q,J,re,ae){const Y=this._documents.getDocument(q),ce=C.Position.to(J);return y.asPromise(()=>this._provider.provideReferences(Y,ce,re,ae)).then(ve=>{if(Array.isArray(ve))return ve.map(C.location.from)})}}class O{constructor(q,J,re,ae,Y,ce,ve){this._documents=q,this._commands=J,this._diagnostics=re,this._provider=ae,this._logService=Y,this._extension=ce,this._apiDeprecation=ve,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(q,J,re,ae){const Y=this._documents.getDocument(q),ce=c.Selection.isISelection(J)?C.Selection.to(J):C.Range.to(J),ve=[];for(const we of this._diagnostics.getDiagnostics(q))if(ce.intersection(we.range)&&ve.push(we)>O._maxCodeActionsPerFile)break;const Re={diagnostics:ve,only:re.only?new A.CodeActionKind(re.only):void 0,triggerKind:C.CodeActionTriggerKind.to(re.trigger)};return y.asPromise(()=>this._provider.provideCodeActions(Y,ce,Re,ae)).then(we=>{var je;if(!s.isNonEmptyArray(we)||ae.isCancellationRequested)return;const K=this._cache.add(we),ie=new p.DisposableStore;this._disposables.set(K,ie);const Ee=[];for(let Ne=0;Ne<we.length;Ne++){const $e=we[Ne];!$e||(O._isCommand($e)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ee.push({_isSynthetic:!0,title:$e.title,command:this._commands.toInternal($e,ie)})):(Re.only&&($e.kind?Re.only.contains($e.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${$e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ee.push({cacheId:[K,Ne],title:$e.title,command:$e.command&&this._commands.toInternal($e.command,ie),diagnostics:$e.diagnostics&&$e.diagnostics.map(C.Diagnostic.from),edit:$e.edit&&C.WorkspaceEdit.from($e.edit),kind:$e.kind&&$e.kind.value,isPreferred:$e.isPreferred,disabled:(je=$e.disabled)===null||je===void 0?void 0:je.reason})))}return{cacheId:K,actions:Ee}})}async resolveCodeAction(q,J){var re;const[ae,Y]=q,ce=this._cache.get(ae,Y);if(!ce||O._isCommand(ce)||!this._provider.resolveCodeAction)return;const ve=(re=await this._provider.resolveCodeAction(ce,J))!==null&&re!==void 0?re:ce;return(ve==null?void 0:ve.edit)?C.WorkspaceEdit.from(ve.edit):void 0}releaseCodeActions(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}O._maxCodeActionsPerFile=1e3;class W{constructor(q,J){this._documents=q,this._provider=J}provideDocumentFormattingEdits(q,J,re){const ae=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideDocumentFormattingEdits(ae,J,re)).then(Y=>{if(Array.isArray(Y))return Y.map(C.TextEdit.from)})}}class ee{constructor(q,J){this._documents=q,this._provider=J}provideDocumentRangeFormattingEdits(q,J,re,ae){const Y=this._documents.getDocument(q),ce=C.Range.to(J);return y.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(Y,ce,re,ae)).then(ve=>{if(Array.isArray(ve))return ve.map(C.TextEdit.from)})}}class oe{constructor(q,J){this._documents=q,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(q,J,re,ae,Y){const ce=this._documents.getDocument(q),ve=C.Position.to(J);return y.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ce,ve,re,ae,Y)).then(Re=>{if(Array.isArray(Re))return Re.map(C.TextEdit.from)})}}class V{constructor(q,J){this._provider=q,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(q,J){const re=k.IdObject.mixin({symbols:[]});return y.asPromise(()=>this._provider.provideWorkspaceSymbols(q,J)).then(ae=>{if(s.isNonEmptyArray(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ce=k.IdObject.mixin(C.WorkspaceSymbol.from(Y));this._symbolCache.set(ce._id,Y),re.symbols.push(ce)}}).then(()=>(re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re))}async resolveWorkspaceSymbol(q,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const ae=await y.asPromise(()=>this._provider.resolveWorkspaceSymbol(re,J));return ae&&R.mixin(q,C.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(q){const J=this._resultCache.get(q);if(J){for(let[re,ae]=J;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class B{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}provideRenameEdits(q,J,re,ae){const Y=this._documents.getDocument(q),ce=C.Position.to(J);return y.asPromise(()=>this._provider.provideRenameEdits(Y,ce,re,ae)).then(ve=>{if(!!ve)return C.WorkspaceEdit.from(ve)},ve=>{const Re=B._asMessage(ve);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(ve)})}resolveRenameLocation(q,J,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(q),Y=C.Position.to(J);return y.asPromise(()=>this._provider.prepareRename(ae,Y,re)).then(ce=>{let ve,Re;if(A.Range.isRange(ce)?(ve=ce,Re=ae.getText(ce)):P.isObject(ce)&&(ve=ce.range,Re=ce.placeholder),!!ve){if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ve),text:Re}}},ce=>{const ve=B._asMessage(ce);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ce)})}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class j{constructor(q,J){this.resultId=q,this.tokens=J}}class T{constructor(q,J){this._documents=q,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(q,J,re){const ae=this._documents.getDocument(q),Y=J!==0?this._previousResults.get(J):null;return y.asPromise(()=>Y&&typeof Y.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,re):this._provider.provideDocumentSemanticTokens(ae,re)).then(ce=>(Y&&this._previousResults.delete(J),ce?(ce=T._fixProvidedSemanticTokens(ce),this._send(T._convertToEdits(Y,ce),ce)):null))}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return T._isSemanticTokens(q)?T._isCorrectSemanticTokens(q)?q:new A.SemanticTokens(new Uint32Array(q.data),q.resultId):T._isSemanticTokensEdits(q)?T._isCorrectSemanticTokensEdits(q)?q:new A.SemanticTokensEdits(q.edits.map(J=>new A.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const J of q.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,J){if(!T._isSemanticTokens(J)||!q||!q.tokens)return J;const re=q.tokens,ae=re.length,Y=J.data,ce=Y.length;let ve=0;const Re=Math.min(ae,ce);for(;ve<Re&&re[ve]===Y[ve];)ve++;if(ve===ae&&ve===ce)return new A.SemanticTokensEdits([],J.resultId);let we=0;const je=Re-ve;for(;we<je&&re[ae-we-1]===Y[ce-we-1];)we++;return new A.SemanticTokensEdits([{start:ve,deleteCount:ae-ve-we,data:Y.subarray(ve,ce-we)}],J.resultId)}_send(q,J){if(T._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new j(q.resultId,q.data)),l.encodeSemanticTokensDto({id:re,type:"full",data:q.data})}if(T._isSemanticTokensEdits(q)){const re=this._nextResultId++;return T._isSemanticTokens(J)?this._previousResults.set(re,new j(J.resultId,J.data)):this._previousResults.set(re,new j(q.resultId)),l.encodeSemanticTokensDto({id:re,type:"delta",deltas:(q.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=T;class N{constructor(q,J){this._documents=q,this._provider=J}provideDocumentRangeSemanticTokens(q,J,re){const ae=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(ae,C.Range.to(J),re)).then(Y=>Y?this._send(Y):null)}_send(q){return l.encodeSemanticTokensDto({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=N;class F{constructor(q,J,re,ae,Y){this._documents=q,this._commands=J,this._provider=re,this._apiDeprecation=ae,this._extension=Y,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,J,re,ae){const Y=this._documents.getDocument(q),ce=C.Position.to(J),ve=Y.getWordRangeAtPosition(ce)||new A.Range(ce,ce),Re=ve.with({end:ce}),we=new v.StopWatch(!0),je=await y.asPromise(()=>this._provider.provideCompletionItems(Y,ce,ae,C.CompletionContext.to(re)));if(!je||ae.isCancellationRequested)return;const K=Array.isArray(je)?new A.CompletionList(je):je,ie=F.supportsResolving(this._provider)?this._cache.add(K.items):this._cache.add([]),Ee=new p.DisposableStore;this._disposables.set(ie,Ee);const Ne=[],$e={x:ie,b:Ne,a:{replace:C.Range.from(ve),insert:C.Range.from(Re)},c:K.isIncomplete||void 0,d:we.elapsed()};for(let We=0;We<K.items.length;We++){const Xe=K.items[We],De=this._convertCompletionItem(Xe,[ie,We],Re,ve);Ne.push(De)}return $e}async resolveCompletionItem(q,J){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const ae=await y.asPromise(()=>this._provider.resolveCompletionItem(re,J));if(!!ae)return this._convertCompletionItem(ae,q)}releaseCompletionItems(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,J,re,ae){var Y;const ce=this._disposables.get(J[0]);if(!ce)throw Error("DisposableStore is missing...");const ve={x:J,a:(Y=q.label)!==null&&Y!==void 0?Y:"",o:q.label2,b:q.kind!==void 0?C.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(C.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(q.command,ce)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ve.h=q.textEdit.newText):typeof q.insertText=="string"?ve.h=q.insertText:q.insertText instanceof A.SnippetString&&(ve.h=q.insertText.value,ve.i|=4);let Re;return q.textEdit?Re=q.textEdit.range:q.range&&(Re=q.range),A.Range.isRange(Re)?ve.j=C.Range.from(Re):Re&&(!(re==null?void 0:re.isEqual(Re.inserting))||!(ae==null?void 0:ae.isEqual(Re.replacing)))&&(ve.j={insert:C.Range.from(Re.inserting),replace:C.Range.from(Re.replacing)}),ve}}class M{constructor(q,J,re){this._documents=q,this._provider=J,this._commands=re,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,J,re,ae){const Y=this._documents.getDocument(q),ce=C.Position.to(J),ve=await y.asPromise(()=>this._provider.provideInlineCompletionItems(Y,ce,re,ae));if(!ve||ae.isCancellationRequested)return;const Re=this._cache.add(ve.items);let we;return{pid:Re,items:ve.items.map((je,K)=>{let ie;return je.command&&(we||(we=new p.DisposableStore,this._disposables.set(Re,we)),ie=this._commands.toInternal(je.command,we)),{text:je.text,range:je.range?C.Range.from(je.range):void 0,command:ie,idx:K}})}}disposeCompletions(q){this._cache.delete(q);const J=this._disposables.get(q);J&&J.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,J){const re=this._cache.get(q,J);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new d.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let J=U.map.get(q);return J||(J=new U,U.map.set(q,J)),J}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=U,U.map=new WeakMap;class x{constructor(q,J){this._documents=q,this._provider=J,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(q,J,re,ae){const Y=this._documents.getDocument(q),ce=C.Position.to(J),ve=this.reviveContext(re);return y.asPromise(()=>this._provider.provideSignatureHelp(Y,ce,ae,ve)).then(Re=>{if(Re){const we=this._cache.add([Re]);return Object.assign(Object.assign({},C.SignatureHelp.from(Re)),{id:we})}})}reviveContext(q){let J;if(q.activeSignatureHelp){const re=C.SignatureHelp.to(q.activeSignatureHelp),ae=this._cache.get(q.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=re.activeSignature,J.activeParameter=re.activeParameter):J=re}return Object.assign(Object.assign({},q),{activeSignatureHelp:J})}releaseSignatureHelp(q){this._cache.delete(q)}}class G{constructor(q,J){this._documents=q,this._provider=J}provideInlayHints(q,J,re){const ae=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideInlayHints(ae,C.Range.to(J),re)).then(Y=>Y?{hints:Y.map(C.InlayHint.from)}:void 0)}}class se{constructor(q,J){this._documents=q,this._provider=J,this._cache=new _.Cache("DocumentLink")}provideLinks(q,J){const re=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideDocumentLinks(re,J)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(C.DocumentLink.from)};{const Y=this._cache.add(ae),ce={links:[],id:Y};for(let ve=0;ve<ae.length;ve++){const Re=C.DocumentLink.from(ae[ve]);Re.cacheId=[Y,ve],ce.links.push(Re)}return ce}}})}resolveLink(q,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const re=this._cache.get(...q);return re?y.asPromise(()=>this._provider.resolveDocumentLink(re,J)).then(ae=>ae&&C.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(q){this._cache.delete(q)}}class be{constructor(q,J){this._documents=q,this._provider=J}provideColors(q,J){const re=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideDocumentColors(re,J)).then(ae=>Array.isArray(ae)?ae.map(ce=>({color:C.Color.from(ce.color),range:C.Range.from(ce.range)})):[])}provideColorPresentations(q,J,re){const ae=this._documents.getDocument(q),Y=C.Range.to(J.range),ce=C.Color.to(J.color);return y.asPromise(()=>this._provider.provideColorPresentations(ce,{document:ae,range:Y},re)).then(ve=>{if(!!Array.isArray(ve))return ve.map(C.ColorPresentation.from)})}}class Te{constructor(q,J){this._documents=q,this._provider=J}provideFoldingRanges(q,J,re){const ae=this._documents.getDocument(q);return y.asPromise(()=>this._provider.provideFoldingRanges(ae,J,re)).then(Y=>{if(!!Array.isArray(Y))return Y.map(C.FoldingRange.from)})}}class Ce{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}provideSelectionRanges(q,J,re){const ae=this._documents.getDocument(q),Y=J.map(C.Position.to);return y.asPromise(()=>this._provider.provideSelectionRanges(ae,Y,re)).then(ce=>{if(!s.isNonEmptyArray(ce))return[];if(ce.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Re=0;Re<Y.length;Re++){const we=[];ve.push(we);let je=Y[Re],K=ce[Re];for(;;){if(!K.range.contains(je))throw new Error("INVALID selection range, must contain the previous range");if(we.push(C.SelectionRange.from(K)),!K.parent)break;je=K.range,K=K.parent}}return ve})}}class Me{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,re){const ae=this._documents.getDocument(q),Y=C.Position.to(J),ce=await this._provider.prepareCallHierarchy(ae,Y,re);if(!ce)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ce)?ce.map(Re=>this._cacheAndConvertItem(ve,Re)):[this._cacheAndConvertItem(ve,ce)]}async provideCallsTo(q,J,re){const ae=this._itemFromCache(q,J);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!Y)return Y.map(ce=>({from:this._cacheAndConvertItem(q,ce.from),fromRanges:ce.fromRanges.map(ve=>C.Range.from(ve))}))}async provideCallsFrom(q,J,re){const ae=this._itemFromCache(q,J);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!Y)return Y.map(ce=>({to:this._cacheAndConvertItem(q,ce.to),fromRanges:ce.fromRanges.map(ve=>C.Range.from(ve))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){var re;const ae=this._cache.get(q),Y={_sessionId:q,_itemId:ae.size.toString(36),name:J.name,detail:J.detail,kind:C.SymbolKind.from(J.kind),uri:J.uri,range:C.Range.from(J.range),selectionRange:C.Range.from(J.selectionRange),tags:(re=J.tags)===null||re===void 0?void 0:re.map(C.SymbolTag.from)};return ae.set(Y._itemId,J),Y}_itemFromCache(q,J){const re=this._cache.get(q);return re==null?void 0:re.get(J)}}class qe{constructor(q,J){this.adapter=q,this.extension=J}}class ze{constructor(q,J,re,ae,Y,ce,ve){this._adapter=new Map,this._uriTransformer=J,this._proxy=q.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=Y,this._logService=ce,this._apiDeprecation=ve}_transformDocumentSelector(q){return s.coalesce(s.asArray(q).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(q){if(typeof q=="string")return{$serialized:!0,language:q};if(q)return{$serialized:!0,language:q.language,scheme:this._transformScheme(q.scheme),pattern:typeof q.pattern=="undefined"?void 0:C.GlobPattern.from(q.pattern),exclusive:q.exclusive}}_transformScheme(q){return this._uriTransformer&&typeof q=="string"?this._uriTransformer.transformOutgoingScheme(q):q}_createDisposable(q){return new A.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return ze._handlePool++}_withAdapter(q,J,re,ae,Y=!1){const ce=this._adapter.get(q);if(!ce)return Promise.resolve(ae);if(ce.adapter instanceof J){let ve;ce.extension&&(ve=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const Re=re(ce.adapter,ce.extension),we=ce.extension;return we&&Promise.resolve(Re).then(()=>this._logService.trace(`[${we.identifier.value}] provider DONE after ${Date.now()-ve}ms`),je=>{Y&&je instanceof S.CancellationError||(this._logService.error(`[${we.identifier.value}] provider FAILED`),this._logService.error(je))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,J){const re=this._nextHandle();return this._adapter.set(re,new qe(q,J)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,J,re,ae){const Y=this._addNewAdapter(new f(this._documents,re),q),ce=ae&&ae.label||ze._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(J),ce),this._createDisposable(Y)}$provideDocumentSymbols(q,J,re){return this._withAdapter(q,f,ae=>ae.provideDocumentSymbols(w.URI.revive(J),re),void 0)}registerCodeLensProvider(q,J,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new u(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(J),Y);let ce=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(Y));ce=A.Disposable.from(ce,ve)}return ce}$provideCodeLenses(q,J,re){return this._withAdapter(q,u,ae=>ae.provideCodeLenses(w.URI.revive(J),re),void 0)}$resolveCodeLens(q,J,re){return this._withAdapter(q,u,ae=>ae.resolveCodeLens(J,re),void 0)}$releaseCodeLenses(q,J){this._withAdapter(q,u,re=>Promise.resolve(re.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(q,J,re){const ae=this._addNewAdapter(new n(this._documents,re),q);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDefinition(q,J,re,ae){return this._withAdapter(q,n,Y=>Y.provideDefinition(w.URI.revive(J),re,ae),[])}registerDeclarationProvider(q,J,re){const ae=this._addNewAdapter(new i(this._documents,re),q);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDeclaration(q,J,re,ae){return this._withAdapter(q,i,Y=>Y.provideDeclaration(w.URI.revive(J),re,ae),[])}registerImplementationProvider(q,J,re){const ae=this._addNewAdapter(new r(this._documents,re),q);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideImplementation(q,J,re,ae){return this._withAdapter(q,r,Y=>Y.provideImplementation(w.URI.revive(J),re,ae),[])}registerTypeDefinitionProvider(q,J,re){const ae=this._addNewAdapter(new o(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideTypeDefinition(q,J,re,ae){return this._withAdapter(q,o,Y=>Y.provideTypeDefinition(w.URI.revive(J),re,ae),[])}registerHoverProvider(q,J,re,ae){const Y=this._addNewAdapter(new m(this._documents,re),q);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideHover(q,J,re,ae){return this._withAdapter(q,m,Y=>Y.provideHover(w.URI.revive(J),re,ae),void 0)}registerEvaluatableExpressionProvider(q,J,re,ae){const Y=this._addNewAdapter(new g(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideEvaluatableExpression(q,J,re,ae){return this._withAdapter(q,g,Y=>Y.provideEvaluatableExpression(w.URI.revive(J),re,ae),void 0)}registerInlineValuesProvider(q,J,re,ae){const Y=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new E(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(J),Y);let ve=this._createDisposable(ce);if(Y!==void 0){const Re=re.onDidChangeInlineValues(we=>this._proxy.$emitInlineValuesEvent(Y));ve=A.Disposable.from(ve,Re)}return ve}$provideInlineValues(q,J,re,ae,Y){return this._withAdapter(q,E,ce=>ce.provideInlineValues(w.URI.revive(J),re,ae,Y),void 0)}registerDocumentHighlightProvider(q,J,re){const ae=this._addNewAdapter(new b(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentHighlights(q,J,re,ae){return this._withAdapter(q,b,Y=>Y.provideDocumentHighlights(w.URI.revive(J),re,ae),void 0)}registerLinkedEditingRangeProvider(q,J,re){const ae=this._addNewAdapter(new a(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideLinkedEditingRanges(q,J,re,ae){return this._withAdapter(q,a,async Y=>{const ce=await Y.provideLinkedEditingRanges(w.URI.revive(J),re,ae);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ze._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(q,J,re){const ae=this._addNewAdapter(new L(this._documents,re),q);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideReferences(q,J,re,ae,Y){return this._withAdapter(q,L,ce=>ce.provideReferences(w.URI.revive(J),re,ae,Y),void 0)}registerCodeActionProvider(q,J,re,ae){var Y,ce;const ve=new p.DisposableStore,Re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(Re,this._transformDocumentSelector(J),{providedKinds:(Y=ae==null?void 0:ae.providedCodeActionKinds)===null||Y===void 0?void 0:Y.map(we=>we.value),documentation:(ce=ae==null?void 0:ae.documentation)===null||ce===void 0?void 0:ce.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,ve)}))},ze._extLabel(q),Boolean(re.resolveCodeAction)),ve.add(this._createDisposable(Re)),ve}$provideCodeActions(q,J,re,ae,Y){return this._withAdapter(q,O,ce=>ce.provideCodeActions(w.URI.revive(J),re,ae,Y),void 0)}$resolveCodeAction(q,J,re){return this._withAdapter(q,O,ae=>ae.resolveCodeAction(J,re),void 0)}$releaseCodeActions(q,J){this._withAdapter(q,O,re=>Promise.resolve(re.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(q,J,re){const ae=this._addNewAdapter(new W(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(q,J,re,ae){return this._withAdapter(q,W,Y=>Y.provideDocumentFormattingEdits(w.URI.revive(J),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(q,J,re){const ae=this._addNewAdapter(new ee(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(q,J,re,ae,Y){return this._withAdapter(q,ee,ce=>ce.provideDocumentRangeFormattingEdits(w.URI.revive(J),re,ae,Y),void 0)}registerOnTypeFormattingEditProvider(q,J,re,ae){const Y=this._addNewAdapter(new oe(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(J),ae,q.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(q,J,re,ae,Y,ce){return this._withAdapter(q,oe,ve=>ve.provideOnTypeFormattingEdits(w.URI.revive(J),re,ae,Y,ce),void 0)}registerWorkspaceSymbolProvider(q,J){const re=this._addNewAdapter(new V(J,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(q,J,re){return this._withAdapter(q,V,ae=>ae.provideWorkspaceSymbols(J,re),{symbols:[]})}$resolveWorkspaceSymbol(q,J,re){return this._withAdapter(q,V,ae=>ae.resolveWorkspaceSymbol(J,re),void 0)}$releaseWorkspaceSymbols(q,J){this._withAdapter(q,V,re=>re.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(q,J,re){const ae=this._addNewAdapter(new B(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(J),B.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(q,J,re,ae,Y){return this._withAdapter(q,B,ce=>ce.provideRenameEdits(w.URI.revive(J),re,ae,Y),void 0)}$resolveRenameLocation(q,J,re,ae){return this._withAdapter(q,B,Y=>Y.resolveRenameLocation(w.URI.revive(J),re,ae),void 0)}registerDocumentSemanticTokensProvider(q,J,re,ae){const Y=this._nextHandle(),ce=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new qe(new T(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(J),ae,ce);let ve=this._createDisposable(Y);if(ce){const Re=re.onDidChangeSemanticTokens(we=>this._proxy.$emitDocumentSemanticTokensEvent(ce));ve=A.Disposable.from(ve,Re)}return ve}$provideDocumentSemanticTokens(q,J,re,ae){return this._withAdapter(q,T,Y=>Y.provideDocumentSemanticTokens(w.URI.revive(J),re,ae),null,!0)}$releaseDocumentSemanticTokens(q,J){this._withAdapter(q,T,re=>re.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(q,J,re,ae){const Y=this._addNewAdapter(new N(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(J),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(q,J,re,ae){return this._withAdapter(q,N,Y=>Y.provideDocumentRangeSemanticTokens(w.URI.revive(J),re,ae),null,!0)}registerCompletionItemProvider(q,J,re,ae){const Y=this._addNewAdapter(new F(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(J),ae,F.supportsResolving(re),`${q.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(q,J,re,ae,Y){return this._withAdapter(q,F,ce=>ce.provideCompletionItems(w.URI.revive(J),re,ae,Y),void 0)}$resolveCompletionItem(q,J,re){return this._withAdapter(q,F,ae=>ae.resolveCompletionItem(J,re),void 0)}$releaseCompletionItems(q,J){this._withAdapter(q,F,re=>re.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(q,J,re){const ae=this._addNewAdapter(new M(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideInlineCompletions(q,J,re,ae,Y){return this._withAdapter(q,M,ce=>ce.provideInlineCompletions(w.URI.revive(J),re,ae,Y),void 0)}$handleInlineCompletionDidShow(q,J,re){this._withAdapter(q,M,async ae=>{ae.handleDidShowCompletionItem(J,re)},void 0)}$freeInlineCompletionsList(q,J){this._withAdapter(q,M,async re=>{re.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(q,J,re,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,ce=this._addNewAdapter(new x(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(J),Y),this._createDisposable(ce)}$provideSignatureHelp(q,J,re,ae,Y){return this._withAdapter(q,x,ce=>ce.provideSignatureHelp(w.URI.revive(J),re,ae,Y),void 0)}$releaseSignatureHelp(q,J){this._withAdapter(q,x,re=>re.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(q,J,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new G(this._documents,re),q);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(J),ae);let ce=this._createDisposable(Y);if(ae!==void 0){const ve=re.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(ae));ce=A.Disposable.from(ce,ve)}return ce}$provideInlayHints(q,J,re,ae){return this._withAdapter(q,G,Y=>Y.provideInlayHints(w.URI.revive(J),re,ae),void 0)}registerDocumentLinkProvider(q,J,re){const ae=this._addNewAdapter(new se(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(J),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(q,J,re){return this._withAdapter(q,se,ae=>ae.provideLinks(w.URI.revive(J),re),void 0)}$resolveDocumentLink(q,J,re){return this._withAdapter(q,se,ae=>ae.resolveLink(J,re),void 0)}$releaseDocumentLinks(q,J){this._withAdapter(q,se,re=>re.releaseLinks(J),void 0)}registerColorProvider(q,J,re){const ae=this._addNewAdapter(new be(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentColors(q,J,re){return this._withAdapter(q,be,ae=>ae.provideColors(w.URI.revive(J),re),[])}$provideColorPresentations(q,J,re,ae){return this._withAdapter(q,be,Y=>Y.provideColorPresentations(w.URI.revive(J),re,ae),void 0)}registerFoldingRangeProvider(q,J,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new Te(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(J),Y);let ce=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ce=A.Disposable.from(ce,ve)}return ce}$provideFoldingRanges(q,J,re,ae){return this._withAdapter(q,Te,Y=>Y.provideFoldingRanges(w.URI.revive(J),re,ae),void 0)}registerSelectionRangeProvider(q,J,re){const ae=this._addNewAdapter(new Ce(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideSelectionRanges(q,J,re,ae){return this._withAdapter(q,Ce,Y=>Y.provideSelectionRanges(w.URI.revive(J),re,ae),[])}registerCallHierarchyProvider(q,J,re){const ae=this._addNewAdapter(new Me(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$prepareCallHierarchy(q,J,re,ae){return this._withAdapter(q,Me,Y=>Promise.resolve(Y.prepareSession(w.URI.revive(J),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(q,J,re,ae){return this._withAdapter(q,Me,Y=>Y.provideCallsTo(J,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(q,J,re,ae){return this._withAdapter(q,Me,Y=>Y.provideCallsFrom(J,re,ae),void 0)}$releaseCallHierarchy(q,J){this._withAdapter(q,Me,re=>Promise.resolve(re.releaseSession(J)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:D.regExpFlags(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:ze._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?ze._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?ze._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:ze._serializeRegExp(q.beforeText),afterText:q.afterText?ze._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?ze._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(ze._serializeOnEnterRule)}setLanguageConfiguration(q,J,re){let{wordPattern:ae}=re;if(ae&&D.regExpLeadsToEndlessLoop(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(J,ae):this._documents.setWordDefinitionFor(J,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const Y=this._nextHandle(),ce={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?ze._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?ze._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?ze._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,J,ce),this._createDisposable(Y)}$setWordDefinitions(q){for(const J of q)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(ge[235],pe([0,1,5,20,7]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(k,D){this._proxy=k.getProxy(w.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,D){await this._proxy.$changeLanguage(k,D);const I=this._documents.getDocumentData(k);if(!I)throw new Error(`document '${k.toString}' NOT found`);return I.document}async tokenAtPosition(k,D){var I;const s=k.version,P=R.Position.from(D),c=await this._proxy.$tokensAtPosition(k.uri,P),p={type:C.StandardTokenType.Other,range:(I=k.getWordRangeAtPosition(D))!==null&&I!==void 0?I:new C.Range(D.line,D.character,D.line,D.character)};if(!c)return p;const l={range:R.Range.to(c.range),type:R.TokenType.to(c.type)};return!l.range.contains(D)||s!==k.version?p:l}}e.ExtHostLanguages=A}),define(ge[236],pe([0,1,5,14,39]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let y=class{constructor(D,I){this._logService=I,this._proxy=D.getProxy(w.MainContext.MainThreadMessageService)}showMessage(D,I,s,P,c){const p={extension:D};let l;typeof P=="string"||A(P)?l=[P,...c]:(p.modal=P&&P.modal,p.useCustom=P&&P.useCustom,l=c),p.useCustom&&C.checkProposedApiEnabled(D);const h=[];for(let _=0;_<l.length;_++){const v=l[_];if(typeof v=="string")h.push({title:v,handle:_,isCloseAffordance:!1});else if(typeof v=="object"){let{title:S,isCloseAffordance:d}=v;h.push({title:S,isCloseAffordance:!!d,handle:_})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(I,s,p,h).then(_=>{if(typeof _=="number")return l[_]})}};y=Ve([He(1,R.ILogService)],y),e.ExtHostMessageService=y}),define(ge[237],pe([0,1,23,3,75,73,6,22,8,12,2,85,5,20,7,64,214,124]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class S{constructor(u,t){const n=S._Keys.nextId();u.$registerNotebookEditorDecorationType(n,p.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){u.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=S,S._Keys=new A.IdGenerator("NotebookEditorDecorationType");class d{constructor(u,t,n,i,r,o){this._textDocumentsAndEditors=n,this._textDocuments=i,this.logService=r,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=u.getProxy(c.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(c.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(c.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:m=>{var g;if(m&&m.$mid===12){const E=(g=m.notebookEditor)===null||g===void 0?void 0:g.notebookUri,b=m.cell.handle,a=this._documents.get(E),L=a==null?void 0:a.getCell(b);if(L)return L.apiCell}return m}})}get activeNotebookEditor(){var u;return(u=this._activeNotebookEditor)===null||u===void 0?void 0:u.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}getEditorById(u){return this._editors.get(u)}getIdByEditor(u){for(const[t,n]of this._editors)if(n.apiEditor===u)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,t){const n=this._documents.get(u);if(!n&&!t)throw new Error(`NO notebook document for '${u}'`);return n}_getProviderData(u){const t=this._notebookContentProviders.get(u);if(!t)throw new Error(`NO provider for '${u}'`);return t}registerNotebookContentProvider(u,t,n,i,r){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:u,provider:n});let o;return n.onDidChangeNotebookContentOptions&&(o=n.onDidChangeNotebookContentOptions(()=>{const m=p.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,m)})),this._notebookProxy.$registerNotebookProvider({id:u.identifier,location:u.extensionLocation},t,p.NotebookDocumentContentOptions.from(i),d._convertNotebookRegistrationData(u,r)),new l.Disposable(()=>{o==null||o.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(u,t){if(!t)return;const n=t.filenamePattern.map(i=>p.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,t,n){const i=d._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,r,t);let o;return r!==void 0&&(o=n.onDidChangeCellStatusBarItems(m=>this._notebookProxy.$emitCellStatusBarEvent(r))),new l.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,r),o&&o.dispose()})}createNotebookEditorDecorationType(u){return new S(this._notebookEditorsProxy,u).value}async createNotebookDocument(u){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&p.NotebookData.from(u.content)});return s.URI.revive(t)}async openNotebookDocument(u){const t=this._documents.get(u);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(u),i=this._documents.get(s.URI.revive(n));return I.assertIsDefined(i==null?void 0:i.apiNotebook)}async showNotebookDocument(u,t){var n;s.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let i;typeof t=="object"?i={position:p.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(p.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:i={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.viewType,i),o=r&&((n=this._editors.get(r))===null||n===void 0?void 0:n.apiEditor);if(o)return o;throw r?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,t,n,i){var r;const o=this._notebookStatusBarItemProviders.get(u),m=s.URI.revive(t),g=this._documents.get(m);if(!g||!o)return;const E=g.getCellFromIndex(n);if(!E)return;const b=await o.provideCellStatusBarItems(E.apiCell,i);if(!b)return;const a=new y.DisposableStore,L=this._statusBarCache.add([a]),O=(r=b&&b.map(W=>p.NotebookStatusBarItem.from(W,this._commandsConverter,a)))!==null&&r!==void 0?r:void 0;return{cacheId:L,items:O}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,t,n,i,r){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,n),this._notebookProxy.$registerNotebookSerializer(o,{id:u.identifier,location:u.extensionLocation},t,p.NotebookDocumentContentOptions.from(i),d._convertNotebookRegistrationData(u,r)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(u,t,n){const i=this._notebookSerializer.get(u);if(!i)throw new Error("NO serializer found");const r=await i.deserializeNotebook(t.buffer,n);return p.NotebookData.from(r)}async $notebookToData(u,t,n){const i=this._notebookSerializer.get(u);if(!i)throw new Error("NO serializer found");const r=await i.serializeNotebook(p.NotebookData.to(t),n);return w.VSBuffer.wrap(r)}async $openNotebook(u,t,n,i,r){const{provider:o}=this._getProviderData(u),m=await o.openNotebook(s.URI.revive(t),{backupId:n,untitledDocumentData:i==null?void 0:i.buffer},r);return{metadata:p.NotebookDocumentMetadata.from(m.metadata),cells:m.cells.map(p.NotebookCellData.from)}}async $saveNotebook(u,t,n){const i=this.getNotebookDocument(s.URI.revive(t)),{provider:r}=this._getProviderData(u);return await r.saveNotebook(i.apiNotebook,n),!0}async $saveNotebookAs(u,t,n,i){const r=this.getNotebookDocument(s.URI.revive(t)),{provider:o}=this._getProviderData(u);return await o.saveNotebookAs(s.URI.revive(n),r.apiNotebook,i),!0}async $backupNotebook(u,t,n){var i;const r=this.getNotebookDocument(s.URI.revive(t)),o=this._getProviderData(u),m=(i=this._extensionStoragePaths.workspaceValue(o.extension))!==null&&i!==void 0?i:this._extensionStoragePaths.globalValue(o.extension),g=String(C.hash([r.uri.toString(),this._backupIdPool++])),E=s.URI.joinPath(m,g),b=await o.provider.backupNotebook(r.apiNotebook,{destination:E},n);return r.updateBackup(b),b.id}$acceptModelChanged(u,t,n){this.getNotebookDocument(s.URI.revive(u)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(u,t){const n=this.getNotebookDocument(s.URI.revive(u));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(u){const t=this.getNotebookDocument(s.URI.revive(u));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(u,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",u,t);const n=this._editors.get(u);if(!n)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(p.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(p.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(u){for(const t in u){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(p.ViewColumn.to(u[t]))}}$acceptDocumentPropertiesChanged(u,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",u.path,t);const n=this.getNotebookDocument(s.URI.revive(u));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(u,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const i=new v.ExtHostNotebookEditor(t,this._notebookEditorsProxy,u,n.visibleRanges.map(p.NotebookRange.to),n.selections.map(p.NotebookRange.to),typeof n.viewColumn=="number"?p.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,i)}$acceptDocumentAndEditorsDelta(u){var t,n,i;if(u.removedDocuments)for(const o of u.removedDocuments){const m=s.URI.revive(o),g=this._documents.get(m);g&&(g.dispose(),this._documents.delete(m),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(E=>E.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const E of this._editors.values())E.notebookData.uri.toString()===m.toString()&&this._editors.delete(E.id)}if(u.addedDocuments){const o=[];for(const m of u.addedDocuments){const g=s.URI.revive(m.uri),E=m.viewType;if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const b=this,a=new _.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(L){b._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){b._onDidChangeCellOutputs.fire(L)},emitCellMetadataChange(L){b._onDidChangeCellMetadata.fire(L)},emitCellExecutionStateChange(L){b._onDidChangeCellExecutionState.fire(L)}},E,m.metadata?p.NotebookDocumentMetadata.to(m.metadata):new l.NotebookDocumentMetadata,g);a.acceptModelChanged({versionId:m.versionId,rawEvents:[{kind:h.NotebookCellsChangeType.Initialize,changes:[[0,0,m.cells]]}]},!1),o.push(...m.cells.map(L=>_.ExtHostCell.asModelAddData(a.apiNotebook,L))),(t=this._documents.get(g))===null||t===void 0||t.dispose(),this._documents.set(g,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(u.addedEditors)for(const o of u.addedEditors){if(this._editors.has(o.id))return;const m=s.URI.revive(o.documentUri),g=this._documents.get(m);g&&this._createExtHostEditor(g,o.id,o)}const r=[];if(u.removedEditors)for(const o of u.removedEditors){const m=this._editors.get(o);m&&(this._editors.delete(o),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===m.id&&(this._activeNotebookEditor=void 0),r.push(m))}if(u.visibleEditors){this._visibleNotebookEditors=u.visibleEditors.map(m=>this._editors.get(m)).filter(m=>!!m);const o=new Set;this._visibleNotebookEditors.forEach(m=>o.add(m.id));for(const m of this._editors.values()){const g=o.has(m.id);m._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(m=>m).filter(m=>m.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.newActiveEditor===null?this._activeNotebookEditor=void 0:u.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(u.newActiveEditor)),u.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.apiEditor)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(ge[238],pe([0,1,3,6,5,26,2,20,87,22,13,64,21,17,14,7]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let _=class{constructor(u,t,n,i){this._mainContext=u,this._initData=t,this._extHostNotebook=n,this._logService=i,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=u.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(u,t,n,i,r,o){for(let N of this._kernelData.values())if(N.controller.id===t&&A.ExtensionIdentifier.equals(u.identifier,N.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const m=this._handlePool++,g=this;this._logService.trace(`NotebookController[${m}], CREATED by ${u.identifier.value}, ${t}`);const E=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${u.identifier}'`);let b=!1;const a=new R.DisposableStore,L=new w.Emitter,O=new w.Emitter,W={id:`${u.identifier.value}/${t}`,viewType:n,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:i||u.identifier.value,preloads:o?o.map(k.NotebookRendererScript.from):[]};let ee=r??E,oe;this._proxy.$addKernel(m,W).catch(N=>{console.log(N),b=!0});let V=0;const B=()=>{if(b)return;const N=++V;Promise.resolve().then(()=>{N===V&&this._proxy.$updateKernel(m,W)})},j=new I.ResourceMap,T={get id(){return t},get viewType(){return W.viewType},onDidChangeNotebookAssociation:L.event,get label(){return W.label},set label(N){var F;W.label=(F=N??u.displayName)!==null&&F!==void 0?F:u.name,B()},get detail(){var N;return(N=W.detail)!==null&&N!==void 0?N:""},set detail(N){W.detail=N,B()},get description(){var N;return(N=W.description)!==null&&N!==void 0?N:""},set description(N){W.description=N,B()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(N){W.supportedLanguages=N,B()},get hasExecutionOrder(){var N;return(N=W.hasExecutionOrder)!==null&&N!==void 0?N:!1},set hasExecutionOrder(N){W.hasExecutionOrder=N,B()},get rendererScripts(){return W.preloads?W.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(N){ee=N??E},get interruptHandler(){return oe},set interruptHandler(N){oe=N,W.supportsInterrupt=Boolean(N),B()},createNotebookCellExecution(N){if(b)throw new Error("notebook controller is DISPOSED");if(!j.has(N.notebook.uri))throw g._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(F=>F.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return g._createNotebookCellExecution(N)},dispose:()=>{b||(this._logService.trace(`NotebookController[${m}], DISPOSED`),b=!0,this._kernelData.delete(m),a.dispose(),L.dispose(),O.dispose(),this._proxy.$removeKernel(m))},onDidReceiveMessage:O.event,postMessage(N,F){return g._proxy.$postMessage(m,F&&g._extHostNotebook.getIdByEditor(F),N)},asWebviewUri(N){return D.asWebviewUri(N,g._initData.remote)},updateNotebookAffinity(N,F){g._proxy.$updateNotebookPriority(m,N.uri,F)}};return this._kernelData.set(m,{extensionId:u.identifier,controller:T,onDidReceiveMessage:O,onDidChangeSelection:L,associatedNotebooks:j}),T}$acceptNotebookAssociation(u,t,n){const i=this._kernelData.get(u);if(i){const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));n?i.associatedNotebooks.set(r.uri,!0):i.associatedNotebooks.delete(r.uri),this._logService.trace(`NotebookController[${u}] ASSOCIATE notebook`,r.uri.toString(),n),i.onDidChangeSelection.fire({selected:n,notebook:r.apiNotebook})}}async $executeCells(u,t,n){const i=this._kernelData.get(u);if(!i)return;const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(t)),o=[];for(let m of n){const g=r.getCell(m);g&&o.push(g.apiCell)}try{this._logService.trace(`NotebookController[${u}] EXECUTE cells`,r.uri.toString(),o.length),await i.controller.executeHandler.call(i.controller,o,r.apiNotebook,i.controller)}catch(m){this._logService.error(`NotebookController[${u}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(u,t,n){var i;const r=this._kernelData.get(u);if(!r)return;const o=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,o.apiNotebook);else for(let m of n){const g=o.getCell(m);g&&((i=this._activeExecutions.get(g.uri))===null||i===void 0||i.cancel())}}$acceptKernelMessageFromRenderer(u,t,n){const i=this._kernelData.get(u);if(!i)return;const r=this._extHostNotebook.getEditorById(t);if(!r)throw new Error(`send message for UNKNOWN editor: ${t}`);i.onDidReceiveMessage.fire(Object.freeze({editor:r.apiEditor,message:n}))}_createNotebookCellExecution(u){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const i=new S(n.notebook,n,this._mainContext.getProxy(C.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(n.uri,i);const r=i.onDidChangeState(()=>{i.state===v.Resolved&&(i.dispose(),r.dispose(),this._activeExecutions.delete(n.uri))});return i.asApiObject()}};_=Ve([He(3,l.ILogService)],_),e.ExtHostNotebookKernels=_;var v;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(v||(v={}));class S extends R.Disposable{constructor(u,t,n){super();this._document=u,this._cell=t,this._proxy=n,this._onDidChangeState=new w.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new c.CancellationTokenSource),this._collector=new d(10,i=>this.applyEdits(i)),this._executionOrder=t.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(u){await this._collector.addItem(u)}async applyEdits(u){return this._proxy.$applyEdits(this._document.uri,u,!1)}verifyStateForOutput(){if(this._state===v.Init)throw new Error("Must call start before modifying cell output");if(this._state===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(u){const t={editType:9,handle:this._cell.handle,internalMetadata:u};this.applyEdits([t])}cellIndexToHandle(u){let t=this._cell;if(typeof u=="number"?t=this._document.getCellFromIndex(u):u&&(t=this._document.getCellFromApiCell(u)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(u){return u.map(t=>{const n=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return n===t.items?k.NotebookCellOutput.from(t):k.NotebookCellOutput.from({items:n,id:t.id,metadata:t.metadata})})}async updateOutputs(u,t,n){const i=this.cellIndexToHandle(t),r=this.validateAndConvertOutputs(p.asArray(u));return this.applyEditSoon({editType:2,handle:i,append:n,outputs:r})}async updateOutputItems(u,t,n){return h.NotebookCellOutput.isNotebookCellOutput(t)&&(t=t.id),u=h.NotebookCellOutput.ensureUniqueMimeTypes(p.asArray(u),!0),this.applyEditSoon({editType:7,items:u.map(k.NotebookCellOutputItem.from),outputId:t,append:n})}asApiObject(){const u=this;return Object.freeze({get token(){return u._tokenSource.token},get cell(){return u._cell.apiCell},get executionOrder(){return u._executionOrder},set executionOrder(n){u._executionOrder=n,u.mixinMetadata({executionOrder:n})},start(n){var i;if(u._state===v.Resolved||u._state===v.Started)throw new Error("Cannot call start again");u._state=v.Started,u._onDidChangeState.fire(),u.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:(i=n==null?void 0:n.startTime)!==null&&i!==void 0?i:null})},end(n){var i,r;if(u._state===v.Resolved)throw new Error("Cannot call resolve twice");u._state=v.Resolved,u._onDidChangeState.fire(),u.mixinMetadata({runState:null,lastRunSuccess:(i=n==null?void 0:n.success)!==null&&i!==void 0?i:null,runEndTime:(r=n==null?void 0:n.endTime)!==null&&r!==void 0?r:null})},clearOutput(n){return u.verifyStateForOutput(),u.updateOutputs([],n,!1)},async appendOutput(n,i){return u.verifyStateForOutput(),u.updateOutputs(n,i,!0)},async replaceOutput(n,i){return u.verifyStateForOutput(),u.updateOutputs(n,i,!1)},async appendOutputItems(n,i){u.verifyStateForOutput(),u.updateOutputItems(n,i,!0)},async replaceOutputItems(n,i){u.verifyStateForOutput(),u.updateOutputItems(n,i,!1)}})}}class d{constructor(u,t){this.delay=u,this.callback=t,this.batch=[]}addItem(u){return this.batch.push(u),this.waitPromise||(this.waitPromise=s.timeout(this.delay).then(()=>{this.waitPromise=void 0;const t=this.batch;return this.batch=[],this.callback(t)})),this.waitPromise}}}),define(ge[239],pe([0,1,3,5,124]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,D,I){var s;const P=this._extHostNotebook.getEditorById(k);!P||(s=this._rendererMessageEmitters.get(D))===null||s===void 0||s.fire({editor:P.apiEditor,message:I})}createRendererMessaging(k){return{onDidReceiveMessage:(...I)=>this.getOrCreateEmitterFor(k).event(...I),postMessage:(I,s)=>{const P=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,k,s)}}}getOrCreateEmitterFor(k){let D=this._rendererMessageEmitters.get(k);return D||(D=new w.Emitter({onLastListenerRemove:()=>{D==null||D.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,D),D)}}e.ExtHostNotebookRenderers=A}),define(ge[66],pe([0,1,5,3,6,23,4,15]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends C.Disposable{constructor(l,h,_,v){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=v,this._id=v.$register(this.name,h,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?A.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(h=>this._proxy.$clear(h,l))}show(l,h){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof l=="boolean"?l:h)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class I extends D{constructor(l,h){super(l,!1,void 0,h)}append(l){super.append(l),this._id.then(h=>this._proxy.$append(h,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class s extends D{constructor(l,h,_){super(l,!0,h,_)}append(l){throw new Error("Not supported")}}class P{constructor(l,h){this.name=l,this._channel=h}append(l){this._channel.then(h=>h.append(l))}appendLine(l){this._channel.then(h=>h.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,h){this._channel.then(_=>_.show(l,h))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=P;let c=class{constructor(l){this._proxy=l.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new I(l,this._proxy)}createOutputChannelFromLogFile(l,h){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new s(l,h,this._proxy)}};c=Ve([He(0,k.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=y.createDecorator("IExtHostOutputService")}),define(ge[240],pe([0,1,13,21,3,6,5,2,7,16,17,57]),function(Q,e,w,R,C,A,y,k,D,I,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(p,l,h){const _=p.getProxy(y.MainContext.MainThreadQuickOpen);class v{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,m,g=R.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(r),b=++this._instances,a=_.$show(b,{title:m==null?void 0:m.title,placeHolder:m==null?void 0:m.placeHolder,matchOnDescription:m==null?void 0:m.matchOnDescription,matchOnDetail:m==null?void 0:m.matchOnDetail,ignoreFocusLost:m==null?void 0:m.ignoreFocusOut,canPickMany:m==null?void 0:m.canPickMany},g),L={},O=a.then(()=>L);return Promise.race([O,E]).then(W=>{if(W!==L)return E.then(ee=>{const oe=[];for(let V=0;V<ee.length;V++){const B=ee[V];let j,T,N,F,M;typeof B=="string"?j=B:(j=B.label,T=B.description,N=B.detail,F=B.picked,M=B.alwaysShow),oe.push({label:j,description:T,handle:V,detail:N,picked:F,alwaysShow:M})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{m.onDidSelectItem(ee[V])}),_.$setItems(b,oe),a.then(V=>{if(typeof V=="number")return ee[V];if(Array.isArray(V))return V.map(B=>ee[B])})})}).then(void 0,W=>{if(!I.isPromiseCanceledError(W))return _.$setError(b,W),Promise.reject(W)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=R.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,_.$input(r,typeof this._validateInput=="function",o).then(void 0,m=>{if(!I.isPromiseCanceledError(m))return Promise.reject(m)})}$validateInput(r){return this._validateInput?w.asPromise(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=R.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!m)return;const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(E=>E.uri.toString()===m.uri.toString())}createQuickPick(r,o){const m=new t(r,o,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const m=this._sessions.get(r);m&&m._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const m=this._sessions.get(r);m instanceof t&&m._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const m=this._sessions.get(r);m instanceof t&&m._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const m=this._sessions.get(r);m&&m._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class S{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,m)=>{const g=o===D.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(g,o)}),this.update({buttons:r.map((o,m)=>({iconPath:d(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=A.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const m=r[o];this._pendingUpdate[o]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function d(i){if(i instanceof D.ThemeIcon)return{id:i.id};const r=u(i),o=f(i);return{dark:typeof r=="string"?k.URI.file(r):r,light:typeof o=="string"?k.URI.file(o):o}}function f(i){return typeof i=="object"&&"light"in i?i.light:i}function u(i){return typeof i=="object"&&"dark"in i?i.dark:i}class t extends S{constructor(r,o,m){super(r,m);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,m)=>{this._handlesToItems.set(m,o),this._itemsToHandles.set(o,m)}),this.update({items:r.map((o,m)=>({label:o.label,description:o.description,handle:m,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=s.coalesce(r.map(m=>this._handlesToItems.get(m)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=s.coalesce(r.map(m=>this._handlesToItems.get(m)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends S{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?P.default.Error:P.default.Ignore})}}return new v(l,h)}e.createExtHostQuickOpen=c}),define(ge[241],pe([0,1,2,3,53,6,13,5,17,97,14,26,39]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(r){if(r)return typeof r.iconPath=="string"?w.URI.file(r.iconPath):r.iconPath}function l(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const m=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,g=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return I.comparePaths(m,g)}function h(r,o){let m=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(m=l(r,o),m!==0)return m;if(r.light&&o.light)m=l(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(m!==0)return m;if(r.dark&&o.dark)m=l(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return m}function _(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let m=0;m<r.arguments.length;m++){const g=r.arguments[m],E=o.arguments[m];if(g!==E)return g<E?-1:1}return 0}function v(r,o){let m=I.comparePaths(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(m!==0)return m;if(r.command&&o.command)m=_(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(m!==0)return m;if(r.decorations&&o.decorations)m=h(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return m}function S(r,o){for(let m=0;m<r.length;m++)if(r[m]!==o[m])return!1;return!0}function d(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?S(r.arguments,o.arguments):r.arguments===o.arguments)}function f(r,o){return D.equals(r,o,d)}class u{constructor(o,m,g){this._extension=o,this._proxy=m,this._sourceControlHandle=g,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return c.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(o){if(c.checkProposedApiEnabled(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){c.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,m){c.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,m)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=u;class t{constructor(o,m,g,E,b){this._proxy=o,this._commands=m,this._sourceControlHandle=g,this._id=E,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,m){const g=this._resourceStatesCommandsMap.get(o);return g?y.asPromise(()=>this._commands.executeCommand(g.command,...g.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const m=[...this._resourceStates].sort(v),E=D.sortedDiff(this._resourceSnapshot,m,v).map(L=>{const O=L.toInsert.map(W=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,W);const oe=W.resourceUri,V=p(W.decorations),B=W.decorations&&p(W.decorations.light)||V,j=W.decorations&&p(W.decorations.dark)||V,T=[];let N;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const se=new A.DisposableStore;N=this._commands.converter.toInternal(W.command,se),this._resourceStatesDisposablesMap.set(ee,se)}else this._resourceStatesCommandsMap.set(ee,W.command);B&&T.push(B),j&&j.toString()!==(B==null?void 0:B.toString())&&T.push(j);const F=W.decorations&&W.decorations.tooltip||"",M=W.decorations&&!!W.decorations.strikeThrough,U=W.decorations&&!!W.decorations.faded,x=W.contextValue||"";return{rawResource:[ee,oe,T,F,M,U,x,N],handle:ee}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),b=E.map(({start:L,deleteCount:O,toInsert:W})=>[L,O,W.map(ee=>ee.rawResource)]),a=E.reverse();for(const{start:L,deleteCount:O,toInsert:W}of a){const ee=W.map(V=>V.handle),oe=this._handlesSnapshot.splice(L,O,...ee);for(const V of oe)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),(o=this._resourceStatesDisposablesMap.get(V))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=m,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,m,g,E,b,a){this._proxy=m,this._commands=g,this._id=E,this._label=b,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,b,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=o;const m=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&f(this._statusBarCommands,o))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=o;const m=(o||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(o,m){const g=new t(this._proxy,this._commands,this.handle,o,m),E=R.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,E),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const o=[],m=[];for(const[g,E]of this.createdResourceGroups){E.dispose();const b=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});R.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),b.dispose(),this._groups.delete(g.handle),this._proxy.$unregisterGroup(this.handle,g.handle)}),o.push([g.handle,g.id,g.label,g.features]);const a=g._takeResourceStateSnapshot();a.length>0&&m.push([g.handle,a]),this._groups.set(g.handle,g)}this._proxy.$registerGroups(this.handle,o,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(m=>{const g=m._takeResourceStateSnapshot();g.length!==0&&o.push([m.handle,g])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([C.debounce(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([C.debounce(100)],n.prototype,"eventuallyUpdateResourceStates",null);let i=class Un{constructor(o,m,g){this._commands=m,this.logService=g,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const b=this._sourceControls.get(E.sourceControlHandle);if(!b)return E;const a=b.getResourceGroup(E.groupHandle);return a?a.getResourceState(E.handle):E}else if(E&&E.$mid===4){const b=this._sourceControls.get(E.sourceControlHandle);return b?b.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const b=this._sourceControls.get(E.handle);return b||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,m,g,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,m,g,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const b=Un._handlePool++,a=new n(o,this._proxy,this._commands,m,g,E);this._sourceControls.set(b,a);const L=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(o.identifier))||[];return L.push(a),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(o.identifier),L),a}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const m=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(o.identifier)),g=m&&m[m.length-1];return g&&g.inputBox}$provideOriginalResource(o,m,g){const E=w.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const b=this._sourceControls.get(o);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):y.asPromise(()=>b.quickDiffProvider.provideOriginalResource(E,g)).then(a=>a||null)}$onInputBoxValueChange(o,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const g=this._sourceControls.get(o);return g&&g.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(o,m,g,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,m,g);const b=this._sourceControls.get(o);if(!b)return Promise.resolve(void 0);const a=b.getResourceGroup(m);return a?a.$executeResourceCommand(g,E):Promise.resolve(void 0)}$validateInput(o,m,g){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):y.asPromise(()=>E.inputBox.validateInput(m,g)).then(b=>b?Promise.resolve([b.message,b.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var m,g;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((m=this._sourceControls.get(o))===null||m===void 0||m.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((g=this._sourceControls.get(this._selectedSourceControlHandle))===null||g===void 0||g.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};i._handlePool=0,i=Ve([He(2,s.ILogService)],i),e.ExtHostSCM=i});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[242],pe([0,1,7,5,164,6]),function(Q,e,w,R,C,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(c,p,l,h,_=w.StatusBarAlignment.Left,v){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,nt(this,y,c,"f"),nt(this,k,p,"f"),this._entryId=D.ID_GEN++,this._extension=l,this._id=h,this._alignment=_,this._priority=v}get id(){var c;return(c=this._id)!==null&&c!==void 0?c:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var c;return(c=this._command)===null||c===void 0?void 0:c.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set name(c){this._name=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!D.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){var p;((p=this._command)===null||p===void 0?void 0:p.fromApi)!==c&&(this._internalCommandRegistration.clear(),typeof c=="string"?this._command={fromApi:c,internal:Be(this,k,"f").toInternal({title:"",command:c},this._internalCommandRegistration)}:c?this._command={fromApi:c,internal:Be(this,k,"f").toInternal(c,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var c;this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let l;this._name?l=this._name:l=C.localize(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,y,"f").$setEntry(this._entryId,p,l,this._text,this._tooltip,(c=this._command)===null||c===void 0?void 0:c.internal,h,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,k=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class I{constructor(c){this._messages=[],this._item=c.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=C.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const p={message:c};return this._messages.unshift(p),this._update(),new w.Disposable(()=>{const l=this._messages.indexOf(p);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(c,p){this._proxy=c.getProxy(R.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new I(this)}createStatusBarEntry(c,p,l,h){return new D(this._proxy,this._commands,c,p,l,h)}setStatusBarMessage(c,p){const l=this._statusMessage.setMessage(c);let h;return typeof p=="number"?h=setTimeout(()=>l.dispose(),p):typeof p!="undefined"&&p.then(()=>l.dispose(),()=>l.dispose()),new w.Disposable(()=>{l.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=s}),define(ge[90],pe([0,1,5,3,4]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,I){return this._proxy.$getValue(k,D).then(s=>s||I)}setValue(k,D,I){return this._proxy.$setValue(k,D,I)}$acceptValue(k,D,I){this._onDidChangeStorage.fire({shared:k,key:D,value:I})}}e.ExtHostStorage=A,e.IExtHostStorage=C.createDecorator("IExtHostStorage")}),define(ge[91],pe([0,1,4,27,14,89,2]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=w.createDecorator("IExtensionStoragePaths");let k=class{constructor(I,s,P){var c;this._logService=s,this._extHostFileSystem=P,this._workspace=(c=I.workspace)!==null&&c!==void 0?c:void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getOrCreateWorkspaceStoragePath(){var I;if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,s);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(c){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(I=y.URI.revive(this._workspace.configuration))===null||I===void 0?void 0:I.toString(),name:this._workspace.name},void 0,2))),P}catch(c){this._logService.error("[ExtHostStorage]",c);return}}workspaceValue(I){if(this._value)return y.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return y.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}};k=Ve([He(0,R.IExtHostInitDataService),He(1,C.ILogService),He(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ge[33],pe([0,1,3,5,4,2,15,6,7,165,16,208,21,32,192,12]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=C.createDecorator("IExtHostTerminalService");class _{constructor(n,i,r,o){this._proxy=n,this._id=i,this._creationOptions=r,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(g,E=!0){m._checkDisposed(),m._proxy.$sendText(m._id,g,E)},show(g){m._checkDisposed(),m._proxy.$show(m._id,g)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:h.withNullAsUndefined(n.shellPath),shellArgs:h.withNullAsUndefined(n.shellArgs),cwd:h.withNullAsUndefined(n.cwd),env:h.withNullAsUndefined(n.env),icon:h.withNullAsUndefined(n.iconPath),initialText:h.withNullAsUndefined(n.message),strictEnv:h.withNullAsUndefined(n.strictEnv),hideFromUser:h.withNullAsUndefined(n.hideFromUser),isFeatureTerminal:h.withNullAsUndefined(i==null?void 0:i.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:h.withNullAsUndefined(i==null?void 0:i.useShellEnvironment),isSplitTerminal:h.withNullAsUndefined(i==null?void 0:i.isSplitTerminal)})}async createExtensionTerminal(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:i,isSplitTerminal:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,i){return n===this._cols&&i===this._rows||n===0||i===0?!1:(this._cols=n,this._rows=i,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=_;class v{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,i){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let S=1,d=class extends k.Disposable{constructor(n,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=i.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[r,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var n;return(n=this._activeTerminal)===null||n===void 0?void 0:n.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(n){const i=n?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.path)||""}getDefaultShellArgs(n){const i=n?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.args)||[]}createExtensionTerminal(n,i){const r=new _(this._proxy,p.generateUuid(),n,n.name),o=new v(n.pty);return r.createExtensionTerminal(i==null?void 0:i.isSplitTerminal,n.iconPath).then(m=>{const g=this._setupExtHostProcessListeners(m,o);this._terminalProcessDisposables[m]=g}),this._terminals.push(r),r.value}attachPtyToTerminal(n,i){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const o=new v(i),m=this._setupExtHostProcessListeners(n,o);this._terminalProcessDisposables[n]=m}async $acceptActiveTerminalChanged(n){const i=this._activeTerminal;if(n===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const r=this._getTerminalById(n);r&&(this._activeTerminal=r,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,i){const r=this._getTerminalById(n);r&&this._onDidWriteTerminalData.fire({terminal:r.value,data:i})}async $acceptTerminalDimensions(n,i,r){const o=this._getTerminalById(n);o&&o.setDimensions(i,r)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,r){var o;(o=this._terminalProcesses.get(n))===null||o===void 0||o.resize(i,r)}async $acceptTerminalTitleChange(n,i){const r=this._getTerminalById(n);r&&(r.name=i)}async $acceptTerminalClosed(n,i){const r=this._getTerminalObjectIndexById(this._terminals,n);if(r!==null){const o=this._terminals.splice(r,1)[0];o.setExitCode(i),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(n,i,r,o){if(i){const E=this._getTerminalObjectIndexById(this._terminals,i);if(E!==null){this._terminals[E]._id=n,this._onDidOpenTerminal.fire(this.terminals[E]),this._terminals[E].isOpen=!0;return}}const m={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:A.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},g=new _(this._proxy,n,m,r);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(n,i){const r=this._getTerminalById(n);r&&r._setProcessId(i)}async $startExtensionTerminal(n,i){const r=this._getTerminalById(n);if(!r)return{message:I.localize(0,null,n)};r.isOpen||await new Promise(m=>{const g=this.onDidOpenTerminal(async E=>{E===r.value&&(g.dispose(),m())})});const o=this._terminalProcesses.get(n);o?o.startSendingEvents(i):this._extensionTerminalAwaitingStart[n]={initialDimensions:i}}_setupExtHostProcessListeners(n,i){const r=new k.DisposableStore;r.add(i.onProcessReady(m=>this._proxy.$sendProcessReady(n,m.pid,m.cwd))),r.add(i.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(n,m))),this._bufferer.startBuffering(n,i.onProcessData),r.add(i.onProcessExit(m=>this._onProcessExit(n,m))),i.onProcessOverrideDimensions&&r.add(i.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(n,m))),this._terminalProcesses.set(n,i);const o=this._extensionTerminalAwaitingStart[n];return o&&i instanceof v&&(i.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),r}$acceptProcessAckDataEvent(n,i){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.input(i)}$acceptProcessResize(n,i,r){var o;try{(o=this._terminalProcesses.get(n))===null||o===void 0||o.resize(i,r)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(n,i){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.shutdown(i)}$acceptProcessRequestInitialCwd(n){var i;(i=this._terminalProcesses.get(n))===null||i===void 0||i.getInitialCwd().then(r=>this._proxy.$sendProcessInitialCwd(n,r))}$acceptProcessRequestCwd(n){var i;(i=this._terminalProcesses.get(n))===null||i===void 0||i.getCwd().then(r=>this._proxy.$sendProcessCwd(n,r))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,i){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,i),this._proxy.$registerProfileProvider(n),new D.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(n,i){var r;const o=new c.CancellationTokenSource().token,m=await((r=this._profileProviders.get(n))===null||r===void 0?void 0:r.provideProfileOptions(o));if(!o.isCancellationRequested){if(!m)throw new Error(`No terminal profile options provided for id "${n}"`);"pty"in m&&this.createExtensionTerminal(m,{isSplitTerminal:i}),this.createTerminalFromOptions(m,{isSplitTerminal:i})}}async $provideLinks(n,i){const r=this._getTerminalById(n);if(!r)return[];this._terminalLinkCache.delete(n);const o=this._terminalLinkCancellationSource.get(n);o&&o.dispose(!0);const m=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,m);const g=[],E={terminal:r.value,line:i},b=[];for(const O of this._linkProviders)b.push(new Promise(async W=>{m.token.onCancellationRequested(()=>W({provider:O,links:[]}));const ee=await O.provideTerminalLinks(E,m.token)||[];m.token.isCancellationRequested||W({provider:O,links:ee})}));const a=await Promise.all(b);if(m.token.isCancellationRequested)return[];const L=new Map;for(const O of a)O&&O.links.length>0&&g.push(...O.links.map(W=>{const ee={id:S++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return L.set(ee.id,{provider:O.provider,link:W}),ee}));return this._terminalLinkCache.set(n,L),g}$activateLink(n,i){var r;const o=(r=this._terminalLinkCache.get(n))===null||r===void 0?void 0:r.get(i);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(n,i){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const r=this._terminalProcessDisposables[n];r&&(r.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,i)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,i){const r=this._getTerminalObjectIndexById(n,i);return r!==null?n[r]:null}_getTerminalObjectIndexById(n,i){let r=null;return n.some((o,m)=>o._id===i?(r=m,!0):!1),r}getEnvironmentVariableCollection(n){let i=this._environmentVariableCollections.get(n.identifier.value);return i||(i=new f,this._setEnvironmentVariableCollection(n.identifier.value,i)),i}_syncEnvironmentVariableCollection(n,i){const r=P.serializeEnvironmentVariableCollection(i.map);this._proxy.$setEnvironmentVariableCollection(n,i.persistent,r.length===0?void 0:r)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const r=i[0],o=new f(i[1]);this._setEnvironmentVariableCollection(r,o)})}$acceptDefaultProfile(n,i){this._defaultProfile=n,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(n,i){this._environmentVariableCollections.set(n,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,i)})}};d=Ve([He(1,y.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class f{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Replace})}append(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Append})}prepend(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,i){const r=this.map.get(n);(!r||r.value!==i.value||r.type!==i.type)&&(this.map.set(n,i),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((r,o)=>n.call(i,o,r,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let u=class extends d{constructor(n){super(!1,n)}createTerminal(n,i,r){throw new s.NotSupportedError}createTerminalFromOptions(n,i){throw new s.NotSupportedError}};u=Ve([He(0,y.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(ge[243],pe([0,1,3,17,5,125,20,7]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(s,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=s.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(s){const P=this._extHostDocumentsAndEditors.allEditors();return s?P:P.map(c=>c.value)}async showTextDocument(s,P,c){let p;typeof P=="number"?p={position:y.ViewColumn.from(P),preserveFocus:c}:typeof P=="object"?p={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:p={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(s.uri,p),h=l&&this._extHostDocumentsAndEditors.getEditor(l);if(h)return h.value;throw l?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}createTextEditorDecorationType(s,P){return new A.TextEditorDecorationType(this._proxy,s,P).value}$acceptEditorPropertiesChanged(s,P){const c=this._extHostDocumentsAndEditors.getEditor(s);if(!c)throw new Error("unknown text editor");if(P.options&&c._acceptOptions(P.options),P.selections){const p=P.selections.selections.map(y.Selection.to);c._acceptSelections(p)}if(P.visibleRanges){const p=R.coalesce(P.visibleRanges.map(y.Range.to));c._acceptVisibleRanges(p)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const p=k.TextEditorSelectionChangeKind.fromValue(P.selections.source),l=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:l,kind:p})}if(P.visibleRanges){const p=R.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:p})}}$acceptEditorPositionData(s){for(const P in s){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("Unknown text editor");const p=y.ViewColumn.to(s[P]);c.value.viewColumn!==p&&(c._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:p}))}}getDiffInformation(s){return Promise.resolve(this._proxy.$getDiffInformation(s))}}e.ExtHostEditors=D});var Qt=this&&this.__rest||function(Q,e){var w={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(w[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(Q);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[C])&&(w[R[C]]=Q[R[C]]);return w};define(ge[244],pe([0,1,2,4,5,6,7]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class k{constructor(s,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=s.getProxy(C.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:c=>{var p,l;if(c&&c.$mid===11){const h=c.uri===void 0?void 0:w.URI.revive(c.uri);return(l=(p=this._itemsBySourceAndUriMap.get(c.source))===null||p===void 0?void 0:p.get(D(h)))===null||l===void 0?void 0:l.get(c.handle)}return c}})}async $getTimeline(s,P,c,p,l){const h=this._providers.get(s);return h==null?void 0:h.provideTimeline(w.URI.revive(P),c,p,l)}registerTimelineProvider(s,P,c,p){const l=new A.DisposableStore,h=this.convertTimelineItem(P.id,p,l).bind(this);let _;P.onDidChange&&(_=P.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:P.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:s,onDidChange:void 0,async provideTimeline(S,d,f,u){var t;(u==null?void 0:u.resetCache)&&(l.clear(),(t=v.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(S,d,f);if(n==null)return;const i=h(S,u);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(i)})},dispose(){var S;for(const d of v.values())(S=d.get(P.id))===null||S===void 0||S.clear();_==null||_.dispose(),l.dispose()}}))}convertTimelineItem(s,P,c){return(p,l)=>{let h;if(l==null?void 0:l.cacheResults){let _=this._itemsBySourceAndUriMap.get(s);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(s,_));const v=D(p);h=_.get(v),h===void 0&&(h=new Map,_.set(v,h))}return _=>{var v,S;const{iconPath:d}=_,f=Qt(_,["iconPath"]),u=`${s}|${(v=_.id)!==null&&v!==void 0?v:_.timestamp}`;h==null||h.set(u,_);let t,n,i;return _.iconPath&&(d instanceof y.ThemeIcon?i={id:d.id}:w.URI.isUri(d)?(t=d,n=d):{light:t,dark:n}=d),Object.assign(Object.assign({},f),{id:(S=f.id)!==null&&S!==void 0?S:void 0,handle:u,source:s,command:_.command?P.toInternal(_.command,c):void 0,icon:t,iconDark:n,themeIcon:i,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(s){if(this._providers.get(s.id))throw new Error(`Timeline Provider ${s.id} already exists.`);return this._proxy.$registerTimelineProvider({id:s.id,label:s.label,scheme:s.scheme}),this._providers.set(s.id,s),A.toDisposable(()=>{var c;for(const p of this._itemsBySourceAndUriMap.values())(c=p.get(s.id))===null||c===void 0||c.clear();this._providers.delete(s.id),this._proxy.$unregisterTimelineProvider(s.id),s.dispose()})}}e.ExtHostTimeline=k;function D(I){return I==null?void 0:I.toString()}}),define(ge[245],pe([0,1,6,10,2,5]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,I,s,P){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const c=P.schemes.find(p=>!y.supportedSchemes.has(p));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,s),this._proxy.$registerUriOpener(I,P.schemes,D,P.label),w.toDisposable(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(D,I,s){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const c=C.URI.revive(I);return P.canOpenExternalUri(c,s)}async $openUri(D,I,s){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(C.URI.revive(I.resolvedUri),{sourceUri:C.URI.revive(I.sourceUri)},s)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(ge[246],pe([0,1,5,2,6,16,26]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(I,s){if(this.handles.has(y.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const P=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(I)),this.handlers.set(P,s),this._proxy.$registerUriHandler(P,I),C.toDisposable(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(I)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(I,s){const P=this.handlers.get(I);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(s))}catch(c){A.onUnexpectedError(c)}return Promise.resolve(void 0)}async createAppUri(I){return R.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[67],pe([0,1,3,2,176,200,87,5]),function(Q,e,w,R,C,A,y,k){"use strict";var D,I,s,P,c,p,l,h,_,v,S,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(g,E,b,a,L,O,W){D.set(this,void 0),I.set(this,void 0),s.set(this,void 0),P.set(this,void 0),c.set(this,void 0),p.set(this,void 0),l.set(this,""),h.set(this,void 0),_.set(this,!1),v.set(this,!1),S.set(this,!1),this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new w.Emitter),this._onDidDispose=Be(this,d,"f").event,nt(this,D,g,"f"),nt(this,I,E,"f"),nt(this,h,b,"f"),nt(this,P,a,"f"),nt(this,c,L,"f"),nt(this,p,O,"f"),nt(this,S,u(O),"f"),nt(this,s,W,"f")}dispose(){nt(this,_,!0,"f"),Be(this,d,"f").fire(),Be(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return nt(this,v,!0,"f"),y.asWebviewUri(g,Be(this,P,"f").remote)}get cspSource(){return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,l,"f")}set html(g){this.assertNotDisposed(),Be(this,l,"f")!==g&&(nt(this,l,g,"f"),!Be(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(nt(this,v,!0,"f"),Be(this,s,"f").report("Webview vscode-resource: uris",Be(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,I,"f").$setHtml(Be(this,D,"f"),g))}get options(){return this.assertNotDisposed(),Be(this,h,"f")}set options(g){this.assertNotDisposed(),Be(this,I,"f").$setOptions(Be(this,D,"f"),i(Be(this,p,"f"),Be(this,c,"f"),g)),nt(this,h,g,"f")}async postMessage(g){if(Be(this,_,"f"))return!1;const E=A.serializeWebviewMessage(g,{serializeBuffersForPostMessage:Be(this,S,"f")});return Be(this,I,"f").$postMessage(Be(this,D,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Be(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,D=new WeakMap,I=new WeakMap,s=new WeakMap,P=new WeakMap,c=new WeakMap,p=new WeakMap,l=new WeakMap,h=new WeakMap,_=new WeakMap,v=new WeakMap,S=new WeakMap,d=new WeakMap;function u(m){try{const g=C.normalizeVersion(C.parseVersion(m.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch(g){return!1}}e.shouldSerializeBuffersForPostMessage=u;class t{constructor(g,E,b,a,L){this.initData=E,this.workspace=b,this._logService=a,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=g.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(g,E,...b){const a=this.getWebview(g);if(a){const{message:L}=A.deserializeWebviewMessage(E,b);a._onMessageEmitter.fire(L)}}$onMissingCsp(g,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,E,b){const a=new f(g,this._webviewProxy,r(E),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(g,a),a._onDidDispose(()=>{this._webviews.delete(g)}),a}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=t;function n(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=n;function i(m,g,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||o(m,g)}}e.serializeWebviewOptions=i;function r(m){var g;return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,portMapping:m.portMapping,localResourceRoots:(g=m.localResourceRoots)===null||g===void 0?void 0:g.map(E=>R.URI.from(E))}}e.reviveOptions=r;function o(m,g){return[...((g==null?void 0:g.getWorkspaceFolders())||[]).map(E=>E.uri),m.extensionLocation]}}),define(ge[247],pe([0,1,21,75,6,10,24,2,20,67,85,5,7]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new s.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return y.joinPath(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class l{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,i){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new p(n,i);return this._documents.set(r,o),o}delete(t,n){const i=this.key(t,n.uri);this._documents.delete(i)}key(t,n){return`${t}@@@${n}`}}var h;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(h||(h={}));class _{constructor(){this._providers=new Map}addTextProvider(t,n,i){return this.add(0,t,n,i)}addCustomProvider(t,n,i){return this.add(1,t,n,i)}get(t){return this._providers.get(t)}add(t,n,i,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:i,provider:r}),new c.Disposable(()=>this._providers.delete(n))}}class v{constructor(t,n,i,r,o){this._extHostDocuments=n,this._extensionStoragePaths=i,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new _,this._documents=new l,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,i,r){const o=new C.DisposableStore;return S(i)?(o.add(this._editorProviders.addTextProvider(n,t,i)),this._proxy.$registerTextEditorProvider(I.toExtensionData(t),n,r.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},I.shouldSerializeBuffersForPostMessage(t))):(o.add(this._editorProviders.addCustomProvider(n,t,i)),this.supportEditing(i)&&o.add(i.onDidChangeCustomDocument(m=>{const g=this.getCustomDocumentEntry(n,m.document.uri);if(d(m)){const E=g.addEdit(m);this._proxy.$onDidEdit(m.document.uri,n,E,m.label)}else this._proxy.$onContentChange(m.document.uri,n)})),this._proxy.$registerCustomEditorProvider(I.toExtensionData(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,I.shouldSerializeBuffersForPostMessage(t))),c.Disposable.from(o,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,i,r,o){var m;const g=this._editorProviders.get(n);if(!g)throw new Error(`No provider found for '${n}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${n}'`);const E=k.URI.revive(t),b=await g.provider.openCustomDocument(E,{backupId:i,untitledDocumentData:r==null?void 0:r.buffer},o);let a;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(a=(m=this._extensionStoragePaths.workspaceValue(g.extension))!==null&&m!==void 0?m:this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(n,b,a),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(t,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=k.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,i,r,o,m){const g=this._editorProviders.get(i);if(!g)throw new Error(`No provider found for '${i}'`);const E=D.ViewColumn.to(o),b=this._extHostWebview.createNewWebview(n,r.webviewOptions,g.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(n,i,r.title,E,r.panelOptions,b),L=k.URI.revive(t);switch(g.type){case 1:{const{document:O}=this.getCustomDocumentEntry(i,L);return g.provider.resolveCustomEditor(O,a,m)}case 0:{const O=this._extHostDocuments.getDocument(L);return g.provider.resolveCustomTextEditor(O,a,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,i){this.getCustomDocumentEntry(n,t).disposeEdits(i)}async $onMoveCustomEditor(t,n,i){const r=this._editorProviders.get(i);if(!r)throw new Error(`No provider found for '${i}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const m=k.URI.revive(n),g=this._extHostDocuments.getDocument(m);await r.provider.moveCustomTextEditor(g,o,w.CancellationToken.None)}async $undo(t,n,i,r){return this.getCustomDocumentEntry(n,t).undo(i,r)}async $redo(t,n,i,r){return this.getCustomDocumentEntry(n,t).redo(i,r)}async $revert(t,n,i){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,i),r.disposeBackup()}async $onSave(t,n,i){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,i),r.disposeBackup()}async $onSaveAs(t,n,i,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,k.URI.revive(i),r)}async $backup(t,n,i){const r=this.getCustomDocumentEntry(n,t),m=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},i);return r.updateBackup(m),m.id}getCustomDocumentEntry(t,n){const i=this._documents.get(t,k.URI.revive(n));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const n=this._editorProviders.get(t),i=n==null?void 0:n.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function S(u){return typeof u.resolveCustomTextEditor=="function"}function d(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function f(u){const t=u.scheme===A.Schemas.file||u.scheme===A.Schemas.untitled?u.fsPath:u.toString();return R.hash(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[248],pe([0,1,3,6,2,32,20,67,5,7]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";var s,P,c,p,l,h,_,v,S,d,f,u,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(m,g,E,b,a,L,O){super();s.set(this,void 0),P.set(this,void 0),c.set(this,void 0),p.set(this,void 0),l.set(this,void 0),h.set(this,void 0),_.set(this,void 0),v.set(this,void 0),S.set(this,!0),d.set(this,!0),f.set(this,!1),u.set(this,this._register(new w.Emitter)),this.onDidDispose=Be(this,u,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,nt(this,s,m,"f"),nt(this,P,g,"f"),nt(this,c,E,"f"),nt(this,l,L,"f"),nt(this,v,a,"f"),nt(this,h,b,"f"),nt(this,p,O,"f")}dispose(){Be(this,f,"f")||(nt(this,f,!0,"f"),Be(this,u,"f").fire(),Be(this,P,"f").$disposeWebview(Be(this,s,"f")),Be(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,p,"f")}get viewType(){return this.assertNotDisposed(),Be(this,c,"f")}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(m){this.assertNotDisposed(),Be(this,h,"f")!==m&&(nt(this,h,m,"f"),Be(this,P,"f").$setTitle(Be(this,s,"f"),m))}get iconPath(){return this.assertNotDisposed(),Be(this,_,"f")}set iconPath(m){this.assertNotDisposed(),Be(this,_,"f")!==m&&(nt(this,_,m,"f"),Be(this,P,"f").$setIconPath(Be(this,s,"f"),C.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Be(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,v,"f")=="number"&&Be(this,v,"f")<0))return Be(this,v,"f")}get active(){return this.assertNotDisposed(),Be(this,d,"f")}get visible(){return this.assertNotDisposed(),Be(this,S,"f")}_updateViewState(m){Be(this,f,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(nt(this,d,m.active,"f"),nt(this,S,m.visible,"f"),nt(this,v,m.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(m,g){this.assertNotDisposed(),Be(this,P,"f").$reveal(Be(this,s,"f"),{viewColumn:m?y.ViewColumn.from(m):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Be(this,f,"f"))throw new Error("Webview is disposed")}}s=new WeakMap,P=new WeakMap,c=new WeakMap,p=new WeakMap,l=new WeakMap,h=new WeakMap,_=new WeakMap,v=new WeakMap,S=new WeakMap,d=new WeakMap,f=new WeakMap,u=new WeakMap,t=new WeakMap;class i{constructor(m,g,E){this.webviews=g,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return A.generateUuid()}createWebviewPanel(m,g,E,b,a={}){const L=typeof b=="object"?b.viewColumn:b,O={viewColumn:y.ViewColumn.from(L),preserveFocus:typeof b=="object"&&!!b.preserveFocus},W=k.shouldSerializeBuffersForPostMessage(m),ee=i.newHandle();this._proxy.$createWebviewPanel(k.toExtensionData(m),ee,g,{title:E,panelOptions:r(a),webviewOptions:k.serializeWebviewOptions(m,this.workspace,a),serializeBuffersForPostMessage:W},O);const oe=this.webviews.createNewWebview(ee,a,m);return this.createNewWebviewPanel(ee,g,E,L,a,oe)}$onDidChangeWebviewPanelViewStates(m){const g=Object.keys(m);g.sort((E,b)=>{const a=m[E],L=m[b];return a.active?1:L.active?-1:+a.visible-+L.visible});for(const E of g){const b=this.getWebviewPanel(E);if(!b)continue;const a=m[E];b._updateViewState({active:a.active,visible:a.visible,viewColumn:y.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(m){const g=this.getWebviewPanel(m);g==null||g.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,g,E){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:E,extension:m}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:k.shouldSerializeBuffersForPostMessage(m)}),new I.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(m,g,E,b){const a=this._serializers.get(g);if(!a)throw new Error(`No serializer found for '${g}'`);const{serializer:L,extension:O}=a,W=this.webviews.createNewWebview(m,E.webviewOptions,O),ee=this.createNewWebviewPanel(m,g,E.title,b,E.panelOptions,W);await L.deserializeWebviewPanel(ee,E.state)}createNewWebviewPanel(m,g,E,b,a,L){const O=new n(m,this._proxy,g,E,b,a,L);return this._webviewPanels.set(m,O),O}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=i;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[249],pe([0,1,3,6,67,5,7]),function(Q,e,w,R,C,A,y){"use strict";var k,D,I,s,P,c,p,l,h,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends R.Disposable{constructor(f,u,t,n,i,r){super();k.set(this,void 0),D.set(this,void 0),I.set(this,void 0),s.set(this,void 0),P.set(this,!1),c.set(this,void 0),p.set(this,void 0),l.set(this,void 0),h.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Be(this,h,"f").event,_.set(this,this._register(new w.Emitter)),this.onDidDispose=Be(this,_,"f").event,nt(this,I,t,"f"),nt(this,p,n,"f"),nt(this,k,f,"f"),nt(this,D,u,"f"),nt(this,s,i,"f"),nt(this,c,r,"f")}dispose(){Be(this,P,"f")||(nt(this,P,!0,"f"),Be(this,_,"f").fire(),Be(this,s,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,p,"f")}set title(f){this.assertNotDisposed(),Be(this,p,"f")!==f&&(nt(this,p,f,"f"),Be(this,D,"f").$setWebviewViewTitle(Be(this,k,"f"),f))}get description(){return this.assertNotDisposed(),Be(this,l,"f")}set description(f){this.assertNotDisposed(),Be(this,l,"f")!==f&&(nt(this,l,f,"f"),Be(this,D,"f").$setWebviewViewDescription(Be(this,k,"f"),f))}get visible(){return Be(this,c,"f")}get webview(){return Be(this,s,"f")}get viewType(){return Be(this,I,"f")}_setVisible(f){f===Be(this,c,"f")||Be(this,P,"f")||(nt(this,c,f,"f"),Be(this,h,"f").fire())}show(f){this.assertNotDisposed(),Be(this,D,"f").$show(Be(this,k,"f"),!!f)}assertNotDisposed(){if(Be(this,P,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,I=new WeakMap,s=new WeakMap,P=new WeakMap,c=new WeakMap,p=new WeakMap,l=new WeakMap,h=new WeakMap,_=new WeakMap;class S{constructor(f,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,u,t,n){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider(C.toExtensionData(f),u,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(f,u,t,n,i){const r=this._viewProviders.get(u);if(!r)throw new Error(`No view provider found for '${u}'`);const{provider:o,extension:m}=r,g=this._extHostWebview.createNewWebview(f,{},m),E=new v(f,this._proxy,u,t,g,!0);this._webviewViews.set(f,E),await o.resolveWebviewView(E,{state:n},i)}async $onDidChangeWebviewViewVisibility(f,u){this.getWebviewView(f)._setVisible(u)}async $disposeWebviewView(f){const u=this.getWebviewView(f);this._webviewViews.delete(f),u.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const u=this._webviewViews.get(f);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=S}),define(ge[128],pe([0,1,3,5,2,10,8,4,15]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class xn{constructor(P){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,c){let p;if(typeof P=="string"){p=P;try{P=C.URI.parse(P)}catch(l){return Promise.reject(`Invalid uri - '${P}'`)}}return y.isFalsyOrWhitespace(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,p,c)}async asExternalUri(P,c){if(y.isFalsyOrWhitespace(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(P,c);return C.URI.from(p)}};I.InitialState={focused:!0},I=Ve([He(0,D.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=k.createDecorator("IExtHostWindow")}),define(ge[250],pe([0,1,9,101,32,49,6,5,2,15]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let s=class extends y.Disposable{constructor(c,p){super();const l=c.getProxy(k.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async h=>{const _=D.URI.file(w.join(R.tmpdir(),C.generateUuid()));return await l.$download(h,_),_})}};s=Ve([He(0,I.IExtHostRpcService),He(1,A.IExtHostCommands)],s),e.ExtHostDownloadService=s}),define(ge[251],pe([0,1,2,9,148,28,66,27,15,6,14,112,43]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(v,S,d){this.name=v,this.file=S,this.appender=d}static async create(v,S){const d=await P.createRotatingLogger(v,S,30*c.ByteSize.MB,1);return d.clearFormatters(),new p(v,S,d)}append(v){this.appender.critical(v)}flush(){this.appender.flush()}}class l extends y.AbstractExtHostOutputChannel{constructor(v,S,d){super(v,!1,w.URI.file(S.file),d);this._appender=S}append(v){super.append(v),this._appender.append(v),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(v,S){this._appender.flush(),super.show(v,S)}clear(){this._appender.flush(),super.clear()}}let h=class extends y.ExtHostOutputService{constructor(v,S,d){super(v);this.logService=S,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new I.MutableDisposable,this._logsLocation=d.logsLocation}$setVisibleChannel(v){if(v){const S=this._channels.get(v);S&&(this._visibleChannelDisposable.value=S.onDidAppend(()=>S.update()))}}createOutputChannel(v){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const S=this._doCreateOutChannel(v);return S.then(d=>d._id.then(f=>this._channels.set(f,d))),new y.LazyOutputChannel(v,S)}async _doCreateOutChannel(v){try{const S=R.join(this._logsLocation.fsPath,`output_logging_${C.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(S)||await A.Promises.mkdir(S,{recursive:!0});const f=`${this._namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}`,u=w.URI.file(R.join(S,`${f}.log`)),t=await p.create(f,u.fsPath);return new l(v,t,this._proxy)}catch(S){return this.logService.error(S),new y.ExtHostPushOutputChannel(v,this._proxy)}}};h=Ve([He(0,D.IExtHostRpcService),He(1,s.ILogService),He(2,k.IExtHostInitDataService)],h),e.ExtHostOutputService2=h}),define(ge[252],pe([0,1,32,15,33]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends C.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,D,I){return this.createTerminalFromOptions({name:k,shellPath:D,shellArgs:I})}createTerminalFromOptions(k,D){const I=new C.ExtHostTerminal(this._proxy,w.generateUuid(),k,k.name);return this._terminals.push(I),I.create(k,D),I.value}};A=Ve([He(0,R.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(ge[253],pe([0,1,5,15,6,27,2,37,24,28,7,11,48,3,74,14]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(m,g,E){this.remoteAddress=m,this.localAddress=g,this._dispose=E,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function v(o){const m=o.trim().split(`
`),g=[];return m.forEach(b=>{const a=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);a&&a.length>=3&&g.push({pid:parseInt(a[1],10),socket:parseInt(a[2],10)})}),g.reduce((b,a)=>(b[a.socket]=a,b),{})}e.getSockets=v;function S(...o){const m=[].concat(...o.map(f));return[...new Map(m.filter(g=>g.st==="0A").map(g=>{const E=g.local_address.split(":");return{socket:parseInt(g.inode,10),ip:d(E[0]),port:parseInt(E[1],16)}}).map(g=>[g.ip+":"+g.port,g])).values()]}e.loadListeningPorts=S;function d(o){let m="";if(o.length===8)for(let g=o.length-2;g>=0;g-=2)m+=parseInt(o.substr(g,2),16),g!==0&&(m+=".");else for(let g=o.length-4;g>=0;g-=4)m+=parseInt(o.substr(g,4),16).toString(16),g!==0&&(m+=":");return m}e.parseIpAddress=d;function f(o){const m=o.trim().split(`
`),g=m.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return m.map(b=>b.trim().split(/\s+/).reduce((a,L,O)=>(a[g[O]||O]=L,a),{}))}e.loadConnectionTable=f;function u(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function t(o){const m=o.trim().split(`
`),g=[];return m.forEach(E=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);b&&b.length>=4&&g.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),g}e.getRootProcesses=t;async function n(o,m,g){const E=g.reduce((a,L)=>(a[L.pid]=L,a),{}),b=[];return o.forEach(({socket:a,ip:L,port:O})=>{var W;const ee=m[a]?m[a].pid:void 0,oe=ee?(W=E[ee])===null||W===void 0?void 0:W.cmd:void 0;ee&&oe&&!u(oe)&&b.push({host:L,port:O,detail:oe,pid:ee})}),b}e.findPorts=n;function i(o,m,g){const E=new Map,b=t(m);for(const a of o){const L=g.get(a.port);if(L){E.set(a.port,L);continue}const O=b.find(W=>W.cmd.includes(`${a.port}`));if(O){let W=O,ee;do ee=b.find(oe=>oe.ppid===W.pid),ee&&(W=ee);while(ee);E.set(a.port,{host:a.ip,port:a.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else E.set(a.port,{host:a.ip,port:a.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=i;let r=class extends C.Disposable{constructor(m,g,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(w.MainContext.MainThreadTunnelService),P.isLinux&&g.remote.isRemote&&g.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,g){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(g,m.displayName);if(E){const b=new _(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,g){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:m,provider:g}),this._proxy.$registerPortsAttributesProvider(m,E),new s.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(m,g,E,b,a){const L=[];for(const W of m){const ee=this._portAttributesProviders.get(W);if(!ee)return[];L.push(...await Promise.all(g.map(async oe=>ee.provider.providePortAttributes(oe,E,b,a))))}const O=L.filter(W=>!!W);return O.length>0?O.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let g=new l.MovingAverage,E;for(;this._candidateFindingEnabled;){const b=new Date().getTime(),a=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${a.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-b;g.update(L),(!E||JSON.stringify(E)!==JSON.stringify(a))&&(E=a,await this._proxy.$onFoundNewCandidates(E)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(g.value)))}}async setTunnelExtensionFunctions(m){var g;return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider((g=m.tunnelFeatures)!==null&&g!==void 0?g:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,C.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,g){if(this._extensionTunnels.has(m.host)){const E=this._extensionTunnels.get(m.host);E.has(m.port)&&(g&&E.get(m.port).disposeListener.dispose(),await E.get(m.port).tunnel.dispose(),E.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,g){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(m,g);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const b=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const a=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:b,disposeListener:a}),c.TunnelDto.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const g=await Promise.all(m.map(b=>{var a;return this._showCandidatePort(b.host,b.port,(a=b.detail)!==null&&a!==void 0?a:"")})),E=m.filter((b,a)=>g[a]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(b=>b.port).join(", ")} to ${E.map(b=>b.port).join(", ")}`),E}async findCandidatePorts(){let m="",g="";try{m=await I.Promises.readFile("/proc/net/tcp","utf8"),g=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch(B){}const E=S(m,g),b=await new Promise(B=>{k.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,T,N)=>{B(T)})}),a=v(b),L=await I.readdir("/proc"),O=[];for(let B of L)try{const j=Number(B),T=D.joinPath(y.URI.file("/proc"),B);if((await I.Promises.stat(T.fsPath)).isDirectory()&&!isNaN(j)){const F=await I.Promises.readlink(D.joinPath(T,"cwd").fsPath),M=await I.Promises.readFile(D.joinPath(T,"cmdline").fsPath,"utf8");O.push({pid:j,cwd:F,cmd:M})}}catch(j){}const W=[],ee=E.filter(B=>{const j=a[B.socket];return j||W.push(B),j}),oe=n(ee,a,O);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const B=await new Promise(j=>{k.exec("ps -F -A -l | grep root",(T,N,F)=>{j(N)})});this._foundRootPorts=i(W,B,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return oe.then(B=>V?B.concat(V):B)}};r=Ve([He(0,R.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,h.ILogService)],r),e.ExtHostTunnelService=r}),define(ge[254],pe([0,1,13,21,16,3,6,99,222,126,23]),function(Q,e,w,R,C,A,y,k,D,I,s){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(r,o){try{return JSON.stringify(r,o)}catch(m){return"null"}}function p(r,o){return JSON.stringify(r,o)}function l(r){return r?(o,m)=>m&&m.$mid===1?r.transformOutgoing(m):m:null}var h;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},S=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class f extends y.Disposable{constructor(o,m=null,g=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=m,this._uriTransformer=g,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,b=I.ProxyIdentifier.count;E<b;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?k.transformIncomingURIs(o,this._uriTransformer):o}getProxy(o){const{nid:m,sid:g}=o;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,g)),this._proxies[m]}_createProxy(o,m){let g={get:(E,b)=>(typeof b=="string"&&!E[b]&&b.charCodeAt(0)===36&&(E[b]=(...a)=>this._remoteCall(o,b,a)),b===d?m:E[b])};return new Proxy(Object.create(null),g)}set(o,m){return this._locals[o.nid]=m,m}assertRegistered(o){for(let m=0,g=o.length;m<g;m++){const E=o[m];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const m=o.byteLength,g=u.read(o,0),E=g.readUInt8(),b=g.readUInt32();switch(E){case 1:case 2:{let{rpcId:a,method:L,args:O}=t.deserializeRequestJSONArgs(g);this._uriTransformer&&(O=k.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(m,b,a,L,O,E===2);break}case 3:case 4:{let{rpcId:a,method:L,args:O}=t.deserializeRequestMixedArgs(g);this._uriTransformer&&(O=k.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(m,b,a,L,O,E===4);break}case 5:{this._logger&&this._logger.logIncoming(m,b,0,"ack"),this._onDidReceiveAcknowledge(b);break}case 6:{this._receiveCancel(m,b);break}case 7:{this._receiveReply(m,b,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(g);this._uriTransformer&&(a=k.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(m,b,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(g);this._receiveReply(m,b,a);break}case 10:{let a=t.deserializeReplyErrError(g);this._uriTransformer&&(a=k.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(m,b,a);break}case 11:{this._receiveReplyErr(m,b,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,m,g,E,b,a){this._logger&&this._logger.logIncoming(o,m,1,`receiveRequest ${I.getStringIdentifierForProxy(g)}.${E}(`,b);const L=String(m);let O,W;if(a){const oe=new R.CancellationTokenSource;b.push(oe.token),O=this._invokeHandler(g,E,b),W=()=>oe.cancel()}else O=this._invokeHandler(g,E,b),W=v;this._cancelInvokedHandlers[L]=W;const ee=t.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(ee.byteLength,m,1,"ack"),this._protocol.send(ee),O.then(oe=>{delete this._cancelInvokedHandlers[L];const V=t.serializeReplyOK(m,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,m,1,"reply:",oe),this._protocol.send(V)},oe=>{delete this._cancelInvokedHandlers[L];const V=t.serializeReplyErr(m,oe);this._logger&&this._logger.logOutgoing(V.byteLength,m,1,"replyErr:",oe),this._protocol.send(V)})}_receiveCancel(o,m){this._logger&&this._logger.logIncoming(o,m,1,"receiveCancel");const g=String(m);this._cancelInvokedHandlers[g]&&this._cancelInvokedHandlers[g]()}_receiveReply(o,m,g){this._logger&&this._logger.logIncoming(o,m,0,"receiveReply:",g);const E=String(m);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const b=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],b.resolveOk(g)}_receiveReplyErr(o,m,g){this._logger&&this._logger.logIncoming(o,m,0,"receiveReplyErr:",g);const E=String(m);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const b=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let a;g&&(g.$isError?(a=new Error,a.name=g.name,a.message=g.message,a.stack=g.stack):a=g),b.resolveErr(a)}_invokeHandler(o,m,g){try{return Promise.resolve(this._doInvokeHandler(o,m,g))}catch(E){return Promise.reject(E)}}_doInvokeHandler(o,m,g){const E=this._locals[o];if(!E)throw new Error("Unknown actor "+I.getStringIdentifierForProxy(o));let b=E[m];if(typeof b!="function")throw new Error("Unknown method "+m+" on actor "+I.getStringIdentifierForProxy(o));return b.apply(E,g)}_remoteCall(o,m,g){if(this._isDisposed)return Promise.reject(C.canceled());let E=null;if(g.length>0&&R.CancellationToken.isCancellationToken(g[g.length-1])&&(E=g.pop()),E&&E.isCancellationRequested)return Promise.reject(C.canceled());const b=t.serializeRequestArguments(g,this._uriReplacer),a=++this._lastMessageId,L=String(a),O=new D.LazyPromise;E&&E.onCancellationRequested(()=>{const ee=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(ee.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(a);const W=t.serializeRequest(a,o,m,b,!!E);return this._logger&&this._logger.logOutgoing(W.byteLength,a,0,`request: ${I.getStringIdentifierForProxy(o)}.${m}(`,g),this._protocol.send(W),O}}e.RPCProtocol=f,P=S,f.UNRESPONSIVE_TIME=3*1e3;class u{constructor(o,m){this._buff=o,this._offset=m}static alloc(o,m,g){let E=new u(s.VSBuffer.alloc(g+1+4),0);return E.writeUInt8(o),E.writeUInt32(m),E}static read(o,m){return new u(o,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const g=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,g}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,g}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,m}static sizeMixedArray(o,m){let g=0;g+=1;for(let E=0,b=o.length;E<b;E++){const a=o[E],L=m[E];switch(g+=1,L){case 1:g+=this.sizeLongString(a);break;case 2:g+=this.sizeVSBuffer(a);break;case 3:break}}return g}writeMixedArray(o,m){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let g=0,E=o.length;g<E;g++){const b=o[g];switch(m[g]){case 1:this.writeUInt8(1),this.writeLongString(b);break;case 2:this.writeUInt8(2),this.writeVSBuffer(b);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(o);for(let g=0;g<o;g++)switch(this.readUInt8()){case 1:m[g]=this.readLongString();break;case 2:m[g]=this.readVSBuffer();break;case 3:m[g]=void 0;break}return m}}class t{static _arrayContainsBufferOrUndefined(o){for(let m=0,g=o.length;m<g;m++)if(o[m]instanceof s.VSBuffer||typeof o[m]=="undefined")return!0;return!1}static serializeRequestArguments(o,m){if(this._arrayContainsBufferOrUndefined(o)){let g=[],E=[];for(let b=0,a=o.length;b<a;b++){const L=o[b];L instanceof s.VSBuffer?(g[b]=L,E[b]=2):typeof L=="undefined"?(g[b]=s.VSBuffer.alloc(0),E[b]=3):(g[b]=s.VSBuffer.fromString(p(L,m)),E[b]=1)}return{type:"mixed",args:g,argsType:E}}return{type:"simple",args:p(o,m)}}static serializeRequest(o,m,g,E,b){return E.type==="mixed"?this._requestMixedArgs(o,m,g,E.args,E.argsType,b):this._requestJSONArgs(o,m,g,E.args,b)}static _requestJSONArgs(o,m,g,E,b){const a=s.VSBuffer.fromString(g),L=s.VSBuffer.fromString(E);let O=0;O+=u.sizeUInt8(),O+=u.sizeShortString(a),O+=u.sizeLongString(L);let W=u.alloc(b?2:1,o,O);return W.writeUInt8(m),W.writeShortString(a),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(o){const m=o.readUInt8(),g=o.readShortString(),E=o.readLongString();return{rpcId:m,method:g,args:JSON.parse(E)}}static _requestMixedArgs(o,m,g,E,b,a){const L=s.VSBuffer.fromString(g);let O=0;O+=u.sizeUInt8(),O+=u.sizeShortString(L),O+=u.sizeMixedArray(E,b);let W=u.alloc(a?4:3,o,O);return W.writeUInt8(m),W.writeShortString(L),W.writeMixedArray(E,b),W.buffer}static deserializeRequestMixedArgs(o){const m=o.readUInt8(),g=o.readShortString(),E=o.readMixedArray(),b=new Array(E.length);for(let a=0,L=E.length;a<L;a++){const O=E[a];typeof O=="string"?b[a]=JSON.parse(O):b[a]=O}return{rpcId:m,method:g,args:b}}static serializeAcknowledged(o){return u.alloc(5,o,0).buffer}static serializeCancel(o){return u.alloc(6,o,0).buffer}static serializeReplyOK(o,m,g){return typeof m=="undefined"?this._serializeReplyOKEmpty(o):m instanceof s.VSBuffer?this._serializeReplyOKVSBuffer(o,m):this._serializeReplyOKJSON(o,c(m,g))}static _serializeReplyOKEmpty(o){return u.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,m){let g=0;g+=u.sizeVSBuffer(m);let E=u.alloc(8,o,g);return E.writeVSBuffer(m),E.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,m){const g=s.VSBuffer.fromString(m);let E=0;E+=u.sizeLongString(g);let b=u.alloc(9,o,E);return b.writeLongString(g),b.buffer}static deserializeReplyOKJSON(o){const m=o.readLongString();return JSON.parse(m)}static serializeReplyErr(o,m){return m?this._serializeReplyErrEror(o,m):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,m){const g=s.VSBuffer.fromString(c(C.transformErrorForSerialization(m),null));let E=0;E+=u.sizeLongString(g);let b=u.alloc(10,o,E);return b.writeLongString(g),b.buffer}static deserializeReplyErrError(o){const m=o.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(o){return u.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var i;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(i||(i={}))}),define(ge[255],pe([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=w.createDecorator("remoteAgentService")}),define(ge[256],pe([0,1,10,9,11,2,4,255]),function(Q,e,w,R,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=y.createDecorator("pathService");let D=class{constructor(s,P){this.localUserHome=s,this.remoteAgentService=P,this.resolveOS=(async()=>{const c=await this.remoteAgentService.getEnvironment();return(c==null?void 0:c.os)||C.OS})(),this.resolveUserHome=(async()=>{const c=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(c==null?void 0:c.userHome)||s})()}async userHome(s){return(s==null?void 0:s.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?R.win32:R.posix)}async fileURI(s){let P="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const p=s.indexOf("/",2);p===-1?(P=s.substring(2),s="/"):(P=s.substring(2,p),s=s.substring(p)||"/")}return A.URI.from({scheme:w.Schemas.file,authority:P,path:s,query:"",fragment:""})}};D=Ve([He(1,k.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[68],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(y,k){this.line=y,this.character=k}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,k){return new w(0,0)}with(y){return new w(0,0)}}e.Position=w;class R{constructor(y,k,D,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(y,k),this.end=new w(D,I)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new R(0,0,0,0)}with(y){return new R(0,0,0,0)}}e.Range=R;var C;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,17,30,25,29,8,4,9,16,68]),function(Q,e,w,R,C,A,y,k,D,I,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return s.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",c=" characters skipped \u27EB",p=(P.length+c.length+5)*2;e.ISearchService=k.createDecorator("searchService");var l;(function(T){T[T.file=0]="file",T[T.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(T){T[T.File=1]="File",T[T.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function _(T){return!!T.preview}e.resultIsMatch=_;function v(T){return!!T.resource}e.isFileMatch=v;function S(T){return!!T.message}e.isProgressMessage=S;var d;(function(T){T[T.Normal=0]="Normal",T[T.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=f;class u{constructor(N,F,M){this.ranges=F;const U=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(U)){N=y.getNLines(N,M.matchLines);let x="",G=0,se=0;const be=Math.floor(M.charsPerLine/5),Te=[];for(const Ce of U){const Me=Math.max(Ce.startColumn-be,0),qe=Ce.startColumn+M.charsPerLine;if(Me>se+be+p){const ze=P+(Me-se)+c;x+=ze+N.slice(Me,qe),G+=Me-(se+ze.length)}else x+=N.slice(se,qe);Te.push(new i(0,Ce.startColumn-G,Ce.endColumn-G)),se=qe}this.preview={text:x,matches:Array.isArray(this.ranges)?Te:Te[0]}}else{const x=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:N,matches:w.mapArrayOrNot(F,G=>new n(G.startLineNumber-x,G.startColumn,G.endLineNumber-x,G.endColumn))}}}}e.TextSearchMatch=u;function t(T){const N=T[0].startLineNumber;for(const F of T)if(F.startLineNumber!==N||F.endLineNumber!==N)return!1;return!0}class n{constructor(N,F,M,U){this.startLineNumber=N,this.startColumn=F,this.endLineNumber=M,this.endColumn=U}}e.SearchRange=n;class i extends n{constructor(N,F,M){super(N,F,N,M)}}e.OneLineRange=i;var r;(function(T){T.Default="default",T.FileNames="fileNames",T.Type="type",T.Modified="modified",T.CountDescending="countDescending",T.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function o(T,N=!0){const F=T&&T.files&&T.files.exclude,M=N&&T&&T.search&&T.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let U=Object.create(null);return U=C.mixin(U,C.deepClone(F)),U=C.mixin(U,C.deepClone(M),!0),U}e.getExcludes=o;function m(T,N){return T.excludePattern&&R.match(T.excludePattern,N)?!1:T.includePattern||T.usingSearchPaths?T.includePattern&&R.match(T.includePattern,N)?!0:T.usingSearchPaths?!!T.folderQueries&&T.folderQueries.some(F=>{const M=F.folder.fsPath;if(A.isEqualOrParent(N,M)){const U=D.relative(M,N);return!F.includePattern||!!R.match(F.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var g;(function(T){T[T.unknownEncoding=1]="unknownEncoding",T[T.regexParseError=2]="regexParseError",T[T.globParseError=3]="globParseError",T[T.invalidLiteral=4]="invalidLiteral",T[T.rgProcessError=5]="rgProcessError",T[T.other=6]="other",T[T.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(N,F){super(N);this.code=F}}e.SearchError=E;function b(T){const N=T.message;if(I.isPromiseCanceledError(T))return new E(N,g.canceled);try{const F=JSON.parse(N);return new E(F.message,F.code)}catch(F){return new E(N,g.other)}}e.deserializeSearchError=b;function a(T){const N={message:T.message,code:T.code};return new Error(JSON.stringify(N))}e.serializeSearchError=a;function L(T){return T.type==="error"?!0:T.type==="success"}e.isSerializedSearchComplete=L;function O(T){return T.type==="success"}e.isSerializedSearchSuccess=O;function W(T){return!!T.path}e.isSerializedFileMatch=W;function ee(T,N){const F=T.searchPath?T.searchPath:T.relativePath;return y.fuzzyContains(F,N)}e.isFilePatternMatch=ee;class oe{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=oe;function V(T,N){const F=Object.assign(Object.assign({},T||{}),N||{});return Object.keys(F).filter(M=>{const U=F[M];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=V;class B{constructor(N,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=N.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(N,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,F,M))}includedInQuery(N,F,M){return Promise.resolve(this._parsedExcludeExpression(N,F,M)).then(x=>!!x).then(x=>x?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,F,M)).then(G=>!!G):Promise.resolve(!0)).then(x=>x)}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=B;function j(T){for(const N in T)if(typeof T[N]!="boolean")return!0;return!1}}),define(ge[34],pe([0,1,17,13,21,3,22,10,74,24,8,12,2,167,4,14,186,61,62,27,15,7,31,5]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d,f,u,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(L,O,W){return new I.ExtUri(ee=>g(ee,W)).isEqual(L,O)}function r(L,O,W){return i(L.uri,O.uri,W)?0:s.compare(L.uri.toString(),O.uri.toString())}function o(L,O,W){return L.index!==O.index?L.index<O.index?-1:1:i(L.uri,O.uri,W)?s.compare(L.name,O.name):s.compare(L.uri.toString(),O.uri.toString())}function m(L,O,W,ee){const oe=L.slice(0).sort((B,j)=>W(B,j,ee)),V=O.slice(0).sort((B,j)=>W(B,j,ee));return w.delta(oe,V,(B,j)=>W(B,j,ee))}function g(L,O){const W=O.getCapabilities(L.scheme);return!(W&&W&1024)}class E extends v.Workspace{constructor(O,W,ee,oe,V,B){super(O,ee.map(j=>new v.WorkspaceFolder(j)),oe,B);this._name=W,this._isUntitled=V,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(B),ee.forEach(j=>{this._workspaceFolders.push(j),this._structure.set(j.uri,j)})}static toExtHostWorkspace(O,W,ee,oe){if(!O)return{workspace:null,added:[],removed:[]};const{id:V,name:B,folders:j,configuration:T,isUntitled:N}=O,F=[],M=W;W?j.forEach((se,be)=>{const Te=c.URI.revive(se.uri),Ce=E._findFolder(ee||W,Te,oe);Ce?(Ce.name=se.name,Ce.index=se.index,F.push(Ce)):F.push({uri:Te,name:se.name,index:be})}):F.push(...j.map(({uri:se,name:be,index:Te})=>({uri:c.URI.revive(se),name:be,index:Te}))),F.sort((se,be)=>se.index<be.index?-1:1);const U=new E(V,B,F,T?c.URI.revive(T):null,!!N,se=>g(se,oe)),{added:x,removed:G}=m(M?M.workspaceFolders:[],U.workspaceFolders,r,oe);return{workspace:U,added:x,removed:G}}static _findFolder(O,W,ee){for(let oe=0;oe<O.folders.length;oe++){const V=O.workspaceFolders[oe];if(i(V.uri,W,ee))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,W){return W&&this._structure.get(O)&&(O=I.dirname(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let b=class{constructor(O,W,ee,oe){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=oe,this._extHostFileSystemInfo=ee,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const V=W.workspace;this._confirmedWorkspace=V?new E(V.id,V.name,[],V.configuration?c.URI.revive(V.configuration):null,!!V.isUntitled,B=>g(B,ee)):void 0}$initializeWorkspace(O,W){this._trusted=W,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:I.basename(I.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,W,ee,...oe){const V=[];if(Array.isArray(oe)&&oe.forEach(F=>{c.URI.isUri(F.uri)&&!V.some(M=>i(M.uri,F.uri,this._extHostFileSystemInfo))&&V.push({uri:F.uri,name:F.name||I.basenameOrAuthority(F.uri)})}),this._unconfirmedWorkspace||[W,ee].some(F=>typeof F!="number"||F<0)||ee===0&&V.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+ee>B.length)return!1;const j=B.slice(0);j.splice(W,ee,...V.map(F=>({uri:F.uri,name:F.name||I.basenameOrAuthority(F.uri),index:void 0})));for(let F=0;F<j.length;F++){const M=j[F];if(j.some((U,x)=>x!==F&&i(M.uri,U.uri,this._extHostFileSystemInfo)))return!1}j.forEach((F,M)=>F.index=M);const{added:T,removed:N}=m(B,j,o,this._extHostFileSystemInfo);if(T.length===0&&N.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,W,ee,V).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,p.localize(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(O,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async getWorkspaceFolder2(O,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,W){let ee,oe="";if(typeof O=="string"?(ee=c.URI.file(O),oe=O):typeof O!="undefined"&&(ee=O,oe=O.fsPath),!ee)return oe;const V=this.getWorkspaceFolder(ee,!0);if(!V)return oe;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let B=I.relativePath(V.uri,ee);return W&&V.name&&(B=`${V.name}/${B}`),B}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:W,added:ee,removed:oe}=E.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ee,removed:oe}))}findFiles(O,W,ee,oe,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${oe.value}, entryPoint: findFiles`);let B;if(W===null?B=!1:W&&(typeof W=="string"?B=W:B=W.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:T}=a(O);return this._proxy.$startFileSearch(P.withUndefinedAsNull(j),P.withUndefinedAsNull(T),P.withUndefinedAsNull(B),P.withUndefinedAsNull(ee),V).then(N=>Array.isArray(N)?N.map(F=>c.URI.revive(F)):[])}async findTextInFiles(O,W,ee,oe,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${oe.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),j=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:T,folder:N}=a(W.include),F=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,M={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:j,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:T,excludePattern:F},U=!1;if(this._activeSearchCallbacks[B]=x=>{if(U)return;const G=c.URI.revive(x.resource);x.results.forEach(se=>{t.resultIsMatch(se)?ee({uri:G,preview:{text:se.preview.text,matches:w.mapArrayOrNot(se.preview.matches,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:w.mapArrayOrNot(se.ranges,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):ee({uri:G,text:se.text,lineNumber:se.lineNumber})})},V.isCancellationRequested)return{};try{const x=await this._proxy.$startTextSearch(O,P.withUndefinedAsNull(N),M,B,V);return delete this._activeSearchCallbacks[B],x||{}}catch(x){throw delete this._activeSearchCallbacks[B],x}}$handleTextSearchResult(O,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=Ve([He(0,f.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,h.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=l.createDecorator("IExtHostWorkspace");function a(L){let O,W;return L&&(typeof L=="string"?O=L:(O=L.pattern,W=L.baseFolder||c.URI.file(L.base))),{includePattern:O,folder:W}}}),define(ge[35],pe([0,1,25,3,34,5,7,189,83,12,13,4,15,14,2]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(n,i){if(i){const r=i.split(".");let o=n;for(let m=0;o&&m<r.length;m++)o=o[r[m]];return o}}function _(n){return n instanceof l.URI}function v(n){return n&&n.uri instanceof l.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function d(n){return n&&n.uri instanceof l.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function f(n){if(_(n))return{resource:n};if(v(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(d(n))return{resource:n.uri};if(n===null)return{resource:null}}let u=class{constructor(i,r,o){this._proxy=i.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new s.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(i,r))}};u=Ve([He(0,c.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,p.ILogService)],u),e.ExtHostConfiguration=u;class t{constructor(i,r,o,m){this._onDidChangeConfiguration=new R.Emitter,this._proxy=i,this._logService=m,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(i,r,o){const m=f(r)||{},g=this._toReadonlyValue(i?h(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,m,o==null?void 0:o.identifier);function E(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(a){return typeof h(g,a)!="undefined"},get:(a,L)=>{this._validateConfigurationAccess(i?`${i}.${a}`:a,m,o==null?void 0:o.identifier);let O=h(g,a);if(typeof O=="undefined")O=L;else{let W;const ee=(oe,V)=>{let B;const j=()=>{W=W||w.deepClone(g),B=B||h(W,V)};return I.isObject(oe)?new Proxy(oe,{get:(T,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return j(),()=>B;if(W)return B=B||h(W,V),B[N];const F=T[N];return typeof N=="string"?ee(F,`${V}.${N}`):F},set:(T,N,F)=>(j(),B&&(B[N]=F),!0),deleteProperty:(T,N)=>(j(),B&&delete B[N],!0),defineProperty:(T,N,F)=>(j(),B&&Object.defineProperty(B,N,F),!0)}):oe};O=ee(O,a)}return O},update:(a,L,O,W)=>{a=i?`${i}.${a}`:a;const ee=E(O);return L!==void 0?this._proxy.$updateConfigurationOption(ee,a,L,m,W):this._proxy.$removeConfigurationOption(ee,a,m,W)},inspect:a=>{var L,O,W,ee,oe,V,B,j;a=i?`${i}.${a}`:a;const T=w.deepClone(this._configuration.inspect(a,m,this._extHostWorkspace.workspace));if(T)return{key:a,defaultValue:(L=T.default)===null||L===void 0?void 0:L.value,globalValue:(O=T.user)===null||O===void 0?void 0:O.value,workspaceValue:(W=T.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(ee=T.workspaceFolder)===null||ee===void 0?void 0:ee.value,defaultLanguageValue:(oe=T.default)===null||oe===void 0?void 0:oe.override,globalLanguageValue:(V=T.user)===null||V===void 0?void 0:V.override,workspaceLanguageValue:(B=T.workspace)===null||B===void 0?void 0:B.override,workspaceFolderLanguageValue:(j=T.workspaceFolder)===null||j===void 0?void 0:j.override,languageIds:T.overrideIdentifiers}}};return typeof g=="object"&&w.mixin(b,g,!1),Object.freeze(b)}_toReadonlyValue(i){const r=o=>I.isObject(o)?new Proxy(o,{get:(m,g)=>r(m[g]),set:(m,g,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(m,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(m,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(i)}_validateConfigurationAccess(i,r,o){const m=D.OVERRIDE_PROPERTY_PATTERN.test(i)?4:this._configurationScopes.get(i),g=o?`[${o.value}] `:"";if(m===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){(r==null?void 0:r.resource)&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,r){const o=new k.ConfigurationChangeEvent(i,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,g)=>o.affectsConfiguration(m,f(g))})}_toMap(i){return i.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=P.createDecorator("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[69],pe([0,1,2,13,3,5,7,34,40,35,21,33,15,27,4,10,11,14,65,207,16]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function B(j){if(j!=null)return j}oe.to=B})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function B(j){if(j!=null)return j}oe.to=B})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function B(j){if(j!=null)return j}oe.to=B})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(oe){function V(T){if(T){const N=T;return N&&!!N.process}else return!1}oe.is=V;function B(T){if(T==null)return;const N={process:T.process,args:T.args};return T.options&&(N.options=i.from(T.options)),N}oe.from=B;function j(T){if(T!=null)return new y.ProcessExecution(T.process,T.args,T.options)}oe.to=j})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function B(j){if(j!=null)return j}oe.to=B})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(oe){function V(T){if(T){const N=T;return N&&(!!N.commandLine||!!N.command)}else return!1}oe.is=V;function B(T){if(T==null)return;const N={};return T.commandLine!==void 0?N.commandLine=T.commandLine:(N.command=T.command,N.args=T.args),T.options&&(N.options=o.from(T.options)),N}oe.from=B;function j(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new y.ShellExecution(T.commandLine,T.options):new y.ShellExecution(T.command,T.args?T.args:[],T.options)}oe.to=j})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(oe){function V(T){if(T){let N=T;return N&&N.customExecution==="customExecution"}else return!1}oe.is=V;function B(T){return{customExecution:"customExecution"}}oe.from=B;function j(T,N){return N.get(T)}oe.to=j})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(oe){function V(B,j){let T;return B.scope!==void 0&&typeof B.scope!="number"?T=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===y.TaskScope.Workspace&&j&&j.workspaceFile?T=j.workspaceFile:T=d.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:T}}oe.from=V})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(oe){function V(T,N){if(T==null)return[];const F=[];for(let M of T){const U=B(M,N);U&&F.push(U)}return F}oe.fromMany=V;function B(T,N){if(T==null)return;let F;T.execution instanceof y.ProcessExecution?F=r.from(T.execution):T.execution instanceof y.ShellExecution?F=m.from(T.execution):T.execution&&T.execution instanceof y.CustomExecution&&(F=g.from(T.execution));const M=t.from(T.definition);let U;if(T.scope?typeof T.scope=="number"?U=T.scope:U=T.scope.uri:U=y.TaskScope.Workspace,!M||!U)return;const x=T.group?T.group.id:void 0;return{_id:T._id,definition:M,name:T.name,source:{extensionId:N.identifier.value,label:T.source,scope:U},execution:F,isBackground:T.isBackground,group:x,presentationOptions:n.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}oe.from=B;async function j(T,N,F){if(T==null)return;let M;r.is(T.execution)?M=r.to(T.execution):m.is(T.execution)?M=m.to(T.execution):g.is(T.execution)&&(M=g.to(T._id,F));const U=t.to(T.definition);let x;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?x=T.source.scope:x=await N.resolveWorkspaceFolder(w.URI.revive(T.source.scope)):x=y.TaskScope.Workspace),!U||!x)return;const G=new y.Task(U,x,T.name,T.source.label,M,T.problemMatchers);return T.isBackground!==void 0&&(G.isBackground=T.isBackground),T.group!==void 0&&(G.group=y.TaskGroup.from(T.group)),T.presentationOptions&&(G.presentationOptions=n.to(T.presentationOptions)),T._id&&(G._id=T._id),T.detail&&(G.detail=T.detail),G}oe.to=j})(b=e.TaskDTO||(e.TaskDTO={}));var a;(function(oe){function V(j){return j}oe.from=V;function B(j){if(!!j)return Object.assign(Object.create(null),j)}oe.to=B})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(V,B,j){this._id=B,this._task=j,u.set(this,void 0),nt(this,u,V,"f")}get task(){return this._task}terminate(){Be(this,u,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}u=new WeakMap;var O;(function(oe){function V(B){return{id:B._id,task:void 0}}oe.from=V})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(V,B,j,T,N,F,M,U){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=V.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=j,this._editorService=T,this._configurationService=N,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=U,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,B,j){if(!j)return new y.Disposable(()=>{});const T=this.nextHandle();return this._handlers.set(T,{type:B,provider:j,extension:V}),this._proxy.$registerTaskProvider(T,B),new y.Disposable(()=>{this._handlers.delete(T),this._proxy.$unregisterTaskProvider(T)})}registerTaskSystem(V,B){this._proxy.$registerTaskSystem(V,B)}fetchTasks(V){return this._proxy.$fetchTasks(a.from(V)).then(async B=>{const j=[];for(let T of B){const N=await b.to(T,this._workspaceProvider,this._providedCustomExecutions2);N&&j.push(N)}return j})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(B=>V.push(B)),V}terminateTask(V){if(!(V instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,B,j){const T=this._providedCustomExecutions2.get(V.id);if(T){if(this._activeCustomExecutions2.get(V.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(V.id,T),this._terminalService.attachPtyToTerminal(B,await T.callback(j))}this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const B=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const B=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:B,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const B=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:V.exitCode})}$provideTasks(V,B){const j=this._handlers.get(V);if(!j)return Promise.reject(new Error("no handler found"));const T=[],N=R.asPromise(()=>j.provider.provideTasks(s.CancellationToken.None)).then(F=>this.provideTasksInternal(B,T,j,F));return new Promise(F=>{N.then(M=>{Promise.all(T).then(()=>{F(M)})})})}async $resolveTask(V,B){const j=this._handlers.get(V);if(!j)return Promise.reject(new Error("no handler found"));if(B.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${j.type}].`);const T=await b.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const N=await j.provider.resolveTask(T,s.CancellationToken.None);if(!N)return;this.checkDeprecation(N,j);const F=b.from(N,j.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(F.execution)&&await this.addCustomExecution(F,N,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,B,j){const T=await this._proxy.$createTaskId(V);!j&&!this._providedCustomExecutions2.has(T)&&this._notProvidedCustomExecutions.add(T),this._providedCustomExecutions2.set(T,B.execution)}async getTaskExecution(V,B){if(typeof V=="string"){const N=this._taskExecutionPromises.get(V);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let j=this._taskExecutionPromises.get(V.id);if(j)return j;const T=new Promise(async(N,F)=>{const M=B||await b.to(V.task,this._workspaceProvider,this._providedCustomExecutions2);M?N(new L(this,V.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(V.id,T),T.then(N=>(this._taskExecutions.set(V.id,N),N),N=>Promise.reject(N))}checkDeprecation(V,B){V._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let j=this._notProvidedCustomExecutions.values(),T=j.next();for(;!T.done;)!this._activeCustomExecutions2.has(T.value)&&this._lastStartedTask!==T.value&&(this._providedCustomExecutions2.delete(T.value),this._notProvidedCustomExecutions.delete(T.value)),T=j.next()}};W=Ve([He(0,c.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,v.ILogService),He(7,S.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let ee=class extends W{constructor(V,B,j,T,N,F,M,U){super(V,B,j,T,N,F,M,U);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(V,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const j=b.from(B,V);if(j===void 0)throw new Error("Task is not valid");if(g.is(j.execution))await this.addCustomExecution(j,B,!1);else throw new f.NotSupportedError;const T=await this.getTaskExecution(await this._proxy.$getTaskExecution(j),B);return this._proxy.$executeTask(j).catch(N=>{throw new Error(N)}),T}provideTasksInternal(V,B,j,T){const N=[];if(T)for(let F of T){this.checkDeprecation(F,j),(!F.definition||!V[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=b.from(F,j.extension);M&&g.is(M.execution)?(N.push(M),B.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:j.extension}}async resolveTaskInternal(V){if(g.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,B,j){}};ee=Ve([He(0,c.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,v.ILogService),He(7,S.IExtHostApiDeprecationService)],ee),e.WorkerExtHostTask=ee,e.IExtHostTask=l.createDecorator("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)},Qt=this&&this.__rest||function(Q,e){var w={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(w[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(Q);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[C])&&(w[R[C]]=Q[R[C]]);return w};define(ge[257],pe([0,1,17,13,23,21,3,72,54,6,25,12,2,32,5,40,15,86,20,7,34,217,123]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d,f,u,t){"use strict";var n,i,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const m=(j,T)=>`${j}:${T.toString()}`;let g=class{constructor(T,N,F){this.documents=N,this.workspace=F,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new u.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(l.MainContext.MainThreadTesting),this.runQueue=new E(this.proxy),this.workspaceObservers=new V(this.proxy),this.textDocumentObservers=new B(this.proxy,N)}registerTestController(T,N){const F=p.generateUuid();this.controllers.set(F,{instance:N,extensionId:T}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var U;for(const x of M)(U=this.testControllers.get(x))===null||U===void 0||U.subscribeFn(F,N)},0),new d.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(T){return this.textDocumentObservers.checkout(T.uri)}createWorkspaceTestObserver(T){return this.workspaceObservers.checkout(T.uri)}async runTests(T,N=A.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(P.isDefined).map(U=>({src:U.src,testId:U.item.extId}));await this.proxy.$runTests({exclude:T.exclude?F(T.exclude).map(M=>M.testId):void 0,tests:F(T.tests),debug:T.debug},N)}createTestRun(T,N,F,M=!0){return this.runQueue.createTestRun(T,N,F,M)}$publishTestResults(T){this.results=Object.freeze(T.map(N=>s.deepFreeze(S.TestResults.to(N))).concat(this.results).sort((N,F)=>F.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(T,N){const F=c.URI.revive(N),M=m(T,F);if(this.testControllers.has(M))return;const U=new A.CancellationTokenSource;let x;if(T===1){let Ce=this.documents.getDocument(F);if(!Ce){const Me=new I.DisposableStore;Ce=await new Promise(qe=>{Me.add(R.disposableTimeout(()=>qe(void 0),5e3)),Me.add(this.documents.onDidAddDocuments(ze=>{const Ke=ze.find(q=>q.document.uri.toString()===F.toString());Ke&&qe(Ke)}))}).finally(()=>Me.dispose())}if(Ce){const Me=await this.workspace.getWorkspaceFolder2(F,!1);x=qe=>qe.createDocumentTestRoot?qe.createDocumentTestRoot(Ce.document,U.token):e.createDefaultDocumentTestRoot(qe,Ce.document,Me,U.token)}}else{const Ce=await this.workspace.getWorkspaceFolder2(F,!1);Ce&&(x=Me=>Me.createWorkspaceTestRoot(Ce,U.token))}if(!x)return;const G=async(Ce,Me)=>{try{const qe=await x(Me);qe&&be.addRoot(qe,Ce)}catch(qe){console.error(qe)}},se=new I.DisposableStore,be=se.add(this.ownedTests.createForHierarchy(Ce=>this.proxy.$publishDiff(T,N,Ce)));se.add(I.toDisposable(()=>U.dispose(!0)));const Te=[];for(const[Ce,Me]of this.controllers)Te.push(G(Ce,Me.instance));Promise.all(Te).then(()=>be.pushDiff([3,-1])),this.testControllers.set(M,{store:se,collection:be,subscribeFn:G})}async $expandTest(T,N){const F=w.mapFind(this.testControllers.values(),M=>M.collection.treeId===T.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(T.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(T,N){var F;const M=c.URI.revive(N),U=m(T,M);(F=this.testControllers.get(U))===null||F===void 0||F.store.dispose(),this.testControllers.delete(U)}$acceptDiff(T,N,F){T===1?this.textDocumentObservers.acceptDiff(c.URI.revive(N),F):this.workspaceObservers.acceptDiff(c.URI.revive(N),F)}async $runTestsForProvider(T,N){const F=this.controllers.get(T.tests[0].src.controller);if(!F)return;const M=T.tests.map(({testId:G,src:se})=>this.ownedTests.getTestById(G,se==null?void 0:se.tree)).filter(P.isDefined).map(([G,se])=>se),U=T.excludeExtIds.map(G=>this.ownedTests.getTestById(G)).filter(P.isDefined).filter(([G,se])=>M.some(be=>G.comparePositions(be,se)===1));if(!M.length)return;const x={tests:M.map(G=>O.unwrap(G.actual)),exclude:U.map(([,G])=>O.unwrap(G.actual)),debug:T.debug};await this.runQueue.enqueueRun({dto:b.fromInternal(T),token:N,extensionId:F.extensionId,req:x,doRun:()=>F.instance.runTests(x,N)})}$lookupTest(T){const N=this.ownedTests.getTestById(T.testId);if(!N)return Promise.resolve(void 0);const F=N[1],{actual:M,discoverCts:U,expandLevels:x}=F,G=Qt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(G)}flushCollectionDiffs(){for(const{collection:T}of this.testControllers.values())T.flushDiff()}getInternalTestForReference(T){var N,F;return(F=(N=this.workspaceObservers.getMirroredTestDataByReference(T))!==null&&N!==void 0?N:w.mapFind(this.testControllers.values(),M=>M.collection.getTestByReference(T)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(T)}};g=Ve([He(0,_.IExtHostRpcService),He(1,h.IExtHostDocumentsAndEditors),He(2,f.IExtHostWorkspace)],g),e.ExtHostTesting=g;class E{constructor(T){this.proxy=T,this.state=new Map}enqueueRun(T){let N=this.state.get(T.extensionId);N||(N={queue:[],current:void 0},this.state.set(T.extensionId,N));const F=new R.DeferredPromise,M=()=>{const U=[],x=new Set;N.current={publicReq:T.req,factory:G=>{const se=new a(G,T.dto,x,this.proxy);return U.push(se),T.token.onCancellationRequested(()=>se.end()),se}},this.invokeRunner(T.extensionId,T.dto.id,T.doRun,U).finally(()=>F.complete())};return N.queue.push(M),N.queue.length===1&&M(),F.p}createTestRun(T,N,F,M){var U,x;const G=this.state.get(T);if((G==null?void 0:G.current.publicReq)===N)return G.current.factory(F);const se=b.fromPublic(N),be=new a(F,se,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(x=(U=N.exclude)===null||U===void 0?void 0:U.map(Te=>Te.id))!==null&&x!==void 0?x:[],id:se.id,tests:N.tests.map(Te=>Te.id),persist:M}),be.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(se.id)),be}invokeRunner(T,N,F,M){try{const U=F();return R.isThenable(U)?U.then(()=>this.handleInvokeResult(T,N,M,void 0)).catch(x=>this.handleInvokeResult(T,N,M,x)):this.handleInvokeResult(T,N,M,void 0)}catch(U){return this.handleInvokeResult(T,N,M,U)}}async handleInvokeResult(T,N,F,M){const U=this.state.get(T);!U||(U.queue.shift(),U.queue.length>0?U.queue[0]():this.state.delete(T),await Promise.all(F.map(x=>x.onEnd.wait())))}}class b{constructor(T,N,F){this.id=T,this.include=N,this.exclude=F}static fromPublic(T){var N,F;return new b(p.generateUuid(),new Set(T.tests.map(M=>M.id)),new Set((F=(N=T.exclude)===null||N===void 0?void 0:N.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(T){return new b(T.runId,new Set(T.tests.map(N=>N.testId)),new Set(T.excludeExtIds))}isIncluded(T){for(let N=T;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class a{constructor(T,N,F,M){this.name=T,n.set(this,void 0),i.set(this,void 0),r.set(this,p.generateUuid()),o.set(this,void 0),this.onEnd=new R.Barrier,nt(this,n,M,"f"),nt(this,i,N,"f"),nt(this,o,F,"f"),M.$startedTestRunTask(N.id,{id:Be(this,r,"f"),name:T,running:!0})}setState(T,N,F){Be(this,i,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,n,"f").$updateTestStateInRun(Be(this,i,"f").id,Be(this,r,"f"),T.id,N,F))}appendMessage(T,N){Be(this,i,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,n,"f").$appendTestMessageInRun(Be(this,i,"f").id,Be(this,r,"f"),T.id,S.TestMessage.from(N)))}appendOutput(T){Be(this,n,"f").$appendOutputToRun(Be(this,i,"f").id,Be(this,r,"f"),C.VSBuffer.fromString(T))}end(){Be(this,n,"f").$finishedTestRunTask(Be(this,i,"f").id,Be(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(T){const N=Be(this,o,"f");if(N.has(T.id))return;const F=[];for(;F.unshift(S.TestItem.from(T)),!(N.has(T.id)||(N.add(T.id),!T.parent));)T=T.parent;Be(this,n,"f").$addTestsToRun(Be(this,i,"f").id,F)}}n=new WeakMap,i=new WeakMap,r=new WeakMap,o=new WeakMap;const L=async(j,T,N,F)=>{if(!N)return;const M=await j.createWorkspaceTestRoot(N,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(T)});const U=O.getWrapperForTestItem(M,T);return U.refreshMatch(),U};e.createDefaultDocumentTestRoot=L;class O extends d.TestItemImpl{constructor(T,N,F){super(T.id,T.label,T.uri,void 0);if(this.actual=T,this.filterDocument=N,this.actualParent=F,!(T instanceof d.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${T.id} did not`);this.debuggable=T.debuggable,this.runnable=T.runnable,this.description=T.description,this.error=T.error,this.status=T.status,this.range=T.range,this.resolveHandler=T.resolveHandler;const M=v.getPrivateApiFor(this);v.getPrivateApiFor(T).bus.event(x=>{switch(x[0]){case 3:this[x[1]]=x[2];break;case 0:const G=O.getWrapperForTestItem(x[1],this.filterDocument,this);v.getPrivateApiFor(G).parent=T,G.refreshMatch();break;default:M.bus.fire(x)}})}static removeFilter(T){this.wrapperMap.delete(T)}static getWrapperForTestItem(T,N,F){let M=this.wrapperMap.get(N);if(M==null?void 0:M.has(T))return M.get(T);M||(M=new WeakMap,this.wrapperMap.set(N,M));const U=new O(T,N,F);return M.set(T,U),U}static unwrap(T){return T instanceof O?T.actual:T}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var T,N;const F=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const x=O.getWrapperForTestItem(U,this.filterDocument,this);x.hasNodeMatchingFilter?this.children.has(x.id)||this.addChild(x):x.dispose()}const M=this.children.size>0||((T=this.actual.uri)===null||T===void 0?void 0:T.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((N=this.actualParent)===null||N===void 0||N.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&v.getPrivateApiFor(this.actualParent).children.delete(this.id),v.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,S.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:N,removed:F}=this;return{get added(){return[...T].map(M=>M.revived)},get updated(){return[...N].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ee extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(T){let N=[];for(const F of T){const M=this.items.get(F);M&&N.push(M.revived)}return N}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,N){return Object.assign(Object.assign({},T),{revived:S.TestItem.toPlain(T.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=ee;class oe{constructor(){this.resources=new Map}checkout(T){var N,F;const M=T.toString(),U=(N=this.resources.get(M))!==null&&N!==void 0?N:this.createObserverData(T);return(F=U.pendingDeletion)===null||F===void 0||F.dispose(),U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return U.tests.rootTestItems},dispose:k.once(()=>{--U.observers||(U.pendingDeletion=this.eventuallyDispose(T))})}}getMirroredTestDataByReference(T){for(const{tests:N}of this.resources.values()){const F=N.getMirroredTestDataByReference(T);if(F)return F}}eventuallyDispose(T){return R.disposableTimeout(()=>this.unlisten(T),10*1e3)}createObserverData(T){const N=new ee,F=this.listen(T,U=>N.apply(U)),M={observers:0,tests:N,listener:F};return this.resources.set(T.toString(),M),M}unlisten(T){var N;const F=T.toString(),M=this.resources.get(F);M&&(M.observers=-1,(N=M.pendingDeletion)===null||N===void 0||N.dispose(),M.listener.dispose(),this.resources.delete(F))}}class V extends oe{constructor(T){super();this.proxy=T,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){this.proxy.$subscribeToDiffs(0,T);const F=T.toString();return this.diffListeners.set(F,N),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,T),this.diffListeners.delete(F)})}}class B extends oe{constructor(T,N){super();this.proxy=T,this.documents=N,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){if(!this.documents.getDocument(T))return new d.Disposable(()=>{});const M=T.toString();return this.diffListeners.set(M,N),this.proxy.$subscribeToDiffs(1,T),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,T),this.diffListeners.delete(M)})}}}),define(ge[258],pe([0,1,17,52,30,77,22,10,9,24,8,12,2,142,172,84,61,210,256,31]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(E,b,a,L){this.configurationService=E,this.workspaceContextService=b,this.editorGroupsService=a,this.pathService=L}text(E,b,a={}){E=this.getContentPattern(E,a);const L=this.configurationService.getValue(),O=b&&b.some(ee=>!this.configurationService.getValue({resource:ee}).search.useRipgrep),W=this.commonQuery(b==null?void 0:b.map(_.toWorkspaceFolder),a);return Object.assign(Object.assign({},W),{type:2,contentPattern:E,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(E,b){const a=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},E),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(E,b)&&(L.isCaseSensitive=!0),this.isMultiline(E)&&(L.isMultiline=!0),L}file(E,b={}){const a=this.commonQuery(E,b);return Object.assign(Object.assign({},a),{type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey})}handleIncludeExclude(E,b){return E?(E=Array.isArray(E)?E.map(r):r(E),b?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],b={}){const a=this.handleIncludeExclude(b.includePattern,b.expandPatterns),L=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),O=E.length>1,W=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,b,L)):E.map(V=>this.getFolderQueryForRoot(V,b,L,O))).filter(V=>!!V),ee={_reason:b._reason,folderQueries:W,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:L.pattern,includePattern:a.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const B=w.coalesce(w.flatten(this.editorGroupsService.groups.map(T=>T.editors.map(N=>N.resource)))).filter(T=>d.pathIncludedInQuery(ee,T.fsPath)),j=this.commonQueryFromFileList(B);return Object.assign(Object.assign({},ee),j)}const oe=b.extraFileResources&&b.extraFileResources.filter(V=>d.pathIncludedInQuery(ee,V.fsPath));return ee.extraFileResources=oe&&oe.length?oe:void 0,ee}commonQueryFromFileList(E){const b=[],a=new y.ResourceMap,L={};let O=!1;return E.forEach(W=>{var ee,oe;if(W.scheme===k.Schemas.walkThrough)return;if(I.isAbsolutePath(W)){const B=(oe=(ee=this.workspaceContextService.getWorkspaceFolder(W))===null||ee===void 0?void 0:ee.uri)!==null&&oe!==void 0?oe:W.with({path:D.dirname(W.fsPath)});let j=a.get(B);j||(O=!0,j={folder:B,includePattern:{}},b.push(j),a.set(B,j));const T=D.relative(B.fsPath,W.fsPath);P.assertIsDefined(j.includePattern)[T.replace(/\\/g,"/")]=!0}else W.fsPath&&(O=!0,L[W.fsPath]=!0)}),{folderQueries:b,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(E,b){if(b.isSmartCase){if(E.isRegExp){if(s.containsUppercaseCharacter(E.pattern,!0))return!0}else if(s.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&p.isMultilineRegexSource(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const b=j=>D.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),L=(Array.isArray(E)?E:n(E)).map(j=>{const T=this.pathService.resolvedUserHome;return T?A.untildify(j,T.scheme===k.Schemas.file?T.fsPath:T.path):j}),O=R.groupBy(L,j=>b(j)?"searchPaths":"exprSegments"),W=(O.exprSegments||[]).map(j=>s.rtrim(j,"/")).map(j=>s.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),i(j))),ee={},oe=this.expandSearchPathPatterns(O.searchPaths||[]);oe&&oe.length&&(ee.searchPaths=oe);const V=w.flatten(W),B=t(...V);return B&&(ee.pattern=B),ee}getExcludesForFolder(E,b){return b.disregardExcludeSettings?void 0:d.getExcludes(E,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const b=w.flatten(E.map(L=>{let{pathPortion:O,globPortion:W}=u(L);W&&(W=o(W));const ee=this.expandOneSearchPath(O);return w.flatten(ee.map(oe=>this.resolveOneSearchPathPattern(oe,W)))})),a=new Map;return b.forEach(L=>{const O=L.searchPath.toString(),W=a.get(O);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):a.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(E){if(D.isAbsolute(E)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==k.Schemas.file?[{searchPath:b[0].uri.with({path:E})}]:[{searchPath:c.URI.file(D.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=r(E),E.startsWith("../")||E===".."){const L=D.posix.resolve(b.path,E);return[{searchPath:b.with({path:L})}]}const a=o(E);return[{searchPath:b,pattern:a}]}else{if(E==="./"||E===".\\")return[];{const b=E.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const W=b.match(new RegExp(`^${O.name}(?:/(.*))?`));return W?{match:W,folder:O}:null}).filter(P.isDefined);if(L.length)return L.map(O=>{const W=O.match[1];return{searchPath:O.folder.uri,pattern:W&&o(W)}});{const O=E.match(/\.[\/\\](.+)[\/\\]?/),W=O?O[1]:E,ee=l.localize(0,null,W);throw new Error(ee)}}}}resolveOneSearchPathPattern(E,b){const a=E.pattern&&b?`${E.pattern}/${b}`:E.pattern||b,L=[{searchPath:E.searchPath,pattern:a}];return a&&!a.endsWith("**")&&L.push({searchPath:E.searchPath,pattern:a+"/**"}),L}getFolderQueryForSearchPath(E,b,a){const L=this.getFolderQueryForRoot(_.toWorkspaceFolder(E.searchPath),b,a,!1);return L?Object.assign(Object.assign({},L),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,b,a,L){let O;const W=c.URI.isUri(E)?E:E.uri;if(a.searchPaths){const j=a.searchPaths.filter(T=>I.isEqual(T.searchPath,W))[0];if(j&&!j.pattern)return null;j&&(O=j.pattern)}const ee=this.configurationService.getValue({resource:W}),oe=this.getExcludesForFolder(ee,b),V=Object.assign(Object.assign({},oe||{}),O||{}),B=c.URI.isUri(E)?I.basename(E):E.name;return{folder:W,folderName:L?B:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:ee.files&&ee.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!ee.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!ee.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!ee.search.followSymlinks}}};f=Ve([He(0,h.IConfigurationService),He(1,_.IWorkspaceContextService),He(2,v.IEditorGroupsService),He(3,S.IPathService)],f),e.QueryBuilder=f;function u(g){const E=g.match(/[\*\{\}\(\)\[\]\?]/);if(E){const b=E.index,a=g.substr(0,b).match(/[/|\\][^/\\]*$/);if(a){let L=g.substr(0,a.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:g.substr((a.index||0)+1)}}}return{pathPortion:g}}function t(...g){return g.length?g.reduce((E,b)=>(E[b]=!0,E),Object.create(null)):void 0}function n(g){return C.splitGlobAware(g,",").map(E=>E.trim()).filter(E=>!!E.length)}function i(g){return[`**/${g}/**`,`**/${g}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function r(g){return g.replace(/\\/g,"/")}function o(g){return r(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(g,E){g=w.distinct(g,L=>L.toString());const b=[],a=E.getWorkspace();return g&&g.forEach(L=>{let O;if(E.getWorkbenchState()===2)O=I.relativePath(a.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const W=E.getWorkspaceFolder(L);if(W){const ee=W.name;if(a.folders.filter(V=>V.name===ee).length===1){const V=I.relativePath(W.uri,L);V===""?O=`./${W.name}`:O=`./${W.name}/${V}`}else O=L.fsPath}}O&&b.push(O)}),b}e.resolveResourcesForSearchIncludes=m}),define(ge[259],pe([0,1,24,2,21,16,4,258,31,61]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const s=7e3;function P(h,_){const v=_.activationEvents;if(!v)return Promise.resolve(void 0);const S=[],d=[];for(const r of v)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||h.forceUsingSearch?d.push(o):S.push(o)}if(S.length===0&&d.length===0)return Promise.resolve(void 0);let f;const u=new Promise((r,o)=>{f=r}),t=r=>f({activationEvent:r}),n=Promise.all(S.map(r=>c(h,r,t))).then(()=>{}),i=p(h,_.identifier,d,t);return Promise.all([n,i]).then(()=>{f(void 0)}),u}e.checkActivateWorkspaceContainsExtension=P;async function c(h,_,v){for(const S of h.folders)if(await h.exists(w.joinPath(R.URI.revive(S),_))){v(`workspaceContains:${_}`);return}}async function p(h,_,v,S){if(v.length===0)return Promise.resolve(void 0);const d=new C.CancellationTokenSource,f=h.checkExists(h.folders,v,d.token),u=setTimeout(async()=>{d.cancel(),S(`workspaceContainsTimeout:${v.join(",")}`)},s);let t=!1;try{t=await f}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}d.dispose(),clearTimeout(u),t&&S(`workspaceContains:${v.join(",")}`)}function l(h,_,v,S){const d=h.get(y.IInstantiationService),f=h.get(D.ISearchService),t=d.createInstance(k.QueryBuilder).file(_.map(n=>I.toWorkspaceFolder(R.URI.revive(n))),{_reason:"checkExists",includePattern:v,exists:!0});return f.fileSearch(t,S).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=l});var nt=this&&this.__classPrivateFieldSet||function(Q,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!C:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(Q,w):C?C.value=w:e.set(Q,w),w},Be=this&&this.__classPrivateFieldGet||function(Q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(Q):R?R.value:e.get(Q)};define(ge[41],pe([0,1,162,9,70,24,13,6,22,2,14,5,35,220,90,34,39,218,16,26,23,196,7,116,4,27,91,15,82,48,33,3,259,88,197]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d,f,u,t,n,i,r,o,m,g,E,b,a,L,O,W){"use strict";var ee,oe,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=i.createDecorator("IHostUtils");let B=class Bn extends k.Disposable{constructor(F,M,U,x,G,se,be,Te,Ce,Me){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=U,this._initData=be,this._extHostWorkspace=x,this._extHostConfiguration=G,this._logService=se,this._extHostTunnelService=Ce,this._extHostTerminalService=Me,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=F.createChild(new g.ServiceCollection([l.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(ze=>qe.add(d.ExtensionIdentifier.toKey(ze))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Ke,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,S.transformErrorForSerialization(Ke),q)},actualActivateExtension:async(ze,Ke)=>{if(qe.has(d.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Ke),new p.HostExtension;const q=this._registry.getExtensionDescription(ze);return this._activateExtension(q,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){S.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this._deactivate(G))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const U=this._activator.getActivatedExtension(F);if(U.activationFailed)return Promise.reject(U.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(U=>{if(!!this._getEntryPoint(U))return this._hostUtils.realpath(U.extensionLocation.fsPath).then(x=>F.set(I.URI.file(x).fsPath,U))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const U=this._activator.getActivatedExtension(F);if(!U)return M;try{typeof U.module.deactivate=="function"&&(M=Promise.resolve(U.module.deactivate()).then(void 0,x=>(this._logService.error(x),Promise.resolve(void 0))))}catch(x){this._logService.error(x)}try{k.dispose(U.subscriptions)}catch(x){this._logService.error(x)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(U=>{const x=U.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,x.codeLoadingTime,x.activateCallTime,x.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",x),U},U=>{throw this._logExtensionActivationTimes(F,M,"failure"),U})}_logExtensionActivationTimes(F,M,U,x){const G=j(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},G),x||{}),{outcome:U}))}_doActivateExtension(F,M){const U=j(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",U);const x=this._getEntryPoint(F);if(!x)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const G=new p.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,A.joinPath(F.extensionLocation,x),G),this._loadExtensionContext(F)]).then(se=>(C.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Bn._callActivate(this._logService,F.identifier,se[0],se[1],G))).then(se=>(C.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),se))}_loadExtensionContext(F){const M=new u.ExtensionGlobalMemento(F,this._storage),U=new u.ExtensionMemento(F.identifier.value,!1,this._storage),x=new W.ExtensionSecrets(F,this._secretState),G=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,U.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Te;return Object.freeze({globalState:M,workspaceState:U,secrets:x,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Ce){return R.join(F.extensionLocation.fsPath,Ce)},get storagePath(){var Ce;return(Ce=be._storagePath.workspaceValue(F))===null||Ce===void 0?void 0:Ce.fsPath},get globalStoragePath(){return be._storagePath.globalValue(F).fsPath},get logPath(){return R.join(be._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return I.URI.joinPath(be._initData.logsLocation,F.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(F)},get globalStorageUri(){return be._storagePath.globalValue(F)},get extensionMode(){return G},get extension(){return Te===void 0&&(Te=new T(be,F.identifier,F,se)),Te},get extensionRuntime(){return _.checkProposedApiEnabled(F),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,U,x,G){return U=U||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,U,x,G).then(se=>new p.ActivatedExtension(!1,null,G.build(),U,se,x.subscriptions))}static _callActivateOptional(F,M,U,x,G){if(typeof U.activate=="function")try{G.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const se=typeof global=="object"?global:self,be=U.activate.apply(se,[x]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(be).then(Te=>(G.activateResolveStop(),Te))}catch(se){return Promise.reject(se)}else return Promise.resolve(U)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,U=>{this._logService.error(U)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,G=>{this._logService.error(G)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(G=>this._handleWorkspaceContainsEagerExtensions(G.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],U=this._handleWorkspaceContainsEagerExtensions(M),x=Promise.all([F,U]).then(()=>{});return Promise.race([x,y.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),x}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const U=!this._initData.remote.isRemote&&!!this._initData.remote.authority,x={folders:F.map(se=>se.uri),forceUsingSearch:U,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,be,Te)=>this._mainThreadWorkspaceProxy.$checkExists(se,be,Te)},G=await L.checkActivateWorkspaceContainsExtension(x,M);if(!!G)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:G.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(w.localize(0,null));const U=await this._loadCommonJSModule(null,M,new p.ExtensionActivationTimesBuilder(!1));if(!U||typeof U.run!="function")throw new Error(w.localize(1,null,M.toString()));return new Promise((x,G)=>{const se=(Ce,Me)=>{Ce?G(Ce):x(typeof Me=="number"&&Me>0?1:0)},be=A.originalFSPath(M),Te=U.run(be,se);Te&&Te.then&&Te.then(()=>{x(0)}).catch(Ce=>{G(Ce.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,k.toDisposable(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const U=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${U}`,!1),{authorityPrefix:U,resolver:this._resolvers[U]}}async $resolveAuthority(F,M){const{authorityPrefix:U,resolver:x}=await this._activateAndGetResolver(F);if(!x)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${U}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(x)),C.mark(`code/extHost/willResolveAuthority/${U}`);const G=await x.resolve(F,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${U}`);const se={authority:F,host:G.host,port:G.port,connectionToken:G.connectionToken},be={extensionHostEnv:G.extensionHostEnv,isTrusted:G.isTrusted};return{type:"ok",value:{authority:se,options:be,tunnelInformation:{environmentTunnels:G.environmentTunnels}}}}catch(G){if(C.mark(`code/extHost/didResolveAuthorityError/${U}`),G instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G}}async $getCanonicalURI(F,M){const{authorityPrefix:U,resolver:x}=await this._activateAndGetResolver(F);if(!x)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${U}`);const G=I.URI.revive(M);if(typeof x.getCanonicalURI=="undefined")return G;const se=await y.asPromise(()=>x.getCanonicalURI(G));return se||G}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(U=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(x=>x.extensionLocation=I.URI.revive(x.extensionLocation));const U=await this.getExtensionPathIndex();return await Promise.all(M.map(async x=>{const G=this._registry.getExtensionDescription(x);if(!G)return;const se=await this._hostUtils.realpath(G.extensionLocation.fsPath);U.delete(I.URI.file(se).fsPath)})),await Promise.all(F.map(async x=>{const G=await this._hostUtils.realpath(x.extensionLocation.fsPath);U.set(I.URI.file(G).fsPath,x)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=f.VSBuffer.alloc(F),U=Math.random()%256;for(let x=0;x<F;x++)M.writeUInt8(U,x);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};B=Ve([He(0,i.IInstantiationService),He(1,e.IHostUtils),He(2,m.IExtHostRpcService),He(3,h.IExtHostWorkspace),He(4,c.IExtHostConfiguration),He(5,s.ILogService),He(6,r.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,E.IExtHostTunnelService),He(9,b.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function j(N,F){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=i.createDecorator("IExtHostExtensionService");class T{constructor(F,M,U,x){ee.set(this,void 0),oe.set(this,void 0),V.set(this,void 0),nt(this,ee,F,"f"),nt(this,oe,M,"f"),nt(this,V,U.identifier,"f"),this.id=U.identifier.value,this.extensionUri=U.extensionLocation,this.extensionPath=R.normalize(A.originalFSPath(U.extensionLocation)),this.packageJSON=U,this.extensionKind=x}get isActive(){return Be(this,ee,"f").isActivated(Be(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,ee,"f").getExtensionExports(Be(this,V,"f"))}activate(){return Be(this,ee,"f").activateByIdWithErrors(Be(this,V,"f"),{startup:!1,extensionId:Be(this,oe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=T,ee=new WeakMap,oe=new WeakMap,V=new WeakMap}),define(ge[50],pe([0,1,9,2,3,13,5,7,121,34,41,40,209,35,204,15,4,12,36,47]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=_.createDecorator("IExtHostDebugService");let f=class{constructor(g,E,b,a,L,O){this._workspaceService=E,this._extensionService=b,this._editorsService=a,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=g.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(ee=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,E){const b=g;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let a=`debug:${encodeURIComponent(b.path||"")}`,L="?";return E&&(a+=`${L}session=${encodeURIComponent(E.id)}`,L="&"),a+=`${L}ref=${b.sourceReference}`,R.URI.parse(a)}else{if(b.path)return R.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const E=[];for(const b of g.getAllExtensionDescriptions())if(b.contributes){const a=b.contributes.debuggers;if(a&&a.length>0)for(const L of a)l.isDebuggerMainContribution(L)&&E.push(L.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(E=>g.push(E)),g}addBreakpoints(g){this.startBreakpoints();const E=g.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(E,[],[]);const b=[],a=new Map;for(const L of E)if(L instanceof k.SourceBreakpoint){let O=a.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},a.set(L.location.uri.toString(),O),b.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof k.FunctionBreakpoint&&b.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(g){this.startBreakpoints();const E=g.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],E,[]);const b=E.filter(O=>O instanceof k.SourceBreakpoint).map(O=>O.id),a=E.filter(O=>O instanceof k.FunctionBreakpoint).map(O=>O.id),L=E.filter(O=>O instanceof k.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(b,a,L)}startDebugging(g,E,b){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,E,{parentSessionID:b.parentSession?b.parentSession.id:void 0,repl:b.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,E,b){if(!E)return new k.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:a,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,b,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,a),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(g,E,b){if(!b)return new k.Disposable(()=>{});if(!this.definesDebugType(g,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:a,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,a),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(g,E){if(!E)return new k.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:b,factory:E}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==E)})}async $runInTerminal(g,E){return Promise.resolve(void 0)}async $substituteVariables(g,E){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let b;const a=await this.getFolder(g);return a&&(b={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,E)}createDebugAdapter(g,E){if(g.type==="implementation")return new r(g.implementation)}createSignService(){}async $startDASession(g,E){const b=this,a=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),W=this.createDebugAdapter(O,a);if(!W)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const ee=W;return this._debugAdapters.set(g,ee),this.getDebugAdapterTrackers(a).then(oe=>(oe&&this._debugAdaptersTrackers.set(g,oe),ee.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const B=V,j={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign(B.arguments.value);j.body={signature:T},ee.sendResponse(j)}else throw new Error("no signer")}catch(T){j.success=!1,j.message=T.message,ee.sendResponse(j)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(V),V=l.convertToVSCPaths(V,!0),b._debugServiceProxy.$acceptDAMessage(g,V)}),ee.onError(V=>{oe&&oe.onError&&oe.onError(V),this._debugServiceProxy.$acceptDAError(g,V.name,V.message,V.stack)}),ee.onExit(V=>{oe&&oe.onExit&&oe.onExit(v.withNullAsUndefined(V),void 0),this._debugServiceProxy.$acceptDAExit(g,v.withNullAsUndefined(V),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),ee.startSession()))})}$sendDAMessage(g,E){E=l.convertToDAPaths(E,!1);const b=this._debugAdaptersTrackers.get(g);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(E);const a=this._debugAdapters.get(g);a&&a.sendMessage(E)}$stopDASession(g){const E=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),E&&E.onWillStopSession&&E.onWillStopSession();const b=this._debugAdapters.get(g);return this._debugAdapters.delete(g),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const E=[],b=[],a=[];if(g.added)for(const L of g.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let W;if(L.type==="function")W=new k.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")W=new k.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const ee=R.URI.revive(L.uri);W=new k.SourceBreakpoint(new k.Location(ee,new k.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}W._id=O,this._breakpoints.set(O,W),E.push(W)}}if(g.removed)for(const L of g.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),b.push(O))}if(g.changed){for(const L of g.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof k.FunctionBreakpoint&&L.type==="function"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(O instanceof k.SourceBreakpoint&&L.type==="source"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new k.Location(R.URI.revive(L.uri),new k.Position(L.line,L.character))}a.push(O)}}}this.fireBreakpointChanges(E,b,a)}$provideDebugConfigurations(g,E,b){return A.asPromise(async()=>{const a=this.getConfigProviderByHandle(g);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(E);return a.provideDebugConfigurations(L,b)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(g,E,b,a){return A.asPromise(async()=>{const L=this.getConfigProviderByHandle(g);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(E);return L.resolveDebugConfiguration(O,b,a)})}$resolveDebugConfigurationWithSubstitutedVariables(g,E,b,a){return A.asPromise(async()=>{const L=this.getConfigProviderByHandle(g);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(E);return L.resolveDebugConfigurationWithSubstitutedVariables(O,b,a)})}async $provideDebugAdapter(g,E){const b=this.getAdapterDescriptorFactoryByHandle(g);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(E);return this.getAdapterDescriptor(b,a).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(g){const E=await this.getSession(g);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(g){const E=await this.getSession(g);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,E){const b=await this.getSession(g);b&&b._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(g,E){const a={session:await this.getSession(g),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(g){if(g instanceof k.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof k.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const E=this._adapterFactories.filter(b=>b.type===g);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(g){const E=this._adapterFactories.filter(b=>b.handle===g);if(E.length>0)return E[0].factory}getConfigProviderByHandle(g){const E=this._configProviders.filter(b=>b.handle===g);if(E.length>0)return E[0].provider}definesDebugType(g,E){if(g.contributes){const b=g.contributes.debuggers;if(b&&b.length>0){for(const a of b)if(a.label&&a.type&&a.type===E)return!0}}return!1}getDebugAdapterTrackers(g){const b=g.configuration.type,a=this._trackerFactories.filter(L=>L.type===b||L.type==="*").map(L=>A.asPromise(()=>L.factory.createDebugAdapterTracker(g)).then(O=>O,O=>null));return Promise.race([Promise.all(a).then(L=>{const O=L.filter(W=>!!W);if(O.length>0)return new i(O)}),new Promise((L,O)=>{const W=setTimeout(()=>{clearTimeout(W),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(g,E){const b=E.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new k.DebugAdapterServer(b));if(g){const L=await this._extensionService.getExtensionRegistry();return A.asPromise(()=>g.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,L))).then(O=>{if(O)return O})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,a))}daExecutableFromPackage(g,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,E,b){(g.length>0||E.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:E,changed:b}))}async getSession(g){if(g)if(typeof g=="string"){const E=this._debugSessions.get(g);if(E)return E}else{let E=this._debugSessions.get(g.id);if(!E){const b=await this.getFolder(g.folderUri),a=g.parent?this._debugSessions.get(g.parent):void 0;E=new u(this._debugServiceProxy,g.id,g.type,g.name,b,g.configuration,a),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(g){if(g){const E=R.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};f=Ve([He(0,h.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,s.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class u{constructor(g,E,b,a,L,O,W){this._debugServiceProxy=g,this._id=E,this._type=b,this._name=a,this._workspaceFolder=L,this._configuration=O,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}get parentSession(){return this._parentSession}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,E)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=u;class t{constructor(g){this.value=Object.freeze({append(E){g.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=t;class n extends c.AbstractVariableResolverService{constructor(g,E,b,a,L){function O(){if(E){const W=E.activeEditor();if(W)return W.document.uri;const ee=a.tabs.filter(oe=>oe.isActive);if(ee.length>0)return ee[0].resource}}super({getFolderUri:W=>{const ee=g.filter(oe=>oe.name===W);if(ee&&ee.length>0)return ee[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(W,ee)=>b.getConfiguration(void 0,W).get(ee),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=O();if(W)return w.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const W=O();if(W){const ee=L.getWorkspaceFolder(W);if(ee)return w.normalize(ee.uri.fsPath)}}},getSelectedText:()=>{if(E){const W=E.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(E){const W=E.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=n;class i{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(E=>E.onError?E.onError(g):void 0)}onExit(g,E){this.trackers.forEach(b=>b.onExit?b.onExit(g,E):void 0)}}class r extends D.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends f{constructor(g,E,b,a,L,O){super(g,E,b,a,L,O)}createVariableResolver(g,E,b){return new n(g,E,b,this._editorTabs)}};o=Ve([He(0,h.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,s.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(ge[260],pe([0,1,70,2,5,35,39,26,15,27,4,41,36,14]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(d,f,u,t,n,i,r){this._apiFactory=d,this._extensionRegistry=f,this._instaService=u,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=i,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,f,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,f,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let f of d.nodeModuleName)this._factories.set(f,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(f=>d.alternativeModuleName(f))}};l=Ve([He(2,s.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,I.IExtHostInitDataService),He(6,p.ILogService)],l),e.RequireInterceptor=l;class h{constructor(d,f,u,t,n){this._apiFactory=d,this._extensionPaths=f,this._extensionRegistry=u,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,f){const u=this._extensionPaths.findSubstr(f.fsPath);if(u){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(u.identifier));return t||(t=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(u.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,i)=>t+=`	${i} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(d,f){this.nodeModuleName="keytar";const{environment:u}=f,t=d.getProxy(C.MainContext.MainThreadKeytar);if(u.appRoot){let n=u.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,i)=>t.$getPassword(n,i),setPassword:(n,i,r)=>t.$setPassword(n,i,r),deletePassword:(n,i)=>t.$deletePassword(n,i),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(d,f){return this._impl}alternativeModuleName(d){const f=d.length;if(f<=7||!this.alternativeNames)return;const u=f-7;if((d.charAt(u)==="/"||d.charAt(u)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};_=Ve([He(0,D.IExtHostRpcService),He(1,I.IExtHostInitDataService)],_);let v=class{constructor(d,f,u){this._extensionPaths=d,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(C.MainContext.MainThreadTelemetry);const t=u.getProxy(C.MainContext.MainThreadWindow);this._impl=(n,i)=>{const r=R.URI.parse(n);return i?this.callOriginal(n,i):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,i)}}load(d,f,u){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=u(d),this._impl}callOriginal(d,f){return this.sendNoForwardTelemetry(),this._original(d,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=Ve([He(2,D.IExtHostRpcService)],v)}),define(ge[261],pe([0,1,168,11,7,205,34,41,40,35,33,15,50,191,13,206,47]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let v=class extends c.ExtHostDebugServiceBase{constructor(f,u,t,n,i,r,o){super(f,u,t,n,i,o);this._terminalService=r,this._integratedTerminalInstances=new S}createDebugAdapter(f,u){switch(f.type){case"server":return new A.SocketDebugAdapter(f);case"pipeServer":return new A.NamedPipeDebugAdapter(f);case"executable":return new A.ExecutableDebugAdapter(f,u.type)}return super.createDebugAdapter(f,u)}daExecutableFromPackage(f,u){const t=A.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),f.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new p.SignService}async $runInTerminal(f,u){if(f.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),i=this._terminalService.getDefaultShellArgs(!0),r=JSON.stringify({shell:n,shellArgs:i});let o=await this._integratedTerminalInstances.checkout(r),m,g=!1;if(o)m=f.cwd;else{const L={shellPath:n,shellArgs:i,cwd:f.cwd,name:f.title||w.localize(0,null)};g=!0,o=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,r)}o.show(!0);const E=await o.processId;g?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?o.sendText("cls"):n.indexOf("bash")>=0?o.sendText("clear"):R.isWindows?o.sendText("cls"):o.sendText("clear"));const b=h.prepareCommand(n,f.args,m,f.env);o.sendText(b);const a=this.onDidTerminateDebugSession(L=>{L.id===u&&(this._integratedTerminalInstances.free(o),a.dispose())});return E}else if(f.kind==="external")return h.runInExternalTerminal(f,await this._configurationService.getConfigProvider());return super.$runInTerminal(f,u)}createVariableResolver(f,u,t){return new c.ExtHostVariableResolverService(f,u,t,this._editorTabs,this._workspaceService)}};v=Ve([He(0,P.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,s.IExtHostTerminalService),He(6,_.IExtHostEditorTabs)],v),e.ExtHostDebugService=v;class S{constructor(){this._terminalInstances=new Map}async checkout(f){const t=[...this._terminalInstances.entries()].map(([n,i])=>l.createCancelablePromise(async r=>{if(i.lastUsedAt!==-1&&await h.hasChildProcesses(await n.processId))return null;const o=Date.now();return i.lastUsedAt+S.minUseDelay>o||r.isCancellationRequested||i.config!==f?null:(i.lastUsedAt=o,n)}));return await l.firstParallel(t,n=>!!n)}insert(f,u){this._terminalInstances.set(f,{lastUsedAt:Date.now(),config:u})}free(f){const u=this._terminalInstances.get(f);u&&(u.lastUsedAt=-1)}onTerminalClosed(f){this._terminalInstances.delete(f)}}S.minUseDelay=1e3}),define(ge[262],pe([0,1,9,2,110,34,50,40,35,33,15,27,69,10,14,65,47]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let v=class extends c.ExtHostTaskBase{constructor(d,f,u,t,n,i,r,o,m){super(d,f,u,t,n,i,r,o);this.workspaceService=u,this.editorTabs=m,f.remote.isRemote&&f.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:f.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,f){const u=f;if(!f.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const t=c.TaskHandleDTO.from(u,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(n,f);return this._proxy.$executeTask(t).catch(()=>{}),i}else{const t=c.TaskDTO.from(f,d);if(t===void 0)return Promise.reject(new Error("Task is not valid"));c.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,f,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),f);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(d,f,u,t){const n=[];if(t)for(let i of t){this.checkDeprecation(i,u),(!i.definition||!d[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const r=c.TaskDTO.from(i,u.extension);r&&(n.push(r),c.CustomExecutionDTO.is(r.execution)&&f.push(this.addCustomExecution(r,i,!0)))}return{tasks:n,extension:u.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const f=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(d,this._editorService,f,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,f){const u=R.URI.revive(d),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(u),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(i),o={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let m of f.variables)t.variables[m]=await r.resolveAsync(o,m);if(f.process!==void 0){let m;if(f.process.path!==void 0){m=f.process.path.split(w.delimiter);for(let g=0;g<m.length;g++)m[g]=await r.resolveAsync(o,m[g])}t.process=await C.win32.findExecutable(await r.resolveAsync(o,f.process.name),f.process.cwd!==void 0?await r.resolveAsync(o,f.process.cwd):void 0,m)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(d,f,u){return C.win32.findExecutable(d,f,u)}};v=Ve([He(0,s.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,l.ILogService),He(7,h.IExtHostApiDeprecationService),He(8,_.IExtHostEditorTabs)],v),e.ExtHostTask=v}),define(ge[263],pe([0,1,13,16,70,6,2,5,254,14,79,82,27,185,15,63,41,33]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(f,u,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(f,null,n),u=S._transform(u,this._rpcProtocol);const i=new P.ServiceCollection(...s.getSingletonServiceDescriptors());i.set(c.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},u)),i.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),i.set(h.IURITransformerService,new h.URITransformerService(n)),i.set(_.IHostUtils,t);const r=new p.InstantiationService(i,!0),o=r.invokeFunction(b=>b.get(v.IExtHostTerminalService));this._disposables.add(o),this._logService=r.invokeFunction(b=>b.get(I.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",u),this._extensionService=r.invokeFunction(b=>b.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(a,L)=>{let O="",W,ee;for(const oe of L)O+=`
	at ${oe.toString()}`,ee=oe.getFileName(),!W&&ee&&(W=b.findSubstr(ee));return m.set(a,W),`${a.name||"Error"}: ${a.message||""}${O}`}});const g=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),E=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(b=>{const a=R.transformErrorForSerialization(b),L=m.get(b);L?g.$onExtensionRuntimeError(L.identifier,a):E.$onUnexpectedError(a)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const u=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([w.timeout(4e3),u]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,u){f.extensions.forEach(n=>n.extensionLocation=y.URI.revive(u.transformIncomingURIs(n.extensionLocation))),f.environment.appRoot=y.URI.revive(u.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(u.transformIncomingURIs(n)))),f.environment.extensionTestsLocationURI=y.URI.revive(u.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=y.URI.revive(u.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=y.URI.revive(u.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=y.URI.revive(u.transformIncomingURIs(f.logsLocation)),f.logFile=y.URI.revive(u.transformIncomingURIs(f.logFile)),f.workspace=u.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=S}),define(ge[264],pe([0,1,9,21,60,30,24,44,31]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(c,p,l){this.config=c,this.provider=p,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&A.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&A.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const p=this.config.folderQueries||[];return new Promise((l,h)=>{const _=v=>{this.resultCount++,c(v)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const S=v.toString(),d=w.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,d)||this.matchFile(_,{base:v,basename:d})}),Promise.all(p.map(v=>this.searchInFolder(v,_))).then(v=>{l({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{h(new Error(C.toErrorMessage(v)))})})}async searchInFolder(c,p){const l=new R.CancellationTokenSource,h=this.getSearchOptionsForFolder(c),_=this.initDirectoryTree(),v=new D.QueryGlobTester(this.config,c),S=!v.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(l),d=k.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,l.token),u=d.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(n=>{const i=w.posix.relative(c.folder.path,n.path);if(S){const r=w.basename(n.path);this.matchFile(p,{base:c.folder,relativePath:i,basename:r});return}this.addDirectoryEntries(_,c.folder,i,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,v,p),{providerTime:u,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(c){const p=D.resolvePatternsForProvider(this.config.includePattern,c.includePattern),l=D.resolvePatternsForProvider(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:l,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},p,l,h){if(l===this.filePattern){const v=w.basename(this.filePattern);this.matchFile(h,{base:p,relativePath:this.filePattern,basename:v})}function _(v){const S=w.basename(v),d=w.dirname(v);let f=c[d];f||(f=c[d]=[],_(d)),f.push({base:p,relativePath:v,basename:S})}_(l)}matchDirectoryTree({rootEntries:c,pathToEntries:p},l,h){const _=this,v=this.filePattern;function S(d){const f=A.hasSiblingFn(()=>d.map(u=>u.basename));for(let u=0,t=d.length;u<t;u++){const n=d[u],{relativePath:i,basename:r}=n;if(!l.includedInQuerySync(i,r,v!==r?f:void 0))continue;const o=p[i];if(o)S(o);else{if(i===v)continue;_.matchFile(h,n)}if(_.isLimitHit)break}}S(c)}matchFile(c,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(p))}}class s{constructor(){this.sessions=new Map}fileSearch(c,p,l,h){const _=this.getSessionTokenSource(c.cacheKey),v=new I(c,p,_&&_.token);let S=0;const d=f=>{S+=f.length,l(f.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(v,s.BATCH_SIZE,d,h).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:f.stats}}))}clearCache(c){const p=this.getSessionTokenSource(c);p&&p.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new R.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:y.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,p,l,h){h.onCancellationRequested(()=>{c.cancel()});const _=S=>{S&&(v.push(S),p>0&&v.length>=p&&(l(v),v=[]))};let v=[];return c.search(_).then(S=>(v.length&&l(v),S),S=>(v.length&&l(v),Promise.reject(S)))}}e.FileSearchManager=s,s.BATCH_SIZE=512}),define(ge[129],pe([0,1,9,17,21,60,24,30,2,31,10,12]),function(Q,e,w,R,C,A,y,k,D,I,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(d,f,u){this.query=d,this.provider=f,this.fileUtils=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,f){const u=this.query.folderQueries||[],t=new C.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((n,i)=>{this.collector=new l(d);let r=!1;const o=(m,g)=>{if(!r&&!this.isLimitHit){const E=this.resultSize(m);_(m)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const b=this.resultSize(m);this.resultCount+=b,(b>0||!_(m))&&this.collector.add(m,g)}};Promise.all(u.map((m,g)=>this.searchInFolder(m,E=>o(E,g),t.token))).then(m=>{t.dispose(),this.collector.flush();const g=m.some(E=>!!E&&!!E.limitHit);n({limitHit:this.isLimitHit||g,messages:R.flatten(m.map(E=>(E==null?void 0:E.message)?P.isArray(E.message)?E.message:[E.message]:[])),stats:{type:"textSearchProvider"}})},m=>{t.dispose();const g=A.toErrorMessage(m);i(new Error(g))})})}resultSize(d){return _(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,f){const u=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:u.slice(0,f),preview:{matches:t.slice(0,f),text:d.preview.text},uri:d.uri}}async searchInFolder(d,f,u){const t=new I.QueryGlobTester(this.query,d),n=[],i={report:m=>{if(!this.validateProviderResult(m))return;const g=d.folder.scheme===s.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(m.uri))):void 0,E=y.relativePath(d.folder,m.uri);E&&n.push(t.includedInQuery(E,w.basename(E),g).then(b=>{b&&f(m)}))}},r=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,i,u);return await Promise.all(n),o}validateProviderResult(d){if(_(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const f=I.resolvePatternsForProvider(this.query.includePattern,d.includePattern),u=I.resolvePatternsForProvider(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:u,includes:f,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function p(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class l{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,f=>this.sendItems(f))}add(d,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!y.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(h(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=l;function h(S){return _(S)?{preview:{matches:R.mapArrayOrNot(S.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:S.preview.text},ranges:R.mapArrayOrNot(S.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function _(S){return!!S.preview}e.extensionResultIsMatch=_;class v{constructor(d,f){this.maxBatchSize=d,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,f){!d||this.addItemToBatch(d,f)}addItems(d,f){!d||this.addItemsToBatch(d,f)}addItemToBatch(d,f){this.batch.push(d),this.batchSize+=f,this.onUpdate()}addItemsToBatch(d,f){this.batch=this.batch.concat(d),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(ge[71],pe([0,1,6,5,4,264,15,63,14,2,129]),function(Q,e,w,R,C,A,y,k,D,I,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=C.createDecorator("IExtHostSearch");let P=class{constructor(h,_,v){this.extHostRpc=h,this._uriTransformer=_,this._logService=v,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,_){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const v=this._handlePool++;return this._textSearchProvider.set(v,_),this._proxy.$registerTextSearchProvider(v,this._transformScheme(h)),w.toDisposable(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(h,_){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const v=this._handlePool++;return this._fileSearchProvider.set(v,_),this._proxy.$registerFileSearchProvider(v,this._transformScheme(h)),w.toDisposable(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(h,_,v,S){const d=c(v),f=this._fileSearchProvider.get(h);if(f)return this._fileSearchManager.fileSearch(d,f,u=>{this._proxy.$handleFileMatch(h,_,u.map(t=>t.resource))},S);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,_,v,S){const d=this._textSearchProvider.get(h);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const f=c(v);return this.createTextSearchManager(f,d).search(t=>this._proxy.$handleTextMatch(h,_,t),S)}createTextSearchManager(h,_){return new s.TextSearchManager(h,_,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};P=Ve([He(0,y.IExtHostRpcService),He(1,k.IURITransformerService),He(2,D.ILogService)],P),e.ExtHostSearch=P;function c(l){return Object.assign(Object.assign({},l),{folderQueries:l.folderQueries&&l.folderQueries.map(p),extraFileResources:l.extraFileResources&&l.extraFileResources.map(h=>I.URI.revive(h))})}e.reviveQuery=c;function p(l){return Object.assign(Object.assign({},l),{folder:I.URI.revive(l.folder)})}}),define(ge[265],pe([0,1,21,16,3,57,2,152,106,143,78,43,5,226,225,49,227,35,228,229,230,212,231,40,41,232,213,234,235,236,66,215,240,241,242,90,33,243,216,20,7,246,67,128,34,39,52,201,233,117,127,69,50,71,14,63,15,27,237,199,48,65,223,244,198,91,89,249,247,248,224,62,257,245,88,47,119,238,68,239,10,187]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d,f,u,t,n,i,r,o,m,g,E,b,a,L,O,W,ee,oe,V,B,j,T,N,F,M,U,x,G,se,be,Te,Ce,Me,qe,ze,Ke,q,J,re,ae,Y,ce,ve,Re,we,je,K,ie,Ee,Ne,$e,We,Xe,De,ye,ke,le,he,H,Z,ue,Ie,Pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ue(xe){const Qe=xe.get(re.IExtHostInitDataService),rt=xe.get(Xe.IExtHostFileSystemInfo),tt=xe.get(ie.IExtHostConsumerFileSystem),Ye=xe.get(i.IExtHostExtensionService),ot=xe.get(U.IExtHostWorkspace),Et=xe.get(he.IExtHostTelemetry),bt=xe.get(v.IExtHostConfiguration),_e=xe.get(q.IURITransformerService),fe=xe.get(J.IExtHostRpcService),de=xe.get(ee.IExtHostStorage),X=xe.get(K.IExtensionStoragePaths),Oe=xe.get(Ke.ILogService),Le=xe.get(ce.IExtHostTunnelService),Ze=xe.get(ve.IExtHostApiDeprecationService),et=xe.get(M.IExtHostWindow),ft=xe.get(ke.IExtHostSecretState),ct=xe.get(le.IExtHostEditorTabs);fe.set(c.ExtHostContext.ExtHostFileSystemInfo,rt),fe.set(c.ExtHostContext.ExtHostLogService,Oe),fe.set(c.ExtHostContext.ExtHostWorkspace,ot),fe.set(c.ExtHostContext.ExtHostConfiguration,bt),fe.set(c.ExtHostContext.ExtHostExtensionService,Ye),fe.set(c.ExtHostContext.ExtHostStorage,de),fe.set(c.ExtHostContext.ExtHostTunnelService,Le),fe.set(c.ExtHostContext.ExtHostWindow,et),fe.set(c.ExtHostContext.ExtHostSecretState,ft),fe.set(c.ExtHostContext.ExtHostTelemetry,Et),fe.set(c.ExtHostContext.ExtHostEditorTabs,ct);const it=fe.set(c.ExtHostContext.ExtHostDecorations,xe.get(Ce.IExtHostDecorations)),vt=fe.set(c.ExtHostContext.ExtHostDocumentsAndEditors,xe.get(n.IExtHostDocumentsAndEditors)),ht=fe.set(c.ExtHostContext.ExtHostCommands,xe.get(h.IExtHostCommands)),lt=fe.set(c.ExtHostContext.ExtHostTerminalService,xe.get(oe.IExtHostTerminalService)),mt=fe.set(c.ExtHostContext.ExtHostDebugService,xe.get(qe.IExtHostDebugService)),Pt=fe.set(c.ExtHostContext.ExtHostSearch,xe.get(ze.IExtHostSearch)),Ct=fe.set(c.ExtHostContext.ExtHostTask,xe.get(Me.IExtHostTask)),At=fe.set(c.ExtHostContext.ExtHostOutputService,xe.get(b.IExtHostOutputService)),Rt=fe.set(c.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(fe)),St=fe.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(fe,vt)),Xt=fe.set(c.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(fe,vt,Oe)),Yt=fe.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new u.ExtHostDocumentSaveParticipant(Oe,St,fe.getProxy(c.MainContext.MainThreadBulkEdits))),pt=fe.set(c.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(fe,ht,vt,St,Oe,X)),Jt=fe.set(c.ExtHostContext.ExtHostNotebookKernels,new H.ExtHostNotebookKernels(fe,Qe,pt,Oe)),Zt=fe.set(c.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(fe,pt)),Dt=fe.set(c.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(fe,vt)),hn=fe.set(c.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(fe.getProxy(c.MainContext.MainThreadTreeViews),ht,Oe)),en=fe.set(c.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(fe.getProxy(c.MainContext.MainThreadEditorInsets),Dt,Qe)),xt=fe.set(c.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(fe,Oe)),ut=fe.set(c.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(fe,_e,St,ht,xt,Oe,Ze)),tn=fe.set(c.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(fe,ut)),Ft=fe.set(c.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(fe,Oe,vt)),Mt=fe.set(c.ExtHostContext.ExtHostQuickOpen,L.createExtHostQuickOpen(fe,ot,ht)),qt=fe.set(c.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(fe,ht,Oe)),bn=fe.set(c.ExtHostContext.ExtHostComments,new _.ExtHostComments(fe,ht,St)),fn=fe.set(c.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(fe.getProxy(c.MainContext.MainThreadProgress))),En=fe.set(c.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(fe)),mn=fe.set(c.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(fe)),Bt=fe.set(c.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(fe)),nn=fe.set(c.ExtHostContext.ExtHostTimeline,new we.ExtHostTimeline(fe,ht)),Ht=fe.set(c.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(fe,{remote:Qe.remote},ot,Oe,Ze)),rn=fe.set(c.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,Ht,ot)),_n=fe.set(c.ExtHostContext.ExtHostCustomEditors,new Ne.ExtHostCustomEditors(fe,St,X,Ht,rn)),Sn=fe.set(c.ExtHostContext.ExtHostWebviewViews,new Ee.ExtHostWebviewViews(fe,Ht)),Ot=fe.set(c.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(fe,vt,ot)),Kt=fe.set(c.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(fe)),yn=G.values(c.ExtHostContext);fe.assertRegistered(yn);const Dn=new We.ExtHostBulkEdits(fe,vt),sn=new l.ExtHostClipboard(fe),on=new E.ExtHostMessageService(fe,Oe),$t=new d.ExtHostDialogs(fe),Gt=new W.ExtHostStatusBar(fe,ht.converter),Wt=new g.ExtHostLanguages(fe,St);return p.ExtHostApiCommands.register(ht),function(Fe,an,It){const gt=function(){let te=!Fe.isUnderDevelopment;function me(Ae){te||(Oe.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")me(st);else{const wt=st;typeof wt.scheme=="undefined"&&me(st),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&x.throwProposedApiError(Fe)}return st}}(),Cn={getSession(te,me,Ae){return Bt.getSession(Fe,te,me,Ae)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(te,me,Ae,st){return Bt.registerAuthenticationProvider(te,me,Ae,st)},get onDidChangeAuthenticationProviders(){return x.checkProposedApiEnabled(Fe),Bt.onDidChangeAuthenticationProviders},get providers(){return x.checkProposedApiEnabled(Fe),Bt.providers},logout(te,me){return x.checkProposedApiEnabled(Fe),Bt.removeSession(te,me)}},kn={registerCommand(te,me,Ae){return ht.registerCommand(!0,te,me,Ae)},registerTextEditorCommand(te,me,Ae){return ht.registerCommand(!0,te,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Oe.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(_t=>{me.apply(Ae,[wt,_t,...st])}).then(_t=>{_t||Oe.warn("Edits from command "+te+" were not applied.")},_t=>{Oe.warn("An error occurred while running command "+te,_t)})})},registerDiffInformationCommand:(te,me,Ae)=>(x.checkProposedApiEnabled(Fe),ht.registerCommand(!0,te,async(...st)=>{const wt=vt.activeEditor(!0);if(!wt){Oe.warn("Cannot execute "+te+" because there is no active text editor.");return}const _t=await Dt.getDiffInformation(wt.id);me.apply(Ae,[_t,...st])})),executeCommand(te,...me){return ht.executeCommand(te,...me)},getCommands(te=!1){return ht.getCommands(te)}},gn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var te,me;return(me=(te=Qe.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&me!==void 0?me:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return lt.getDefaultShell(!1)},get isTelemetryEnabled(){return Et.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Et.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,me){return et.openUri(te,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:me==null?void 0:me.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Qe.environment.appUriScheme)return Rt.createAppUri(te);!Pe.matchesScheme(te,Ie.Schemas.http)&&!Pe.matchesScheme(te,Ie.Schemas.https)&&x.checkProposedApiEnabled(Fe);try{return await et.asExternalUri(te,{allowTunneling:!!Qe.remote.authority})}catch(me){return te}},get remoteName(){return Te.getRemoteName(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Qe.remote.isRemote?T.ExtensionKind.Workspace:T.ExtensionKind.UI,ln={registerTestController(te){return x.checkProposedApiEnabled(Fe),Ot.registerTestController(Fe.identifier.value,te)},createDocumentTestObserver(te){return x.checkProposedApiEnabled(Fe),Ot.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return x.checkProposedApiEnabled(Fe),Ot.createWorkspaceTestObserver(te)},runTests(te){return x.checkProposedApiEnabled(Fe),Ot.runTests(te)},createTestItem(te,me){return new T.TestItemImpl(te.id,te.label,te.uri,me)},createTestRun(te,me,Ae){return x.checkProposedApiEnabled(Fe),Ot.createTestRun(Fe.identifier.value,te,me,Ae)},get onDidChangeTestResults(){return x.checkProposedApiEnabled(Fe),Ot.onResultsChanged},get testResults(){return x.checkProposedApiEnabled(Fe),Ot.results}};ln.createTestRunTask=ln.createTestRun;const In={getExtension(te){const me=an.getExtensionDescription(te);if(me)return new i.Extension(Ye,Fe.identifier,me,pn)},get all(){return an.getAllExtensionDescriptions().map(te=>new i.Extension(Ye,Fe.identifier,te,pn))},get onDidChange(){return an.onDidChange}},Pn={createDiagnosticCollection(te){return xt.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:te=>xt.getDiagnostics(te),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(te,me){return Wt.changeLanguage(te.uri,me)},match(te,me){return s.score(j.LanguageSelector.from(te),me.uri,me.languageId,!0)},registerCodeActionsProvider(te,me,Ae){return ut.registerCodeActionProvider(Fe,gt(te),me,Ae)},registerCodeLensProvider(te,me){return ut.registerCodeLensProvider(Fe,gt(te),me)},registerDefinitionProvider(te,me){return ut.registerDefinitionProvider(Fe,gt(te),me)},registerDeclarationProvider(te,me){return ut.registerDeclarationProvider(Fe,gt(te),me)},registerImplementationProvider(te,me){return ut.registerImplementationProvider(Fe,gt(te),me)},registerTypeDefinitionProvider(te,me){return ut.registerTypeDefinitionProvider(Fe,gt(te),me)},registerHoverProvider(te,me){return ut.registerHoverProvider(Fe,gt(te),me,Fe.identifier)},registerEvaluatableExpressionProvider(te,me){return ut.registerEvaluatableExpressionProvider(Fe,gt(te),me,Fe.identifier)},registerInlineValuesProvider(te,me){return ut.registerInlineValuesProvider(Fe,gt(te),me,Fe.identifier)},registerDocumentHighlightProvider(te,me){return ut.registerDocumentHighlightProvider(Fe,gt(te),me)},registerLinkedEditingRangeProvider(te,me){return ut.registerLinkedEditingRangeProvider(Fe,gt(te),me)},registerReferenceProvider(te,me){return ut.registerReferenceProvider(Fe,gt(te),me)},registerRenameProvider(te,me){return ut.registerRenameProvider(Fe,gt(te),me)},registerDocumentSymbolProvider(te,me,Ae){return ut.registerDocumentSymbolProvider(Fe,gt(te),me,Ae)},registerWorkspaceSymbolProvider(te){return ut.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,me){return ut.registerDocumentFormattingEditProvider(Fe,gt(te),me)},registerDocumentRangeFormattingEditProvider(te,me){return ut.registerDocumentRangeFormattingEditProvider(Fe,gt(te),me)},registerOnTypeFormattingEditProvider(te,me,Ae,...st){return ut.registerOnTypeFormattingEditProvider(Fe,gt(te),me,[Ae].concat(st))},registerDocumentSemanticTokensProvider(te,me,Ae){return ut.registerDocumentSemanticTokensProvider(Fe,gt(te),me,Ae)},registerDocumentRangeSemanticTokensProvider(te,me,Ae){return ut.registerDocumentRangeSemanticTokensProvider(Fe,gt(te),me,Ae)},registerSignatureHelpProvider(te,me,Ae,...st){return typeof Ae=="object"?ut.registerSignatureHelpProvider(Fe,gt(te),me,Ae):ut.registerSignatureHelpProvider(Fe,gt(te),me,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(te,me,...Ae){return ut.registerCompletionItemProvider(Fe,gt(te),me,Ae)},registerInlineCompletionItemProvider(te,me){return x.checkProposedApiEnabled(Fe),ut.registerInlineCompletionsProvider(Fe,gt(te),me)},registerDocumentLinkProvider(te,me){return ut.registerDocumentLinkProvider(Fe,gt(te),me)},registerColorProvider(te,me){return ut.registerColorProvider(Fe,gt(te),me)},registerFoldingRangeProvider(te,me){return ut.registerFoldingRangeProvider(Fe,gt(te),me)},registerSelectionRangeProvider(te,me){return ut.registerSelectionRangeProvider(Fe,te,me)},registerCallHierarchyProvider(te,me){return ut.registerCallHierarchyProvider(Fe,te,me)},setLanguageConfiguration:(te,me)=>ut.setLanguageConfiguration(Fe,te,me),getTokenInformationAtPosition(te,me){return x.checkProposedApiEnabled(Fe),Wt.tokenAtPosition(te,me)},registerInlayHintsProvider(te,me){return x.checkProposedApiEnabled(Fe),ut.registerInlayHintsProvider(Fe,te,me)}},cn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(te,me,Ae){const st=await(y.URI.isUri(te)?Promise.resolve(vn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(st,me,Ae)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(Fe,te)},onDidChangeActiveTextEditor(te,me,Ae){return Dt.onDidChangeActiveTextEditor(te,me,Ae)},onDidChangeVisibleTextEditors(te,me,Ae){return Dt.onDidChangeVisibleTextEditors(te,me,Ae)},onDidChangeTextEditorSelection(te,me,Ae){return Dt.onDidChangeTextEditorSelection(te,me,Ae)},onDidChangeTextEditorOptions(te,me,Ae){return Dt.onDidChangeTextEditorOptions(te,me,Ae)},onDidChangeTextEditorVisibleRanges(te,me,Ae){return Dt.onDidChangeTextEditorVisibleRanges(te,me,Ae)},onDidChangeTextEditorViewColumn(te,me,Ae){return Dt.onDidChangeTextEditorViewColumn(te,me,Ae)},onDidCloseTerminal(te,me,Ae){return lt.onDidCloseTerminal(te,me,Ae)},onDidOpenTerminal(te,me,Ae){return lt.onDidOpenTerminal(te,me,Ae)},onDidChangeActiveTerminal(te,me,Ae){return lt.onDidChangeActiveTerminal(te,me,Ae)},onDidChangeTerminalDimensions(te,me,Ae){return x.checkProposedApiEnabled(Fe),lt.onDidChangeTerminalDimensions(te,me,Ae)},onDidWriteTerminalData(te,me,Ae){return x.checkProposedApiEnabled(Fe),lt.onDidWriteTerminalData(te,me,Ae)},get state(){return et.state},onDidChangeWindowState(te,me,Ae){return et.onDidChangeWindowState(te,me,Ae)},showInformationMessage(te,...me){return on.showMessage(Fe,A.default.Info,te,me[0],me.slice(1))},showWarningMessage(te,...me){return on.showMessage(Fe,A.default.Warning,te,me[0],me.slice(1))},showErrorMessage(te,...me){return on.showMessage(Fe,A.default.Error,te,me[0],me.slice(1))},showQuickPick(te,me,Ae){return Mt.showQuickPick(te,!!Fe.enableProposedApi,me,Ae)},showWorkspaceFolderPick(te){return Mt.showWorkspaceFolderPick(te)},showInputBox(te,me){return Mt.showInput(te,me)},showOpenDialog(te){return $t.showOpenDialog(te)},showSaveDialog(te){return $t.showSaveDialog(te)},createStatusBarItem(te,me,Ae){let st,wt,_t;return typeof te=="string"?(st=te,wt=me,_t=Ae):(wt=te,_t=me),Gt.createStatusBarEntry(Fe,st,wt,_t)},setStatusBarMessage(te,me){return Gt.setStatusBarMessage(te,me)},withScmProgress(te){return Ze.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),fn.withProgress(Fe,{location:T.ProgressLocation.SourceControl},(me,Ae)=>te({report(st){}}))},withProgress(te,me){return fn.withProgress(Fe,te,me)},createOutputChannel(te){return At.createOutputChannel(te)},createWebviewPanel(te,me,Ae,st){return rn.createWebviewPanel(Fe,te,me,Ae,st)},createWebviewTextEditorInset(te,me,Ae,st){return x.checkProposedApiEnabled(Fe),en.createWebviewEditorInset(te,me,Ae,st,Fe)},createTerminal(te,me,Ae){return typeof te=="object"?"pty"in te?lt.createExtensionTerminal(te):(te.iconPath&&x.checkProposedApiEnabled(Fe),lt.createTerminalFromOptions(te)):lt.createTerminal(te,me,Ae)},registerTerminalLinkProvider(te){return lt.registerLinkProvider(te)},registerTerminalProfileProvider(te,me){return lt.registerProfileProvider(te,me)},registerTreeDataProvider(te,me){return hn.registerTreeDataProvider(te,me,Fe)},createTreeView(te,me){return hn.createTreeView(te,me,Fe)},registerWebviewPanelSerializer:(te,me)=>rn.registerWebviewPanelSerializer(Fe,te,me),registerCustomEditorProvider:(te,me,Ae={})=>_n.registerCustomEditorProvider(Fe,te,me,Ae),registerFileDecorationProvider(te){return it.registerFileDecorationProvider(te,Fe.identifier)},registerUriHandler(te){return Rt.registerUriHandler(Fe.identifier,te)},createQuickPick(){return Mt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Mt.createInputBox(Fe.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(te,me,Ae){return mn.onDidChangeActiveColorTheme(te,me,Ae)},registerWebviewViewProvider(te,me,Ae){return Sn.registerWebviewViewProvider(Fe,te,me,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return x.checkProposedApiEnabled(Fe),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeActiveNotebookEditor(te,me,Ae)},get visibleNotebookEditors(){return x.checkProposedApiEnabled(Fe),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return x.checkProposedApiEnabled(Fe),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeNotebookEditorSelection(te,me,Ae)},onDidChangeNotebookEditorVisibleRanges(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeNotebookEditorVisibleRanges(te,me,Ae)},showNotebookDocument(te,me){return x.checkProposedApiEnabled(Fe),pt.showNotebookDocument(te,me)},registerExternalUriOpener(te,me,Ae){return x.checkProposedApiEnabled(Fe),Kt.registerExternalUriOpener(Fe.identifier,te,me,Ae)},get openEditors(){return x.checkProposedApiEnabled(Fe),ct.tabs},get onDidChangeOpenEditors(){return x.checkProposedApiEnabled(Fe),ct.onDidChangeTabs},getInlineCompletionItemController(te){return x.checkProposedApiEnabled(Fe),m.InlineCompletionController.get(te)}},vn={get rootPath(){return Ze.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw R.readonly()},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw R.readonly()},updateWorkspaceFolders:(te,me,...Ae)=>ot.updateWorkspaceFolders(Fe,te,me||0,...Ae),onDidChangeWorkspaceFolders:function(te,me,Ae){return ot.onDidChangeWorkspace(te,me,Ae)},asRelativePath:(te,me)=>ot.getRelativePath(te,me),findFiles:(te,me,Ae,st)=>ot.findFiles(j.GlobPattern.from(te),j.GlobPattern.from(me),Ae,Fe.identifier,st),findTextInFiles:(te,me,Ae,st)=>{let wt,_t;return typeof me=="object"?(wt=me,_t=Ae):(wt={},_t=me,st=Ae),ot.findTextInFiles(te,wt||{},_t,Fe.identifier,st)},saveAll:te=>ot.saveAll(te),applyEdit(te){return Dn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,me,Ae,st)=>Ft.createFileSystemWatcher(j.GlobPattern.from(te),me,Ae,st),get textDocuments(){return St.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.readonly()},openTextDocument(te){let me;const Ae=te;if(typeof te=="string")me=Promise.resolve(y.URI.file(te));else if(y.URI.isUri(te))me=Promise.resolve(te);else if(!Ae||typeof Ae=="object")me=St.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(st=>St.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(te,me,Ae)=>St.onDidAddDocument(te,me,Ae),onDidCloseTextDocument:(te,me,Ae)=>St.onDidRemoveDocument(te,me,Ae),onDidChangeTextDocument:(te,me,Ae)=>St.onDidChangeDocument(te,me,Ae),onDidSaveTextDocument:(te,me,Ae)=>St.onDidSaveDocument(te,me,Ae),onWillSaveTextDocument:(te,me,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Fe)(te,me,Ae),onDidChangeConfiguration:(te,me,Ae)=>It.onDidChangeConfiguration(te,me,Ae),getConfiguration(te,me){return me=arguments.length===1?void 0:me,It.getConfiguration(te,me,Fe)},registerTextDocumentContentProvider(te,me){return Xt.registerTextDocumentContentProvider(te,me)},registerTaskProvider:(te,me)=>(Ze.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Fe,te,me)),registerFileSystemProvider(te,me,Ae){return tn.registerFileSystemProvider(Fe.identifier,te,me,Ae,Fe.enableProposedApi)},get fs(){return tt.value},registerFileSearchProvider:(te,me)=>(x.checkProposedApiEnabled(Fe),Pt.registerFileSearchProvider(te,me)),registerTextSearchProvider:(te,me)=>(x.checkProposedApiEnabled(Fe),Pt.registerTextSearchProvider(te,me)),registerRemoteAuthorityResolver:(te,me)=>(x.checkProposedApiEnabled(Fe),Ye.registerRemoteAuthorityResolver(te,me)),registerResourceLabelFormatter:te=>(x.checkProposedApiEnabled(Fe),En.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,me,Ae)=>Ft.onDidCreateFile(te,me,Ae),onDidDeleteFiles:(te,me,Ae)=>Ft.onDidDeleteFile(te,me,Ae),onDidRenameFiles:(te,me,Ae)=>Ft.onDidRenameFile(te,me,Ae),onWillCreateFiles:(te,me,Ae)=>Ft.getOnWillCreateFileEvent(Fe)(te,me,Ae),onWillDeleteFiles:(te,me,Ae)=>Ft.getOnWillDeleteFileEvent(Fe)(te,me,Ae),onWillRenameFiles:(te,me,Ae)=>Ft.getOnWillRenameFileEvent(Fe)(te,me,Ae),openTunnel:te=>(x.checkProposedApiEnabled(Fe),Le.openTunnel(Fe,te).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return x.checkProposedApiEnabled(Fe),Le.getTunnels()},onDidChangeTunnels:(te,me,Ae)=>(x.checkProposedApiEnabled(Fe),Le.onDidChangeTunnels(te,me,Ae)),registerPortAttributesProvider:(te,me)=>(x.checkProposedApiEnabled(Fe),Le.registerPortsAttributesProvider(te,me)),registerTimelineProvider:(te,me)=>(x.checkProposedApiEnabled(Fe),nn.registerTimelineProvider(te,me,Fe.identifier,ht.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>(x.checkProposedApiEnabled(Fe),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,me,Ae)=>ot.onDidGrantWorkspaceTrust(te,me,Ae)},An={get inputBox(){return Ze.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Fe)},createSourceControl(te,me,Ae){return qt.createSourceControl(Fe,te,me,Ae)}},Tn={createCommentController(te,me){return bn.createCommentController(Fe,te,me)}},Rn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(te,me,Ae){return mt.onDidStartDebugSession(te,me,Ae)},onDidTerminateDebugSession(te,me,Ae){return mt.onDidTerminateDebugSession(te,me,Ae)},onDidChangeActiveDebugSession(te,me,Ae){return mt.onDidChangeActiveDebugSession(te,me,Ae)},onDidReceiveDebugSessionCustomEvent(te,me,Ae){return mt.onDidReceiveDebugSessionCustomEvent(te,me,Ae)},onDidChangeBreakpoints(te,me,Ae){return mt.onDidChangeBreakpoints(te,me,Ae)},registerDebugConfigurationProvider(te,me,Ae){return mt.registerDebugConfigurationProvider(te,me,Ae||T.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,me){return mt.registerDebugAdapterDescriptorFactory(Fe,te,me)},registerDebugAdapterTrackerFactory(te,me){return mt.registerDebugAdapterTrackerFactory(te,me)},startDebugging(te,me,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?mt.startDebugging(te,me,{parentSession:Ae}):mt.startDebugging(te,me,Ae||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,me){return mt.asDebugSourceUri(te,me)}},Ln={registerTaskProvider:(te,me)=>Ct.registerTaskProvider(Fe,te,me),fetchTasks:te=>Ct.fetchTasks(te),executeTask:te=>Ct.executeTask(Fe,te),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(te,me,Ae)=>Ct.onDidStartTask(te,me,Ae),onDidEndTask:(te,me,Ae)=>Ct.onDidEndTask(te,me,Ae),onDidStartTaskProcess:(te,me,Ae)=>Ct.onDidStartTaskProcess(te,me,Ae),onDidEndTaskProcess:(te,me,Ae)=>Ct.onDidEndTaskProcess(te,me,Ae)},Fn={async openNotebookDocument(te,me){x.checkProposedApiEnabled(Fe);let Ae;if(y.URI.isUri(te))Ae=te,await pt.openNotebookDocument(te);else if(typeof te=="string")Ae=y.URI.revive(await pt.createNotebookDocument({viewType:te,content:me}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return x.checkProposedApiEnabled(Fe),pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return x.checkProposedApiEnabled(Fe),pt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return x.checkProposedApiEnabled(Fe),pt.onDidSaveNotebookDocument},get notebookDocuments(){return x.checkProposedApiEnabled(Fe),pt.notebookDocuments.map(te=>te.apiNotebook)},registerNotebookSerializer(te,me,Ae,st){return x.checkProposedApiEnabled(Fe),pt.registerNotebookSerializer(Fe,te,me,Ae,Fe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(te,me,Ae,st)=>(x.checkProposedApiEnabled(Fe),pt.registerNotebookContentProvider(Fe,te,me,Ae,Fe.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(te,me)=>(x.checkProposedApiEnabled(Fe),pt.registerNotebookCellStatusBarItemProvider(Fe,te,me)),createNotebookEditorDecorationType(te){return x.checkProposedApiEnabled(Fe),pt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return x.checkProposedApiEnabled(Fe),Zt.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeNotebookDocumentMetadata(te,me,Ae)},onDidChangeNotebookCells(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeNotebookCells(te,me,Ae)},onDidChangeNotebookCellExecutionState(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeNotebookCellExecutionState(te,me,Ae)},onDidChangeCellOutputs(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeCellOutputs(te,me,Ae)},onDidChangeCellMetadata(te,me,Ae){return x.checkProposedApiEnabled(Fe),pt.onDidChangeCellMetadata(te,me,Ae)},createConcatTextDocument(te,me){return x.checkProposedApiEnabled(Fe),new je.ExtHostNotebookConcatDocument(pt,St,te,me)},createNotebookController(te,me,Ae,st,wt){return x.checkProposedApiEnabled(Fe),Jt.createNotebookController(Fe,te,me,Ae,st,wt)}};return{version:Qe.version,authentication:Cn,commands:kn,comments:Tn,debug:Rn,env:gn,extensions:In,languages:Pn,notebook:Fn,scm:An,tasks:Ln,test:ln,window:cn,workspace:vn,Breakpoint:T.Breakpoint,CallHierarchyIncomingCall:T.CallHierarchyIncomingCall,CallHierarchyItem:T.CallHierarchyItem,CallHierarchyOutgoingCall:T.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:w.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:T.CodeAction,CodeActionKind:T.CodeActionKind,CodeActionTriggerKind:T.CodeActionTriggerKind,CodeLens:T.CodeLens,Color:T.Color,ColorInformation:T.ColorInformation,ColorPresentation:T.ColorPresentation,ColorThemeKind:T.ColorThemeKind,CommentMode:T.CommentMode,CommentThreadCollapsibleState:T.CommentThreadCollapsibleState,CompletionItem:T.CompletionItem,CompletionItemKind:T.CompletionItemKind,CompletionItemTag:T.CompletionItemTag,CompletionList:T.CompletionList,CompletionTriggerKind:T.CompletionTriggerKind,ConfigurationTarget:T.ConfigurationTarget,CustomExecution:T.CustomExecution,DebugAdapterExecutable:T.DebugAdapterExecutable,DebugAdapterInlineImplementation:T.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:T.DebugAdapterNamedPipeServer,DebugAdapterServer:T.DebugAdapterServer,DebugConfigurationProviderTriggerKind:T.DebugConfigurationProviderTriggerKind,DebugConsoleMode:T.DebugConsoleMode,DecorationRangeBehavior:T.DecorationRangeBehavior,Diagnostic:T.Diagnostic,DiagnosticRelatedInformation:T.DiagnosticRelatedInformation,DiagnosticSeverity:T.DiagnosticSeverity,DiagnosticTag:T.DiagnosticTag,Disposable:T.Disposable,DocumentHighlight:T.DocumentHighlight,DocumentHighlightKind:T.DocumentHighlightKind,DocumentLink:T.DocumentLink,DocumentSymbol:T.DocumentSymbol,EndOfLine:T.EndOfLine,EnvironmentVariableMutatorType:T.EnvironmentVariableMutatorType,EvaluatableExpression:T.EvaluatableExpression,InlineValueText:T.InlineValueText,InlineValueVariableLookup:T.InlineValueVariableLookup,InlineValueEvaluatableExpression:T.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:T.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:T.ExtensionKind,ExtensionMode:T.ExtensionMode,ExternalUriOpenerPriority:T.ExternalUriOpenerPriority,FileChangeType:T.FileChangeType,FileDecoration:T.FileDecoration,FileSystemError:T.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:T.FoldingRange,FoldingRangeKind:T.FoldingRangeKind,FunctionBreakpoint:T.FunctionBreakpoint,InlineCompletionItem:T.InlineSuggestion,InlineCompletionList:T.InlineSuggestions,Hover:T.Hover,IndentAction:I.IndentAction,Location:T.Location,MarkdownString:T.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:T.ParameterInformation,PortAutoForwardAction:T.PortAutoForwardAction,Position:T.Position,ProcessExecution:T.ProcessExecution,ProgressLocation:T.ProgressLocation,QuickInputButtons:T.QuickInputButtons,Range:T.Range,RelativePattern:T.RelativePattern,Selection:T.Selection,SelectionRange:T.SelectionRange,SemanticTokens:T.SemanticTokens,SemanticTokensBuilder:T.SemanticTokensBuilder,SemanticTokensEdit:T.SemanticTokensEdit,SemanticTokensEdits:T.SemanticTokensEdits,SemanticTokensLegend:T.SemanticTokensLegend,ShellExecution:T.ShellExecution,ShellQuoting:T.ShellQuoting,SignatureHelp:T.SignatureHelp,SignatureHelpTriggerKind:T.SignatureHelpTriggerKind,SignatureInformation:T.SignatureInformation,SnippetString:T.SnippetString,SourceBreakpoint:T.SourceBreakpoint,StandardTokenType:T.StandardTokenType,StatusBarAlignment:T.StatusBarAlignment,SymbolInformation:T.SymbolInformation,SymbolKind:T.SymbolKind,SymbolTag:T.SymbolTag,Task:T.Task,TaskGroup:T.TaskGroup,TaskPanelKind:T.TaskPanelKind,TaskRevealKind:T.TaskRevealKind,TaskScope:T.TaskScope,TextDocumentSaveReason:T.TextDocumentSaveReason,TextEdit:T.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:T.TextEditorLineNumbersStyle,TextEditorRevealType:T.TextEditorRevealType,TextEditorSelectionChangeKind:T.TextEditorSelectionChangeKind,ThemeColor:T.ThemeColor,ThemeIcon:T.ThemeIcon,TreeItem:T.TreeItem,TreeItemCollapsibleState:T.TreeItemCollapsibleState,UIKind:c.UIKind,Uri:y.URI,ViewColumn:T.ViewColumn,WorkspaceEdit:T.WorkspaceEdit,InlayHint:T.InlayHint,InlayHintKind:T.InlayHintKind,RemoteAuthorityResolverError:T.RemoteAuthorityResolverError,ResolvedAuthority:T.ResolvedAuthority,SourceControlInputBoxValidationType:T.SourceControlInputBoxValidationType,ExtensionRuntime:T.ExtensionRuntime,TimelineItem:T.TimelineItem,NotebookRange:T.NotebookRange,NotebookCellKind:T.NotebookCellKind,NotebookCellExecutionState:T.NotebookCellExecutionState,NotebookDocumentMetadata:T.NotebookDocumentMetadata,NotebookCellMetadata:T.NotebookCellMetadata,NotebookCellData:T.NotebookCellData,NotebookData:T.NotebookData,NotebookRendererScript:T.NotebookRendererScript,NotebookCellStatusBarAlignment:T.NotebookCellStatusBarAlignment,NotebookEditorRevealType:T.NotebookEditorRevealType,NotebookCellOutput:T.NotebookCellOutput,NotebookCellOutputItem:T.NotebookCellOutputItem,NotebookCellStatusBarItem:T.NotebookCellStatusBarItem,NotebookControllerAffinity:T.NotebookControllerAffinity,PortAttributes:T.PortAttributes,LinkedEditingRanges:T.LinkedEditingRanges,TestItemStatus:T.TestItemStatus,TestResultState:T.TestResultState,TestMessage:T.TestMessage,TextSearchCompleteMessageType:Z.TextSearchCompleteMessageType,TestMessageSeverity:T.TestMessageSeverity,WorkspaceTrustState:T.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ue}),define(ge[266],pe([0,1,79,66,34,127,35,49,40,33,69,50,71,91,90,48,65,128,89,62,88,119,47]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S,d,f,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w.registerSingleton(p.IExtensionStoragePaths,p.ExtensionStoragePaths),w.registerSingleton(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),w.registerSingleton(k.IExtHostCommands,k.ExtHostCommands),w.registerSingleton(y.IExtHostConfiguration,y.ExtHostConfiguration),w.registerSingleton(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),w.registerSingleton(P.IExtHostDebugService,P.WorkerExtHostDebugService),w.registerSingleton(A.IExtHostDecorations,A.ExtHostDecorations),w.registerSingleton(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),w.registerSingleton(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),w.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),w.registerSingleton(c.IExtHostSearch,c.ExtHostSearch),w.registerSingleton(l.IExtHostStorage,l.ExtHostStorage),w.registerSingleton(s.IExtHostTask,s.WorkerExtHostTask),w.registerSingleton(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),w.registerSingleton(h.IExtHostTunnelService,h.ExtHostTunnelService),w.registerSingleton(v.IExtHostWindow,v.ExtHostWindow),w.registerSingleton(C.IExtHostWorkspace,C.ExtHostWorkspace),w.registerSingleton(f.IExtHostSecretState,f.ExtHostSecretState),w.registerSingleton(u.IExtHostTelemetry,u.ExtHostTelemetry),w.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ge[92],pe([0,1,17,14,31,68]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=y;function k(P,c,p,l){const h=w.mapArrayOrNot(p,D),_=new C.TextSearchMatch(c,h,l),v=_.preview.matches;return{ranges:w.mapArrayOrNot(h,I),uri:P,preview:{text:_.preview.text,matches:w.mapArrayOrNot(v,I)}}}e.createTextSearchResult=k;function D(P){return new C.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function I(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let s=class{constructor(c,p){this.prefix=c,this.logService=p}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};s=Ve([He(1,R.ILogService)],s),e.OutputChannel=s}),define(ge[267],pe([0,1,93,23]),function(Q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,k=512*8,D=512*128;class I{constructor(n){this.iconvLiteDecoder=n}static async create(n){let i;if(n!==e.UTF8)i=(await new Promise((o,m)=>{Q(["iconv-lite-umd"],o,m)})).getDecoder(p(n));else{const r=new TextDecoder;i={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new I(i)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function s(t,n){var i;const r=((i=n.minBytesRequiredForDetection)!==null&&i!==void 0?i:n.guessEncoding)?k:y;return new Promise((o,m)=>{const g=w.newWriteableStream(O=>O.join("")),E=[];let b=0,a;const L=async()=>{try{const O=await u({buffer:R.VSBuffer.concat(E),bytesRead:b},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),a=await I.create(O.encoding);const W=a.write(R.VSBuffer.concat(E).buffer);g.write(W),E.length=0,b=0,o({stream:g,detected:O})}catch(O){m(O)}};w.listenStream(t,{onData:async O=>{a?g.write(a.write(O.buffer)):(E.push(O),b+=O.byteLength,b>=r&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>g.error(O),onEnd:async()=>{a||await L(),g.end(a==null?void 0:a.end())}})})}e.toDecodeStream=s;async function P(t,n,i){const o=(await new Promise((E,b)=>{Q(["iconv-lite-umd"],E,b)})).getEncoder(p(n),i);let m=!1,g=!1;return{read(){if(g)return null;const E=t.read();if(typeof E!="string"){if(g=!0,!m&&(i==null?void 0:i.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const b=o.end();return b&&b.length>0?(m=!0,R.VSBuffer.wrap(b)):null}return m=!0,R.VSBuffer.wrap(o.write(E))}}}e.toEncodeReadable=P;async function c(t){return(await new Promise((i,r)=>{Q(["iconv-lite-umd"],i,r)})).encodingExists(p(t))}e.encodingExists=c;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function l(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const i=t.readUInt8(0),r=t.readUInt8(1);if(i===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return i===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const h=["ascii","utf-16","utf-32"];async function _(t){const n=await new Promise((g,E)=>{Q(["jschardet"],g,E)}),i=t.slice(0,D),r=d(i.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const m=o.encoding.toLowerCase();return 0<=h.indexOf(m)?null:S(o.encoding)}const v={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[n]||n}function d(t){let n="";for(let i=0;i<t.length;i++)n+=String.fromCharCode(t[i]);return n}function f(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=f;function u({buffer:t,bytesRead:n},i){let r=l(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let m=!0,g=!0,E=!1;for(let b=0;b<n&&b<A;b++){const a=b%2==1,L=t.readUInt8(b)===0;if(L&&(E=!0),m&&(a&&!L||!a&&L)&&(m=!1),g&&(a&&L||!a&&!L)&&(g=!1),L&&!m&&!g)break}E&&(m?r=e.UTF16le:g?r=e.UTF16be:o=!0)}return i&&!o&&!r&&t?_(t.slice(0,n)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[130],pe([0,1,267,28,129]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends C.TextSearchManager{constructor(k,D,I=R){super(k,D,{readdir:s=>I.readdir(s.fsPath),toCanonicalName:s=>w.toCanonicalName(s)})}}e.NativeTextSearchManager=A}),define(ge[268],pe([0,1,269,283,284,2,285]),function(Q,e,w,R,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(P,c,p,l,h,_){const v=_.environment.useHostProxy,S=typeof v=="boolean"?v:!_.remote.isRemote,d=y.createProxyResolver({resolveProxy:u=>P.resolveProxy(u),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(u,t,...n)=>{switch(u){case y.LogLevel.Trace:l.trace(t,...n);break;case y.LogLevel.Debug:l.debug(t,...n);break;case y.LogLevel.Info:l.info(t,...n);break;case y.LogLevel.Warning:l.warn(t,...n);break;case y.LogLevel.Error:l.error(t,...n);break;case y.LogLevel.Critical:l.critical(t,...n);break;case y.LogLevel.Off:break;default:i(u,t,n);break}function i(r,o,...m){l.error("Unknown log level",r),l.error(o,...m)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:u=>{h.$publicLog2("resolveProxy",u)},useHostProxy:S,env:process.env}),f=D(c,d);return s(p,f)}e.connectProxyResolver=k;function D(P,c){const p={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(h=>{p.config=P.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(h=>{l.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},w,y.createHttpPatch(w,c,{config:"off"},l,!0)),on:Object.assign({},w,y.createHttpPatch(w,c,{config:"on"},l,!0)),override:Object.assign({},w,y.createHttpPatch(w,c,{config:"override"},l,!0)),onRequest:Object.assign({},w,y.createHttpPatch(w,c,p,l,!0)),default:Object.assign(w,y.createHttpPatch(w,c,p,l,!1))},https:{off:Object.assign({},R,y.createHttpPatch(R,c,{config:"off"},l,!0)),on:Object.assign({},R,y.createHttpPatch(R,c,{config:"on"},l,!0)),override:Object.assign({},R,y.createHttpPatch(R,c,{config:"override"},l,!0)),onRequest:Object.assign({},R,y.createHttpPatch(R,c,p,l,!0)),default:Object.assign(R,y.createHttpPatch(R,c,p,l,!1))},tls:Object.assign(C,y.createTlsPatch(C))}}const I=new Map;function s(P,c){return P.getExtensionPathIndex().then(p=>{const l=Q.__$__nodeRequire("module"),h=l._load;l._load=function(v,S,d){if(v==="tls")return c.tls;if(v!=="http"&&v!=="https")return h.apply(this,arguments);const f=c[v],u=p.findSubstr(A.URI.file(S.filename).fsPath);let t=I.get(u);if(t||I.set(u,t={}),!t[v]){let n=f.default;u&&u.enableProposedApi&&(n=f[u.proxySupport]||f.onRequest),t[v]=Object.assign({},n)}return t[v]}})}}),define(ge[270],pe([0,1,37,9,76,29,11,8,92,271]),function(Q,e,w,R,C,A,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const s=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(d,f,u,t){const n=c(d,f,u,t),i=f.folder.fsPath;return{cmd:w.spawn(s,n.args,{cwd:i}),rgDiskPath:s,siblingClauses:n.siblingClauses,rgArgs:n,cwd:i}}e.spawnRipgrepCmd=P;function c(d,f,u,t){const n=["--files","--hidden","--case-sensitive"];l([f],u,!1).forEach(r=>{const o=D.anchorGlob(r);if(n.push("-g",o),y.isMacintosh){const m=C.normalizeNFD(o);m!==o&&n.push("-g",m)}});const i=p([f],t,void 0,!1);return i.globArgs.forEach(r=>{const o=`!${D.anchorGlob(r)}`;if(n.push("-g",o),y.isMacintosh){const m=C.normalizeNFD(o);m!==o&&n.push("-g",m)}}),f.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),f.ignoreSymlinks||n.push("--follow"),d.exists&&n.push("--quiet"),n.push("--no-config"),f.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:i.siblingClauses}}function p(d,f,u,t=!0){const n=[];let i={};return d.forEach(r=>{const o=Object.assign({},r.excludePattern||{},f||{}),m=h(o,t?r.folder.fsPath:void 0,u);n.push(...m.globArgs),m.siblingClauses&&(i=Object.assign(i,m.siblingClauses))}),{globArgs:n,siblingClauses:i}}e.foldersToRgExcludeGlobs=p;function l(d,f,u=!0){const t=[];return d.forEach(n=>{const i=Object.assign({},f||{},n.includePattern||{}),r=h(i,u?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=l;function h(d,f,u){const t=[],n={};return Object.keys(d).forEach(i=>{if(u&&u.has(i)||!i)return;const r=d[i];i=v(f?_(f,i):i),i.startsWith("\\\\")?i="\\\\"+i.substr(2).replace(/\\/g,"/"):i=i.replace(/\\/g,"/"),typeof r=="boolean"&&r?(i.startsWith("\\\\")&&(i+="**"),t.push(S(i))):r&&r.when&&(n[i]=r)}),{globArgs:t,siblingClauses:n}}function _(d,f){return R.isAbsolute(f)?f:R.join(d,f)}e.getAbsoluteGlob=_;function v(d){return d=k.rtrim(d,"\\"),k.rtrim(d,"/")}function S(d){return A.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=S}),define(ge[272],pe([0,1,37,59,9,100,17,60,30,76,29,11,44,8,12,28,31,270,98]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(i=>i())});class f{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=S.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const m=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),g=o.folder.fsPath;r.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==g).forEach(E=>{s.isEqualOrParent(E,g)&&(m[C.relative(g,E)]=!0)}),this.folderExcludePatterns.set(g,new t(m,g))})}cancel(){this.isCanceled=!0}walk(r,o,m,g,E){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);o.forEach(b=>{const a=C.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,a)||this.matchFile(m,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(r,(b,a)=>{this.call(this.cmdTraversal,this,b,m,g,L=>{if(L){const O=k.toErrorMessage(L);console.error(O),this.errors.push(O),a(L,void 0)}else a(null,void 0)})},(b,a)=>{this.fileWalkSW.stop();const L=b?y.coalesce(b)[0]:null;E(L,this.isLimitHit)})}parallel(r,o,m){const g=new Array(r.length),E=new Array(r.length);let b=!1,a=0;if(r.length===0)return m(null,[]);r.forEach((L,O)=>{o(L,(W,ee)=>{if(W?(b=!0,g[O]=null,E[O]=W):(g[O]=ee,E[O]=null),++a===r.length)return m(b?E:null,g)})})}call(r,o,...m){try{r.apply(o,m)}catch(g){m[m.length-1](g)}}cmdTraversal(r,o,m,g){const E=r.folder.fsPath,b=P.isMacintosh;let a;const L=()=>a&&a.kill();d.add(L);let O=T=>{d.delete(L),O=()=>{},g(T)},W="";const ee=this.initDirectoryTree();let oe;const V=v.spawnRipgrepCmd(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);a=V.cmd,oe=!Object.keys(V.siblingClauses).length;const B=V.rgArgs.args.map(T=>T.match(/^-/)?T:`'${T}'`).join(" ");let j=`${V.rgDiskPath} ${B}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),m({message:j}),this.cmdResultCount=0,this.collectStdout(a,"utf8",m,(T,N,F)=>{if(T){O(T);return}if(this.isLimitHit){O();return}const U=(W+(b?I.normalizeNFC(N||""):N)).split(`
`);if(F){const x=U.length;U[x-1]=U[x-1].trim(),U[x-1]||U.pop()}else W=U.pop()||"";if(U.length&&U[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=U.length,oe){for(const x of U)if(this.matchFile(o,{base:E,relativePath:x,searchPath:this.getSearchPath(r,x)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,ee,E,U,o),F&&(this.matchDirectoryTree(ee,E,o),O())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),m=o.getBasenameTerms(),g=o.getPathTerms(),E=["-L","."];if(m.length||g.length){E.push("-not","(","(");for(const b of m)E.push("-name",b),E.push("-o");for(const b of g)E.push("-path",b),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),w.spawn("find",E,{cwd:r.folder.fsPath})}readStdout(r,o,m){let g="";this.collectStdout(r,o,()=>{},(E,b,a)=>{if(E){m(E);return}g+=b,a&&m(null,g)})}collectStdout(r,o,m,g){let E=(L,O,W)=>{(L||W)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),g(L,O,W)},b=!1;r.stdout?(this.forwardData(r.stdout,o,E),r.stdout.once("data",()=>b=!0)):m({message:"stdout is null"});let a;r.stderr?a=this.collectData(r.stderr):m({message:"stderr is null"}),r.on("error",L=>{E(L)}),r.on("close",L=>{let O;!b&&(O=this.decodeData(a,o))&&n(O)?E(new Error(`command failed with error code ${L}: ${this.decodeData(a,o)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(r,o,m){const g=new A.StringDecoder(o);return r.on("data",E=>{m(null,g.write(E))}),g}collectData(r){const o=[];return r.on("data",m=>{o.push(m)}),o}decodeData(r,o){const m=new A.StringDecoder(o);return r.map(g=>m.write(g)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},m,g,E){g.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:m,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const b=a=>{const L=C.basename(a),O=C.dirname(a);let W=o[O];W||(W=o[O]=[],b(O)),W.push({base:m,relativePath:a,basename:L,searchPath:this.getSearchPath(r,a)})};g.forEach(b)}matchDirectoryTree({rootEntries:r,pathToEntries:o},m,g){const E=this,b=this.folderExcludePatterns.get(m),a=this.filePattern;function L(O){E.directoriesWalked++;const W=D.hasSiblingFn(()=>O.map(ee=>ee.basename));for(let ee=0,oe=O.length;ee<oe;ee++){const V=O[ee],{relativePath:B,basename:j}=V;if(b.test(B,j,a!==j?W:void 0))continue;const T=o[B];if(T)L(T);else{if(E.filesWalked++,B===a)continue;E.matchFile(g,V)}if(E.isLimitHit)break}}L(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,m,g,E){const b=r.folder,a=D.hasSiblingFn(()=>m);this.parallel(m,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const W=o?[o,L].join(C.sep):L;if(this.folderExcludePatterns.get(r.folder.fsPath).test(W,L,this.config.filePattern!==L?a:void 0))return O(null);const ee=[b.fsPath,W].join(C.sep);R.lstat(ee,(oe,V)=>{if(oe||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(ee,V,(B,j)=>B||this.isCanceled||this.isLimitHit?O(null):j.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ee,V,(T,N)=>T||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?O(null):(this.walkedPaths[N]=!0,h.readdir(ee).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,W,F,g,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&l.isNumber(j.size)&&j.size>this.maxFilesize||this.matchFile(g,{base:b.fsPath,relativePath:W,searchPath:this.getSearchPath(r,W)}),O(null,void 0)))})},L=>{const O=L&&y.coalesce(L);return E(O&&O.length>0?O[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return _.isFilePatternMatch(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,m){return o.isSymbolicLink()?R.stat(r,m):m(null,o)}realPathIfNeeded(r,o,m){return o.isSymbolicLink()?R.realpath(r,(g,E)=>g?m(g):m(null,E)):m(null,r)}getSearchPath(r,o){return r.folderName?C.join(r.folderName,o):o}}e.FileWalker=f;class u{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new f(r)}search(r,o,m){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(g,E)=>{m(g,{limitHit:E,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=u;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,m;Object.keys(r).filter(g=>r[g]).forEach(g=>{C.isAbsolute(g)?(o=o||D.getEmptyExpression(),o[g]=r[g]):(m=m||D.getEmptyExpression(),m[g]=r[g])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=m&&D.parse(m,{trimForExclusions:!0})}test(r,o,m){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,m)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,r),o,m)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(i){const r=i.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return p.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(ge[131],pe([0,1,37,286,100,17,52,30,9,8,2,31,68,287,271,92]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(b){this.outputChannel=b}provideTextSearchResults(b,a,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify(Object.assign(Object.assign({},a),{folder:a.folder.toString()}))}`),new Promise((W,ee)=>{O.onCancellationRequested(()=>M());const oe=n(b,a),V=a.folder.fsPath,B=oe.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${_} ${B}
 - cwd: ${V}`);let j=w.spawn(_,oe,{cwd:V});j.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),ee(P.serializeSearchError(new P.SearchError(be&&be.message,P.SearchErrorCode.rgProcessError)))});let T=!1;const N=new f(a.maxResults,V,a.previewOptions);N.on("result",be=>{T=!0,x="",L.report(be)});let F=!1;const M=()=>{F=!0,j&&j.kill(),N&&N.cancel()};let U=!1;N.on("hitLimit",()=>{U=!0,M()});let x="";j.stdout.on("data",be=>{N.handleData(be),T||(x+=be)});let G=!1;j.stdout.once("data",()=>G=!0);let se="";j.stderr.on("data",be=>{const Te=be.toString();this.outputChannel.appendLine(Te),se+=Te}),j.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(T?"Got result from parser":"No result from parser"),x&&this.outputChannel.appendLine(`Got data without result: ${x}`),this.outputChannel.appendLine(""),F)W({limitHit:U});else{N.flush(),j=null;let be;se&&!G&&(be=S(se))?ee(P.serializeSearchError(new P.SearchError(be.message,be.code))):W({limitHit:U})}})})}}e.RipgrepTextSearchEngine=v;function S(E){const b=E.split(`
`),a=b[0].trim();if(b.some(O=>O.startsWith("regex parse error")))return new P.SearchError(d(b),P.SearchErrorCode.regexParseError);const L=a.match(/grep config error: unknown encoding: (.*)/);if(L)return new P.SearchError(`Unknown encoding: ${L[1]}`,P.SearchErrorCode.unknownEncoding);if(a.startsWith("error parsing glob"))return new P.SearchError(a.charAt(0).toUpperCase()+a.substr(1),P.SearchErrorCode.globParseError);if(a.startsWith("the literal"))return new P.SearchError(a.charAt(0).toUpperCase()+a.substr(1),P.SearchErrorCode.invalidLiteral);if(a.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(a,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function d(E){const b=["Regex parse error"],a=E.filter(L=>L.startsWith("PCRE2:"));if(a.length>=1){const L=a[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];b.push(":"+O)}}return b.join("")}e.buildRegexParseError=d;class f extends R.EventEmitter{constructor(b,a,L){super();this.maxResults=b,this.rootFolder=a,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,a){return super.on(b,a),this}handleData(b){if(this.isDone)return;const a=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(a)}handleDecodedData(b){let a=b.indexOf(`
`);const L=this.remainder+b;if(a>=0)a+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;a>=0;)this.handleLine(L.substring(O,a).trim()),O=a+1,a=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(b){if(this.isDone||!b)return;let a;try{a=JSON.parse(b)}catch(L){throw new Error(`malformed line from rg: ${b}`)}if(a.type==="match"){const L=u(a.data.path),O=s.URI.file(D.join(this.rootFolder,L)),W=this.createTextSearchMatch(a.data,O);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(a.type==="context"){const L=u(a.data.path),O=s.URI.file(D.join(this.rootFolder,L));this.createTextSearchContext(a.data,O).forEach(ee=>this.onResult(ee))}}createTextSearchMatch(b,a){const L=b.line_number-1;let O=!1,W=u(b.lines);L===0&&I.startsWithUTF8BOM(W)&&(O=!0,W=I.stripUTF8BOM(W));const ee=Buffer.from(W);let oe=0,V=0,B=L;b.submatches.length===0&&b.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const j=A.coalesce(b.submatches.map((T,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=u(T.match);L===0&&N===0&&O&&(F=I.stripUTF8BOM(F),T.start=T.start<=3?0:T.start-3,T.end=T.end<=3?0:T.end-3);const M=ee.slice(oe,T.start).toString().length,U=V+M,x=t(F),G=B,se=x.numLines+G,be=x.numLines>0?x.lastLineLength:x.lastLineLength+U;return oe=T.end,V=be,B=se,new c.Range(G,U,se,be)}));return h.createTextSearchResult(a,W,j,this.previewOptions)}createTextSearchContext(b,a){const L=u(b.lines),O=b.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((W,ee)=>({text:W,uri:a,lineNumber:O+ee}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=f;function u(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const b=/\n/g;let a=0,L=-1,O;for(;O=b.exec(E);)a++,L=O.index;const W=L>=0?E.length-L-1:E.length;return{numLines:a,lastLineLength:W}}function n(E,b){const a=["--hidden"];a.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=y.groupBy(b.includes,ee=>ee.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const ee=new Set;O.forEach(oe=>{ee.add(oe)}),a.push("-g","!*"),ee.forEach(oe=>{i(oe).map(h.anchorGlob).forEach(V=>{a.push("-g",V)})})}L&&L.length&&L.forEach(ee=>{a.push("-g",ee)}),b.excludes.map(h.anchorGlob).forEach(ee=>a.push("-g",`!${ee}`)),b.maxFileSize&&a.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?a.push("--no-ignore-parent"):a.push("--no-ignore"),b.followSymlinks&&a.push("--follow"),b.encoding&&b.encoding!=="utf8"&&a.push("--encoding",b.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=I.escapeRegExpCharacters(E.pattern),E.isRegExp=!0),b.usePCRE2&&a.push("--pcre2"),a.push("--crlf"),E.isRegExp&&(E.pattern=r(E.pattern),a.push("--auto-hybrid-regex"));let W;if(E.isWordMatch){const oe=I.createRegExp(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");a.push("--regexp",oe)}else if(E.isRegExp){let ee=m(E.pattern);ee=g(ee),a.push("--regexp",ee)}else W=E.pattern,a.push("--fixed-strings");return a.push("--no-config"),b.useGlobalIgnoreFiles||a.push("--no-ignore-global"),a.push("--json"),E.isMultiline&&a.push("--multiline"),b.beforeContext&&a.push("--before-context",b.beforeContext+""),b.afterContext&&a.push("--after-context",b.afterContext+""),a.push("--"),W&&a.push(W),a.push("."),a}function i(E){const b=k.splitGlobAware(E,"/");return b.map((a,L)=>b.slice(0,L+1).join("/"))}e.spreadGlobComponents=i;function r(E){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(b);)E=E.replace(b,"$1\\x{$2}");const a=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(a);)E=E.replace(a,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=r;const o=E=>E.type==="Assertion"&&E.kind==="lookbehind";function m(E){let b;try{b=new p.RegExpParser().parsePattern(E)}catch(oe){return E}let a="",L=0;const O=(oe,V,B)=>{a+=E.slice(L,oe)+B,L=V},W=[];return new p.RegExpVisitor({onCharacterEnter(oe){if(oe.raw!=="\\n")return;const V=W[0];if(!V)O(oe.start,oe.end,"\\r?\\n");else if(!W.some(o))if(V.type==="CharacterClass")if(V.negate){const B=E.slice(V.start+2,oe.start)+E.slice(oe.end,V.end-1);O(V.start,V.end,"(?!\\r?\\n"+(B?`|[${B}]`:"")+")")}else{const B=E.slice(V.start+1,oe.start)+E.slice(oe.end,V.end-1);O(V.start,V.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else V.type==="Quantifier"&&O(oe.start,oe.end,"(?:\\r?\\n)")},onQuantifierEnter(oe){W.unshift(oe)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(oe){W.unshift(oe)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(oe){W.unshift(oe)},onCharacterClassLeave(){W.shift()},onAssertionEnter(oe){o(oe)&&W.push(oe)},onAssertionLeave(oe){W[0]===oe&&W.shift()}}).visit(b),a+=E.slice(L),a}e.fixRegexNewline=m;function g(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=g}),define(ge[273],pe([0,1,21,131,114,10]),function(Q,e,w,R,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,s,P,c){const p=new R.RipgrepTextSearchEngine(this.outputChannel);if(s.folder.scheme===A.Schemas.userData){const l=Object.assign(Object.assign({},s),{folder:s.folder.with({scheme:A.Schemas.file})}),h=new C.Progress(_=>P.report(Object.assign(Object.assign({},_),{uri:_.uri.with({scheme:s.folder.scheme})})));return this.withToken(c,_=>p.provideTextSearchResults(I,l,h,_))}else return this.withToken(c,l=>p.provideTextSearchResults(I,s,P,l))}async withToken(I,s){const P=k(I);this.inProgress.add(P);const c=await s(P.token);return this.inProgress.delete(P),c}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=y;function k(D){const I=new w.CancellationTokenSource;return D.onCancellationRequested(()=>I.cancel()),I}}),define(ge[274],pe([0,1,28,131,130]),function(Q,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,I,s){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(p){s({message:p})}},c=new C.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(P),w);return new Promise((p,l)=>c.search(h=>{I(h.map(y))},D).then(h=>p({limitHit:h.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=A;function y(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,I)=>{if(I.ranges){const s=I;return D+(Array.isArray(s.ranges)?s.ranges.length:1)}else return D+1},0)}}}),define(ge[275],pe([0,1,59,288,17,13,16,3,98,9,44,2,43,31,272,274]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(w);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const i=d(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=A.createCancelablePromise(o=>this.doFileSearchWithEngine(l.Engine,i,m=>r.fire(m),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const i=d(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=A.createCancelablePromise(o=>this.ripgrepTextSearch(i,m=>r.fire(m),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,i){return t.maxFileSize=c.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(i,n,n)}doFileSearch(t,n,i){return this.doFileSearchWithEngine(l.Engine,t,n,i)}doFileSearchWithEngine(t,n,i,r,o=_.BATCH_SIZE){let m=0;const g=b=>{Array.isArray(b)?(m+=b.length,i(b.map(a=>this.rawMatchToSearchItem(a)))):b.relativePath?(m++,i(this.rawMatchToSearchItem(b))):i(b)};if(n.sortByScore){let b=this.trySortedSearchFromCache(n,g,r);if(!b){const a=n.maxResults?Object.assign({},n,{maxResults:null}):n,L=new t(a);b=this.doSortedSearch(L,n,i,g,r)}return new Promise((a,L)=>{b.then(([O,W])=>{const ee=W.map(oe=>this.rawMatchToSearchItem(oe));this.sendProgress(ee,i,o),a(O)},L)})}const E=new t(n);return this.doSearch(E,g,o,r).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:"searchProcess",fromCache:!1,resultCount:m,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?I.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,i,r,o){const m=new k.Emitter;let g=A.createCancelablePromise(b=>{let a=[];const L=O=>{Array.isArray(O)?a=O:(r(O),m.fire(O))};return this.doSearch(t,L,-1,b).then(O=>[O,a])}),E;if(n.cacheKey){E=this.getOrCreateCache(n.cacheKey);const b={promise:g,event:m.event,resolved:!1};E.resultsToSearchCache[n.filePattern||""]=b,g.then(()=>{b.resolved=!0},a=>{delete E.resultsToSearchCache[n.filePattern||""]}),g=this.preventCancellation(g)}return g.then(([b,a])=>{const L=E?E.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&s.StopWatch.create(!1);return this.sortResults(n,a,L,o).then(W=>{const ee=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:ee,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:W.length},messages:b.messages,limitHit:b.limitHit||typeof n.maxResults=="number"&&a.length>n.maxResults},W]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new v)}trySortedSearchFromCache(t,n,i){const r=t.cacheKey&&this.caches[t.cacheKey];if(!r)return;const o=this.getResultsFromCache(r,t.filePattern||"",n,i);if(o)return o.then(([m,g,E])=>{const b=s.StopWatch.create(!1);return this.sortResults(t,g,r.scorerCache,i).then(a=>{const L=b.elapsed(),O={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:g.length,sortingTime:L};return[{type:"success",limitHit:m.limitHit||typeof t.maxResults=="number"&&g.length>t.maxResults,stats:O},a]})})}sortResults(t,n,i,r){const o=D.prepareQuery(t.filePattern||""),m=(E,b)=>D.compareItemsByFuzzyScore(E,b,o,!0,S,i),g=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(n,m,g,1e4,r)}sendProgress(t,n,i){if(i&&i>0)for(let r=0;r<t.length;r+=i)n(t.slice(r,r+i));else n(t)}getResultsFromCache(t,n,i,r){const o=s.StopWatch.create(!1),m=n.indexOf(I.sep)>=0;let g;for(const L in t.resultsToSearchCache)if(n.startsWith(L)){if(m&&L.indexOf(I.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];g={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!g)return null;const E=o.elapsed(),b=s.StopWatch.create(!1),a=g.event(i);return r&&r.onCancellationRequested(()=>{a.dispose()}),g.promise.then(([L,O])=>{if(r&&r.isCancellationRequested)throw y.canceled();const W=[],ee=D.prepareQuery(n).normalizedLowercase;for(const oe of O)!p.isFilePatternMatch(oe,ee)||W.push(oe);return[L,W,{cacheWasResolved:g.resolved,cacheLookupTime:E,cacheFilterTime:b.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,i,r){return new Promise((o,m)=>{let g=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(i?(g.push(E),i>0&&g.length>=i&&(n(g),g=[])):n(E))},E=>{n(E)},(E,b)=>{g.length&&n(g),E?m(E):o(b)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,i){return t.then(n,i)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=_,_.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(u){return I.basename(u.relativePath)}getItemDescription(u){return I.dirname(u.relativePath)}getItemPath(u){return u.relativePath}};function d(u){return Object.assign(Object.assign({},u),{folderQueries:u.folderQueries&&u.folderQueries.map(f),extraFileResources:u.extraFileResources&&u.extraFileResources.map(t=>P.URI.revive(t))})}function f(u){return Object.assign(Object.assign({},u),{folder:P.URI.revive(u.folder)})}}),define(ge[276],pe([0,1,6,2,28,14,31,275,273,92,15,63,27,71,10,130]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends p.ExtHostSearch{constructor(S,d,f,u){super(S,f,u);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new I.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new I.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(l.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(S,d){const f=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=f,this._proxy.$registerFileSearchProvider(f,this._transformScheme(S)),w.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(S,d,f,u){const t=p.reviveQuery(f);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,d,t,u):super.$provideFileSearchResults(S,d,f,u)}doInternalFileSearch(S,d,f,u){const t=n=>{if(y.isSerializedFileMatch(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,d,n.map(i=>R.URI.file(i.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(f,t,u)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,d){return new h.NativeTextSearchManager(S,d)}};_=Ve([He(0,s.IExtHostRpcService),He(1,c.IExtHostInitDataService),He(2,P.IURITransformerService),He(3,A.ILogService)],_),e.NativeExtHostSearch=_}),define(ge[132],pe([0,1,289,122,290,3,103,9,101,32,6,23,104,16,11]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(g){this.socket=g,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;p.onUnexpectedError(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const E=b=>g(P.VSBuffer.wrap(b));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(g){return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,E=>{if(E){if(E.code==="EPIPE")return;p.onUnexpectedError(E)}})}catch(E){if(E.code==="EPIPE")return;p.onUnexpectedError(E)}}end(){this.socket.end()}drain(){return new Promise((g,E)=>{if(this.socket.bufferSize===0){g();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),g()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=h;var _;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class S extends s.Disposable{constructor(g,E,b,a){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=a,E?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),p.onUnexpectedError(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),p.onUnexpectedError(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new c.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(P.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,E){let b=2;g.byteLength<126?b+=0:g.byteLength<2**16?b+=2:b+=8;const a=P.VSBuffer.alloc(b);if(E?a.writeUInt8(194,0):a.writeUInt8(130,0),g.byteLength<126)a.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){a.writeUInt8(126,1);let L=1;a.writeUInt8(g.byteLength>>>8&255,++L),a.writeUInt8(g.byteLength>>>0&255,++L)}else{a.writeUInt8(127,1);let L=1;a.writeUInt8(0,++L),a.writeUInt8(0,++L),a.writeUInt8(0,++L),a.writeUInt8(0,++L),a.writeUInt8(g.byteLength>>>24&255,++L),a.writeUInt8(g.byteLength>>>16&255,++L),a.writeUInt8(g.byteLength>>>8&255,++L),a.writeUInt8(g.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=a.byteLength+g.byteLength,this.socket.write(P.VSBuffer.concat([a,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),a=(E.readUInt8(0)&128)>>>7,L=E.readUInt8(1),O=(L&128)>>>7,W=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=a,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),b=E.readUInt8(1),a=(b&128)>>>7;let L=b&127,O=1;L===126?L=E.readUInt8(++O)*2**8+E.readUInt8(++O):L===127&&(L=E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O));let W=0;a&&(W=E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=W}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);d(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(P.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function d(m,g){if(g===0)return;let E=m.byteLength>>>2;for(let ee=0;ee<E;ee++){const oe=m.readUInt32BE(ee*4);m.writeUInt32BE(oe^g,ee*4)}let b=E*4,a=m.byteLength-b;const L=g>>>24&255,O=g>>>16&255,W=g>>>8&255;a>=1&&m.writeUInt8(m.readUInt8(b)^L,b),a>=2&&m.writeUInt8(m.readUInt8(b+1)^O,b+1),a>=3&&m.writeUInt8(m.readUInt8(b+2)^W,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function u(){const m=I.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let g;return e.XDG_RUNTIME_DIR?g=k.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):g=k.join(D.tmpdir(),`vscode-ipc-${m}.sock`),n(g),g}e.createRandomIPCHandle=u;function t(m,g,E){const b=w.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${E}-${g}-sock`;let a;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?a=k.join(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${E}-${g}.sock`):a=k.join(m,`${E}-${g}.sock`),n(a),a}e.createStaticIPCHandle=t;function n(m){const g=f[l.platform];typeof g=="number"&&m.length>=g&&console.warn(`WARNING: IPC handle "${m}" is longer than ${g} chars, try a shorter --user-data-dir`)}class i extends y.IPCServer{constructor(g){super(i.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const E=A.Event.fromNodeEventEmitter(g,"connection");return A.Event.map(E,b=>({protocol:new c.Protocol(new h(b)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(m){return new Promise((g,E)=>{const b=R.createServer();b.on("error",E),b.listen(m,()=>{b.removeListener("error",E),g(new i(b))})})}e.serve=r;function o(m,g){return new Promise((E,b)=>{const a=R.createConnection(m,()=>{a.removeListener("error",b),E(c.Client.fromSocket(new h(a),g))});a.once("error",b)})}e.connect=o}),define(ge[277],pe([0,1,132,269,59,49,2,118,14]),function(Q,e,w,R,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(c,p,l){this._commands=c,this.logService=p,this._ipcHandlePath=l,this._server=R.createServer((h,_)=>this.onRequest(h,_)),this.setup().catch(h=>(p.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,p){const l=[];c.setEncoding("utf8"),c.on("data",h=>l.push(h)),c.on("end",()=>{const h=JSON.parse(l.join(""));switch(h.type){case"open":this.open(h,p);break;case"openExternal":this.openExternal(h,p);break;case"status":this.getStatus(h,p);break;case"extensionManagement":this.manageExtensions(h,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${h.type}`,_=>{_&&this.logService.error(_)}),p.end();break}})}open(c,p){let{fileURIs:l,folderURIs:h,forceNewWindow:_,diffMode:v,addMode:S,forceReuseWindow:d,gotoLineMode:f,waitMarkerFilePath:u}=c;const t=[];if(Array.isArray(h))for(const n of h)try{t.push({folderUri:y.URI.parse(n)})}catch(i){}if(Array.isArray(l))for(const n of l)try{k.hasWorkspaceFileExtension(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(i){}if(t.length){const n=u?y.URI.file(u):void 0,r={forceNewWindow:_,diffMode:v,addMode:S,gotoLineMode:f,forceReuseWindow:d,preferNewWindow:!d&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}p.writeHead(200),p.end()}async openExternal(c,p){for(const l of c.uris){const h=y.URI.parse(l),_=h.scheme==="file"?h:l;await this._commands.executeCommand("_remoteCLI.openExternal",_)}p.writeHead(200),p.end()}async manageExtensions(c,p){try{const l=v=>v==null?void 0:v.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),h={list:c.list,install:l(c.install),uninstall:l(c.uninstall),force:c.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);p.writeHead(200),p.write(_)}catch(l){p.writeHead(500),p.write(String(l),h=>{h&&this.logService.error(h)})}p.end()}async getStatus(c,p){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(l),p.end()}catch(l){p.writeHead(500),p.write(String(l),h=>{h&&this.logService.error(h)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let s=class extends I{constructor(c,p){super(c,p,w.createRandomIPCHandle())}};s=Ve([He(0,A.IExtHostCommands),He(1,D.ILogService)],s),e.CLIServer=s}),define(ge[278],pe([0,1,70,265,260,5,268,41,250,2,10,7,277,102]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends C.RequireInterceptor{_installInterceptor(){const v=this,S=Q.__$__nodeRequire("module"),d=S._load;S._load=function(u,t,n){for(let i of v._alternatives){let r=i(u);if(r){u=r;break}}return v._factories.has(u)?v._factories.get(u).load(u,I.URI.file(p.realpathSync(t.filename)),i=>d.apply(this,[i,t,n])):d.apply(this,arguments)}}}class h extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,v,this._registry).install(),w.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await y.connectProxyResolver(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),w.mark("code/extHost/didInitProxyResolver");const f=process.send,u=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?f.apply(process,t):(u.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,S,d){if(S.scheme!==s.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let f=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{v&&w.mark(`code/extHost/willLoadExtensionCode/${v.value}`),f=Q.__$__nodeRequire(S.fsPath)}catch(u){return Promise.reject(u)}finally{v&&w.mark(`code/extHost/didLoadExtensionCode/${v.value}`),d.codeLoadingStop()}return Promise.resolve(f)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const S in v){const d=v[S];d===null?delete process.env[S]:process.env[S]=d}}}e.ExtHostExtensionService=h}),define(ge[279],pe([0,1,79,251,252,262,261,276,278,221,253,50,41,66,71,69,33,48,14]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h,_,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w.registerSingleton(c.IExtHostExtensionService,D.ExtHostExtensionService),w.registerSingleton(S.ILogService,I.ExtHostLogService),w.registerSingleton(P.IExtHostDebugService,y.ExtHostDebugService),w.registerSingleton(p.IExtHostOutputService,R.ExtHostOutputService2),w.registerSingleton(l.IExtHostSearch,k.NativeExtHostSearch),w.registerSingleton(h.IExtHostTask,A.ExtHostTask),w.registerSingleton(_.IExtHostTerminalService,C.ExtHostTerminalService),w.registerSingleton(v.IExtHostTunnelService,s.ExtHostTunnelService)}),define(ge[280],pe([0,1,122,291,70,16,104,132,188,219,263,23,99,28,102,13,266,279]),function(Q,e,w,R,C,A,y,k,D,I,s,P,c,p,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const _=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const i=Q.__$__nodeRequire("module"),r=i._load;i._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function S(i){process.exit=function(r){if(i)v(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let d=function(i){v()};function f(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,r)=>{let o=null,m=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const g=108e5,E=3e5,b=new h.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),g),a=new h.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),E);process.on("message",(O,W)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=P.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let oe;if(O.skipWebSocketFrames)oe=new k.NodeSocket(W);else{const V=P.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));oe=new k.WebSocketNodeSocket(new k.NodeSocket(W),O.permessageDeflate,V,!1)}o?(b.cancel(),a.cancel(),o.beginAcceptReconnection(oe,ee),o.endAcceptReconnection()):(clearTimeout(m),o=new y.PersistentProtocol(oe,ee),o.onDidDispose(()=>d("renderer disconnected")),i(o),o.onSocketClose(()=>{b.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(a.isScheduled())return;b.isScheduled()&&a.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const m=w.createConnection(i,()=>{m.removeListener("error",o),r(new y.PersistentProtocol(new k.NodeSocket(m)))});m.once("error",o),m.on("close",()=>{d("renderer closed the socket")})})}}async function u(){const i=await f();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(r=>{I.isMessageOfType(r,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||i.send(r)}drain(){return i.drain()}}}function t(i){return new Promise(r=>{const o=i.onMessage(m=>{o.dispose();const g=JSON.parse(m.toString()),E=g.commit,b=D.default.commit;E&&b&&E!==b&&v(55);const a=[];process.on("unhandledRejection",(W,ee)=>{a.push(ee),setTimeout(()=>{const oe=a.indexOf(ee);oe>=0&&ee.catch(V=>{a.splice(oe,1),console.warn(`rejected promise not handled within 1 second: ${V}`),V&&V.stack&&console.warn(`stack trace: ${V.stack}`),A.onUnexpectedError(W)})},1e3)}),process.on("rejectionHandled",W=>{const ee=a.indexOf(W);ee>=0&&a.splice(ee,1)}),process.on("uncaughtException",function(W){A.onUnexpectedError(W)});let L=0;setInterval(function(){try{process.kill(g.parentPid,0),L=0}catch(W){W&&W.code==="EPERM"?(L++,L>=3&&d(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):d(`parent process ${g.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let O;try{O=Q.__$__nodeRequire("native-watchdog"),O.start(g.parentPid)}catch(W){A.onUnexpectedError(W)}i.send(I.createMessageOfType(0)),r({protocol:i,initData:g})});i.send(I.createMessageOfType(1))})}async function n(){C.mark("code/extHost/willConnectToRenderer");const i=await u();C.mark("code/extHost/didConnectToRenderer");const r=await t(i);C.mark("code/extHost/didWaitForInitData");const{initData:o}=r;S(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0;const m=new class{exit(a){v(a)}exists(a){return p.exists(a)}realpath(a){return l.realpath(a)}};let g=null;if(o.remote.authority&&_.uriTransformerPath)try{const a=Q.__$__nodeRequire(_.uriTransformerPath)(o.remote.authority);g=new c.URITransformer(a)}catch(b){console.error(b)}const E=new s.ExtensionHostMain(r.protocol,o,m,g);d=b=>E.terminate(b)}e.startExtensionHostProcess=n}),define(ge[292],pe([0,1,280]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4f3d865a6b46a4ead49cf83fe1c30d95d0a34220/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
